import javax.sound.midi.Track;
import java.io.*;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Scanner;
import java.util.StringTokenizer;

public class Main {

    private static class FastScanner {
        private BufferedReader reader = null;
        private StringTokenizer tokenizer = null;

        public FastScanner(InputStream in) {
            reader = new BufferedReader(new InputStreamReader(in));
            tokenizer = null;
        }

        public char nextChar() throws IOException {
            char[] arr = new char[1];
            reader.read(arr);
            return arr[0];
        }


        public String next() {
            if (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }


        public int nextInt() {
            return Integer.parseInt(next());
        }

    }

    public static void main(String[] args) throws IOException {
        BufferedInputStream bin = new BufferedInputStream(System.in);
        FastScanner scanner = new FastScanner(bin);
        PrintWriter out = new PrintWriter(new BufferedOutputStream(System.out));
//        FastScanner scanner = new FastScanner(new FileInputStream("files/file1.txt"));




        // string diff
        // int - number of such strings
        Hashtable<String, Integer> noSQL = new Hashtable<>();
        int n = scanner.nextInt();
        String str;
        for (int i = 0; i < n; i++) {
            str = scanner.next();
            if (noSQL.containsKey(str)) {
                noSQL.put(str, noSQL.get(str) + 1);
                int j = noSQL.get(str);
                while (noSQL.containsKey(str + j)) {
                    j++;
                }
                noSQL.put(str + j, 0);
                out.println(str + j);
            } else {
                noSQL.put(str, 0);
                out.println(str);
            }



        }

        out.flush();
    }

//    BufferedInputStream bin = new BufferedInputStream(System.in);
//    //        FastScanner scanner = new FastScanner(bin);
//    Scanner scanner = new Scanner(System.in);
//    //        FastScanner scanner = new FastScanner(new FileInputStream("files/file1.txt"));
//    long sum;
//    sum = (long) Math.pow(scanner.nextLong(), 2) + (long) Math.pow(scanner.nextLong(), 2);
//
//    PrintWriter out = new PrintWriter(new BufferedOutputStream(System.out));
//        out.println(sum);
//        out.flush();
}

