#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
#include <climits>

#define sz(x) ((int) ((x).size()))
#define all(x) (x).begin(), (x).end()

using namespace std;
using i64 = int64_t;

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    i64 n, k;
    cin >> n >> k;
    vector<i64> s(n), c(n), a(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        c[i] = 2520LL / s[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<i64> sorted(n);
    iota(all(sorted), 0);
    sort(all(sorted), [&](int i, int j) {
        return c[i] > c[j];
    });

    i64 sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += c[i] * abs(s[i] - a[i]);
    }

    int ptr = 0;
    i64 ans = 0;
    k *= 2520LL;
    while (sum > k) {
        i64 delta = c[sorted[ptr]] * abs(s[sorted[ptr]] - a[sorted[ptr]]);
        if (sum <= k + delta) {
            i64 d = abs(s[sorted[ptr]] - a[sorted[ptr]]);
            while (sum <= k + delta) {
                delta -= c[sorted[ptr]];
                d--;
            }
            ans += d + 1;
            break;
        } else {
            sum -= delta;
            ans += abs(s[sorted[ptr]] - a[sorted[ptr]]);
        }
        ptr++;
    }

    cout << ans;

    return 0;
}