#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
#include <climits>

#define sz(x) ((int) ((x).size()))
#define all(x) (x).begin(), (x).end()

#define inf 1'000'000'000'000

using namespace std;
using i64 = int64_t;
using ll = long long;

bool is_valid(ll i) {
    return i >= 0;
}

void get_min(ll pos, vector<ll> &a, bool is_last = false) {
    if (is_valid(pos - 6)) {
        if (!is_last)
            a[pos] = a[pos - 6];
        if (is_last)
            a[pos] = min(a[pos - 6] + 1, a[pos]);
    }

    for (ll i = pos - 5; i < pos; i++) {
        if (is_valid(pos))
            a[pos] = min(a[pos], a[i] + 1);
    }
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;

    cin >> n;

    vector<ll> a(n, inf);
    vector<ll> back(n, 0);

    a[0] = 0;
    back[0] = 0;

    for (ll i = 1; i < n - 1; i++) {
        cin >> back[i];

        back[i] += back[i - back[i]];

        get_min(i, a);

        if (back[i] != 0) {
            a[i - back[i]] = min(a[i - back[i]], a[i]);
            a[i] = inf;
        }
    }

    get_min(n - 1, a, true);

    ll res = a[n - 1];
    if (res == inf)
        cout << "-1\n";
    else
        cout << res << "\n";

    return 0;
}