#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

#define int ll

const int N = 1e5 + 7;
const int F = 2520;

int n, k;
int s[N];
int a[N];
int ind[N];

void run_solve() {
  cin >> n >> k;
  k *= F;
  for (int i = 0; i < n; ++i) {
    cin >> s[i];
  }
  int cur = 0;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    cur += abs(s[i] - a[i]) * F / s[i];
  }
  iota(ind, ind + n, 0);
  sort(ind, ind + n, [&](int i, int j) { return s[i] < s[j]; });
  int ans = 0;
  int cur_i = 0;
  while (cur > k) {
    int i = ind[cur_i];
    ++cur_i;
    if (cur - abs(s[i] - a[i]) * F / s[i] <= k) {
      ans += (s[i] * (cur - k) - 1) / F + 1;
      cur = k;
    } else {
      cur -= abs(s[i] - a[i]) * F / s[i];
      ans += abs(s[i] - a[i]);
    }
  }
  cout << ans << '\n';
}