def distance(p1, p2):
    x1, y1 = p1
    x2, y2 = p2
    return ((x2 - x1) ** 2 + (y2 - y1) ** 2) ** 0.5

def line_length(vertices):
    total_length = 0

    for i in range(len(vertices) - 1):
        total_length += distance(vertices[i], vertices[i + 1])

    return total_length

vertices = []

N = int(input())

for i in range(N):
    x, y = map(int, input().split())
    vertices.append((x, y))

length = line_length(vertices)
print(length)