#include <iostream>

int find_gcd(int a, int b) {
    while (b) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

std::pair<int, int> find_max_gcd_pair(int L, int R) {
    int max_gcd = 1;
    std::pair<int, int> result_pair = std::make_pair(L, L + 1);

    for (int x = L; x <= R; x++) {
        for (int y = x + 1; y <= R; y++) {
            int gcd = find_gcd(x, y);

            if (gcd > max_gcd) {
                max_gcd = gcd;
                result_pair = std::make_pair(x, y);
            }
        }
    }

    return result_pair;
}

int main() {
    int L, R;
    std::cin >> L >> R;

    if (L < R) {
        std::pair<int, int> max_gcd_pair = find_max_gcd_pair(L, R);
        std::cout << max_gcd_pair.first << " " << max_gcd_pair.second << std::endl;
    }

    return 0;
}