#include <iostream>

int find_gcd(int a, int b) {
    while (b) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

std::pair<int, int> find_first_max_gcd_pair(int L, int R) {
    int max_gcd = 0;
    std::pair<int, int> result_pair;

    for (int x = R; x >= L; x--) {
        for (int y = x - 1; y >= L; y--) {
            int gcd = find_gcd(x, y);

            if (gcd >= max_gcd) {
                max_gcd = gcd;
                result_pair = std::make_pair(x, y);
            }
        }
    }

    return result_pair;
}

int main() {
    int L, R;
    std::cin >> L >> R;

    if (L < R) {
        std::pair<int, int> first_max_gcd_pair = find_first_max_gcd_pair(L, R);
        std::cout << first_max_gcd_pair.first << " " << first_max_gcd_pair.second << std::endl;
    }

    return 0;
}

