#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

int main()
{

	int n, k;
	cin >> n >> k;
	vector<pair<int, int>> pairs(n);
	for (int i = 0; i < n; i++){
		int temp;
		cin >> temp;
		pairs[i] = make_pair(temp, 0);
	}
	
	double difference = 0;
	for (int i = 0; i < n; i++){
		int temp;
		cin >> temp;
		pairs[i].second = temp;
		
		difference += abs(pairs[i].first - (double)pairs[i].second) / pairs[i].first;
		
	}
	
	sort(pairs.begin(), pairs.end());
	
	for (int i = 0; i < n; i++){
	//	cout << pairs[i].first << ' ' <<  pairs[i].second << '\n';
	}
	//cout << difference;
	
	int i = 0;
	int seconds = 0;
	while (difference > k){
	//	cout << difference << ' ' << seconds << ' ' << i << '\n';
		double increment = abs(pairs[i].first - (double)pairs[i].second) / pairs[i].first;
		if (difference - increment <= k){
			int steps = ceil((difference - k) * pairs[i].first);
			difference = k - 1;
			seconds += steps;
		}
		else{
			difference -= increment;
			seconds += abs(pairs[i].first - pairs[i].second);
		}
		i++;
	}
	cout << seconds;
	
    return 0;
}
