#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

int nok = 2520;


int main()
{

	long long n, k;
	cin >> n >> k;
	k *= nok;
	
	vector<pair<long long, long long>> pairs(n);
	for (int i = 0; i < n; i++){
		int temp;
		cin >> temp;
		pairs[i] = make_pair(temp, 0);
	}
	
	long long difference = 0;
	for (int i = 0; i < n; i++){
		int temp;
		cin >> temp;
		pairs[i].second = temp * nok / pairs[i].first;
		
		difference += abs(pairs[i].second - nok);
		
	}
	
	sort(pairs.begin(), pairs.end());
	
	for (int i = 0; i < n; i++){
	//	cout << pairs[i].first << ' ' <<  pairs[i].second << '\n';
	}
	//cout << difference;
	
	int i = 0;
	int seconds = 0;
	while (difference > k){
	//	cout << difference << ' ' << seconds << ' ' << i << '\n';
		int increment = abs(pairs[i].second - nok);
		if (difference - increment < k){
			int steps = abs(difference - k) / (nok / pairs[i].first);
			if (abs(difference - k) % (nok / pairs[i].first) > 0){
				steps++;
			}
			difference = k - 1;
			seconds += steps;
		}
		else{
			difference -= increment;
			seconds += abs(pairs[i].second * pairs[i].first / nok - pairs[i].first);
		}
		i++;
	}
	cout << seconds;
	
    return 0;
}
