//
// Created by a on 06.03.2022.
//
// clang-format off

#include <algorithm>
#include <cstdio>
#pragma GCC optimize("Os")
#pragma GCC optimize("Ofast", "no-stack-protector", "inline")
#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("avx,avx2,fma")


#include <bits/stdc++.h>
//#include <ext/rope>

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;

//template<typename T>
// #define ordered_set tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>

#define endl "\n"
#define int long long
#define ui unsigned int
#define ll long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mall(a) a.mutable_begin(), a.mutable_end()
#define X first
#define Y second
#define pii pair<int, int>
#define ull unsigned ll
#define double long double
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator>>(istream& in, const pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

struct edge {
    int u, w;

    edge() {}

    edge(int u, int w) : u(u), w(w) {}
};

void solve() {
    int n, m , k;
    std::cin >> n >> m >> k;
    std::vector <std::vector <edge>> g(n * m);
    std::vector <std::vector <char>> c(n, std::vector <char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> c[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m - 1; ++j) {
            if (c[i][j] == '.' && j + 2 < m && c[i][j + 2] == '.') {
                g[i * m + j].push_back({i * m + j + 2, 1});
                g[i * m + j + 2].push_back({i * m + j, 1});
            }
            if (c[i][j] == '.' && c[i][j + 1] == '.') {
                g[i * m + j].push_back({i * m + j + 1, 0});
                g[i * m + j + 1].push_back({i * m + j, 0});
            }
        }
    }
    for (int i = 0; i + 1< n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (c[i][j] == '.' && c[i + 1][j] == '.') {
                g[i * m + j].push_back({(i + 1) * m + j, 0});
                g[(i + 1) * m + j].push_back({i * m + j, 0});
            }
            if (c[i][j] == '.' && i + 2 < n && c[i + 2][j] == '.') {
                g[i * m + j].push_back({(i + 2) * m + j, 1});
                g[(i + 2) * m + j].push_back({i * m + j, 1});
            }
        }
    }
    std::deque <int> q;
    std::vector <int> dist(n * m, 1e9);
    std::vector <int> used(n * m, 0);
    int sx, sy, ex, ey;
    std::cin >> sx >> sy >> ex >> ey;
    --sx;
    --sy;
    --ex;
    --ey;
    int x = sx * m + sy;
    int y = ex * m + ey;
    q.push_back(x);
    // cout << x << std::flush;

    dist[x] = 0;
    while (!q.empty()) {
        auto u = q.front();
        q.pop_front();
        if (used[u]) {
            continue;
        }
        used[u] = 1;
        for (auto v : g[u]) {
            if (!used[v.u] && dist[v.u] > dist[u] + v.w) {
                if (v.w == 1) {
                    q.push_back(v.u);
                }
                else {
                    q.push_front(v.u);
                }
                dist[v.u] = dist[u] + v.w;
            }
        }
    }
    if (dist[y] <= k) {
        std::cout << "YES";
    }
    else {
        std::cout << "NO";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#if defined(LOCAL)
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;

    while (t--)
        solve();
}