def max_introverts_seated(N, K):
    if K == 1:
        return N - 2

    max_seated = 0

    # Сначала посадите одного интроверта на каждый стул
    seated = min(K, N - 1) # количество уже посаженных интровертов
    max_seated = max(max_seated, seated)

    # Далее продолжайте посадку интровертов, пока есть достаточно места
    while seated + K <= N - 2: # пока есть место для еще одного интроверта
        seated += K
        max_seated += 1


    return max_seated

# Пример использования
N = int(input())
K = int(input())
result = max_introverts_seated(N, K)
if result <= 0:
    print('Error')
elif result > 1:
    print(result)
elif result == 1:
    print('Undefined')