MOD = 10**9 + 7

def roulette_game(N, K, S1, S2):
    def nCr(n, r):
        res = 1
        for i in range(1, r + 1):
            res = res * (n - i + 1) // i
        return res % MOD

    ways_first = nCr(N + S1 - 1, S1)
    ways_second = nCr(N + S2 - 1, S2)

    if ways_first > ways_second:
        return "First"
    elif ways_first < ways_second:
        return "Second"
    else:
        return "Equal"


# Считывание входных данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вызов функции и вывод результата
print(roulette_game(N, K, S1, S2))
