MOD = 10**9 + 7

def roulette_game(N, K, S1, S2):
    dp = [0] * (N * K + 1)
    dp[0] = 1

    for _ in range(N):
        new_dp = [0] * (N * K + 1)
        for i in range(N * K):
            for j in range(1, K + 1):
                if i + j <= N * K:
                    new_dp[i + j] = (new_dp[i + j] + dp[i]) % MOD
        dp = new_dp

    ways_first = dp[S1]
    ways_second = dp[S2]

    if ways_first > ways_second:
        return "First"
    elif ways_first < ways_second:
        return "Second"
    else:
        return "Equal"

# Чтение входных данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вызов функции и вывод результата
print(roulette_game(N, K, S1, S2))
