#include <iostream>
#include <cmath>

struct { double d; bool b; } m[3001][501];

double count(int Q, int N, int K)
{
    if (Q < N)    return 0;
    if (Q > K * N)  return 0;
    if (N == 1)   return (Q >= 1 && Q <= K) ? 1 : 0;
    if (Q <= 0)   return 0;
    if (N == 0)   return 0;
    if (m[Q][N].b) return m[Q][N].d;
    double r = 0;
    for(int j = 1; j <= K; ++j)
        r += count(Q - j, N - 1, K);
    m[Q][N].d = r;
    m[Q][N].b = true;
    return m[Q][N].d;
}

int main()
{
    int n;
    std::cin >> n;
    int k;
    std::cin >> k;
    int s1;
    std::cin >> s1;
    int s2;
    std::cin >> s2;
    double result1 = count(s1, n, k) / pow(k, n);
    double result2 = count(s2, n, k) / pow(k, n);
    if (result1 > result2)
    {
        std::cout << "First" << std::endl;
    }
    else if (result1 == result2)
    {
       std::cout << "Equal" << std::endl;
    }
    else
    {
        std::cout << "Second" << std::endl;
    }
}