import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(reader.readLine());
        int K = Integer.parseInt(reader.readLine());
        int S1 = Integer.parseInt(reader.readLine());
        int S2 = Integer.parseInt(reader.readLine());

        int[][] dp1 = new int[N + 1][S1 + 1];
        int[][] dp2 = new int[N + 1][S2 + 1];

        dp1[0][0] = 1;
        dp2[0][0] = 1;

        for (int i = 1; i <= N; i++) {
            for (int j = 1; j <= K; j++) {
                for (int s = 0; s <= S1; s++) {
                    if (s - j >= 0) {
                        dp1[i][s] += dp1[i - 1][s - j];
                    }
                }
            }
        }

        for (int i = 1; i <= N; i++) {
            for (int j = 1; j <= K; j++) {
                for (int s = 0; s <= S2; s++) {
                    if (s - j >= 0) {
                        dp2[i][s] += dp2[i - 1][s - j];
                    }
                }
            }
        }

        if (dp1[N][S1] > dp2[N][S2]) {
            System.out.println("First");
        } else if (dp1[N][S1] < dp2[N][S2]) {
            System.out.println("Second");
        } else {
            System.out.println("Equal");
        }
    }
}
