import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(reader.readLine());
        int K = Integer.parseInt(reader.readLine());
        int S1 = Integer.parseInt(reader.readLine());
        int S2 = Integer.parseInt(reader.readLine());

        int[] dp1 = new int[S1 + 1];
        int[] dp2 = new int[S2 + 1];

        dp1[0] = 1;
        dp2[0] = 1;

        for (int i = 1; i <= N; i++) {
            for (int s = S1; s >= 0; s--) {
                dp1[s] = 0;
                for (int j = 1; j <= K && s - j >= 0; j++) {
                    dp1[s] += dp1[s - j];
                }
            }
        }

        for (int i = 1; i <= N; i++) {
            for (int s = S2; s >= 0; s--) {
                dp2[s] = 0;
                for (int j = 1; j <= K && s - j >= 0; j++) {
                    dp2[s] += dp2[s - j];
                }
            }
        }

        if (dp1[S1] > dp2[S2]) {
            System.out.println("First");
        } else if (dp1[S1] < dp2[S2]) {
            System.out.println("Second");
        } else {
            System.out.println("Equal");
        }
    }
}
