import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int L = Integer.parseInt(reader.readLine());
        int R = Integer.parseInt(reader.readLine());

        for (int x = L; x <= R; x++) {
            for (int y = x + 1; y <= R; y++) {
                int gcd = findNOD(x, y);
                if (gcd != 1) {
                    System.out.println(x + " " + y);
                    return;
                }
            }
        }
    }

    public static int findNOD(int a, int b) {
        while (b != 0) {
            int temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }
}
