#include <algorithm>
#include <bitset>
#include <chrono>
#include <cmath>
#include <cstring>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <limits>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>
// #include "json.hpp" // lib for json, dont forget to coment on contests
// #include <curl/curl.h> // lib for curl, dont forget to coment on contests
// #include <bit>
// #include "optimization.h"

// using json = nlohmann::json; // namespace for json, dont forget to coment on
// contests
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define ld long double
#define f first // TODO: remove
#define s second
#define eb emplace_back
#define pb push_back

// #define FAST_ALLOCATOR_MEMORY 1e8
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag,
             tree_order_statistics_node_update>
    ordered_set;

const int INF = 1e9 + 10;
const int MOD1 = 1e9 + 7;
const int P = 31;
const int P1 = 43;
const int MOD = 1e9;
const ld EPS = 1e-7;

const int MAX_BITSET = 123;

pair<int, int> union_pair(pair<int, int> a, pair<int, int> b) {
    return {min(a.first, b.first), max(a.second, b.second)};
}

bool inters_pair(pair<int, int> a, pair<int, int> b) {
    return a.second + 1 >= b.first;
}

struct Segments {
    set<pair<int, int>> st;

    void add(int x) {
        if (st.empty()) {
            st.insert({x, x});
            return;
        }
        auto it = st.lower_bound({x, INF});
        pair<int, int> newSeg = {x, x};
        if (it != st.begin()) {
            auto it1 = it;
            auto l = *(--it1);
            // cout << l.first << ' ' << l.second << '\n';
            if (inters_pair(l, newSeg)) {
                st.erase(l);
                newSeg = union_pair(l, newSeg);
            }
        }

        if (it != st.end()) {
            auto it1 = it;
            auto r = *(it1);
            // cout << r.first << ' ' << r.second << '\n';

            if (inters_pair(newSeg, r)) {
                st.erase(r);
                newSeg = union_pair(newSeg, r);
            }
        }

        // cout << newSeg.first << ' ' << newSeg.second << '\n';

        st.insert(newSeg);
    }

    int get_next(int x) {
        if (st.empty()) {
            return x;
        }
        auto it = st.lower_bound({x, INF});
        if (it == st.begin()) {
            return x;
        } else {
            return (--it)->second + 1;
        }
    }
};

void solve() {
    int n;
    cin >> n;

    map<string, Segments> p;

    auto isDigit = [](char x) { return (x >= '0' && x <= '9'); };

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;

        // auto &st = p[s];
        int newNum = p[s].get_next(0);

        // if (i == 1) {
        //     for (auto i : p[s].st) {
        //         cout << i.first << ' ' << i.second << '\n';
        //     }
        // }

        if (newNum == 0) {
            cout << s << '\n';
        } else {
            s += to_string(newNum);
            cout << s << '\n';
        }

        string name;
        string nm;
        int pos = s.length();
        while (pos != 0 && isDigit(s[pos - 1])) {
            pos--;
        }

        name = s.substr(0, pos);
        if (pos == s.length()) {
            nm = "";
        } else {
            nm = s.substr(pos, s.length() - pos);
        }

        auto add = [i, &p](string s, string x, string nm) {
            // if (i == 1) {
            //     cout << s << ' ' << x << ' ' << nm << '\n';
            // }
            if (nm == "") {
                p[s + x].add(0);
            } else {
                p[s + x].add(stoll(nm));
            }
        };

        string x = "";
        add(name, nm, x);
        while (nm.size() != 0) {
            x = nm.back() + x;
            nm.pop_back();
            add(name, nm, x);
            // nm /= 10;
        }
        add(name, nm, x);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    int t = 1;
    // cin >> t;
    //    t = readInt();
    while (t--) {
        solve();
        // solve1();
    }

    // while (!isEof()){
    //     solve();
    // }

    return 0;
}