#include <stdio.h>
#include <stdlib.h>
struct detal {
	long nado;
	long real;
	double otkl;
};
void swap(struct detal* xp, struct detal* yp) 
{ 
	double temp = xp->nado; 
	xp->nado = yp->nado; 
	yp->nado = temp; 
	temp = xp->real; 
	xp->real = yp->real; 
	yp->real = temp; 
	temp = xp->otkl; 
	xp->otkl = yp->otkl; 
	yp->otkl = temp; 
} 
void selectionSort(struct detal *arr, int n) 
{ 
    int i, j, min_idx; 
  
    // One by one move boundary of 
    // unsorted subarray 
    for (i = 0; i < n - 1; i++) { 
        // Find the minimum element in 
        // unsorted array 
        min_idx = i; 
        for (j = i + 1; j < n; j++) 
            if (arr[j].otkl > arr[min_idx].otkl) 
                min_idx = j; 
  
        // Swap the found minimum element 
        // with the first element 
        swap(&arr[min_idx], &arr[i]); 
    } 
} 
void selectionSort2(struct detal *arr, int n) 
{ 
    int i, j, min_idx; 
  
    // One by one move boundary of 
    // unsorted subarray 
    for (i = 0; i < n - 1; i++) { 
        // Find the minimum element in 
        // unsorted array 
        min_idx = i; 
        for (j = i + 1; j < n; j++) 
            if (arr[j].nado < arr[min_idx].nado) 
                min_idx = j; 
  
        // Swap the found minimum element 
        // with the first element 
        swap(&arr[min_idx], &arr[i]); 
    } 
} 
int main(void) {
	int count, dopus_deviation, ves;
	if (scanf("%d", &count) != 1) return 1;
	if (scanf("%d", &dopus_deviation) != 1) return 1;
	struct detal *detals = (struct detal *)malloc(sizeof(struct detal) * count);
	for (size_t i = 0; i < count; ++i) {
		scanf("%d", &ves);
		detals[i].nado = ves;
	}
	double otkl_sum = 0;
	for (size_t i = 0; i < count; ++i) {
		scanf("%d", &ves);
		detals[i].real = ves;
		detals[i].otkl = (double)labs(detals[i].real - detals[i].nado) / detals[i].nado;
		otkl_sum += detals[i].otkl;
	}
	long steps = 0;
	while (otkl_sum > dopus_deviation) {
		selectionSort(detals, count);
		selectionSort2(detals, count);
		// for (size_t i = 0; i < count; ++i) {
		// 	printf("%ld  %ld  %lf\n", detals[i].nado, detals[i].real, detals[i].otkl);
		// }
		// printf("\n");
		long index = 0;
		// printf("%ld\n", index);
		otkl_sum -= detals[index].otkl;
		if (detals[index].real > detals[index].nado) {
			detals[index].real -= 1;
		} else {
			detals[index].real += 1;
		}
		detals[index].otkl = (double)labs(detals[index].real - detals[index].nado) / detals[index].nado;
		otkl_sum += detals[index].otkl;
		steps += 1;
	}
	printf("%ld\n", steps);
	return 0;
}
