#include <stdio.h>
#include <stdlib.h>
struct detal {
	long nado;
	long real;
	double otkl;
	double new_delta_otkl;
};
void swap(struct detal* xp, struct detal* yp) 
{ 
	double temp = xp->nado; 
	xp->nado = yp->nado; 
	yp->nado = temp; 
	temp = xp->real; 
	xp->real = yp->real; 
	yp->real = temp; 
	temp = xp->otkl; 
	xp->otkl = yp->otkl; 
	yp->otkl = temp; 
	temp = xp->new_delta_otkl; 
	xp->new_delta_otkl = yp->new_delta_otkl; 
	yp->new_delta_otkl = temp; 
} 
void selectionSort(struct detal *arr, int n) 
{ 
    int i, j, min_idx; 
  
    // One by one move boundary of 
    // unsorted subarray 
    for (i = 0; i < n - 1; i++) { 
        // Find the minimum element in 
        // unsorted array 
        min_idx = i; 
        for (j = i + 1; j < n; j++) 
            if (arr[j].new_delta_otkl > arr[min_idx].new_delta_otkl)
                min_idx = j; 
  
        // Swap the found minimum element 
        // with the first element 
        swap(&arr[min_idx], &arr[i]); 
    } 
} 
int main(void) {
	int count, dopus_deviation, ves;
	if (scanf("%d", &count) != 1) return 1;
	if (scanf("%d", &dopus_deviation) != 1) return 1;
	struct detal *detals = (struct detal *)malloc(sizeof(struct detal) * count);
	for (size_t i = 0; i < count; ++i) {
		scanf("%d", &ves);
		detals[i].nado = ves;
	}
	double otkl_sum = 0;
	for (size_t i = 0; i < count; ++i) {
		scanf("%d", &ves);
		detals[i].real = ves;
		detals[i].otkl = (double)labs(detals[i].real - detals[i].nado) / detals[i].nado;
		detals[i].new_delta_otkl = detals[i].otkl - (double)labs(detals[i].real - detals[i].nado + (detals[i].real > detals[i].nado ? -1 : 1)) / detals[i].nado;
		otkl_sum += detals[i].otkl;
	}
	long steps = 0;
	bool need_sort = true;
	while (otkl_sum > dopus_deviation) {
		if (need_sort == true) {
			selectionSort(detals, count);
		}
		// printf("need_sort: %d\n", need_sort);
		// for (size_t i = 0; i < count; ++i) {
		// 	printf("%ld  %ld  %lf  %lf\n", detals[i].nado, detals[i].real, detals[i].otkl, detals[i].new_delta_otkl);
		// }
		// printf("\n");
		long index = 0;
		for (size_t i = 0; i < count; ++i) {
			if (detals[i].nado != detals[i].real) {
				index = i;
				break;
			}
		}
		otkl_sum -= detals[index].otkl;
		detals[index].real += (detals[index].real > detals[index].nado ? -1 : 1);
		detals[index].otkl = (double)labs(detals[index].real - detals[index].nado) / detals[index].nado;
		detals[index].new_delta_otkl = detals[index].otkl - (double)labs(detals[index].real - detals[index].nado + (detals[index].real > detals[index].nado ? -1 : 1)) / detals[index].nado;
		if (detals[index].new_delta_otkl > 0.999) {
			need_sort = false;
		}
		otkl_sum += detals[index].otkl;
		steps += 1;
	}
	printf("%ld\n", steps);
	return 0;
}
