#include <stdio.h>
#include <float.h>
#include <stdlib.h>
struct detal {
	long nado;
	long real;
	double otkl;
	double new_delta_otkl;
};
void swap(struct detal* xp, struct detal* yp) 
{ 
	long t1 = xp->nado; 
	xp->nado = yp->nado; 
	yp->nado = t1; 
	long t2 = xp->real; 
	xp->real = yp->real; 
	yp->real = t2; 
	double t3 = xp->otkl; 
	xp->otkl = yp->otkl; 
	yp->otkl = t3; 
	double t4 = xp->new_delta_otkl; 
	xp->new_delta_otkl = yp->new_delta_otkl; 
	yp->new_delta_otkl = t4; 
} 
void selectionSort(struct detal *arr, int n) 
{ 
    int i, j, min_idx; 
  
    // One by one move boundary of 
    // unsorted subarray 
    for (i = 0; i < n - 1; i++) { 
        // Find the minimum element in 
        // unsorted array 
        min_idx = i; 
        for (j = i + 1; j < n; j++) 
            if (arr[j].new_delta_otkl > arr[min_idx].new_delta_otkl)
                min_idx = j; 
  
        // Swap the found minimum element 
        // with the first element 
        swap(&arr[min_idx], &arr[i]); 
    } 
} 
int main(void) {
	long count, dopus_deviation, ves;
	if (scanf("%ld", &count) != 1) return 1;
	if (scanf("%ld", &dopus_deviation) != 1) return 1;
	struct detal *detals = (struct detal *)malloc(sizeof(struct detal) * count);
	for (size_t i = 0; i < count; ++i) {
		scanf("%ld", &ves);
		detals[i].nado = ves;
	}
	double otkl_sum = 0;
	for (size_t i = 0; i < count; ++i) {
		scanf("%ld", &ves);
		detals[i].real = ves;
		detals[i].otkl = (double)labs(detals[i].real - detals[i].nado) / detals[i].nado;
		detals[i].new_delta_otkl = detals[i].otkl - (double)labs(detals[i].real - detals[i].nado + (detals[i].real > detals[i].nado ? -1 : 1)) / detals[i].nado;
		otkl_sum += detals[i].otkl;
	}
	// while (otkl_sum > dopus_deviation && fixes_iter < fixes_count) {
	// 	size_t index2 = fixes[fixes_iter++];
	// 	otkl_sum -= detals[index2].otkl;
	// 	detals[index2].real += (detals[index2].real > detals[index2].nado ? -1 : 1);
	// 	detals[index2].otkl = (double)labs(detals[index2].real - detals[index2].nado) / detals[index2].nado;
	// 	detals[index2].new_delta_otkl = detals[index2].otkl - (double)labs(detals[index2].real - detals[index2].nado + (detals[index2].real > detals[index2].nado ? -1 : 1)) / detals[index2].nado;
	// 	otkl_sum += detals[index2].otkl;
	// 	steps += 1;
	// }
	long steps = 0;
	// bool need_sort = true;
	long index = 0;
	selectionSort(detals, count);
	while (otkl_sum > dopus_deviation) {
		// if (need_sort == true) {
		// 	need_sort = false;
		// }
		// for (size_t i = 0; i < count; ++i) {
		// 	printf("%ld  %ld  %lf  %lf  %s\n", detals[i].nado, detals[i].real, detals[i].otkl, detals[i].new_delta_otkl, i == index ? "(selected)" : "");
		// }
		// printf("\n");
		otkl_sum -= detals[index].otkl;
		detals[index].real += (detals[index].real > detals[index].nado ? -1 : 1);
		detals[index].otkl = (double)labs(detals[index].real - detals[index].nado) / detals[index].nado;
		double prev_delta = detals[index].new_delta_otkl;
		detals[index].new_delta_otkl = detals[index].otkl - (double)labs(detals[index].real - detals[index].nado + (detals[index].real > detals[index].nado ? -1 : 1)) / detals[index].nado;
		otkl_sum += detals[index].otkl;
		if (detals[index].new_delta_otkl >= prev_delta || ((index + 1) < count && detals[index].new_delta_otkl >= detals[index + 1].new_delta_otkl )) {
			// do nothing
		} else {
			index += 1;
		}
		steps += 1;
	}
	printf("%ld\n", steps);
	return 0;
}
