#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <set>

// #pragma GCC optimize("Ofast,fast-math,unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,popcnt,tune=native")
// #pragma GCC optimize("no-stack-protector")
// #pragma GCC optimize "-O3"

#define times(I, X) for (int I=0; I<X; I++)
#define rtimes(I, X) for(int I=X; I>=0; I--)
#define all(x) (x).begin(), (x).end()
 
#ifdef DEBUG
	#define dump(X) std::cout << __LINE__ << "L: [" << #X << "] = [" << X << "]\n"
#else
	#define dump(X)
#endif
#define pb push_back
#define ll long long
#define fir first
#define sec second
#define inf INT_MAX

using namespace std;
const int SZE = 2e5 + 1;
const int MOD = 998244353;

void solve() {
	int n; cin >> n;
}

int main() {
	#ifndef DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("basis.in", "r", stdin);
	// freopen("basis.out", "w", stdout);
	#endif

	// int t; cin >> t;
	// for(int i = 0; i < t; i++) {
	// 	solve();
	// }
    double x1, y1, x2, y2;
    double x, y;
    int n; cin >> n;
    double cur = 0;
    cin >> x1 >> y1;
    x = x1; y = y1;
    double maxcur = 0;
    double c;
    for(int i = 0; i < n-1; i++) {
        cin >> x2 >> y2;
        double c = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        maxcur = max(maxcur, c);
        cur += c;
        x1 = x2; y1 = y2;
    }
    c = sqrt((x1 - x) * (x1 - x) + (y1 - y) * (y1 - y));
    maxcur = max(maxcur, c);
    cur += c;
    cur -= maxcur;
    cout << cur << endl;
	return 0;
}

