def find_winner(N, K, S1, S2):
    dp = [0] * (N * K + 1)
    dp[0] = 1  # Изначально один способ получить сумму 0 - ничего не делать.

    for _ in range(N):
        new_dp = [0] * (N * K + 1)
        for i in range(N * K + 1):
            for j in range(1, K + 1):
                if i + j <= N * K:
                    new_dp[i + j] += dp[i]
        dp = new_dp

    if dp[S1] > dp[S2]:
        return "First"
    elif dp[S1] < dp[S2]:
        return "Second"
    else:
        return "Equal"

# Ваши входные данные
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = find_winner(N, K, S1, S2)
print(result)
