#include <iostream>
#include <cmath>
#include "vector"
#include "map"
#include "string"

#define ll long long

void config_io()
{
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::ostream::sync_with_stdio(false);

#ifdef _deb
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#endif

}


int get_number(std::map<std::string, int>& db, std::string us, int number){
   if (db[us + std::to_string(number)] != 0){
       return get_number(db, us, number+1);
   } else {
       return number;
   }
}



int main() {
    config_io();
    int q;
    std::cin >> q;

    std::map<std::string, int> db;

    std::vector<std::string> ans;

    std::string us;
    for (int i = 0; i < q; ++i){
        std::cin >> us;
        if (db[us] == 0){
            ans.push_back(us);
            db[us] += 1;
        } else {
            int number = get_number(db, us, db[us]);
            std::string val = us + std::to_string(number);
            ans.push_back(val);
            db[us] += 1;
            db[val] += 1;
        }
    }

    for (const auto & an : ans){
        std::cout << an << '\n';
    }

}
