#include <iostream>
#include "vector"
#include "map"
#include "string"

#define ll long long

void config_io()
{
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::ostream::sync_with_stdio(false);

#ifdef _deb
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#endif

}


int main() {
    config_io();
    int q;
    std::cin >> q;

    std::map<std::string, int> db;

    std::string us;
    for (int i = 0; i < q; ++i){
        std::cin >> us;
        if (db[us] == 0){
            std::cout << us << '\n';
            db[us]++;
        } else {
            int number = db[us];;
            number++;
            std::string val = us + std::to_string(number);
            std::cout << val << '\n';
            db[us]++;
            db[val]++;
        }
        std::cout << std::flush;
    }
}
