from math import gcd


def find_pair_with_largest_gcd(L, R):
    max_gcd = 0
    pair = ()

    for i in range(L, R + 1):
        for j in range(i + 1, R + 1):
            current_gcd = gcd(i, j)
            if current_gcd > max_gcd:
                max_gcd = current_gcd
                pair = (i, j)

    return pair


# Пример использования
L = int(input())
R = int(input())

print(*find_pair_with_largest_gcd(L, R))