from math import gcd


def find_pair_with_largest_gcd(L, R):
    max_gcd = 1
    max_gcd_pair = (L, L + 1)

    for i in range(L, R):
        for j in range(i + 1, R + 1):
            current_gcd = gcd(i, j)
            if current_gcd > max_gcd:
                max_gcd = current_gcd
                max_gcd_pair = (i, j)
                if max_gcd == R - L:
                    return max_gcd_pair

    return max_gcd_pair


# Пример использования
L, R = map(int, input().split())

print(*find_pair_with_largest_gcd(L, R))
