//#include <iostream>
//#include <string>
//#include <vector>
//#include <set>
//#include <map>
//
//using namespace std;
//
//vector<long> ARRAY = { 104729,
//                       982451653,
//                       6700417,
//                       3889,
//                       999983,
//                       7907,
//                       10007,
//                       1223,
//                       65537,
//                       2038074743,
//};
//
//struct CustomHash {
//    std::size_t operator()(const std::string& str) const {
//        size_t hash = 0;
//        for (int i = 0; i < str.size(); i++) {
//            hash += int(str[i]) * ARRAY[i];
//        }
//        return std::hash<std::string>()(str);
//    }
//};
//
//
//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//    cout.tie(NULL);
//    long long n;
//    cin >> n;
//    map<string, pair<long, iterator<map>>> my_set;
//    string temp;
//    string temp_index;
//    long long index = 1;
//
//    for (long long i = 0; i < n; i++) {
//        // getline(cin, temp);
//        cin >> temp;
//        temp_index = temp;
//        index = 0;
//        auto p = my_set[temp];
//        if (!p) {
//            my_set[temp] = 1;
//            cout << temp;
//        } else {
//            temp_index = temp + ((index > 0) ? to_string(index) : "");
//            while (my_set.contains(temp)) {
//                index++;
//            }
//        }
//    }
//    return 0;
//}


//#include <iostream>
//#include <string>
//#include <vector>
//#include <unordered_set>
//
//using namespace std;
//
//vector<long> ARRAY = { 104729,
//        982451653,
//        6700417,
//        3889,
//        999983,
//        7907,
//        10007,
//        1223,
//        65537,
//        2038074743,
//        };
//
//struct CustomHash {
//    std::size_t operator()(const std::string& str) const {
//        size_t hash = 0;
//        for (int i = 0; i < str.size(); i++) {
//            hash += int(str[i]) * ARRAY[i];
//        }
//        return std::hash<std::string>()(str);
//    }
//};
//
//
//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//    cout.tie(NULL);
//    long long n;
//    cin >> n;
//    unordered_set<string> my_set;
//    string temp;
//    string temp_index;
//    long long index = 0;
//
//    for (long long i = 0; i < n; i++) {
//        // getline(cin, temp);
//        cin >> temp;
//        temp_index = temp;
//        index = 0;
//
//        while (my_set.count(temp_index) > 0) {
//            index++;
//            temp_index = temp + ((index > 0) ? to_string(index) : "");
//        }
//        cout << temp_index << '\n';
//        my_set.insert(temp_index);
//    }
//    return 0;
//}

#include <iostream>
#include <cmath>

using namespace std;

long double custom_abs (long double a) {
    if (a > 0) {
        return a;
    }
    return (-1) * a;
}

int main() {
    long double n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;

    long double pred = 0.5 * n + 0.5 * k * n;

    if (s1 < pred && s2 < pred) {
        if (s1 > s2) {
            cout << "First" << endl;
            return 0;
        } else if (s1 < s2) {
            cout << "Second" << endl;
            return 0;
        } else {
            cout << "Equal" << endl;
            return 0;
        }
    }
    if (s1 > pred && s2 > pred) {
        if (s1 < s2) {
            cout << "First" << endl;
            return 0;
        } else if (s1 > s2) {
            cout << "Second" << endl;
            return 0;
        } else {
            cout << "Equal" << endl;
            return 0;
        }
    }

    if (custom_abs(pred - s1) < custom_abs(pred - s2))
        cout << "First" << endl;
    else if (custom_abs(pred - s1) > custom_abs(pred - s2))
        cout << "Second" << endl;
    else
        cout << "Equal" << endl;

    return 0;
}