#include <iostream>
#include <string>
#include <vector>
#include <unordered_set>

using namespace std;

vector<long> ARRAY = { 104729,
        982451653,
        6700417,
        3889,
        999983,
        7907,
        10007,
        1223,
        65537,
        2038074743,
        };

struct CustomHash {
    std::size_t operator()(const std::string& str) const {
        size_t hash = 0;
        for (int i = 0; i < str.size(); i++) {
            hash += int(str[i]) * ARRAY[i];
        }
        return std::hash<std::string>()(str);
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n;
    cin >> n;
    unordered_set<string, CustomHash> my_set;
    string temp;
    string temp_index;
    long long index = 0;
    vector<string> vec(n);

    for (long long i = 0; i < n; i++) {
        // getline(cin, temp);
        cin >> temp;
        temp_index = temp;
        index = 0;

        while (my_set.count(temp_index) > 0) {
            index++;
            temp_index = temp + ((index > 0) ? to_string(index) : "");
        }
        vec[i] = temp_index;
        // cout << temp_index << endl;
        my_set.insert(temp_index);
    }

    for (size_t i = 0; i < n; i++) {
        cout << vec[i] << '\n';
    }
    return 0;
}