#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pait<long long, long long>
#define vi vector<int>
#define vvi vector<vi>
#define vll vector<long long>
#define vvll vector<vll>
#define mii map<int, int>
#define forn(i, n) for (int i = 0; i < n; i++)

double EPS = 1e-6;
int INF = 1000000005;
long long INFF = 1000000000000000005LL;
double PI = acos(-1);
int dirx[8] = { -1, 0, 0, 1, -1, -1, 1, 1 };
int diry[8] = { 0, 1, -1, 0, -1, 1, -1, 1 };

#define all(v) v.begin(), v.end()


double get_hyp(pii a, pii b) {
    double dx = a.first - b.first;
    double dy = a.second - b.second;
    return sqrt(dx * dx + dy * dy);
}


void solve() {
    int n;
    cin >> n;
    vector<pii> points(n);
    double answer = 0, cur_hyp=0, mx=-1;
    cin >> points[0].first >> points[0].second;
    for (int i=1; i<n; i++) {
        cin >> points[i].first >> points[i].second;
        cur_hyp = get_hyp(points[i-1], points[i]);
        if (mx == -1) {
            mx = cur_hyp;
        }
        answer += cur_hyp;
        mx = max(mx, cur_hyp);
    } 
    answer += get_hyp(points[0], points[n-1]);
    mx = max(mx, get_hyp(points[0], points[n-1]));
    cout << answer  - mx << endl;
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int tc = 1;
	// cin >> tc;
    cout << std::setprecision(7);
	while (tc--) {
		solve();
	}
	return 0;
}
