// #pragma GCC optimize ("O3")
#include <bits/stdc++.h>
using namespace ::std;
#define forn(i, n) for (int i = 0; i < n; i++)
#define fore(collection) for (auto &it : collection)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;


const int inf = 1e9;

void doWork()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> board(n+4);
    vector<vector<int>> dp(n+4, vector<int>(m+4, inf));
    {
        string tempStr;
        forn(i, m+4)
        {
            tempStr += '#';
        }
        board[0] = tempStr;
        board[1] = tempStr;
        board[n+2] = tempStr;
        board[n+3] = tempStr;
    }
    forn(i, n)
    {
        string x;
        x += "##";
        cin >> board[i+2];
        x += board[i+2];
        x += "##";
        board[i+2] = x;
    }
    



    pii a, b;
    cin >> a.first >> a.second;
    cin >> b.first >> b.second;
    a.first++;a.second++;
    b.first++;b.second++;

    // dp[a.first][a.second] = 0;

    
    list<tuple<int, int, int>> next;
    next.push_back(make_tuple(a.first, a.second, 0));
    while (!next.empty())
    {
        auto x = next.front();
        next.pop_front();


        int point = get<2>(x);
        int px = get<0>(x), py = get<1>(x);
        if (point >= dp[px][py])
            continue;
        if (board[px][py] == '#')
            continue;
        dp[px][py] = point;
        
        int dx, dy;
        dx = 1, dy = 0;
        if (board[px+dx][py+dy] == '#')
            next.push_back(make_tuple(px+2*dx, py+2*dy, point+1));
        else
            next.push_front(make_tuple(px+dx, py+dy, point));

        dx = -1, dy = 0;
        if (board[px+dx][py+dy] == '#')
            next.push_back(make_tuple(px+2*dx, py+2*dy, point+1));
        else
            next.push_front(make_tuple(px+dx, py+dy, point));

        dx = 0, dy = 1;
        if (board[px+dx][py+dy] == '#')
            next.push_back(make_tuple(px+2*dx, py+2*dy, point+1));
        else
            next.push_front(make_tuple(px+dx, py+dy, point));

        dx = 0, dy = -1;
        if (board[px+dx][py+dy] == '#')
            next.push_back(make_tuple(px+2*dx, py+2*dy, point+1));
        else
            next.push_front(make_tuple(px+dx, py+dy, point));

    }
    
    if (dp[b.first][b.second] > k)
        cout << "NO\n";
    else
        cout << "YES\n";
    


    

    

}

int main()
{
    ios_base::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        try
        {
            doWork();
        }
        catch(const exception& e)
        {
            cerr << e.what() << '\n';
        }
    }
    return 0;  
}