﻿#include <iostream>
#include <vector>
#include <string>

int find(std::string& name, std::vector<std::string>& names)
{
	int i = 1;
	for (auto n : names)
	{
		if (n == name)
			return i;
		i++;
	}
	return 0;
}

int main()
{
	std::vector<std::string> names;
	int Q;
	std::cin >> Q;
	for (int i = 0; i < Q; i++)
	{
		std::string name;
		std::cin >> name;
		bool added = false;
		bool changed = false;
		int endNum = 1;
		while (!added)
		{
			int j = find(name, names);
			if (j != 0)
			{
				if (!changed)
				{
					name.append(std::to_string(endNum));
					changed = true;
				}
				else
				{
					name.erase(name.end()-1);
					name.append(std::to_string(++endNum));
				}
			}
			else
			{
				added = true;
			}
		}
		names.push_back(name);
	}
	for (auto name : names)
	{
		std::cout << name << std::endl;
	}
}