def can_seat_introverts(N, K, num_introverts):
    return (num_introverts - 2) * K <= N - num_introverts
def max_introverts_seated(N, K):
    left, right = 2, N 
    while left < right:
        mid = (left + right + 1) // 2

        if can_seat_introverts(N, K, mid):
            left = mid
        else:
            right = mid - 1
    return left
    
N = int(input())
K = int(input())
result = max_introverts_seated(N, K)
print(result)