def can_seat_guests(N, K, mid):
    free_seats = (N - mid) // (mid + 1)
    return free_seats >= K

def max_introverts(N, K):
    if not (3 <= N < 10**9 and 1 <= K <= N - 2):
        return "Недопустимые значения N и K"

    left, right = 2, N
    result = 2 
    
    while left <= right:
        mid = (left + right) // 2
        
        if can_seat_guests(N, K, mid):
            result = mid
            left = mid + 1
        else:
            right = mid - 1
    
    return result

N = int(input())
K = int(input())
print(max_introverts(N, K))