#include <iostream>
#include <vector>
#include <cmath>

struct Point {
	int x, y;
};

int main() {
	int n = 0;
	std::cin >> n;
	std::vector<Point> pol;
	pol.resize(n);
	
	float max = 0;
	float perim = 0;
	for (int i = 0; i < n; i++) {
		std::cin >> pol[i].x >> pol[i].y;
		if (i > 0) {
			float length = sqrt(pow(pol[i].x - pol[i-1].x, 2) + pow(pol[i].y - pol[i-1].y, 2));
			perim += length;
			if (length > max) {
				max = length;
			}
		}
	}
	float length = sqrt(pow(pol[0].x - pol[n-1].x, 2) + pow(pol[0].y - pol[n-1].y, 2));
	perim += length;
	if (length > max) {
		max = length;
	}
	
	std::cout.precision(6);
	std::cout << std::fixed << perim - max;
	
	return 0;
}