class OrderedList:
    def __init__(self, content = []):
        self.content = content

    def search(self, entry, safe = True):
        if len(self.content) == 0: return -1
        l, r = 0, len(self.content)
        while r - l > 1:
            m = (l + r) // 2
            if self.content[m] > entry:
                r = m
            else:
                l = m
        if not safe: return l
        if self.content[l] == entry:
            return l
        return -1

    def insert(self, entry):
        i = self.search(entry, False)
        self.content = self.content[:i+1] + [entry] + self.content[i+1:]

q = int(input())
users = OrderedList()
for i in range(q):
    input_username = input()
    for n in ['', *range(1,q)]:
        username = input_username + str(n)
        if users.search(username) == -1:
            users.insert(username)
            print(username)
            break