class OrderedList:
    def __init__(self, content: list = []):
        self.content = content

    def search(self, entry: str, safe = True):
        if len(self.content) == 0: return -1
        l, r = 0, len(self.content)
        while r - l > 1:
            m = (l + r) // 2
            if self.content[m] > entry:
                r = m
            else:
                l = m
        if not safe: return l
        if self.content[l] == entry:
            return l
        return -1

    def insert(self, entry: str):
        i = self.search(entry, False)
        self.content.insert(i+1, entry)

q = int(input())
users = OrderedList()
for i in range(q):
    input_username = input()
    for n in range(q):
        username = input_username + (str(n) if n > 0 else '')
        if users.search(username) == -1:
            users.insert(username)
            print(username)
            break