#include <iostream>
#include <vector>

using namespace std;

int main()
{
    unsigned long long int N, K, c = 0;
    cin >> N;
    cin >> K;
    vector<int> table(N, 0);

    if (K == 1)
    {
        int ans = (N / 2) + 1;
        cout << ans;
        return 0;
    }
    if (N / K == 1)
    {
        cout << 1;
        return 0;
    }
    for (int i = 0; i < N - 1 && table[i] != 1; i = (i + K) % N)
    {
        table[i] = 1;
    }

    for (int i = 0, prev, next; i < N - 1; i++)
    {
        c = 0;
        if (table[i] == 1)
        {
            prev = (i - K + N) % N;
            next = (i + K) % N;
            for (int j = prev; j != next; j = (j + 1) % N)
            {
                if (table[j] == 0) c++;
            }
        }

        if (c < K)
        {
            table[i] = 0;
        }
    }

    int ans = 0;
    for (int i = 0; i < N - 1; i++)
    {
        if (table[i] == 1) ans++;
    }

    cout << ans;

    return 0;
}
