#include <iostream>

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int main() {
    int l, r;
    std::cin >> l >> r;

    int maxGcd = 0;
    int a, b;

    for (int x = l; x <= r; x++) {
        for (int y = x + 1; y <= r; y++) {
            int currGcd = gcd(x, y);
            if (currGcd > maxGcd) {
                maxGcd = currGcd;
                a = x;
                b = y;
            }
        }
    }

    std::cout << a << " " << b << std::endl;

    return 0;
}
