#include <iostream>

int gcd(int a, int b) {
    while (b != 0) {
        a %= b;
        int temp = b;
        b = a;
        a = temp;
    }
    return a;
}

int main() {
    int L, R;
    std::cin >> L >> R;

    int maxGcd = 0;
    int a, b;

    for (int x = L; x <= R; x++) {
        for (int y = x + 1; y <= R; y++) {
            int currGcd = gcd(x, y);
            if (currGcd > maxGcd) {
                maxGcd = currGcd;
                a = x;
                b = y;
            }
        }
    }

    std::cout << a << " " << b << std::endl;

    return 0;
}
