#include <stdio.h>

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int main() {
    int L, R;
    scanf("%d %d", &L, &R);

    int max_gcd = 0, max_x = 0, max_y = 0;

    for (int x = L; x <= R; x++) {
        for (int y = x + 1; y <= R; y++) {
            int current_gcd = gcd(x, y);
            if (current_gcd > max_gcd) {
                max_gcd = current_gcd;
                max_x = x;
                max_y = y;
            }
        }
    }

    printf("%d %d\n", max_x, max_y);

    return 0;
}
