#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <stack>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <queue>
#include <set>
#include <fstream>

using namespace std;

using ll = long long;
using vvI = vector <vector <int>>;
using vvC = vector <vector <char>>;

vvC v;
int n, m, k, dx, dy, ax, ay, ans(0);

void rec (int x, int y, int f) {
    if (x == ax && y == ay) {
        ans = 1;
        return;
    }

    if (v[x][y] == '#') {
        return;
    }

    v[x][y] = '#';

    rec(x + 1, y, f);
    rec(x - 1, y, f);
    rec(x, y + 1, f);
    rec(x, y - 1, f);

    if (f < k) {
        rec(x + 2, y, f + 1);
        rec(x - 2, y, f + 1);
        rec(x, y + 2, f + 1);
        rec(x, y - 2, f + 1);
    }

    return;
}

int main() {
    std::ios::sync_with_stdio(false);


    cin >> n >> m >> k;
    v.resize(n + 4, vector <char>(m + 4, '#'));

    for (int i(2); i < n + 2; i ++) {
        for (int j(2); j < m + 2; j ++) {
            cin >> v[i][j];
        }
    }

    cin >>  dx >> dy >> ax >> ay;
    dx ++, dy ++, ax ++, ay ++;
    rec(dx, dy, 0);

//    for (int i(0); i < v.size(); i ++) {
//        for (int j(0); j < v[i].size(); j ++) {
//            cout << v[i][j];
//        }
//        cout << '\n';
//    }

    if (ans == 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }

    return 0;
}
/*
*/
