from functools import cache


@cache
def gcd(a, b):
    return gcd(b, a % b) if b else a


l, r = map(int, input().split())
res = (l, r, gcd(l, r))

for x in range(l, r - 1):
    for y in range(x + 2, r + 1):
        new = (x, y, gcd(y, x))
        if new[-1] > res[-1]:
            res = new

print(*res[:2])
