#include <bits/stdc++.h>

using namespace std;
#define fi first
#define se second
#define pb push_back
#define ins insert
#define ers erase
typedef long long ll;
typedef double db;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
double eps = 1e-5;

struct det {
    ll a;
    ll s;
    ll pos;
};

bool operator<(const det &a, const det &b) {
    return a.s < b.s;
}

int main() {
    int n;
    cin >> n;

    double k;
    cin >> k;

    vector<det> d(n);

    for (int i = 0; i < n; ++i) {
        cin >> d[i].s;
    }

    double sum = 0;

    for (int i = 0; i < n; ++i) {
        cin >> d[i].a;
        d[i].pos = i;

        sum += db(abs(d[i].a - d[i].s) / (db) d[i].s);
    }

    sort(d.begin(), d.end());

    ll ans = 0;

    for (int i = 0; i < n; ++i) {
        db sub = db(abs(d[i].a - d[i].s) / (db) d[i].s);

        if (sum - sub >= k - eps) {
            ans += abs(d[i].a - d[i].s);
            sum -= sub;
            continue;
        } else {
            ll l = -1;
            ll r = abs(d[i].a - d[i].s);
            while (r - l > 1) {
                ll m = (l + r) / 2;

                sub = db( m / (db) d[i].s);
                if (sum - sub <= k + eps) r = m;
                else l = m;
            }

            ans += r;
            break;
        }
    }

    cout << ans << '\n';
}

/*
 3 1
 1 2 1
 2 4 3

 3 1
 1 1 3
 8 8 4
 */