#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> p(n, 0);
    for (int i = 1; i < n - 1; ++i) {
        cin >> p[i];
    }

    vector<int> col(n);

    col[0] = 0;
    col[n - 1] = n - 1;

    for (int i = 1; i < n - 1; ++i) {
        if (p[i] == 0) {
            col[i] = i;
        }
        col[i] = col[i - p[i]];
    }

    vector<pair<int, int>> dp(n, {1e10, 1e10});
    dp[0] = {0, 0};

    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= 6; ++j) {
            if (i - j >= 0 && p[i - j] == 0) {
                if (j == 6) {
                    dp[col[i]].se = min(dp[col[i]].se, dp[i - j].se);
                }
                dp[col[i]].fi = min({dp[col[i]].fi, dp[i - j].se + 1, dp[i - j].fi + 1});
            }
        }
    }

    if (min(dp[n - 1].fi, dp[n - 1].se) >= (int) 1e10) {
        cout << "-1\n";
        return 0;
    }

    cout << min(dp[n - 1].fi, dp[n - 1].se) << '\n';

    return 0;
}
