#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define fi first
#define se second

const ll INF = 1e9;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    ll n;
    cin >> n;

    vector<ll> p(n, 0);
    for (ll i = 1; i < n - 1; ++i) {
        cin >> p[i];
    }

    vector<ll> col(n);

    col[0] = 0;
    col[n - 1] = n - 1;

    for (ll i = 1; i < n - 1; ++i) {
        if (p[i] == 0) {
            col[i] = i;
        }
        col[i] = col[i - p[i]];
    }

    vector<ll> dp(n, INF);
    dp[0] = 0;

    for (ll i = 1; i < n; ++i) {
        for (ll j = 1; j <= 6; ++j) {
            if (i - j >= 0 && p[i - j] == 0) {
                if (j == 6) {
                    dp[col[i]] = min(dp[col[i]], dp[col[i - j]]);
                }
                dp[col[i]] = min({dp[col[i]], dp[col[i - j]] + 1, dp[col[i - j]] + 1});
            }
        }
    }

    if (dp[n - 1] >= INF) {
        cout << "-1\n";
        return 0;
    }

    cout << dp[n - 1] << '\n';

    return 0;
}
