FIRST = "First"
SECOND = "Second"
EQUAL = "Equal"

def calculate_distance(n, k, s):
    if s < n or s > k * n:
        return float('inf')
    s *= 2
    mat = (1 + k) * n
    return abs(mat - s)

n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

if n == 1:
    dist1 = 0 if s1 >= n and s1 <= k * n else float('inf')
    dist2 = 0 if s2 >= n and s2 <= k * n else float('inf')

    if dist1 < dist2:
        print(FIRST)
    elif dist2 < dist1:
        print(SECOND)
    else:
        print(EQUAL)
else:
    dist1 = calculate_distance(n, k, s1)
    dist2 = calculate_distance(n, k, s2)

    if dist1 < dist2:
        print(FIRST)
    elif dist2 < dist1:
        print(SECOND)
    else:
        print(EQUAL)