def comfortable_seating(N, K):
    left, right = 1, N
    result = 0
    
    while left <= right:
        mid = (left + right) // 2
        if (N - mid) * 2 >= K * mid:
            result = mid
            left = mid + 1
        else:
            right = mid - 1
    
    return result

N = int(input())
K = int(input())

print(comfortable_seating(N, K))
