#include <iostream>
#include <vector>

int countDecompositions(int number, int K, int M) {
    std::vector<std::vector<int>> dp(K + 1, std::vector<int>(number + 1, 0));
    dp[0][0] = 1;

    for (int k = 1; k <= K; k++) {
        for (int n = 1; n <= number; n++) {
            for (int i = 1; i <= std::min(n, M); i++) {
                dp[k][n] += dp[k - 1][n - i];
            }
        }
    }

    return dp[K][number];
}

int main() {
    int K, M, number, number2;
    std::cin >> K >> M >> number >> number2;

    int count = countDecompositions(number, K, M);
    int count2 = countDecompositions(number2, K, M);

    if (count > count2) {
        std::cout << "First" << std::endl;
    } else if (count < count2) {
        std::cout << "Second" << std::endl;
    } else {
        std::cout << "Equal" << std::endl;
    }

    return 0;
}
