def count_decompositions(number, K, M, count=0):
    if number == 0 and K == 0:
        # Если число разложено и количество слагаемых достигло K,
        # увеличиваем счетчик на 1
        count += 1
        return count
    if number < 0 or K < 0:
        # Недопустимое разложение
        return count
    for i in range(1, min(number, M) + 1):
        # Рекурсивно разлагаем number - i на K - 1 слагаемых,
        # с учетом ограничения M
        count = count_decompositions(number - i, K - 1, M, count)
    return count

K = int(input()) # число запусков рулетки
K = 5
M = int(input()) # количество чисел на рулетке
number = int(input()) # сумма, на которую поставил первый игрок
number2 = int(input()) # сумма, на которую поставил второй игрок

count = count_decompositions(number, K, M)
count2 = count_decompositions(number2, K, M)
if count > count2:
    print('First')
elif count < count2:
    print('Second')
else:
    print('Equal')
