def calculate_winning_chances(N, K, S1, S2):
    # Используем массив для хранения количества способов получить каждую сумму
    dp = [[0] * (N * K + 1) for _ in range(N + 1)]
    dp[0][0] = 1  # Начальное значение: один способ получить сумму 0 после 0 вращений

    for i in range(1, N + 1):
        for j in range(1, K + 1):
            for s in range(i, i * K + 1):
                dp[i][s] = 0
                for prev in range(max(0, s - K), s):
                    dp[i][s] += dp[i - 1][prev]

    chances1 = dp[N][S1]
    chances2 = dp[N][S2]

    if chances1 > chances2:
        return 'First'
    elif chances1 < chances2:
        return 'Second'
    else:
        return 'Equal'

# Вводим значения N, K, S1 и S2
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = calculate_winning_chances(N, K, S1, S2)
print(result)
