#include <iostream>
#include <math.h>
#include <vector>
#include <utility>
#include <cmath>
#include <algorithm>

int main() {
    int n;
    std::cin >> n;
    std::vector<std::pair<int, int>> a(n, std::pair<int, int>(0, 0));
    std::vector<double> dist(n, 0);
    std::cin >> a[0].first >> a[0].second;
    for (int i = 1; i < n; ++i) {
        std::cin >> a[i].first >> a[i].second;
        dist[i - 1] = sqrt(pow((a[i].first - a[i - 1].first), 2) + pow((a[i].second - a[i - 1].second), 2));
    }
    dist[n - 1] = sqrt(pow((a[0].first - a[n - 1].first), 2) + pow((a[0].second - a[n - 1].second), 2));

    double sum{ 0 };
    std::sort(dist.begin(), dist.end());
    for (int i = 0; i < n - 1; ++i) {
        sum += dist[i];
    }
    std::cout << sum << '\n';
    return 0;
}