def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def find_pair_with_max_gcd(L, R):
    max_gcd = 0
    max_gcd_pair = None

    for x in range(L, R+1):
        for y in range(x+1, R+1):
            current_gcd = gcd(x, y)
            if current_gcd > max_gcd:
                max_gcd = current_gcd
                max_gcd_pair = (x, y)

    return max_gcd_pair

L, R = list(map(int, input().split()))

pair = find_pair_with_max_gcd(L, R)
print(* pair)