def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def find_max_gcd_pair(L, R):
    max_gcd = 1
    max_gcd_pair = (L, L + 1)

    for i in range(L, R):
        for j in range(i + 1, R + 1):
            current_gcd = gcd(i, j)
            if current_gcd > max_gcd:
                max_gcd = current_gcd
                max_gcd_pair = (i, j)

    return max_gcd_pair


L = int(input())
R = int(input())

result_pair = find_max_gcd_pair(L, R)
print(result_pair[0], result_pair[1])
