def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def find_max_gcd_pair(L, R):
    max_gcd = 1
    max_gcd_pair = (L, L + 1)  

    for i in range(R, L, -1):
        current_gcd = gcd(i, i - 1)
        if current_gcd > max_gcd:
            max_gcd = current_gcd
            max_gcd_pair = (i, i - 1)
            if max_gcd > 1:
                break  

    return max_gcd_pair


L = int(input())
R = int(input())

result_pair = find_max_gcd_pair(L, R)
print(result_pair[0], result_pair[1])
