#include <bits/stdc++.h>
//
// Created by skygrel19 on 10/14/23.
//
//

using namespace std;

#define ll long long

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for(int i = 1; i < n - 1; i++) cin >> a[i];
    vector <int> last_pos(n);
    vector <int> v(n);
    for(int i = n - 1; i >= 0; i--){
        if(v[i]) continue;
        vector <int> path;
        int ind = i;
        while(a[ind] != 0){
            path.push_back(ind);
            ind -= a[ind];
        }
        for(int j = 0; j < path.size(); j++){
            last_pos[path[j]] = ind;
        }
        last_pos[i] = ind;
    }
    for(int i = 0; i < n; i++){
        cout << last_pos[i] << " ";
    }
    cout << endl;

    vector <vector <int>> dp(n, vector <int>(7, 2 * n));
    dp[0][0] = 0;

    priority_queue <pair <int, pair <int, int>>> q;
    q.push({0, {0, 0}});

    while(!q.empty()){
        int k = q.top().first;
        int ind = q.top().second.first;
        int last = q.top().second.second;
        //cout << -k << " " << ind << " " << last << endl;
        q.pop();
        for(int i = 1; i <= 6; i++){
            if(ind + i >= n) break;
            int nxt = last_pos[ind + i];
            if(i == 6){
                if(dp[ind][last] < dp[nxt][i]){
                    dp[nxt][i] = dp[ind][last];
                    q.push({-dp[nxt][i],{nxt, i}});
                }
            } else {
                if(dp[ind][last] + 1 < dp[nxt][i]){
                    dp[nxt][i] = dp[ind][last] + 1;
                    q.push({-dp[nxt][i],{nxt, i}});
                }

            }
        }
    }

    int nmin = 2 * n;
    for(int i = 0; i < 7; i++){
        nmin = min(nmin, dp[n-1][i]);
    }
    if(nmin == 2 * n) cout << -1;
    else cout << nmin << endl;


}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}