///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

const int MAX_N = 1e3 + 5;

int n, m, k;
char a[MAX_N][MAX_N];

int tail = 0;
pii Q[MAX_N * MAX_N];

const int inf = 1e9;
int dist[MAX_N][MAX_N];

vector<int> dx = {-1, 0, 1, 0};
vector<int> dy = {0, -1, 0, 1};

bool in(int i, int j) {
	return 1 <= i && i <= n && 1 <= j && j <= m;
}

void solve() {
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
    	string row;
    	cin >> row;
    	for (int j = 0; j < m; ++j) {
    		a[i + 1][j + 1] = row[j];
    	}
    }
    int si, sj;
    cin >> si >> sj;
  	int fi, fj;
  	cin >> fi >> fj;
  	for (int i = 1; i <= n; ++i) {
  		for (int j = 1; j <= m; ++j) {
  			dist[i][j] = inf;
  		}
  	}
  	dist[si][sj] = 0;
  	deque<pii> Q;
  	Q.push_front({si, sj});
  	while (!Q.empty()) {
  		int i = Q.front().first, j = Q.front().second;
  		Q.pop_front();
  		for (int t = 0; t < 4; ++t) {
  			int i1 = i + dx[t], j1 = j + dy[t];
  			if (in(i1, j1) && a[i][j] == '.' && dist[i][j] < dist[i1][j1]) {
  				dist[i1][j1] = dist[i][j];
  				Q.push_front({i1, j1});
  			}
  		}
  		for (int t = 0; t < 4; ++t) {
  			int i1 = i + dx[t] * 2, j1 = j + dy[t] * 2;
  			if (in(i1, j1) && a[i][j] == '.' && dist[i][j] + 1 < dist[i1][j1]) {
  				dist[i1][j1] = dist[i][j] + 1;
  				Q.push_back({i1, j1});
  			}
  		}
  	}
  	if (dist[fi][fj] <= k) cout << "YES\n";
  	else cout << "NO\n";
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        