///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

const int MAXN = 1e3 + 10;

vector<int> g[MAXN]; //	on road
vector<int> h[MAXN]; // aim

vector<int> red;

void addRed(int v) {
	for (auto to : g[v]) {
		addRed(to);
	}
	red.push_back(v);
}

void dfs(int v) {
	int i = 0, j = 0;
	while (i < sz(g[v]) && j < sz(h[v])) {
		if (g[v][i] == h[v][j]) {
			dfs(g[v][i]);
			i++;
			j++;
			continue;
		}
		if (g[v][i] < h[v][j]) { //find red vertex
			addRed(g[v][i]);
			i++;
			continue;
		} else { // g[v][i] > h[v][j], needs new vertexes
			j++;
			continue;
		}
	}
	while (i < sz(g[v])) { //all are red
		addRed(g[v][i]);
		i++;
	}
}

int realP[MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
    	int p;
    	cin >> p;
    	g[p].push_back(i);
    }

    for (int i = 1; i < n; i++) {
    	cin >> realP[i];
    	h[realP[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
    	sort(all(g[i]));
    	sort(all(h[i]));
    }
    dfs(0);
    vector<pii> ans;
    for (auto el : red) {
    	ans.push_back({el, realP[el]});
    }
    cout << sz(ans) << '\n';
    for (auto el : ans) {
    	cout << el.f _ el.s << '\n';
    }
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        