#pragma GCC optimize("Ofast")
#pragma comment(linker, "/stack:200000000")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cstdio>
#include <iomanip>

using namespace std;

mt19937 rnd(239);

long long sqr(int x) {
  return 1ll * x * x;
}

int main(void) {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  long long n;
  long long k;
  cin >> n >> k;
  long long s1, s2;
  cin >> s1 >> s2;
  s1 *= 2;
  s2 *= 2;

  long long d1 = abs((k + 1) * n - s1);
  long long d2 = abs((k + 1) * n - s2);

  if (s1 > 2 * n * k && s2 > 2 * n * k) {
    cout << "Equal";
    return 0;
  }

  if (s2 > 2 * n * k) {
    cout << "First";
    return 0;
  }

  if (s1 > 2 * n * k) {
    cout << "Second";
    return 0;
  }

  if (d1 == d2) {
    cout << "Equal";
    return 0;
  }
  if (d1 < d2) {
    cout << "First";
    return 0;
  }
  if (d1 > d2) {
    cout << "Second";
    return 0;
  }
}