#pragma GCC optimize("Ofast")
#pragma comment(linker, "/stack:200000000")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cstdio>
#include <map>
#include <iomanip>

using namespace std;

mt19937 rnd(239);

long long sqr(int x) {
  return 1ll * x * x;
}

int main(void) {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int q;
  cin >> q;
  map<string, int> occur;
  while (q--) {
    string s;
    cin >> s;
    if (occur.count(s) == 0) {
      cout << s << "\n";
      occur[s] = 0;
    }
    else {
      occur[s]++;
      while (occur.count(s + to_string(occur[s]))) {
        occur[s]++;
      }
      cout << s << occur[s] << "\n";
      occur[s + to_string(occur[s])] = 0;
    }
  }
}