#include <bits/stdc++.h>

using namespace std;

const int dx[] = {-1, 1, 0, 0}, dy[] = {0, 0, -1, 1};

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0), cout.tie(0);

  int n, m, k;
  cin >> n >> m >> k;
  vector<string> s(n);
  auto ok = [&](int x, int y) {
    return 0 <= x and x < n and 0 <= y and y < m and s[x][y] == '.';
  };
  for (int i = 0; i < n; ++i) cin >> s[i];
  vector d(n, vector<int>(m, (int)1e9));
  int sx, sy, fx, fy;
  cin >> sx >> sy >> fx >> fy;
  --sx, --sy, --fx, --fy;
  d[sx][sy] = 0;
  deque<pair<int, int>> q;
  q.emplace_front(sx, sy);
  while (!q.empty()) {
    auto [x, y] = q.front();
    q.pop_front();
    for (int it = 0; it < 4; ++it) {
      int nx = x + dx[it], ny = y + dy[it];
      if (ok(nx, ny) and d[nx][ny] > d[x][y]) {
        d[nx][ny] = d[x][y];
        q.emplace_front(nx, ny);
      }
      nx += dx[it];
      ny += dy[it];
      if (ok(nx, ny) and d[nx][ny] > d[x][y] + 1) {
        d[nx][ny] = d[x][y] + 1;
        q.emplace_back(nx, ny);
      }
    }
  }
  cout << (d[fx][fy] <= k ? "YES" : "NO") << '\n';

  return 0;
}
