#include <bits/stdc++.h>

using namespace std;

void myassert(bool f) {
  if (!f) {
    while (true) {}
  }
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0), cout.tie(0);

  int n;
  cin >> n;
  vector<int> p1(n), p2(n);
  vector<vector<int>> g1(n), g2(n);
  for (int i = 1; i < n; ++i) {
    cin >> p1[i];
    g1[p1[i]].push_back(i);
  }
  for (int i = 1; i < n; ++i) {
    cin >> p2[i];
    g2[p2[i]].push_back(i);
  }
  vector<int> sz1(n, 1), sz2(n, 1);
  function<void(int)> dfs1 = [&](int v) {
    for (int to : g1[v]) {
      dfs1(to);
      sz1[v] += sz1[to];
    }
  };
  dfs1(0);
  function<void(int)> dfs2 = [&](int v) {
    for (int to : g2[v]) {
      dfs2(to);
      sz2[v] += sz2[to];
    }
  };
  dfs2(0);
  vector<pair<int, int>> ans;
  auto getsize = [&](int v, int t) {
    if (v == -1) return 0;
    else if (t == 1) return sz1[v];
    else if (t == 2) return sz2[v];
  };
  vector ispar1(n, vector<char>(n));
  function<void(int, int)> zhfs1 = [&](int v, int p) {
    ispar1[v][p] = true;
    for (int to : g1[v]) {
      zhfs1(to, p);
    }
  };
  auto erase = [&](int v, int u) {
    g1[v].erase(find(g1[v].begin(), g1[v].end(), u));
  };
  for (int i = 0; i < n; ++i) zhfs1(i, i);
  vector<int> deg(n);
  for (int i = 0; i < n; ++i) ++deg[p1[i]];
  vector<int> last(n, -1);
  function<void(int, set<pair<int, int>>&)> wtf = [&](int v, set<pair<int, int>>& degs) {
    if (v == -1) return;
    degs.emplace(deg[v], v);
    for (int to : g1[v]) {
      wtf(to, degs);
    }
  };
  function<void(int, int)> match = [&](int v1, int v2) {
    if (v2 == -1) return;
    //cout << v1 << ' ' << v2 << endl;
    int l1 = (g1[v1].size() <= 0 ? -1 : g1[v1][0]), r1 = (g1[v1].size() <= 1 ? -1 : g1[v1][1]);
    int l2 = (g2[v2].size() <= 0 ? -1 : g2[v2][0]), r2 = (g2[v2].size() <= 1 ? -1 : g2[v2][1]);
    //cout << v1 << ' ' << v2 << endl;
    //cout << leafs.size() << ' ' << getsize(l2, 2) + getsize(r2, 2) << endl;
    set<pair<int, int>> L, R;
    wtf(l1, L);
    wtf(r1, R);
    int x = L.size(), y = getsize(l2, 2);
    //cout << L.size() + R.size() + leafs.size() << ' ' << getsize(l2, 2) + getsize(r2, 2) << endl;
    myassert(L.size() + R.size() == getsize(l2, 2) + getsize(r2, 2));
    //cout << L.size() << ' ' << R.size() << endl;
    while (x < y) {
      assert(!R.empty() and R.begin()->first == 0);
      int vv = R.begin()->second;
      R.erase(R.begin());
      erase(p1[vv], vv);
      R.erase({deg[p1[vv]], p1[vv]});
      --deg[p1[vv]];
      R.insert({deg[p1[vv]], p1[vv]});
      int par;
      if (L.empty()) par = v1, l1 = vv;
      else par = L.begin()->second;
      p1[vv] = par;
      g1[par].push_back(vv);
      last[vv] = par;
      L.emplace(v1, 0);
      if (v1 != par) {
        L.erase({deg[p1[vv]], p1[vv]});
        ++deg[p1[vv]];
        L.insert({deg[p1[vv]], p1[vv]});
      }
      ++x;
    }
    while (x > y) {
      assert(!L.empty() and L.begin()->first == 0);
      int vv = L.begin()->second;
      L.erase(L.begin());
      erase(p1[vv], vv);
      L.erase({deg[p1[vv]], p1[vv]});
      --deg[p1[vv]];
      L.insert({deg[p1[vv]], p1[vv]});
      int par;
      if (R.empty()) par = v1, r1 = vv;
      else par = R.begin()->second;
      p1[vv] = par;
      g1[par].push_back(vv);
      last[vv] = par;
      R.emplace(v1, 0);
      if (v1 != par) {
        R.erase({deg[p1[vv]], p1[vv]});
        ++deg[p1[vv]];
        R.insert({deg[p1[vv]], p1[vv]});
      }
      --x;
    }
    //cout << leafsL.size() << ' ' << leafsR.size() << endl;
    if (L.empty()) l1 = -1;
    if (R.empty()) r1 = -1;
    match(l1, l2);
    match(r1, r2);
  };
  match(0, 0);
  for (int i = 0; i < n; ++i) {
    if (last[i] != -1) {
      ans.emplace_back(i, last[i]);
    }
  }
  assert(ans.size() <= n);
  cout << ans.size() << '\n';
  for (auto [u, v] : ans) {
    cout << u << ' ' << v << '\n';
  }

  return 0;
}
