#include <bits/stdc++.h>

using namespace std;

void myassert(bool f) {
  if (!f) {
    while (true) {}
  }
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0), cout.tie(0);

  int n;
  cin >> n;
  vector<int> p1(n), p2(n);
  vector<vector<int>> g1(n), g2(n);
  for (int i = 1; i < n; ++i) {
    cin >> p1[i];
    g1[p1[i]].push_back(i);
  }
  for (int i = 1; i < n; ++i) {
    cin >> p2[i];
    g2[p2[i]].push_back(i);
  }
  vector<int> sz1(n, 1), sz2(n, 1);
  function<void(int)> dfs1 = [&](int v) {
    for (int to : g1[v]) {
      dfs1(to);
      sz1[v] += sz1[to];
    }
  };
  dfs1(0);
  function<void(int)> dfs2 = [&](int v) {
    for (int to : g2[v]) {
      dfs2(to);
      sz2[v] += sz2[to];
    }
  };
  dfs2(0);
  vector<pair<int, int>> ans;
  auto getsize = [&](int v, int t) {
    if (v == -1) return 0;
    else if (t == 1) return sz1[v];
    else if (t == 2) return sz2[v];
  };
  vector ispar1(n, vector<char>(n));
  function<void(int, int)> zhfs1 = [&](int v, int p) {
    ispar1[v][p] = true;
    for (int to : g1[v]) {
      zhfs1(to, p);
    }
  };
  for (int i = 0; i < n; ++i) zhfs1(i, i);
  vector<int> deg(n);
  for (int i = 0; i < n; ++i) ++deg[p1[i]];
  function<void(int, int, int, vector<int>, set<pair<int, int>>)> match = 
  [&](int v1, int v2, int par1, vector<int> leafs, set<pair<int, int>> degs) {
    if (v2 == -1) return;
    if (degs.empty()) {
      myassert(v1 == -1);
      queue<pair<int, int>> q;
      myassert(!leafs.empty());
      ans.emplace_back(leafs.back(), par1);
      q.emplace(v2, leafs.back());
      leafs.pop_back();
      while (!q.empty()) {
        auto [u, r] = q.front();
        q.pop();
        for (int to : g2[u]) {
          myassert(!leafs.empty());
          ans.emplace_back(leafs.back(), r);
          q.emplace(to, leafs.back());
          leafs.pop_back();
        }
      }
      myassert(leafs.empty());
      return;
    }
    myassert(~v1);
    int l1 = (g1[v1].size() <= 0 ? -1 : g1[v1][0]), r1 = (g1[v1].size() <= 1 ? -1 : g1[v1][1]);
    int l2 = (g2[v2].size() <= 0 ? -1 : g2[v2][0]), r2 = (g2[v2].size() <= 1 ? -1 : g2[v2][1]);
    //cout << v1 << ' ' << v2 << endl;
    //cout << leafs.size() << ' ' << getsize(l2, 2) + getsize(r2, 2) << endl;
    set<pair<int, int>> L, R;
    for (auto [d, vert] : degs) {
      if (vert == v1) continue;
      if (ispar1[vert][l1]) L.emplace(d, vert);
      else R.emplace(d, vert);
    }
    int x = L.size(), y = getsize(l2, 2);
    assert(L.size() + R.size() + leafs.size() == getsize(l2, 2) + getsize(r2, 2));
    vector<int> leafsL = leafs, leafsR;
    while (x + leafsL.size() < y) {
      assert(!R.empty() and R.begin()->first == 0);
      int vv = R.begin()->second;
      R.erase(R.begin());
      leafsL.push_back(vv);
      R.erase({deg[p1[vv]], p1[vv]});
      --deg[p1[vv]];
      R.insert({deg[p1[vv]], p1[vv]});
    }
    while (x + leafsL.size() > y) {
      if (!leafsL.empty()) {
        leafsR.push_back(leafsL.back());
        leafsL.pop_back();
        continue;
      }
      assert(!L.empty() and L.begin()->first == 0);
      int vv = L.begin()->second;
      L.erase(L.begin());
      leafsR.push_back(vv);
      L.erase({deg[p1[vv]], p1[vv]});
      --deg[p1[vv]];
      L.insert({deg[p1[vv]], p1[vv]});
      --x;
    }
    //cout << leafsL.size() << ' ' << leafsR.size() << endl;
    match(l1, l2, v1, leafsL, L);
    match(r1, r2, v1, leafsR, R);
  };
  set<pair<int, int>> degs;
  for (int i = 0; i < n; ++i) degs.emplace(deg[i], i);
  match(0, 0, -1, vector<int>{}, degs);
  assert(ans.size() <= n);
  cout << ans.size() << '\n';
  for (auto [u, v] : ans) {
    cout << u << ' ' << v << '\n';
  }

  return 0;
}
