#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <vector>

using namespace std;

int used[1000];
int biection[1000];
int parent[1000];
vector<vector<int>> g1;
vector<vector<int>> g2;
int n;

void dfs(int pos1, int pos2) {
    biection[pos1] = pos2;
    used[pos1] = 1;
    for(int i=0; i < min(g1[pos1].size(), g2[pos2].size()); i++) {
        dfs(g1[pos1][i], g2[pos2][i]);
    }
}

int main() {
    cin >> n;
    for (int i=0; i < n; i++) {
        biection[i] = -1;
        g1.push_back(vector<int>());
        g2.push_back(vector<int>());
    }
    for (int i = 0; i < n-1; i++)
    {
        int a;
        cin >> a;
        g1[a].push_back(i + 1);
        parent[i+1] = a;
    }
    for (int i = 0; i < n-1; i++)
    {
        int a;
        cin >> a;
        g2[a].push_back(i + 1);
    }

    vector<pair<int, int>> res;

    dfs(0, 0);
    bool flag = true;
    while(flag) {
        flag = false;
        for (int pos = 0; pos < n; pos++) {
            if (used[pos] == 0) continue;
            if (g1[pos].size() < g2[biection[pos]].size()) {
                flag = true;
                for (int pos2 = 0; pos2 < n; pos2++) {
                    if (used[pos2] == 0) {
                        ///
                        int pos3 = parent[pos2];
                        if (g1[pos3].size() == 1) {
                            g1[pos3].pop_back();
                        }
                        else {
                            if (g1[pos3][0] == pos2) g1[pos3][0] = g1[pos3][1];
                            g1[pos3].pop_back();
                        }

                        g1[pos].push_back(pos2);
                        dfs(pos2, g2[biection[pos]][g1[pos].size()-1]);

                        res.push_back(pair<int, int>(pos2, pos));
                        ///
                        break;
                    }
                }
            }
        }
    }
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); i++) {
        cout << res[i].first << " " << res[i].second << "\n";
    }
}