#include <iostream>
#include <fstream>
#include <numeric>
#include <algorithm>
#include <utility>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
 
#define inf 1e9
#define eps 1e-9
 
typedef long long ll;
 
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    ifstream fin("input.txt");
    ofstream fout("output.txt");
 
    int n, k;
    
    unordered_map<string,int> m;
    string name;
 
    cin >> n;
 
    for (int i = 0; i < n; ++i) {
        cin >> name;

        auto it = m.find(name);

        if (it == m.end()) {
            m[name] = 1;
            cout << name << "\n";
        } else {
            auto _it = m.find(name + to_string(m[name]));
            
            while (_it != m.end()) {
                m[name]++;
                _it = m.find(name + to_string(m[name]));
            }

            m[name + to_string(m[name])] = 1;
            
            cout << name << to_string(it->second) << "\n";
            it->second++;
        }
    }
}