#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int INF = 1e9;
const ll INFLL = 3 * 1e18;

#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> g(n);
    for (int i = 0; i < n; i++) {
        cin >> g[i];
    }
    int si, sj, ei, ej, s, e;
    cin >> si >> sj >> ei >> ej;
    si--;
    sj--;
    ei--;
    ej--;
    s = si * m + sj;
    e = ei * m + ej;
    vector<int> dist(n * m, INF);
    dist[s] = 0;
    queue<int> q;
    q.push(s);
    auto check = [&](int i, int j) { return (i >= 0 && i < n) && (j >= 0 && j < m) && g[i][j] == '.'; };
    vector<int> plusi = {+1, -1, 0, 0};
    vector<int> plusj = {0, 0, +1, -1};
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        int vi = v / m;
        int vj = v % m;
        for (int i = 0; i < 4; i++) {
            int toi = vi + plusi[i];
            int toj = vj + plusj[i];
            int to = toi * m + toj;
            if (check(toi, toj) && (dist[to] > dist[v])) {
                q.push(to);
                dist[to] = dist[v];
            }

            toi = vi + plusi[i] * 2;
            toj = vj + plusj[i] * 2;
            to = toi * m + toj;
            if (check(toi, toj) && (dist[to] > dist[v] + 1)) {
                q.push(to);
                dist[to] = dist[v] + 1;
            }
        }
    }
    if (dist[e] > k) {
        cout << "NO";
    }
    else {
        cout << "YES";
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}
