#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int INF = 1e9;
const ll INFLL = 3 * 1e18;

#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()
vector<pair<int, int>> ans;
vector<vector<int>> ga;
vector<vector<int>> gb;
vector<int> sza;
vector<int> szb;

void prec(int v, vector<vector<int>> &g, vector<int> &sz) {
    sz[v] = 1;
    if (g[v].empty()) {
        return;
    }
    for (auto u: g[v]) {
        prec(u, g, sz);
        sz[v] += sz[u];
    }
    if (g[v].size() == 2 && sz[g[v][0]] > sz[g[v][1]]) {
        swap(g[v][0], g[v][1]);
    }
}

int szbf(int v, int dir) {
    if (gb[v].empty()) return 0;
    if (gb[v].size() == 1) {
        if (dir == 0) return szb[gb[v][0]];
        else return 0;
    } else return szb[gb[v][dir]];
}

int szaf(int v, int dir) {
    if (ga[v].empty()) return 0;
    if (ga[v].size() == 1) {
        if (dir == 0) return sza[ga[v][0]];
        else return 0;
    } else return sza[ga[v][dir]];
}

int pop(int va, int p) {
    while (!ga[va].empty()) {
        p = va;
        va = ga[va].front();
    }
    if (ga[p].size() == 1) ga[p].pop_back();
    else {
        swap(ga[p][0], ga[p][1]);
        ga[p].pop_back();
    }
    return va;
}

int push(int va, int odir, int u) {
    if (ga[va].size() == 1 && odir == 1 || ga[va].size() == 0) {
        ga[va].push_back(u);
    } else {
        va = ga[va][odir];
        while (ga[va].size() == 2) va = ga[va].back();
        ga[va].push_back(u);
    }
    return va;
}

void transfer(int va, int dir) {
    int odir = int(!dir);
    int u = pop(ga[va][dir], va);
    ans.push_back({u, 0});
    ans.back().second = push(va, odir, u);
    prec(0, ga, sza);
}

void
dfs(int va, int vb) {
    if (ga[va].empty()) return;
    else if (ga[va].size() == 1) dfs(ga[va][0], gb[vb][0]);
    else {
        while (szaf(va, 0) != szbf(vb, 0)) transfer(va, int(szaf(va, 0) < szbf(vb, 0)));

        dfs(ga[va][0], gb[vb][0]);
        dfs(ga[va][1], gb[vb][1]);
    }
}

void solve() {
    int n;
    cin >> n;
    ga.resize(n);
    gb.resize(n);
    sza.assign(n, 1), szb.assign(n, 1);
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        ga[x].push_back(i);
    }
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        gb[x].push_back(i);
    }
    prec(0, ga, sza);
    prec(0, gb, szb);
    dfs(0, 0);
    cout << (int) ans.size() << '\n';
    for (auto it: ans) {
        cout << it.first << ' ' << it.second;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}
