import re
from collections import deque

def binsearch(lsts, e):
  if lsts[0][0] > e:
    return -1

  l = 0
  r = len(lsts)
  while r - l > 1:
    m = (l + r) // 2
    if lsts[m][0] > e:
      r = m
    else:
      l = m

  return l

def repair(lsts):
  if len(lsts) < 1:
    return
  while len(lsts) > 2:
    if lsts[0][1] + 1 < lsts[1][0]:
      break

    l, _ = lsts[0]
    lsts.popleft()
    lsts[0][0] = l

def findEmpty(cur, clear, chislo):
    findi = binsearch(cur, int(chislo))
    if findi == -1:
      print(clear + chislo)
      cur.appendleft([int(chislo), int(chislo)])
      return True
    elif cur[findi][1] < int(chislo):
      print(clear + chislo)
      cur.insert(findi+1, [int(chislo), int(chislo)])
      return True
    else:
      return False

def findDigit(cur, clear, chislo):
  skokamod = 10
  ch = chislo + "1"
  while True:
    findi = binsearch(cur, int(ch))
    if cur[findi][1] < int(ch):
      print(clear + ch)
      cur.insert(findi+1, [int(ch), int(ch)])
      return
    else:
      lasts = cur[findi][1] % skokamod
      if lasts != skokamod - 1:
        print(f"{clear}{cur[findi][1] + 1}")
        cur[findi][1] += 1
        return
      else:
        ch = chislo + str(skokamod)
        skokamod *= 10


Q = int(input())

bd = dict() # elems: deque[(int, int)]

for _ in range(Q):
  name = input()
  mtch = re.search("\d+$", name)

  if mtch is None:
    if name not in bd:
      print(name)
      bd[name] = deque()
      bd[name].appendleft([0, 0])
    else:
      cur = bd[name]
      repair(cur)

      if cur[0][0] != 0:
        print(name)
        cur.appendleft([0, 0])
      else:
        print(f"{name}{cur[0][1] + 1}")
        cur[0][1] += 1

  else:
    chislo = mtch.group(0)
    clear = name[:-len(chislo)]

    if clear not in bd:
      print(name)
      bd[clear] = deque()
      bd[clear].append([int(chislo), int(chislo)])
    else:
      cur = bd[clear]
      if not findEmpty(cur, clear, chislo):
        findDigit(cur, clear, chislo)