import re
from collections import deque

def binsearch(lsts, e):
  if lsts[0][0] > e:
    return -1

  l = 0
  r = len(lsts)
  while r - l > 1:
    m = (l + r) // 2
    if lsts[m][0] > e:
      r = m
    else:
      l = m

  return l

def repair(lsts):
  if len(lsts) < 1:
    return
  while len(lsts) > 1:
    if lsts[0][1] + 1 < lsts[1][0]:
      break

    l, _ = lsts[0]
    lsts.popleft()
    lsts[0][0] = l

def findEmpty(cur, clear, chislo):
    findi = binsearch(cur, int(chislo))
    if findi == -1:
      print(clear + chislo)
      cur.appendleft([int(chislo), int(chislo)])
      return True
    elif cur[findi][1] < int(chislo):
      print(clear + chislo)
      cur.insert(findi+1, [int(chislo), int(chislo)])
      return True
    else:
      return False

def findDigit(cur, clear, chislo):
  skokamod = 10
  ch = chislo + "1"
  while True:
    findi = binsearch(cur, int(ch))
    if cur[findi][1] < int(ch):
      print(clear + ch)
      cur.insert(findi+1, [int(ch), int(ch)])
      return
    else:
      if cur[findi][1] < int(chislo + str(skokamod - 1)):
        print(f"{clear}{cur[findi][1] + 1}")
        cur[findi][1] += 1
        return
      else:
        ch = chislo + str(skokamod)
        skokamod *= 10


Q = int(input())

bd = dict() # elems: deque[(int, int)]
# osnova = "qwerty"
# vhod = [osnova] * 12 + [osnova + "11"] + [osnova] * 100 + [osnova + "100"] * 20 + [osnova + "1001"] + [osnova + "0"] + [osnova + "01"] * 2 + [osnova + "0"]
# Q = len(vhod)

for abcdefg in range(Q):
  name = input()
  # name = vhod[abcdefg]
  mtch = re.search("(\d)+$", name)
  if mtch is not None and int(mtch.group(0)) == 0:
    mtch = None

  if mtch is None:
    if name not in bd:
      print(name)
      bd[name] = deque()
      bd[name].appendleft([0, 0])
    else:
      cur = bd[name]
      repair(cur)

      if cur[0][0] != 0:
        print(name)
        cur.appendleft([0, 0])
      else:
        print(f"{name}{cur[0][1] + 1}")
        cur[0][1] += 1

  else:
    chislo = mtch.group(0)
    cheche = int(chislo)
    clear = name[:-len(chislo)]
    clear += chislo[:-len(str(cheche))]


    if clear not in bd:
      print(name)
      bd[clear] = deque()
      bd[clear].append([cheche, cheche])
    else:
      cur = bd[clear]
      if not findEmpty(cur, clear, str(cheche)):
        findDigit(cur, clear, str(cheche))