#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif

#include <iostream>
#include <vector>
#include <queue>
#include <string>
#include <set>

using namespace std;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("period.txt", "w", stdout);
#endif

	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<int> g(n);
	g[0] = g[1] = 0;
	g[2] = 1;
	for (int i = 3; i < n; i++) {
		vector<int> set;
		for (int k = 0; i - k - 2 >= k; k++)
			set.push_back(g[k] ^ g[i - k - 2]);
		g[i] = mex(set);
	}
	cout << n << '\n';
	for (int i = 0; i < n; i++)
		cout << g[i] << ' ';
}