#define _CRT_SECURE_NO_WARNINGS
#define INF 1e9
#define ACC 1e-6
#define FAC_10 3628800
#define ll long long

#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

struct detail {
    ll current;
    ll target;
};

bool operator<(const detail& fst, const detail& snd) {
    if (fst.target == snd.target)
        return fst.current < snd.current;
    return fst.target < snd.target;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    int res = n / (k + 2) * 2;
    int rem = n % (k + 2);
    if (k % 2 == 0)
        res += rem > k / 2;
    else 
        res += rem > k / 2 + 1;
    cout << res;
}