#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
 
using namespace std;
 
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    long long maxim = 0;
    double sum = 0;
    long long x, y;
    cin >> x >> y;
    long long fx = x;
    long long fy = y;
    for (int i = 1; i < n; i++) {
        long long x1, y1;
        cin >> x1 >> y1;
        long long diff = (x1 - x) * (x1 - x) + (y1 - y) * (y1 - y);
        // cout << "diff = " << diff << "; sum = " << sum << endl;
        sum += sqrt(diff);
        if (diff > maxim) {
            maxim = diff;
        }
        x = x1;
        y = y1;
    }
    long long diff = (fx - x) * (fx - x) + (fy - y) * (fy - y);
    sum += sqrt(diff);
    if (diff > maxim) {
        maxim = diff;
    }
    cout << setprecision(7) << fixed << sum - sqrt(maxim) << endl;
}