#define _CRT_SECURE_NO_WARNINGS
#include <assert.h>

#include <algorithm>
#include <array>
#include <string_view>
#include <bitset>
#include <chrono>
#include <fstream>
#include <functional>
#include <iomanip>
#include <variant>
#include <iostream>
#include <map>
#include <numeric>
#include <optional>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <thread>
#include <unordered_map>
#include <unordered_set>
#include <variant>
#include <vector>

using namespace std;

signed main(int argc, char** argv)
{
	int n;
	cin >> n;
	vector<int> pa(n);
	pa[0] = -1;
	for (int i = 1; i < n; i++)
	{
		cin >> pa[i];
	}
	vector<int> pb(n);
	pb[0] = -1;
	for (int i = 1; i < n; i++)
	{
		cin >> pb[i];
	}

	auto opA = [&]()
	{
		vector<int> q = { 0 };
		int two_suns = -1;
		int zero_suns = -1;
		int reroot = -1;
		for (size_t i = 0; i < q.size(); i++)
		{
			int v = q[i];
			int child = 0;
			for (int j = 0; j < n; j++)
			{
				if (pa[j] == v)
				{
					q.push_back(j);
					child++;
				}
			}
			if (child == 2 && two_suns == -1)
			{
				two_suns = v;
				reroot = q.back();
				q.pop_back();
			}
			if (child == 0)
			{
				zero_suns = v;
			}
		}
		if (two_suns == -1) return pair{ -1, -1 };
		return pair{ reroot, zero_suns };
	};

	auto opB = [&]()
	{
		vector<int> q = { 0 };
		int two_suns = -1;
		int zero_suns = -1;
		int reroot = -1;
		for (size_t i = 0; i < q.size(); i++)
		{
			int v = q[i];
			int child = 0;
			for (int j = 0; j < n; j++)
			{
				if (pb[j] == v)
				{
					q.push_back(j);
					child++;
				}
			}
			if (child == 2 && two_suns == -1)
			{
				two_suns = v;
				reroot = q.back();
				q.pop_back();
			}
			if (child == 0)
			{
				zero_suns = v;
			}
		}
		if (two_suns == -1) return array{ -1, -1, -1 };
		return array{ reroot, zero_suns, two_suns };
	};

	vector<pair<int, int> > opsA, opsB;

	while (1)
	{
		pair<int, int> tmp = opA();
		if (tmp.first == -1) break;
		pa[tmp.first] = tmp.second;
		//for (int i = 0; i < n; i++) cout << pa[i] << " ";
		//cout << "\n";
		opsA.push_back({ tmp.first, tmp.second });
	}

	while (1)
	{
		array tmp = opB();
		if (tmp[0] == -1) break;
		pb[tmp[0]] = tmp[1];

		//for (int i = 0; i < n; i++) cout << pb[i] << " ";
		//cout << "\n";
		opsB.push_back({ tmp[0], tmp[2] });
	}

	auto order = [&](vector<int> p)
	{
		vector<int> q = { 0 };
		for (int i = 0; i < n; i++)
		{
			int v = q[i];
			for (int j = 0; j < n; j++)
			{
				if (p[j] == v)
				{
					q.push_back(j);
				}
			}
		}
		return q;
	};

	vector<int> A = order(pa), B = order(pb);

	//for (auto e : A) cout << e << " "; cout << "\n";
	//for (auto e : B) cout << e << " "; cout << "\n";

	vector<int> orderInit(n);
	for (int i = 0; i < n; i++)
	{
		orderInit[B[i]] = A[i];
	}

	reverse(opsB.begin(), opsB.end());

	cout << opsA.size() + opsB.size() << "\n";
	for (int i = 0; i < opsA.size(); i++) cout << opsA[i].first << " " << opsA[i].second << "\n";
	for (int i = 0; i < opsB.size(); i++) cout << orderInit[opsB[i].first] << " " << orderInit[opsB[i].second] << "\n";
}