#include <iostream>
#include <math.h>

using namespace std;

int main(void) {
    long double n, k, s1, s2;

    cin >> n >> k >> s1 >> s2;

    long double mean = (k + (long double)1.0) / (long double)2.0 * n;

    long double maxval = n * k;

    if ((s1 < n || s1 > maxval) && (s2 < n || s2 > maxval)) {
        cout << "Equal" << endl;
        return 0;
    }

    long double d1 = fabs(mean - s1);
    long double d2 = fabs(mean - s2);
    long double eps = 1e-9;

    // cout << d1 << endl;
    // cout << d2 << endl;
    // cout << fabs(d1 - d2) << endl;

    if (fabs(d1 - d2) < eps) {
        cout << "Equal" << endl;
    } else if (d1 < d2) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }

    return 0;
}
