#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const ll INF = 1e9 + 1;
const ll MOD = 1e9 + 7;
ll MAXN = 1e6 + 1;
const ll ALPH = 26;
const ld EPS = 1e-9;
 
#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()
 
void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {
    void solve() {
        int n;
        cin >> n;

        vector<int> p(n);
        for (int i = 1; i < n - 1; i++) {
            cin >> p[i];
        }
        vector<int> next(n);
        for (int i = 0; i < n; i++) {
            next[i] = i;
        }

        for (int i = 0; i < n; i++) {
            next[i] = next[i - p[i]];
        }


        vector<int> dist(n, INF);
        queue<int> q;

        q.push(0);
        dist[0] = 0;

        while (!q.empty()) {
            int v = q.front();
            q.pop();

            int free = min(n - 1, v + 6);
            int nxt = next[free];
            if (dist[v] < dist[nxt]) {
                q.push(nxt);
                dist[nxt] = dist[v];
            }

            for (int i = 1; i < 6; i++) {
                int nfree = min(n - 1, v + i);
                nxt = next[nfree];

                if (dist[v] + 1 < dist[nxt]) {
                    dist[nxt] = dist[v] + 1;
                    q.push(nxt);
                }
            }
        }
        
        if (dist[n - 1] == INF) {
            cout << -1;
        } else {
            cout << dist[n - 1] + 1;
        }
    }
};
 
signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}