﻿#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <sstream>
#include <numeric>
#include <queue>

using namespace std;

#define int long long

const int inf = 1LL << 60;
const int mod = 1000000007;

template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1, T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int a, b;
    cin >> a >> b;
    if (a + b % 2 == 1 || a - b % 2 == 1) {
        cout << "Error" << endl;
        return 0;
    }
    if (a >= 2 && b >= 2) {
        cout << "Undefined" << endl;
        return 0;
    }
    if (b == 0) {
        cout << a / 2 << "\n0\n0" << endl;
        return 0;
    }
    if (a == 0) {
        cout << "0\n" << b / 2 << "\n0" << endl;
        return 0;
    }
    if (b == 1) {
        cout << (a - 1) / 2 << "\n0\n1" << endl;
        return 0;
    }
    if (a == 1) {
        cout << "0\n" << (b - 1) / 2 << "\n1" << endl;
        return 0;
    }
}