#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>

using namespace std;

bool check(long long x, long long n, long long k) {
    bool res = 0;
    long long l = k / 2;

    long long r = k - l;

    if (x + (x - x/2) * r + (x/2) * l <= n)
        
        res = 1;
    
    if ((n+1) % (k+2) == 0)
        if ((n+1) / (k+2) * 2 - 1 >= x)
            res = 1;
    else
        if ((n) / (k+2) * 2 >= x)
            res = 1;

    return res;
}


int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);


    long long n, k;
    cin >> n >> k;
    

    long long l=2, r=n, m;
    while (r - l > 1) {
        m = (l + r) / 2;

        if (check(m, n, k) == 1)
            l = m;
        else
            r = m;
    }
    cout << l << endl;
}