﻿#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <sstream>
#include <numeric>
#include <queue>

using namespace std;

#define int long long

const int inf = 1LL << 60;
const int mod = 1000000007;

template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1, T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int l, r;
    cin >> l >> r;
    for (int x = r - l; x >= 1; x--) {
        int k1 = (l + x - 1) / x, k2 = r / x;
        if (k1 != k2) {
            cout << x * k1 << " " << x * k2 << endl;
            return 0;
        }
    }
}