#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,bmi")
#include <bits/stdc++.h>

using namespace std;
#define int long long

const int INF = 1e9;



void source() {
    int n; cin >> n;
    vector<int> p(n);
    vector<int> nulls = {0};
    for (int i = 1; i < n - 1; ++i) {
        cin >> p[i];
        if (p[i] == 0) nulls.push_back(i);
    }
    nulls.push_back(n);

    vector<int> dp(n, INF);
    dp[0] = 0;

    for (int x : nulls) {
        for (int j = 1; j <= 5; ++j)
            if ((x + j < n) && (p[x + j] == 0)) dp[x + j] = min(dp[x + j], dp[x] + 1);
        int idx = x + 6;
        if (idx >= n) continue;
        while (p[idx] != 0)
            idx -= p[idx];
        dp[idx] = min(dp[idx], dp[x]);
    }
    if (dp[n - 1] == INF) cout << -1 << '\n';
    else cout << dp[n - 1] << '\n';
}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t; t = 1;
    while (t--) source();



    return 0;
}