#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <iomanip>
#include <algorithm>
#define ll long long

using namespace std;

bool comp(pair<int, int> a, pair<int, int> b){
    return a.first < b.first;
}

int main() {
    ll n, k, count = 0;
    double dev = 0;
    cin >> n >> k;
    vector<pair<int, int>> weight;
    vector<int> ws;
    for (int i = 0; i < n; i++) {
        double x;
        cin >> x;
        ws.push_back(x);
    }
    for (int i = 0; i < n; i++) {
        double x, y;
        x = ws[i];
        cin >> y;
        weight.push_back(make_pair(x, y));
    }

    sort(weight.begin(), weight.end(), comp);
    for(int i = 0; i < n; i++){
        dev += abs(weight[i].first - weight[i].second)/weight[i].first;
    }
    int i = 0;
    while(dev > k){
        while(weight[i].first == weight[i].second){
            i++;
        }
        if(weight[i].second > weight[i].first) {
            weight[i].second--;
        }
        else {
            weight[i].second++;
        }
        dev -= 1/weight[i].first;
        count++;
    }
    cout << count;
}