#include <stdio.h>  
#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
 
using namespace std;

long double EPS = 1e-9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    vector<long long> s(n), a(n);
    for (long long i = 0; i < n; i++) {
    	cin >> s[i];
    }
    for (long long i = 0; i < n; i++) {
    	cin >> a[i];
    }
    long double dev = 0;
    vector<pair<double, long long>> arr;
    for (long long i = 0; i < n; i++) {
    	long long cnt = abs(s[i] - a[i]);
    	long long val = s[i];
    	arr.push_back({val, cnt});
    	dev += (long double) cnt / val;
    }
    long long ans = 0;
    sort(arr.begin(), arr.end());
    long long cur = 0;
    while (dev - k > EPS) {
    	long long cnt = arr[cur].second;
    	long long val = arr[cur].first;
    	// cout << cnt << ' ' << val << endl;
    	// cout << dev << endl;
    	long double diff_dev = (long double) cnt / val; 
    	long double exp_dev = dev - diff_dev;
    	if (exp_dev - k > EPS) {
    		ans += cnt;
    		cur++;
    		dev = exp_dev;
    	}
    	else {
    		long long l = 0;
    		long long r = cnt;
    		while (r - l > 1) {
    			long long m = (l + r) / 2;
    			long double diff_dev_1 = (long double) m / val; 
		    	long double exp_dev_1 = dev - diff_dev_1;
		    	if (exp_dev_1 - k > EPS) {
		    		l = m;
		    	}
		    	else {
		    		r = m;
		    	}
    		}
    		ans += r;
    		break;
    	}
    }
    cout << ans;
}