#include <stdio.h>  
#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
 
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> pa(n, -1), pb(n, -1);
    vector<vector<int>> ga(n), gb(n);
    for (int i = 1; i < n; i++) {
    	cin >> pa[i];
    	ga[pa[i]].push_back(i);
    }
    for (int i = 1; i < n; i++) {
    	cin >> pb[i];
    	gb[pb[i]].push_back(i);
    }

    int cura = 0;
    map<int, int> mapa; 
    queue<int> qa;
    qa.push(0);
    vector<int> pra(n, -1);
    while (!qa.empty()) {
        int v = qa.front();
        mapa[cura++] = v;
        qa.pop();
        for (int u : ga[v]) {
            if (pra[u] == -1) {
                pra[u] = v;
                qa.push(u);
            }
        }
    }

    vector<vector<int>> gra(n);
    for (int i = 1; i < n; i++) {
    	gra[pra[i]].push_back(i);
    }


    int curb = 0;
    map<int, int> mapb; 
    queue<int> qb;
    qb.push(0);
    vector<int> prb(n, -1);
    while (!qb.empty()) {
        int v = qb.front();
        mapb[curb++] = v;
        qb.pop();
        for (int u : gb[v]) {
            if (prb[u] == -1) {
                prb[u] = v;
                qb.push(u);
            }
        }
    }

    set<pair<int, int>> acts;
    for (int i = 0; i < n; i++) {
    	if (pra[i] != prb[i]) {
    		acts.insert({i, prb[i]});
    	}
    }


    vector<pair<int, int>> ans;
	while (acts.size() > 0) {
		for (auto act : acts) {
			int v = act.first;
			int u = act.second;
			if (gra[u].size() < 2) {
				gra[u].push_back(v);
				int prav = pra[v];
				
				// delete
				if(gra[pra[v]].back() != v) swap(gra[pra[v]][0], gra[pra[v]][1]);
				gra[pra[v]].pop_back();

				acts.erase(act);
				ans.push_back({v, u});
				break;
			}
		}
	}    

	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << mapa[ans[i].first] << ' ' << mapb[ans[i].second] << endl;
	}
}