#include <cstdint>
#include <iostream>

using namespace std;

int main() {
  uint64_t l, r;
  cin >> l >> r;

  uint64_t d = r - l;

  uint64_t lo = 1, hi = d;
  while (lo < hi) {
    cout << lo << ' ' << hi << endl;
    uint64_t mid = (lo + hi) / 2 + 1;
    uint64_t t1 = l / mid, t2 = r / mid;
    t1 += (l % mid) ? 1 : 0;
    if (t1 < t2) {
      lo = mid;
    } else {
      hi = mid - 1;
    }
  }

  uint64_t m1 = l / lo + (l % lo ? 1 : 0);
  uint64_t a1 = m1 * lo;
  uint64_t m2 = r / lo;
  uint64_t a2 = m2 * lo;
  cout << a1 << ' ' << a2 << endl;
}
