#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <unordered_map>

using namespace std;

bool isDigit(char s) {
    return s >= '0' && s <= '9';
}

int main() {
    ios_base::sync_with_stdio(false);
    long n = 0;
    cin >> n;
    unordered_map<std::string, pair<vector<bool>, int>> nextName;
    const int maxInd = 999999999;
    for (long i = 0; i < n; i++) {
        string s;
        cin >> s;
        int ind = 0;
        for (int j = s.size() - 1; j >= 1; j++) {
            if (!isDigit(s[j])) {
                break;
            }
            string str = s.substr(0, j);
            ind += (s[j] - '0') * pow(10, s.size() - 1 - j);
            if (nextName[str].first.size() < ind + 1) {
                nextName[str].first.resize(ind + 1);
            }
            nextName[str].first[ind] = true; // taken
        }
        int firstFree = 0;
        for (int j = nextName[s].second; j < maxInd; j++) {
            if (nextName[s].first.size() < j + 1) {
                nextName[s].first.resize(j + 1);
                firstFree = j;
                nextName[s].first[j] = true; // taken
                break;
            } else {
                if (!nextName[s].first[j]) {
                    firstFree = j;
                    nextName[s].first[j] = true; // taken
                    break;
                }
            }
        }
        nextName[s].second = firstFree + 1;
        if (firstFree == 0) {
            cout << s << endl;
        } else {
            cout << s << firstFree << endl;
        }
    }
}
