#include <bits/stdc++.h>

using namespace std;

#define min(a,b) ((a<b)?a:b)

bool tryN(const vector<int>& g, const int& N, int n) {
    int cur = 0;
    int ans = 0;
    int steps = 0;

    while (cur != N - 1) {
         int next = -1;
         for (int i = 1; i <= min(6, N - 1 - cur); i++) {
            if (g[cur + i] >= next) {
                    next = g[cur + i];
                    if (i == 6) {
                        steps--;
                    }
            }
         }
         steps++;
         if (next == -1 || next <= cur) {
                 return false;
         }
         ans++;
         cur = next;
    }

    return steps <= n;
}

int32_t main() {
    ios_base::sync_with_stdio(false);

    int N;
    cin >> N;

    vector<int> p(N);
    for (int i = 1; i <= N - 2; i++)
        cin >> p[i];
    
    vector<int> g(N);
    for (int i = 0; i < N; i++)
        if (p[i] == 0)
               g[i] = i;
        else 
            g[i] = g[i - p[i]];

    int l = 0;
    int r = 2 * 100000 + 1;

    if (!tryN(g, N, r)) {
            cout << -1 << endl;
            return 0;
          }

    while (r - l > 1) {
        int m = (l + r) / 2;

        if (tryN(g, N, m))
            r = m;
        else
            l = m;

    }


    cout << r << endl;
    return 0;
}
