﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
#include <deque>
using namespace std;

#define X real()
#define Y imag()
#define int long long
#define all(X) begin(X), end(X)
#define rall(X) (X).rbegin(), (X).rend()
#define union sedaeda
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

struct node {
	int old_num;
	node *pred = nullptr;
	node *ref = nullptr;
	node *l = nullptr, *r = nullptr;
};

void dfs(node *a, node *b) {
	a->ref = b; b->ref = a;
	if (a->l != nullptr && b->l != nullptr)
		dfs(a->l, b->l);
	if (a->r != nullptr && b->r != nullptr)
		dfs(a->r, b->r);
}

void dfs2(node *v, int h, vector<pair<int, int>> &order) {
	order.push_back({ h, v->old_num });
	if (v->l != nullptr) {
		v->l->pred = v;
		dfs2(v->l, h + 1, order);
	}
	if (v->r != nullptr) {
		v->r->pred = v;
		dfs2(v->r, h + 1, order);
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
//
//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	int n; cin >> n;
	vector<node*> flata, flatb;
	flata.resize(n); flatb.resize(n);

	for (auto &i : flata)
		i = new node();
	for (auto &i : flatb)
		i = new node();

	for (int i = 1; i < n; i++) {
		int p; cin >> p;
		flata[i]->old_num = i;
		if (flata[p]->l == nullptr)
			flata[p]->l = flata[i];
		else flata[p]->r = flata[i];
	}
	for (int i = 1; i < n; i++) {
		int p; cin >> p;
		flatb[i]->old_num = i;
		if (flatb[p]->l == nullptr)
			flatb[p]->l = flatb[i];
		else flatb[p]->r = flatb[i];
	}
	
	

	dfs(flata[0], flatb[0]);
	vector<pair<int, int>> ordera;
	vector<pair<int, int>> orderb;
	dfs2(flata[0], 0, ordera);
	dfs2(flatb[0], 0, orderb);
	sort(all(ordera));
	sort(all(orderb));
	

	int j = n - 1;
	vector<pair<int, int>> ans;
	for (auto &i : orderb) {
		if (flatb[i.second]->ref != nullptr) continue;
		node *vb = flatb[i.second];
		while (flata[ordera[j].second]->ref != nullptr)
			--j;

		node *va = flata[ordera[j].second];
		node* predb = flatb[i.second]->pred;
		node* preda = predb->ref;

		if (predb->l == vb)
			preda->l = va;
		else preda->r = va;
		
		va->ref = vb;
		vb->ref = va;

		ans.push_back({ va->old_num, preda->old_num });
	}
	cout << ans.size() << "\n";
	for (auto &i : ans)
		cout << i.first << " " << i.second << "\n";
	return 0;
}