#include <bits/stdc++.h>
 
typedef long long ll;
 
#define vi              vector<int>
#define vll             vector<ll>
#define vvi             vector<vi>
#define vvl             vector<vll>
#define mii             map<int,int>
#define mll             map<ll,ll>
#define pii             pair<int,int>
#define pll             pair<ll,ll>
#define all(x)          (x).begin(), (x).end()
#define file_io         ifstream cin("knight.in"); ofstream cout("knight.out");
 
 
using namespace std;
 
mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
 
template <typename T>
istream& operator>>(istream& in, vector<T>& a) { for (size_t i = 0; i < a.size(); ++i) in >> a[i]; return in; }
 
template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) { string s = typeid(T).name(); for (const T& i : a) out << i << (s.size() < 2 ? " " : ""); out.seekp(-1, std::ios_base::end);out << '\n'; return out; }
 
 
const char nl = '\n';
const ll MOD = 1e9 + 7;
const ll MOD2 = 998244353;
const ll MOD3 = 1e6 + 7;
const ll INFLL = 1e18;
const ll MAXN = 1e6 + 100;
const ll INF = 1e9;
const ll eps = 1e-9;

bool check(int n, int m, int k) {
  return 2 * (n - m) / k >= m;
}

void solve() {
  int n, k;
  std::cin >> n >> k;
  int l = 2, r = n - k;
  while (r - l > 1) {
    int m = (l + r) / 2;
    if (check(n, m, k)) {
      l = m;
    } else {
      r = m;
    }
  }
  std::cout << l;
}
 
signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    cerr << "time taken : " << (float)clock() / CLOCKS_PER_SEC << " secs"<<nl;
    return 0;
}
