#include <bits/stdc++.h>
 
typedef long long ll;
 
#define vi              vector<int>
#define vll             vector<ll>
#define vvi             vector<vi>
#define vvl             vector<vll>
#define mii             map<int,int>
#define mll             map<ll,ll>
#define pii             pair<int,int>
#define pll             pair<ll,ll>
#define all(x)          (x).begin(), (x).end()
#define file_io         ifstream cin("knight.in"); ofstream cout("knight.out");
 
 
using namespace std;
 
mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
 
template <typename T>
istream& operator>>(istream& in, vector<T>& a) { for (size_t i = 0; i < a.size(); ++i) in >> a[i]; return in; }
 
template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) { string s = typeid(T).name(); for (const T& i : a) out << i << (s.size() < 2 ? " " : ""); out.seekp(-1, std::ios_base::end);out << '\n'; return out; }
 
 
const char nl = '\n';
const ll MOD = 1e9 + 7;
const ll MOD2 = 998244353;
const ll MOD3 = 1e6 + 7;
const ll INFLL = 1e18;
const ll MAXN = 1e6 + 100;
const ll INF = 1e9;
const ll eps = 1e-9;

void solve() {
  ll n;
  ll k;
  cin >> n >> k;
  ll f1, f2;
  cin >> f1 >> f2;
  if (f1 < n || f1 > n*k){
    if (f2 < n || f2 > n*k){
      cout<< "Equal";
    } else {
      cout << "Second";
    }
    return;
  }

  if (f2 < n || f2 > n*k){
    cout << "First";
    return;
  }

  if (n == 1){
    cout << "Equal";
    return;
  }
  
  if ((f1+f2 == n+k*n) || (f1 == f2)){
    cout << "Equal";
    return;
  }
  int offset = 0;
  ll middle = (n + k*n) / 2;
  if (middle*2 + 1 == n + n * k){
    offset = 1;
  }
  f1 = min(abs(f1 - middle), abs(f1 - middle - offset));
  f2 = min(abs(f2 - middle), abs(f2 - middle - offset));

  if (f1 > f2) cout << "Second";
  else cout << "First";
  cout << nl;
}
 
signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    cerr << "time taken : " << (float)clock() / CLOCKS_PER_SEC << " secs"<<nl;
    return 0;
}
