#include <bits/stdc++.h>
 
typedef long long ll;
 
#define vi              vector<int>
#define vll             vector<ll>
#define vvi             vector<vi>
#define vvl             vector<vll>
#define mii             map<int,int>
#define mll             map<ll,ll>
#define pii             pair<int,int>
#define pll             pair<ll,ll>
#define all(x)          (x).begin(), (x).end()
#define file_io         ifstream cin("knight.in"); ofstream cout("knight.out");
 
 
using namespace std;
 
mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
 
template <typename T>
istream& operator>>(istream& in, vector<T>& a) { for (size_t i = 0; i < a.size(); ++i) in >> a[i]; return in; }
 
template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) { string s = typeid(T).name(); for (const T& i : a) out << i << (s.size() < 2 ? " " : ""); out.seekp(-1, std::ios_base::end);out << '\n'; return out; }
 
 
const char nl = '\n';
const ll MOD = 1e9 + 7;
const ll MOD2 = 998244353;
const ll MOD3 = 1e6 + 7;
const ll INFLL = 1e18;
const ll MAXN = 1e6 + 100;
const ll INF = 1e9;
const ll eps = 1e-9;

void solve() {
  int n, m, k;
  cin >> n >> m >> k;

  vector<vector<char>> field(n, vector<char>(m));
  for (int i = 0; i < n; ++i){
    for (int j = 0; j < m; ++j){
      cin >> field[i][j];
    }
  }

  int x, y, a, b;
  cin >> x >> y >> a >> b;
  --x;--y;--a;--b;

  queue<pii> q;
  queue<pii> qj;
  q.push(make_pair(x, y));
  vector<vector<bool>> used(n, vector<bool>(m));
  vector<vector<int>> jumps(n, vector<int>(m, INT_MAX));
  jumps[x][y]= 0;
  vector<pii> dv = {{0,1}, {0, -1}, {1, 0}, {-1, 0}};

  used[x][y] = true;
  while(!q.empty() || !qj.empty()){
    if (q.empty()){
      swap(q, qj);
    }
    pii cur = q.front();
    q.pop();
    used[cur.first][cur.second] = true;
    for (int i = 0; i < 4; ++i){
      pii to = make_pair(cur.first + dv[i].first, cur.second + dv[i].second);
      if (to.first < n && to.first >= 0 && to.second < m && to.second >= 0){
        jumps[to.first][to.second] = min(jumps[to.first][to.second], jumps[to.first -  dv[i].first][to.second - dv[i].second]);
        if (!used[to.first][to.second]){
          if (field[to.first][to.second] == '.'){
            used[cur.first][cur.second] = true;
            
            q.push(to);
          } else if (field[to.first][to.second] == '#'){
            to.first += dv[i].first;
            to.second += dv[i].second;
            //cout << to.first << ' ' << to.second << nl;
            if (to.first < n && to.first >= 0 && to.second < m && to.second >= 0){
              if (!used[to.first][to.second]){
                if (field[to.first][to.second] == '.'){
                  jumps[to.first][to.second] = jumps[to.first - 2 * dv[i].first][to.second - 2 * dv[i].second] + 1;
                  qj.push(to);
                }
              }
            }
          }
          
        }
      }
    }
  }
  //cout << used << jumps;
  cout << (used[a][b] && jumps[a][b] <=k ? "YES" : "NO") << nl;
}
 
signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    cerr << "time taken : " << (float)clock() / CLOCKS_PER_SEC << " secs"<<nl;
    return 0;
}
