﻿#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()

const int inf = (int)1e9;
const ll linf = (ll)1e18;

const ll mod = 998244353ll;
const ld eps = (ld)1e-8;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
	int n; cin >> n;
	vector<ll> x(n);
	vector<ll> y(n);

	for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];


	ld p = 0.0l;
	ld s = 9e18;
	for (int i = 0; i < n; ++i) {
		int j = (i + 1) % n;
		p += sqrtl((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]));
		s = max(s, sqrtl((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j])));
	}

	cout << p - s << "\n";

}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cout << fixed << setprecision(14);
	int tet = 1;
	//cin >> tet;
	while (tet--) {
		solve();
	}
}