#include <iostream>
#include <vector>
#include <queue>
#include <ranges>
#include <algorithm>
#include <iomanip>
#include <stdio.h>
#include <cassert>
#include <set>
#include <map>
#include <unordered_set>
#include <chrono>
#include <complex>
#include <numbers>
#include <random>
#include <bit>
#include <cstring>

using namespace std;

using u64 = std::uint64_t;
using i64 = std::int64_t;
using ci64 = std::int64_t const;

template <typename T>
T read() {
    T tmp;
    cin >> tmp;
    return tmp;
}

int main() {
    ci64 N = read<i64>(), K = read<i64>(), S1 = read<i64>(), S2 = read<i64>();
    bool const s1_iz_zero = S1 < K || S1 > N * K;
    bool const s2_iz_zero = S2 < K || S2 > N * K;

    if (s1_iz_zero && s2_iz_zero) {
        cout << "Equal";
        return 0;
    } else if (s1_iz_zero && !s2_iz_zero) {
        cout << "Second";
        return 0;
    } else if (!s1_iz_zero && s2_iz_zero) {
        cout << "First";
        return 0;
    }

    ci64 double_mean = N * (K + 1);
    i64 diff1 = abs(double_mean - S1 * 2);
    i64 diff2 = abs(double_mean - S2 * 2);
    if (diff1 == diff2) {
        cout << "Equal";
    } else if (diff1 > diff2) {
        cout << "Second";
    } else {
        cout << "First";
    }

    return 0;
}
