#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
template <typename T1, typename T2>
inline bool chkmin(T1 &x, T2 y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
};
template <typename T1, typename T2>
inline bool chkmax(T1 &x, T2 y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
};

using namespace std;

void Input() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::cout.setf(ios::fixed);
    std::cout.precision(10);
}

struct Point {
    ll x, y;
    friend istream &operator>>(istream &in, Point &a) {
        return in >> a.x >> a.y;
    }

    ld dist(Point &oth) {
        return sqrt((x - oth.x) * (x - oth.x) + (y - oth.y) * (y - oth.y));
    }
};

int main() {
    Input();

    int n;
    cin >> n;
    vector<Point> points(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> points[i];
    }
    points[n] = points[0];
    ld per = 0;
    ld mx_side = 0;
    for (int i = 1; i <= n; ++i) {
        ld side = points[i].dist(points[i - 1]);
        if (side > mx_side) {
            mx_side = side;
        }
        per += side;
    }
    std::cout << per - mx_side << "\n";
    return 0;
}
