#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
template <typename T1, typename T2>
inline bool chkmin(T1 &x, T2 y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
};
template <typename T1, typename T2>
inline bool chkmax(T1 &x, T2 y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
};

using namespace std;

void Input() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::cout.setf(ios::fixed);
    std::cout.precision(10);
}

struct Point {
    ll x, y;
    friend istream &operator>>(istream &in, Point &a) {
        return in >> a.x >> a.y;
    }

    ld dist(Point &oth) {
        return sqrt((x - oth.x) * (x - oth.x) + (y - oth.y) * (y - oth.y));
    }
};

int main() {
    Input();
    ll l, r;
    cin >> l >> r;
    for (ll d = r - l; d > 0; --d) {
        ll next_greater = (l + (d - 1)) / d * d;
        ll prev_less = r / d * d;
        if (next_greater < prev_less) {
            std::cout << next_greater << " " << prev_less << "\n";
            return 0;
        }
    }
    return 0;
}
