#include <bits/stdc++.h>

typedef long long ll;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
template <typename T1, typename T2>
inline bool chkmin(T1 &x, T2 y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
};
template <typename T1, typename T2>
inline bool chkmax(T1 &x, T2 y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
};

using namespace std;

void Input() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

const int INF = 1e9;

struct Cord {
    int x, y;
};

int main() {
    Input();

    int n, m, k;
    cin >> n >> m >> k;
    vector<string> s(n);
    for (auto &i : s) {
        cin >> i;
    }

    Cord st, fn;
    cin >> st.x >> st.y;
    st.x--, st.y--;
    cin >> fn.x >> fn.y;
    fn.x--, fn.y--;

    deque<Cord> d;
    d.push_back(st);
    vector<vector<int>> res(n, vector<int>(m, INF));
    res[st.x][st.y] = 0;
    while (!d.empty()) {
        auto cur = d.front();
        d.pop_front();

        auto turns = [&](Cord cur) {
            vector<pair<Cord, int>> go = {
                {{cur.x + 1, cur.y}, 0}, {{cur.x, cur.y + 1}, 0}, {{cur.x - 1, cur.y}, 0},
                {{cur.x, cur.y - 1}, 0}, {{cur.x + 2, cur.y}, 1}, {{cur.x, cur.y + 2}, 1},
                {{cur.x - 2, cur.y}, 1}, {{cur.x, cur.y - 2}, 1},
            };

            vector<pair<Cord, int>> res;
            for (auto [cord, cost] : go) {
                if (0 <= cord.x && cord.x < n && 0 <= cord.y && cord.y <= m &&
                    s[cord.x][cord.y] == '.') {
                    res.push_back({cord, cost});
                }
            };

            return res;
        };

        for (auto [to, cost] : turns(cur)) {
            if (chkmin(res[to.x][to.y], res[cur.x][cur.y] + cost)) {
                if (cost == 0) {
                    d.push_front(to);
                } else {
                    d.push_back(to);
                }
            }
        }
    }

    // cerr << res[fn.x][fn.y] << endl;
    cout << (res[fn.x][fn.y] <= k ? "YES" : "NO") << endl;
    return 0;
}
