#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#if LOCAL
#define dbg(o) ({ cout << #o << " = " << (o) << "\n"; o; })
#else
#define dbg(o) (o)
#endif

#define ff first
#define ss second
#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
ll rng(ll l, ll r) { return uniform_int_distribution<ll> (l, r) (rnd); }

void vendory() {}

void sol() {
    int n;
    cin >> n;
    vector<pair<ld, ld>> a(n);
    for (int i = 0; i < n; ++i) {
        ld x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    ld total = 0, max_ = 0;
    for (int i = 0; i < n; ++i) {
        ld fx = (a[i].ff - a[(i + 1) % n].ff);
        ld fy = (a[i].ss - a[(i + 1) % n].ss);
        ld p = sqrt(fx * fx + fy * fy);
        total += p;
        max_ = max(p, max_);
    }
    cout << setprecision(16) << total - max_ << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#if LOCAL
    freopen("../B/input.txt", "r", stdin);
    vendory();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cout << "\n================================ " << i << " ================================" << endl;
        sol();
    }
#else
    vendory();
    sol();
#endif
    return (0-0);  // <3
}