#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

void FillVector(istream& input, vector<int>& nums, int new_size){
    nums.resize(new_size);
    for (int i = 0; i < nums.size(); ++i) {
        input >> nums[i];
    }
}

void GetData(istream& input, vector<int>& nums1, vector<int>& nums2){
    int len_1, len_2;
    input >> len_1 >> len_2;
    FillVector(input, nums1, len_1);
    FillVector(input, nums2, len_2);
}
/*
void PrintVector(ostream& output, const vector<int>& nums){
    for(int number: nums){
        output << number << ' ';
    }
}
*/

size_t CountEqualPairs(vector<int>& nums1, vector<int>& nums2){
    size_t counter = 0;
    size_t curr_counter = 0, prev_curr = 0;
    for(int i = 0, j = 0; i < nums1.size(); ++i){
        if(i != 0 && nums1[i - 1] == nums1[i]){
            counter += prev_curr;
            continue;
        }
        while(j < nums2.size() && nums1[i] >= nums2[j]){
            if(nums1[i] == nums2[j]) {
                ++curr_counter;
            }
            ++j;
        }
        counter += curr_counter;
        prev_curr = curr_counter;
        curr_counter = 0;
    }
    return counter;
}

void SolveTask(){
    vector<int> nums1;
    vector<int> nums2;
    GetData(cin, nums1, nums2);
    cout << CountEqualPairs(nums1, nums2);
}

int main() {
    SolveTask();
    return 0;
}
