

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.security.KeyPair;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.PriorityQueue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.stream.Collectors;
import javax.lang.model.type.ArrayType;
import javax.swing.JInternalFrame;


public class Main {
  static long fac = 3628800;
  static class Part implements  Comparable<Part>{
   long r,second;
   public Part(long r,long second) {
     this.r = r;
     this.second = second;
   }

    @Override
    public int compareTo(Part o) {
      if(second > o.second) return -1;
      else if(second < o.second) return 1;
      else return 0;
    }
  }

  public static void main(String[] args) {
    MyScanner sc = new MyScanner();
    PrintWriter out = new PrintWriter(System.out);
    long n = sc.nextLong();
    long k = sc.nextLong()*fac;
    List<Part> list = new ArrayList<>();
    long[] s = new long[(int)n];
    long currsum = 0;
    for(int i = 0;i<n;i++) {
      s[i] = sc.nextLong();
    }
    for(int i = 0;i<n;i++) {
      long a = sc.nextInt();
      Part part = new Part(Math.abs(a-s[i]),fac/s[i]);
      list.add(part);
      currsum += part.r*part.second;
    }
    Collections.sort(list);
//    for(Part l : list) {
//      System.out.println(l.r + " " + l.second);
//    }
    int answer = 0;
    for(Part part : list){
      if(currsum <= k) {
        break;
      } else {
        if(part.r*part.second >= (currsum - k)) {
          if((currsum - k) % part.second == 0) {
            answer += (currsum-k)/ part.second;
          } else {
            answer += (currsum-k)/part.second + 1;
          }
          break;
        } else {
          answer += part.r;
          currsum -= part.r* part.second;
        }
      }
    }
    System.out.println(answer);



  }




  static Random rand = new Random();

  //-----------PrintWriter for faster output---------------------------------
  public static PrintWriter out;

  //-----------MyScanner class for faster input----------
  public static class MyScanner {

    BufferedReader br;
    StringTokenizer st;

    public MyScanner() {
      br = new BufferedReader(new InputStreamReader(System.in));
    }

    String next() {
      while (st == null || !st.hasMoreElements()) {
        try {
          st = new StringTokenizer(br.readLine());
        } catch (IOException e) {
          e.printStackTrace();
        }
      }
      return st.nextToken();
    }

    int nextInt() {
      return Integer.parseInt(next());
    }

    long nextLong() {
      return Long.parseLong(next());
    }

    double nextDouble() {
      return Double.parseDouble(next());
    }

    String nextLine() {
      String str = "";
      try {
        str = br.readLine();
      } catch (IOException e) {
        e.printStackTrace();
      }
      return str;
    }

  }


}