#include <iostream>
#include <cmath>

int64_t n, k;

bool bad(int64_t s) {
    return s < n || s > n * k;
}

int main() {
    int64_t s1, s2;
    std::cin >> n >> k >> s1 >> s2;
    if (bad(s1) && bad(s2)) {
        std::cout << "Equal";
    } else if (bad(s1)) {
        std::cout << "Second";
    } else if (bad(s2)) {
        std::cout << "First";
    } else {
        int64_t ans = (k + 1) * n;
        int64_t d1 = std::abs(2 * s1 - ans);
        int64_t d2 = std::abs(2 * s2 - ans);
        if (d1 > d2) {
            std::cout << "Second";
        } else if (d1 < d2) {
            std::cout << "First";
        } else {
            std::cout << "Equal";
        }
    }
}