#include <iostream>
#include <vector>
int n;
std::vector <int> p;

int main() {
    std::cin >> n;
    p.resize(n + 1, 0);
    for (int i = 2; i <= n - 1; i++) {
        std::cin >> p[i];
    }
    std::vector <int> last(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        if (p[i] != 0) {
            last[i] = last[i - p[i]];
        } else {
            last[i] = i;
        }
    }

    std::vector <int> dist(n + 1, 10000000);
    dist[1] = 0;
    for (int i = 1; i < n; i++) {
        int next = last[std::min(i + 6, n)];
        while (dist[next] > dist[i] + 1) {
            if (next == n) {
                dist[n] = std::min(dist[n], dist[i] + 1);
            }
            for (int j = 1; j <= 5; j++) {
                int next1 = last[std::min(n, next + j)];
                dist[next1] = std::min(dist[next1], dist[i] + 1);
            }
            next = last[std::min(n, next + 6)];
        }
        for (int j = 1; j <= 5; j++) {
            int next1 = last[std::min(n, i + j)];
            dist[next1] = std::min(dist[next1], dist[i] + 1);
        }
    }
    if (dist[n] == 10000000) {
        std::cout << "-1";
    } else {
        std::cout << dist[n];
    }
}