#include <iostream>
#include <numeric>
#include <cstdint>

using namespace std;

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int64_t N, K, S1, S2;
    cin >> N >> K >> S1 >> S2;

    int64_t dmean = N * (K + 1);
    int64_t first = abs(2 * S1 - dmean);
    int64_t second = abs(2 * S2 - dmean);

    //Boundary cases
    if (N == 1) {
        cout << "Equal";
        return 0;
    };
    if (K == 1) {
        if ((S1 != N && S2 != N) || (S1 == N && S2 == N)) {
            cout << "Equal";
            return 0;
        };
        if (S1 == N) {
            cout << "First";
            return 0;
        };
        if (S2 == N) {
            cout << "Second";
            return 0;
        };
    };
    if ((S1 < N || S1 > N * K) && (S2 < N || S2 > N * K)) {
        cout << "Equal";
        return 0;
    };


    if (first < second)
        cout << "First";
    if (first > second)
        cout << "Second";
    if (first == second)
        cout << "Equal";

    return 0;
}