#include <iostream>
#include <unordered_map>

using namespace std;

unordered_map<string, int> vars;

bool try_add(string s, int cur_add) {
    string new_s = s;
    if (cur_add > 0) {
        new_s = s + to_string(cur_add);
    }
    if (vars.find(new_s) != vars.end()) {
        return false;
    }

    int ind = new_s.length() - 1;
    long long cur_int = 0;
    long long cur_power = 1;
    while (ind >= 0) {
        //cout << "ind" << ind << '\n';
        if (!isdigit(new_s[ind])) break;
        cur_int = cur_power * (new_s[ind] - '0') + cur_int;
        cur_power *= 10;
        ind -= 1;
        if (new_s[ind + 1] == '0') {
            continue;
        }
        string cur_s = new_s.substr(0, ind + 1);
        if (vars.find(cur_s) != vars.end()) {
            if (vars[cur_s] >= cur_int) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    int Q;
    cin >> Q;

    for (int i = 0; i < Q; ++i) {
        string s;
        cin >> s;
        int cur_add = 0;
        if (vars.find(s) != vars.end()) {
            cur_add = vars[s] + 1;
        }
        //cout << "add " << cur_add << '\n';
        while (true) {
            if (try_add(s, cur_add)) {
                vars[s] = cur_add;
                break;
            }
            cur_add += 1;
        }
        if (cur_add > 0) {
            cout << s + to_string(cur_add) << '\n';
        } else {
            cout << s << '\n';
        }
    }

    return 0;
}