#include <bits/stdc++.h>

using namespace std;
char a[1002][1002];
int mp[1000000];
bool used[1000000];
int ko[1002][1002];
int n, m, K;
queue <int> bf;
vector <pair <int, int>> g[1000000];
void dfs(int x, int y, int c)
{
    if(x<0)
        return;
    if(x>n+1)
        return;
    if(y<0)
        return;
    if(y>m+1)
        return;
    if(ko[x][y]==c)
        return;
    if(a[x][y]=='#')
        return;
    ko[x][y]=c;
    g[c].push_back({x, y});
    dfs(x+1, y, c);
    dfs(x-1, y, c);
    dfs(x, y+1, c);
    dfs(x, y-1, c);
}
void f(int x, int y, int c)
{
    if(a[x][y]=='#')
        return;
    int h=ko[x][y];
    if(used[h]==true)
        return;
    mp[h]=c+1;
    bf.push(h);
    used[h]=1;

}
void jump(int x, int y, int c)
{
    f(x+2, y, c);
    f(x-2, y, c);
    f(x, y+2, c);
    f(x, y-2, c);
}
void bfs()
{
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            int c=ko[i][j];
            mp[c]=1e9;
        }
    }
    mp[1]=0;
    bf.push(1);
    used[1]=1;
    while(bf.empty()==false)
    {
        int c=bf.front();
        bf.pop();
        for(pair <int, int> to: g[c])
        {
            jump(to.first, to.second, mp[c]);
        }
    }
}
int main()
{
   // freopen("x.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>m>>K;
    for(int i=0; i<=n+1; i++)
    {
        for(int j=0; j<=m+1; j++)
        {
            a[i][j]='#';
        }
    }
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>a[i][j];
        }
    }
    int dx, dy, ax, ay;
    cin>>dx>>dy>>ax>>ay;
    dfs(dx, dy, 1);
    int c=2;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            if(a[i][j]=='.')
            {
                if(ko[i][j]==0)
                {
                    dfs(i, j, c);
                    c++;
                }
            }
        }
    }
    if(ko[dx][dy]==ko[ax][ay])
    {
        cout<<"YES";
        return 0;
    }
    bfs();
    int h=ko[ax][ay];
    if(used[h]==false)
    {
        cout<<"NO";
        return 0;
    }
    if(mp[h]<=K)
    {
        cout<<"YES";
        return 0;
    }
    cout<<"NO";
    return 0;
}
