#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,abm,mmx,avx,tune=native")
// #pragma GCC target("avx,avx2")
// #pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define m_p make_pair
#define pii pair <int, int>
#define YES cout << "YES\n"
#define NO cout << "NO\n"
#define vi vector<int>
#define vii vector<pii>
#define vvi vector<vector<int> >
#define mii map<int, int>
const int INF = 1000000007;
const ll INF2 = 100000000000000007;
const int MOD1 = 998244353;
const int MOD = 1000000007;
const int SIZE = 1000010;
const int base = 53;
const long double eps = 1e-6;
const long double pi = acosl(-1.0);
ll add(ll a, ll b) {
    return ((a + b) % MOD + MOD) % MOD;
}
ll mult(ll a, ll b) {
    return (((a % MOD) * (b % MOD)) % MOD + MOD) % MOD;
}
ll binpowmod(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) res = mult(res, a);
        a = mult(a, a);
        n >>= 1;
    }
    return res;
}
ll binpow(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
        }
        a *= a;
        n >>= 1;
    }
    return res;
}
ll inv(ll a) {
    return binpowmod(a, MOD - 2);
}
ll del(ll a, ll b) {
    return mult(a, inv(b));
}
ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}
ll lcm(ll a, ll b) {
    return a * b / gcd(a, b);
}

bool check(ll lb, ll rb, ll pt) {
    return (lb <= pt) && (pt <= rb);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG   
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    double cl = clock();
#endif

    ll n, k;
    cin >> n >> k;
    vector<ll> s(n);
    long double current = 0;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    map<ll, ll> mp;
    for (int i = 0; i < n; ++i) {
        ll a;
        cin >> a;
        mp[s[i]] += abs(a - s[i]);
        current += abs(a - s[i]) / s[i];
    }
    ll ans = 0;
    for (auto & i : mp) {
        long double residue = current - k;
        if (residue < 0) {
            break;
        }
        ll need = min(i.second, (ll)ceill(residue * i.first));
        ans += need;
        current -= (long double)need / i.first;
    }

    cout << ans;

    // long long n, m;
    // cin >> n >> m;

    // long long a = m - 1, b = m;
    // long long ans = 1;
    // for (long long i = 1; i <= min(m, 1000001LL); ++i)
    // {
    //     long long x = (n + i - 1) / i;
    //     long long a1 = x * i;
    //     long long b1 = (x + 1) * i;
    //     if (n <= a1 && m >= a1 && n <= b1 && m >= b1)
    //     {
    //         ans = i;
    //         a = a1;
    //         b = b1;
    //     }
    // }
    // cout << a << " " << b;

    // ll n, k, s1, s2;
    // cin >> n >> k >> s1 >> s2;
    // if (n == 1) {
    //     if (s1 <= k && s2 <= k) {
    //         cout << "Equal" << endl;
    //         return 0;
    //     }
    //     if (s1 <= k) {
    //         cout << "First" << endl;
    //         return 0;
    //     }
    //     cout << "Second" << endl;
    //     return 0;
    // }
    // ll minsum = n, maxsum = n * k;
    // if (check(minsum, maxsum, s1) && !check(minsum, maxsum, s2)) {
    //     cout << "First" << endl;
    //     return 0;
    // }
    // if (!check(minsum, maxsum, s1) && check(minsum, maxsum, s2)) {
    //     cout << "Second" << endl;
    //     return 0;
    // }
    // if (!check(minsum, maxsum, s1) && !check(minsum, maxsum, s2)) {
    //     cout << "Equal" << endl;
    //     return 0;
    // }
    // ll d1 = s1, d2 = s2;
    // ld E = (n + n * k) / 2;
    // d1 = abs(d1 - E);
    // d2 = abs(d2 - E);
    // if (abs(d1 - d2) < 1e-3) cout << "Equal" << endl;
    // else if (d1 < d2) cout << "First" << endl;
    // else cout << "Second" << endl;


#ifdef DEBUG
    cout << "\n\n" << fixed << (clock() - cl) / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}