#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,abm,mmx,avx,tune=native")
// #pragma GCC target("avx,avx2")
// #pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define m_p make_pair
#define pii pair <int, int>
#define YES cout << "YES\n"
#define NO cout << "NO\n"
#define vi vector<int>
#define vii vector<pii>
#define vvi vector<vector<int> >
#define mii map<int, int>
const int INF = 1000000007;
const ll INF2 = 100000000000000007;
const int MOD1 = 998244353;
const int MOD = 1000000007;
const int SIZE = 1000010;
const int base = 53;
const long double eps = 1e-6;
const long double pi = acosl(-1.0);
ll add(ll a, ll b) {
    return ((a + b) % MOD + MOD) % MOD;
}
ll mult(ll a, ll b) {
    return (((a % MOD) * (b % MOD)) % MOD + MOD) % MOD;
}
ll binpowmod(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) res = mult(res, a);
        a = mult(a, a);
        n >>= 1;
    }
    return res;
}
ll binpow(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
        }
        a *= a;
        n >>= 1;
    }
    return res;
}
ll inv(ll a) {
    return binpowmod(a, MOD - 2);
}
ll del(ll a, ll b) {
    return mult(a, inv(b));
}
ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}
ll lcm(ll a, ll b) {
    return a * b / gcd(a, b);
}

bool check(ll lb, ll rb, ll pt) {
    return (lb <= pt) && (pt <= rb);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG   
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    double cl = clock();
#endif

    ll n, k;
    cin >> n >> k;
    vector<ll> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    map<ll, ll> mp;
    for (int i = 0; i < n; ++i) {
        ll a;
        cin >> a;
        mp[s[i]] += abs(a - s[i]);
    }
    ll ans = 0;
    pair<ll, ll> current = {0LL, 0LL};
    for (auto & i : mp) {
        if (current == m_p(0LL, 0LL)) {
            current = {i.second, i.first};
            ll g = gcd(current.first, current.second);
            current.first /= g;
            current.second /= g;
            continue;
        }
        current.first = (current.second * i.second + current.first * i.first);
        current.second = current.second * i.first;
        ll g = gcd(current.first, current.second);
        current.first /= g;
        current.second /= g;
    }
    for (auto & i : mp) {
        if (k * current.second - current.first >= 0) {
            break;
        }
        ll need = min(i.second, (current.first - k * current.second) * i.first);
        ans += need;
        current.first = (current.first * i.first - current.second * need);
        current.second = current.second * i.first;
        ll g = gcd(current.first, current.second);
        current.first /= g;
        current.second /= g;
    }

    cout << ans;

    // int n;
    // cin >> n;
    // vector<int> a(n);
    // vector<int> p(n);
    // p[n - 1] = n - 1;
    // p[0] = 0;
    // for (int i = 1; i < n - 1; ++i)
    // {
    //     cin >> a[i];
    //     if (a[i] == 0)
    //     {
    //         p[i] = i;
    //     }
    //     else
    //     {
    //         p[i] = p[i - a[i]]; 
    //     }
    // }
    // vector<int> dp(n, INT_MAX);

    // dp[n - 1] = 0;
    // for (int i = n - 2; i >= 0; --i)
    // {
    //     if (p[i] == i)
    //     {
    //         if (i + 1 < n)
    //         {
    //             dp[p[i + 1]] = min(dp[p[i + 1]], dp[i] + 1);
    //         }
    //         if (i + 2 < n)
    //         {
    //             dp[p[i + 2]] = min(dp[p[i + 2]], dp[i] + 1);
    //         }
    //         if (i + 3 < n)
    //         {
    //             dp[p[i + 3]] = min(dp[p[i + 3]], dp[i] + 1);
    //         }
    //         if (i + 4 < n)
    //         {
    //             dp[p[i + 4]] = min(dp[p[i + 4]], dp[i] + 1);
    //         }
    //         if (i + 5 < n)
    //         {
    //             dp[p[i + 5]] = min(dp[p[i + 5]], dp[i] + 1);
    //         }
    //         if (i + 1 < n)
    //         {
    //             dp[p[i + 1]] = min(dp[p[i + 1]], dp[i] + 1);
    //         }
    //     }
    // }


#ifdef DEBUG
    cout << "\n\n" << fixed << (clock() - cl) / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}