#include <cassert>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);

    int n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;

    bool one_bad = s1 < n || s1 > n * k, two_bad = s2 < n || s2 > n * k;

    s1 *= 2;
    s2 *= 2;

    int mid = (k + 1) * n;
    if (one_bad && two_bad) {
        cout << "Equal\n";
    } else if (one_bad) {
        cout << "Second\n";
    } else if (two_bad) {
        cout << "First\n";
    } else {
        int r1 = abs(s1 - mid), r2 = abs(s2 - mid);
        if (r1 < r2) {
            cout << "First\n";
        } else if (r1 == r2) {
            cout << "Equal\n";
        } else {
            cout << "Second\n";
        }
    }
}