#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <time.h>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <deque>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 2e5 + 7;
int dist[2][N];
bool used[2][N];
int p[N];
int go[N];

void bfs(int n) {
    deque <pair <int, int>> d;
    for (int i = 1; i <= n; i++) {
        dist[0][i] = dist[1][i] = -1;
        used[0][i] = used[1][i] = 0;
    }
    dist[0][1] = 0;
    d.push_back({0, 1});
    while (!d.empty()) {
        auto [f, v] = d.front();
        d.pop_front();
        if (used[f][v]) {
            continue;
        }
        used[f][v] = 1;
//        cout << "! " << f << ' ' << v << ' ' << dist[f][v] << endl;
        for (int i = 1; i <= 6; i++) {
            int nv = go[min(v + i, n)];
            int ndist = dist[f][v] + (1 - f);
            int nf = (i == 6);
//            cout << nf << ' ' << nv << endl;
            //cout << v << ' ' << nv << endl;
            if (used[nf][nv] || (dist[nf][nv] != -1 && dist[nf][nv] <= ndist)) {
                continue;
            }
            //cout << f << ' ' << v << ' ' << i << ' ' << nf << ' ' << nv << endl;
            dist[nf][nv] = ndist;
            if (f == 1) {
                d.push_front({nf, nv});
            } else {
                d.push_back({nf, nv});
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("in_vanya.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    go[1] = 1;
    go[n] = n;
    for (int i = 2; i < n; i++) {
        cin >> p[i];
        if (p[i] == 0) {
            go[i] = i;
        } else {
            go[i] = go[i - p[i]];
        }
    }
    bfs(n);
    if (dist[0][n] == -1) {
        cout << dist[1][n] << endl;
    } else if (dist[1][n] == -1) {
        cout << dist[1][n] << endl;
    } else {
        cout << min(dist[0][n], dist[1][n]) << endl;
    }
    return 0;
}