#include <cassert>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);

    int n;
    cin >> n;
    vector<int> p1(n), p2(n);
    for (int i = 1; i < n; i++) {
        cin >> p1[i];
    }

    for (int i = 1; i < n; i++) {
        cin >> p2[i];
    }

    vector<vector<int>> level(n);
    level[0] = {0};
    vector<int> f(n);
    vector<bool> can_touch(n, true);
    can_touch[0] = false;
    f[0] = 0;
    vector<pair<int, int>> kek;
    for (int i = 0; i < n; i++) {
        for (auto v : level[i]) {
            int v_2 = f[v];
            vector<int> c1, c2;
            for (int j = 0; j < n; j++) {
                if (p1[j] == v && j != v) {
                    c1.push_back(j);
                }

                if (p2[j] == v_2 && j != v_2) {
                    c2.push_back(j);
                }
            }

            int d = min(c1.size(), c2.size());
            for (int j = 0; j < d; j++) {
                can_touch[c1[j]] = false;
                level[i + 1].push_back(c1[j]);
                f[c1[j]] = c2[j];
            }

            for (int j = c1.size(); j < c2.size(); j++) {
                for (int k = 0; k < n; k++) {
                    if (can_touch[k]) {
                        can_touch[k] = false;
                        level[i + 1].push_back(k);
                        f[k] = c2[j];

                        kek.emplace_back(k, v);
                        p1[k] = v;
                    }
                }
            }
        }
    }

    cout << kek.size() << '\n';
    for (auto [u, v] : kek) {
        cout << u << ' ' << v << '\n';
    }
}