#include <iostream>
#include <fstream>
#include <algorithm> 
#include <string>
#include <cmath>
#include <vector>
using namespace std;

int main(){
    // ifstream in("input.txt");
    int n;
    int inf = 1000000000;
    cin >> n;
    vector<int> a(n, 0);
    for(int i = 1;i <= n - 2;i++){
        cin >> a[i];
    }
    vector<int> depth(n, inf);
    vector<int> portal;
    depth[0] = 0;
    for(int i = 0;i < n;i++){
        if(a[i] == 0){
            portal.push_back(i);
        } else{
             portal.push_back(portal[i - a[i]]);
        }
    }
    for(int i = 0; i < n;i++){
        if (a[i] != 0 || (depth[i] == inf)){
            continue;
        }

        for(int j = 1;j <= min(6, n - 1 - i);j++){
            // cout << i << " " << j << endl;
            int diff = 1;
            if (j == 6){
                diff = 0;
            }
            depth[portal[i + j]] = min(depth[i] + diff, depth[portal[i + j]]);
        }
    }

    // // cout << endl;
    // for(int i =0;i < n;i++){
    //     cout << a[i] << " ";
    //     // cout << a[i] << " " << depth[i] << endl;
    // }
    // cout << endl;
    // for(int i =0;i < n;i++){
    //     cout << depth[i] << " ";
    //     // cout << a[i] << " " << depth[i] << endl;
    // }
    // cout << endl;
    // for(int i =0;i < n;i++){
    //     cout << portal[i] << " ";
    //     // cout << a[i] << " " << depth[i] << endl;
    // }
    // cout << endl;
    if (depth[n - 1] == inf){
        cout << -1;
    } else{
        cout << depth[n - 1];
    }
    // in.close();
    return 0;
}