#include <iostream>
#include <vector>
#include <deque>

using namespace std;



int main()
{
    int n;
    cin >> n;
    vector <int> p(n);
    p[0]=0;
    for (int i = 1; i < n - 1; i++)
    {
        cin >> p[i];
    }
    p[n-1]=0;
    vector <int> t(n);
    for (int i = 0; i < n; i++)
    {
        if (p[i] == 0)
            t[i] = i;
        else
            t[i] = t[max(0, i - p[i])];
    }
    vector <int> m6(n);
    vector<int> m[n];
    for (int i = 0; i < n; i++)
    {
        for (int j = 1; j < 6; j++)
        {
            int k = min(n - 1, i + j);
            int l = t[k];
            m[i].push_back(l);
        }
        int j = 6;
        int k = min(n - 1, i + j);
        int l = t[k];
        m6[i] = l;
    }

    deque<int> Q;

    vector<int> dist(n, -1);
    vector<int> otm(n, -1);

    dist[0] = 0;
    Q.push_back(0);
    while (Q.size())
    {
        int u = Q.front();
        Q.pop_front();
        int v = m6[u];
        if (dist[v] == -1)
        {
            if (otm[u] == 1)
            {
                dist[v] = dist[u];
                Q.push_front(v);
            }
            else
            {
                dist[v] = dist[u] + 1;
                Q.push_back(v);
            }
            otm[v] = 1;
        }
        for (int j = 0; j < m[u].size(); j++)
        {
            int v = m[u][j];
            if (dist[v] == -1)
            {

                if (otm[u] == 1)
                {
                    dist[v] = dist[u];
                    Q.push_front(v);
                }
                else
                {
                    dist[v] = dist[u] + 1;
                    Q.push_back(v);
                }
            }
        }
    }
    cout << dist[n - 1];
}