#include <iostream>
#include <vector>
#include <string>
#include <map>

using namespace std;

class node{
    node* parent;
    node* current;
    vector<node*> children;
    int mean=0;
    int power=0;
    map<int, int> box;
public:
    node(int ch){
        parent = nullptr;
        current = this;
        mean = ch;
        power = 0;
    }
    bool push(int ch) {
        node* tmp;
        if (current->box.count(ch) == 1) {
            current->parent = this;
            current = children[box[ch]];
            return false;
        }
        if(children.size() == 0){ current->box[ch] = current->children.size();}
        else{ box[ch] = current->children.size() - 1;}
        tmp = new node(ch);
        current->children.push_back(tmp);
        current->parent = this;
        current = tmp;
        return true;
    }

    int addToBase(string& str){
        node* tmp = this;
        bool answ = false;
        for(int i = 0; i < str.size(); ++i){
            answ = push(str[i]);
        }
        if(answ == false){++power;}
        this->current = tmp;
        return power;
    }
};

int main() {
    int n=0;
    cin>>n;
    node* root = new node('+');
    while(n!=0){
        --n;
        string str;
        cin >>str;
        int a = root->addToBase(str);
        cout << str << a << endl;
    }
    return 0;
}
