#include <algorithm>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
  int q;
  cin >> q;

  unordered_map<string, int> db;
  set<string> used;

  for (int i{0}; i < q; i++) {
    string cur;
    cin >> cur;

    if (!db.count(cur) && !used.count(cur)) {
      db[cur] = 1;
    } else if (!db.count(cur) && used.count(cur)) {
      db[cur] = 1;

      while (used.count(cur + to_string(db[cur])))
        db[cur]++;

      cur += to_string(db[cur]);
    } else {
      while (used.count(cur + to_string(db[cur])))
        db[cur]++;

      cur += to_string(db[cur]);
    }

    used.insert(cur);

    cout << cur << '\n';
  }
}
