import math


def firstBinomialCoff(n, k):
    return math.factorial(n) / (math.factorial((n - k)) * math.factorial(k))


def SecondBinomialCoff(n, k, s, t):
    return math.factorial((t - s * k - 1)) / (math.factorial((t - s * k - n)) * math.factorial((n - 1)))


def ProbofEachNum(n, s, t):
    T = 0
    for k in range(0, int((t - n) / s) + 1):
        T = T + ((-1) ** k) * firstBinomialCoff(n, k) * SecondBinomialCoff(n, k, s, t)
    return T


n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

t1 = ProbofEachNum(n, k, s1)
t2 = ProbofEachNum(n, k, s2)
if t1 == t2:
    print("Equal")
elif t1 > t2:
    print("First")
else:
    print("Second")
