// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define add push_back
#define f first
#define s second
#define pw(x) (1ll << (x))
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ll INF = (ll)1e9 + 2023;

const int N = 1010;
bool f[N][N];
vector <pair <int, int>> gr[N * N];
deque <int> q;
int d[N * N];
int n, m;

bool inside(int r, int c) {
	return 0 <= r && r < n && 0 <= c && c < m;
}

int to_vn(int r, int c) {
	return r * m + c;
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int k;
	cin >> n >> m >> k;
	
	char kek;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> kek;
			f[i][j] = (kek == '#');
		}
	}
	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (f[i][j]) {
				continue;
			}

			int cur_v = to_vn(i, j);
			int r = i, c = j;

			if (inside(r - 1, c) && !f[r - 1][c]) {
				gr[cur_v].add({to_vn(r - 1, c), 0});
			}
			if (inside(r + 1, c) && !f[r + 1][c]) {
				gr[cur_v].add({to_vn(r + 1, c), 0});
			}
			if (inside(r, c - 1) && !f[r][c - 1]) {
				gr[cur_v].add({to_vn(r, c - 1), 0});
			}
			if (inside(r, c + 1) && !f[r][c + 1]) {
				gr[cur_v].add({to_vn(r, c + 1), 0});
			}

			if (inside(r - 2, c) && !f[r - 2][c]) {
				gr[cur_v].add({to_vn(r - 2, c), 1});
			}
			if (inside(r + 2, c) && !f[r + 2][c]) {
				gr[cur_v].add({to_vn(r + 2, c), 1});
			}
			if (inside(r, c - 2) && !f[r][c - 2]) {
				gr[cur_v].add({to_vn(r, c - 2), 1});
			}
			if (inside(r, c + 2) && !f[r][c + 2]) {
				gr[cur_v].add({to_vn(r, c + 2), 1});
			}
		}
	}

	int dx, dy;
	cin >> dx >> dy;
	dx--; dy--;
	int ax, ay;
	cin >> ax >> ay;
	ax--; ay--;

	int st = to_vn(dx, dy), fn = to_vn(ax, ay);
	fill(d, d + N * N, INF);

	d[st] = 0;
	q.push_back(st);
	while (sz(q)) {
		int v = q.front(); q.pop_front();
		for (auto &ww : gr[v]) {
			int u = ww.f, w = ww.s;
			if (d[v] + w < d[u]) {
				d[u] = d[v] + w;
				if (!w) {
					q.push_front(u);
				} else {
					q.push_back(u);
				}
			}
		}
	}

	cout << (d[fn] <= k ? "YES" : "NO");
}