// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define add push_back
#define f first
#define s second
#define pw(x) (1ll << (x))
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ll INF = (ll)1e9 + 2023;

void dfs(int v_a, int v_b, set<int> &leaves, vector<int> &used, vector<pair<int, int>> &ans, vector<int> &cnt_a,
	const vector<vector<int>> &a, 
	const vector<int> &pa, 
	const vector<vector<int>> &b, 
	const vector<int> &pb, bool new_v) 
{
	if (used[v_a]) {
		return;
	}
	used[v_a] = 1;
	int j = 0;
	for (int i = 0; i < a[v_a].size() && !new_v; ++i) {
		if (used[a[v_a][i]]) {
			continue;
		}
		if (b[v_b].size() > j) {
			dfs(a[v_a][i], b[v_b][j], leaves, used, ans, cnt_a, a, pa, b, pb, false);
			++j;
		} else {
			return;
		}
	}
	for (int i = j; i < b[v_b].size(); ++i) {
		while (true) {
			int v = *(leaves.begin());
			leaves.erase(v);
			if (used[v]) {
				continue;
			}
			cnt_a[pa[v]]--;
			if (cnt_a[pa[v]] == 0) {
				leaves.insert(pa[v]);
			}
			ans.push_back(make_pair(v, v_a));
			dfs(v, b[v_b][i], leaves, used, ans, cnt_a, a, pa, b, pb, true);
			break;
		}
	}
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int n;
	cin >> n;
	vector<vector<int>> a(n), b(n);
	vector<int> pa(n), pb(n), cnt_a(n, 0);
	for (int i = 1; i < n; ++i) {
		cin >> pa[i];
		a[pa[i]].push_back(i);
		cnt_a[pa[i]]++;
	}
	for (int i = 1; i < n; ++i) {
		cin >> pb[i];
		b[pb[i]].push_back(i);
	}
	set<int> leaves;
	for (int i = 0; i < n; ++i) {
		if (cnt_a[i] == 0) {
			leaves.insert(i);
		}
	}
	vector<int> used(n);
	vector<pair<int, int>> ans;
	dfs(0, 0, leaves, used, ans, cnt_a, a, pa, b, pb, false);
	cout << ans.size() << '\n';
	for (auto &op : ans) {
		cout << op.first << ' ' << op.second << '\n'; 
	}
}