#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>

using namespace std;

long long N, K;

bool compare(int x) {
    if ((N - x) / K * 2 >= x) {
        return true;
    } else {
        return false;
    }
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> N >> K;

    long long left = 1, right = N, middle;

    while (left < right) {
        middle = (left + right + 1) / 2;

        if (compare(middle)) {
            left = middle;
        } else {
            right = middle - 1;
        }
    }

    std::cout << left << std::endl;
    return 0;
}