#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

double N, K, S1, S2;

double middle;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> N >> K >> S1 >> S2;

    if (N == 1) {
        if (((S1 <= K) && (S2 <= K)) ||
            ((S1 > K) && (S2 > K))) {
            std::cout << "Equal" << std::endl;
            return 0;
        }

        if (S1 <= K && S2 > K) {
            std::cout << "First" << std::endl;
            return 0;
        }

        std::cout << "Second" << std::endl;
        return 0;
    }

    middle = static_cast<double>(N * K + N) / 2;

    double distance_a = abs(middle - S1);
    double distance_b = abs(middle - S2);

    if (S1 < N || S1 > N * K) {
        distance_a = std::pow(10, 20);
    }

    if (S2 < N || S2 > N * K) {
        distance_b = std::pow(10, 20);
    }

    if (abs(distance_b - distance_a) < std::pow(10, -10)) {
        std::cout << "Equal" << std::endl;
        return 0;
    }

    if (distance_a < distance_b) {
        std::cout << "First" << std::endl;
    } else if (distance_a > distance_b) {
        std::cout << "Second" << std::endl;
    }

    return 0;
}