import java.io.*
import kotlin.math.min

fun BufferedWriter.writeln(str: String) {
    this.write("${str}\n")
}

fun solve(reader: BufferedReader, writer: BufferedWriter) {
    val (n, m) = reader.readLine().split(' ').map { it.toInt() }
    val field = Array(n) { reader.readLine() }
    val amount1 = field.sumOf { it.count { c -> c == '1' } }
    val amount0 = field.sumOf { it.count { c -> c == '0' } }
    val minResult = min(n * m - amount1, n * m - amount0)
    writer.writeln("$minResult")
}


fun main(args: Array<String>) {
    val reader = BufferedReader(InputStreamReader(System.`in`))
    val writer = BufferedWriter(OutputStreamWriter(System.out))

    solve(reader, writer)

    reader.close()
    writer.close()
}