#include <iostream>
#include <climits>


int main()
{
    long long int N, K, S1, S2;
    std::cin >> N >> K >> S1 >> S2;
    if (N == 1) {
        long long s1_diff = 0;
        long long s2_diff = 0;
        if (S1 < N || S1 > K * N) {
            s1_diff = LLONG_MAX;
        }
        if (S2 < N || S2 > K * N) {
            s2_diff = LLONG_MAX;
        }
        if (s1_diff == s2_diff){
            std::cout << "Equal";
        }
        else if (s1_diff < s2_diff) {
            std::cout << "First";
        }
        else if (s2_diff < s1_diff){
            std::cout << "Second";
        }
        return 0;
    }

    long long int expected_sum = (1 + K) * N;
    long long int s1_diff = std::abs(expected_sum - S1 * 2);
    long long int s2_diff = std::abs(expected_sum - S2 * 2);
    long long int max_sum = K * N;
    long long int min_sum = N;
    bool is_s1_too_big = S1 > max_sum;
    bool is_s2_too_big = S2 > max_sum;
    bool is_s1_too_small = S1 < min_sum;
    bool is_s2_too_small = S2 < min_sum;

    if  ((is_s1_too_big && is_s2_too_big) ||
         (is_s1_too_small && is_s2_too_small) ||
         (is_s1_too_big && is_s2_too_small) ||
         (is_s1_too_small && is_s2_too_big))
    {
        std::cout << "Equal";
    }
    else if (is_s2_too_big || is_s2_too_small)
    {
        std::cout << "First";
    }
    else if (is_s1_too_big || is_s1_too_small)
    {
        std::cout << "Second";
    }
    else if (s1_diff == s2_diff){
        std::cout << "Equal";
    }
    else if (s1_diff < s2_diff) {
        std::cout << "First";
    }
    else if (s2_diff < s1_diff){
        std::cout << "Second";
    }
}