﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm> // Для использования std::find

int main() {
    int a;
    std::cin >> a;
    std::vector<std::string> x;
    std::vector<int> y;

    for (int i = 0; i < a; ++i) {
        std::string b;
        std::cin >> b;

        auto it = std::find(x.begin(), x.end(), b); // Поиск элемента в векторе

        if (it == x.end()) {
            x.push_back(b);
            y.push_back(1);
            std::cout << b << std::endl;
        }
        else {
            int index = std::distance(x.begin(), it); // Вычисляем индекс элемента

            std::string newStr = b + std::to_string(y[index]);
            while (std::find(x.begin(), x.end(), newStr) != x.end()) {
                y[index]++;
                newStr = b + std::to_string(y[index]);
            }

            x.push_back(newStr);
            y.push_back(1);
            std::cout << newStr << std::endl;
            y[index]++;
        }
    }

    return 0;
}
