def process_queries(Q, queries):
    name_to_index = {}
    results = []

    for query in queries:
        if query in name_to_index:
            index = name_to_index[query]
            while query + str(index) in name_to_index:
                index += 1
            name_to_index[query] = index
            results.append(query + str(index))
        else:
            name_to_index[query] = 1
            results.append(query)

    return results

Q = int(input())

queries = [input() for _ in range(Q)]

results = process_queries(Q, queries)
for result in results:
    print(result)