def roulette_game(N, K, S1, S2):
    dp = [[0] * (S1 + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for i in range(1, N + 1):
        for j in range(S1 + 1):
            for k in range(1, K + 1):
                if j - k >= 0:
                    dp[i][j] += dp[i - 1][j - k]

    count_first_player = dp[N][S1]
    count_second_player = dp[N][S2]

    if count_first_player > count_second_player:
        return "First"
    elif count_second_player > count_first_player:
        return "Second"
    else:
        return "Equal"

# Ввод данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вызов функции и вывод результата
result = roulette_game(N, K, S1, S2)
print(result)