def find_maximum_introverts(N, K):
    left, right = 0, N
    result = 0

    while left <= right:
        mid = (left + right) // 2

        if (N - mid) * K >= mid:
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result


N = int(input())
K = int(input())

print(find_maximum_introverts(N, K))
