def calculate_probability(N, K, S1, S2):
    First = [0] * (S1 + 1)
    Second = [0] * (S2 + 1)
    First[0] = 1
    Second[0] = 1
    
    for _ in range(N):
        new_first = [0] * (S1 + 1)
        new_second = [0] * (S2 + 1)

        for s in range(S1 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    new_first[s] += First[s - k] / K

        for s in range(S2 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    new_second[s] += Second[s - k] / K

        First = new_first
        Second = new_second

    if First[S1] > Second[S2]:
        return "First"
    elif First[S1] < Second[S2]:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = calculate_probability(N, K, S1, S2)
print(result)
