#include <iostream>
#include <string>
#include <unordered_map>

std::unordered_map<std::string, long long> mp;

int find(std::string &s, int i) {
    std::string ns = s + (i == 0 ? "" : std::to_string(i));
    if (mp.find(ns) != mp.end()) {
        return find(s, i + 1);
    }
    return i;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    int q; std::cin >> q;
    while (q--) {
        std::string s; std::cin >> s;
	std::string cp = s;
	long long cnt = 0;
        long long mx = 0;
	for (int i = 0; i <= s.size(); i++) {
	    auto it = mp.find(cp);
	    long long p = (it == mp.end() ? 0 : it->second);
	    if (p > cnt) {
		std::string st = std::to_string(p);
		std::string rs = st.substr(i);
		if (rs != "") mx = std::max(mx, std::stoll(rs));
	    }
            if (cp.back() < '0' || cp.back() > '9') break;
            cnt = cnt * 10 + (s.back() - '0');
	    cp.pop_back();
            
	}
	long long i = find(s, mx);
	std::string ns = s + (i == 0 ? "" : std::to_string(i));
	std::cout << ns << '\n';
	mp[ns] = 0;
	mp[s] = i;
    }
    return 0;
}

