#include <vector>
#include <queue>
#include <iostream>

const int INF = 1e9;

int main() {
    int n; std::cin >> n;
    std::vector<int> a(n);
    for (int i = 1; i < n - 1; i++) {
	std::cin >> a[i];
	if (a[i] > 0) {
            a[i] = a[i - a[i]];
	} else {
            a[i] = i;
	}
    }
    std::vector<int> used(n + 2);
    std::queue<int> q0, q1;
    q1.push(0);
    int cnt = 1;
    while (q1.size()) {
        for (int i = q1.size(); i > 0; i--) {
            int p = q1.front();
	    q1.pop();
	    if (used[p]) continue;
	    used[p] = 1;
	    if (p + 6 >= n - 1) {
                std::cout << cnt << '\n';
		return 0;
	    }
	    for (int j = 1; j <= 6 && p + j < n; j++) {
                if (!used[a[p + j]]) {
                    if (j == 6) {
                        q0.push(a[p + j]);
		    } else {
                        q1.push(a[p + j]);
		    }
		}
	    }
	}
	while (q0.size()) {
            int p = q0.front();
	    q0.pop();
	    if (used[p]) continue;
	    used[p] = 1;
	    if (p + 6 >= n - 1) {
                std::cout << cnt << '\n';
		return 0;
	    }
	    for (int j = 1; j <= 6 && p + j < n; j++) {
                if (!used[a[p + j]]) {
                    if (j == 6) {
                        q0.push(a[p + j]);
		    } else {
                        q1.push(a[p + j]);
		    }
		}
	    }
	}
	cnt++;
    }
    std::cout << "-1\n";
    return 0;
}

