﻿#include <bits/stdc++.h>
#define int long long

using namespace std;

int di[4] = {-1, 0, 1, 0}; int dj[4] = {0, 1, 0, -1};
int color = 1, n, m;
vector<vector<int>> used;
vector<vector<char>> a;
vector<unordered_set<int>> g;

void dfs(int i, int j) {
    used[i][j] = color;
    for (int k = 0; k < 4; ++k) {
        int i1 = i + di[k], j1 = j + dj[k];
        if (i1 < 0 || i1 >= n || j1 < 0 || j1 >= m) continue;
        if (!used[i1][j1] && a[i1][j1] == '.') {
            dfs(i1, j1);
        }
    }
}

signed main() {
    int k;
    cin >> n >> m >> k;
    a.resize(n, vector<char>(m)); used.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j =0; j < m ;++j) {
            cin >> a[i][j];
        }
    }
    int si, sj, desti, destj; cin >> si >> sj >> desti >> destj;
    si--; sj--; desti--; destj--;
    for (int i =0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!used[i][j] && a[i][j] == '.') {
                dfs(i, j);
                color++;
            }
        }
    }
    int n1 = color;
    g.resize(n1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m ;++j) {
            if (a[i][j] == '#') continue;
            for (int k = 0; k < 4; ++k) {
                int i1 = i + 2 * di[k], j1 = j + 2 * dj[k];
                if (i1 < 0 || i1 >= n || j1 < 0 || j1 >= m || a[i1][j1] == '#') continue;
                if (used[i][j] != used[i1][j1]) {
                    g[used[i][j]].insert(used[i1][j1]);
                }
            }
        }
    }
    // граф построен

    queue<int> q;
    q.push(used[si][sj]);
    vector<int> used1(color);
    vector<int> d(color, 1e9);
    d[used[si][sj]] = 0;
    used1[used[si][sj]] = 1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (!used1[u]) {
                used1[u] = 1;
                q.push(u);
                d[u] = d[v] + 1;
            }
        }
    }
    cout << (d[used[desti][destj]] <= k ? "YES\n" : "NO\n");
}
