﻿#include <bits/stdc++.h>

#define int long long
#define fast_io std::ios_base::sync_with_stdio(0); cin.tie(0)
using namespace std;

std::vector<int> dist;
std::vector<int> used;
std::vector<int> is_6;
int n;

std::vector<std::vector<int>> graf;
void bfs(int v) {
    std::deque<int> q;
    q.push_back(v);
    while (!q.empty()) {
        int u = q.front();
        q.pop_front();
        if (used[u]){
            continue;
        }
        used[u] = 1;
        if (u == n-1){
            break;
        }
        if (graf[u].size() == 1 && graf[u][0] < u){
            int e = graf[u][0];
            dist[e] = dist[u];
            q.push_front(e);
            is_6[e] = is_6[u];
        } else {
            for (int i = 0; i < graf[u].size()-1; i++) {
                int e = graf[u][i];
                int snap = dist[e];
                dist[e] = std::min(dist[e], dist[u] + 1 - is_6[u]);
                if (snap > dist[e]){
                    q.push_back(e);
                }

            }
            int e = graf[u].back();
            q.push_front(e);
            dist[e] = std::min(dist[e], dist[u] + 1 - is_6[u]);
            is_6[e] = 1;
        }
    }
}

signed main() {
    fast_io;
    std::unordered_map<std::string, int> q;
    std::cin >> n;
    graf.resize(n);
    dist.assign(n, INT32_MAX);
    is_6.resize(n);
    used.resize(n);
    dist[0] = 0;
    for (int j = 1; j <= 6; j++){
        if (j < n) {
            graf[0].push_back(j);
        }
    }
    for (int i = 1 ; i < n-1; i++){
        int p;
        std::cin >> p;
        if (p == 0){
            for (int j = 1; j <= 6; j++){
                if (i+j <= n-1) {
                    graf[i].push_back(i + j);
                }
            }
        } else {
            graf[i].push_back(i-p);
        }
    }
    bfs(0);
    if (dist[n-1] == INT32_MAX){
        dist[n-1] = -1;
    }
    std::cout << dist[n-1];
}
