﻿#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Node {
    Node *L = nullptr;
    Node *R = nullptr;
    int num;
    Node() {}
    Node(int num_) : num(num_) {}
};

vector<Node *> a, b;

pair<Node *, bool> dfs_miss(Node *va, Node *vb) {
    if (vb->L && !va->L) {
        return {va, false};
    }
    if (vb->L && va->L) {
        auto ans = dfs_miss(va->L, vb->L);
        if (ans.first) return ans;
    }
    if (vb->R && !va->R) {
        return {va, true};
    }
    if (vb->R && va->R) {
        auto ans = dfs_miss(va->R, vb->R);
        if (ans.first) return ans;
    }
    return {nullptr, false};
}

pair<Node *, bool> dfs_extra(Node *va, Node *vb) {
    if (va->L && !vb->L) {
        return {va, false};
    }
    if (vb->L && va->L) {
        auto ans = dfs_extra(va->L, vb->L);
        if (ans.first) return ans;
    }
    if (va->R && !vb->R) {
        return {va, true};
    }
    if (vb->R && va->R) {
        auto ans = dfs_extra(va->R, vb->R);
        if (ans.first) return ans;
    }
    return {nullptr, false};
}

signed main() {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    a.resize(n); b.resize(n);
    for (int i =0;i<n;++i) { a[i] = new Node(i); b[i] = new Node(i); }
    for (int i = 1; i < n; ++i) {
        int x; cin >> x;
        if (a[x]->L) {
            a[x]->R = a[i];
        } else a[x]->L = a[i];
    }
    for (int i = 1; i < n; ++i) {
        int x; cin >> x;
        if (b[x]->L) {
            b[x]->R = b[i];
        } else b[x]->L = b[i];
    }
    vector<pair<int,int>> ans;
    for (int _ = 0; _ < n; ++_) {
        auto miss = dfs_miss(a[0], b[0]);
        auto extra = dfs_extra(a[0], b[0]);
        if (miss.first == nullptr) {
            assert(extra.first == nullptr);
            break;
        }
        if (!miss.second) {
            if (!extra.second) {
                miss.first->L = extra.first->L;
                ans.emplace_back(extra.first->L->num, miss.first->num);
                extra.first->L = nullptr;
            } else {
                miss.first->L = extra.first->R;
                ans.emplace_back(extra.first->R->num, miss.first->num);
                extra.first->R = nullptr;
            }
        } else {
            if (!extra.second) {
                miss.first->R = extra.first->L;
                ans.emplace_back(extra.first->L->num, miss.first->num);
                extra.first->L = nullptr;
            } else {
                miss.first->R = extra.first->R;
                ans.emplace_back(extra.first->R->num, miss.first->num);
                extra.first->R = nullptr;
            }
        }
    }
    cout << ans.size() << '\n';
    for(auto i : ans) cout << i.first << ' ' << i.second << '\n';
}
