def isPath(matrix, n, m, K):
    visited = [[False for _ in range(m)] for _ in range(n)]

    if checkPath(matrix, start[0], start[1], visited, K):
        print("YES")
    else:
        print("NO")


def isSafe(i, j, matrix, K):
    if 0 <= i < len(matrix) and 0 <= j < len(matrix[0]) and K >= 0:
        return True
    return False


def checkPath(matrix, i, j, visited, K):
    if isSafe(i, j, matrix, K) and matrix[i][j] != "#" and not visited[i][j]:

        visited[i][j] = True

        if i == end[0] and j == end[1]:
            return True

        if checkPath(matrix, i - 1, j, visited, K):
            return True

        if checkPath(matrix, i, j - 1, visited, K):
            return True

        if checkPath(matrix, i + 1, j, visited, K):
            return True

        if checkPath(matrix, i, j + 1, visited, K):
            return True

        if checkPath(matrix, i - 2, j, visited, K - 1):
            return True

        if checkPath(matrix, i, j - 2, visited, K - 1):
            return True

        if checkPath(matrix, i + 2, j, visited, K - 1):
            return True

        if checkPath(matrix, i, j + 2, visited, K - 1):
            return True

    return False


N, M, K = [int(j) for j in input().split()]
m = [input() for _ in range(N)]
start = [int(j) - 1 for j in input().split()]
end = [int(j) - 1 for j in input().split()]

isPath(m, N, M, K)