class BFSElement:
    def __init__(self, i, j, k):
        self.i = i
        self.j = j
        self.k = k


def findPath(matr):
    q = list()

    q.append(BFSElement(start[0], start[1], K))

    while q:
        x = q[0]
        q = q[1:]

        i = x.i
        j = x.j
        k = x.k

        if i < 0 or i >= N or j < 0 or j >= M or k < 0:
            continue
        if matr[i][j] == "#":
            continue

        if i == end[0] and j == end[1]:
            return True

        matr[i][j] = "#"

        for t in range(-1, 2, 2):
            q.append(BFSElement(i + t, j, k))
            q.append(BFSElement(i, j + t, k))

        q.append(BFSElement(i + 2, j, k - 1))
        q.append(BFSElement(i, j + 2, k - 1))
        q.append(BFSElement(i - 2, j, k - 1))
        q.append(BFSElement(i, j - 2, k - 1))

    return False


N, M, K = [int(j) for j in input().split()]
matr = [list(input()) for _ in range(N)]
start = [int(j) - 1 for j in input().split()]
end = [int(j) - 1 for j in input().split()]
if findPath(matr):
    print("YES")
else:
    print("NO")