import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main1 {
    static BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));

    public static void main(String[] args) throws IOException {
        int n = Integer.parseInt(bf.readLine());
        String[] arr = bf.readLine().split(" ");
        int[] brr = new int[n];
        for (int i = 1; i < n - 1; i++) {
            brr[i] = Integer.parseInt(arr[i - 1]);
        }
        Node[] fin = new Node[n];
        for (int i = 0; i < n; i++) {
            fin[i] = new Node();
        }
        fin[n - 1].bol.finish = true;
        fin[n - 1].step.step = 0;
        int last = n - 1;
        for (int i = n - 2; i >= 0; i--) {
            if (brr[i] == 0) {
                if (last - i <= 6 && fin[last].bol.finish) {
                    fin[i].bol = fin[last].bol;
                    Node.Step max = fin[last].step;
                    int maxi = last;
                    for (int j = i + 1; j < Math.min(i + 7, n); j++) {
                        if (brr[j] != 0)
                            fin[j] = fin[Math.max(j - brr[j], 0)];

                        if (max.step >= fin[j].step.step) {
                            maxi = j;
                            max = fin[j].step;
                        }

                    }

                    int as = (maxi - i == 6 ? 0 : 1);
                    fin[i].step.step = max.step + as;
                    last = i;
                } else {
                    System.out.println(-1);
                    return;
                }
            }
        }

        System.out.println(fin[0].step.step);
    }

    static class Node {
        static class Bol {
            boolean finish;

            Bol(boolean b) {
                this.finish = b;
            }
        }

        static class Step {
            int step = Integer.MAX_VALUE;
        }

        Bol bol = null;
        Step step;

        Node() {
            this.bol = new Bol(false);
            this.step = new Step();
        }

        @Override
        public String toString() {
            return bol.finish + " " + step.step;
        }
    }
}
