// A
/*
Середина игры
	Имя входного файла: стандартный ввод
	Имя выходного файла: стандартный вывод
	Ограничение по времени: 0.5 секунд
	Ограничение по памяти: 256 мегабайт

А Вы знали, что сегодня проходит финал международного турнира по крестикам-ноликам на
бесконечной доске? Вадим тоже не знал, но, услышав об этом монументальном событии года, он
открыл стрим и увидел, что между собой сражаются два игрока, Алиса и Боб. Сейчас у Алисы A
очков, а у Боба — B очков. Как всем интересующимся известно, за победу в раунде человеку даётся
2 очка, за ничью — 1 очко, за поражение — 0 очков.
Вадим очень опечален тем, что пропустил часть этой игры, ведь ему очень интересно, в скольких
раундах победила Алиса, в скольких победил Боб и в скольких была ничья. Помогите ему ответить
на этот вопрос.

Формат входных данных
	В первой строке дано одно целое число A — количество очков у Алисы (0 <= A <= 10^9).
	Во второй строке дано одно целое число B — количество очков у Боба (0 <= B <= 10^9).

Формат выходных данных
	Если в данных есть ошибка, то есть текущие результаты никак не достижимы при проведении
любого количество раундов, выведите «Error».
	Если однозначно ответить невозможно, выведите «Undefined».
	Иначе, выведите три числа — количество раундов, в которых победила Алиса, количество раундов, в которых победил Боб, и количество раундов, в которых была ничья
*/

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

int main()
{
    long long a, b;
    cin >> a >> b;
    long long alice = 0, bob = 0, draws = 0;
    if((a+b) % 2 == 1)
    {
        cout << "Error";
        return 0;
    }
    if((a >= 2) && (b >= 2))
    {
        cout << "Undefined";
        return 0;
    }
    if((a == 1) || (b == 1))
    {
        draws++;
        a--;
        b--;
    }
    alice = a / 2;
    bob = b / 2;
    cout << alice << '\n' << bob << '\n' << draws;
    return 0;
}