using System;

class Program
{
    static long GCD(long a, long b)
    {
        while (b != 0)
        {
            long temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }

    static void Main(string[] args)
    {
        Console.Write("Введите значение для L: ");
        long L = Convert.ToInt64(Console.ReadLine());

        Console.Write("Введите значение для R: ");
        long R = Convert.ToInt64(Console.ReadLine());

        // Счетчик времени выполнения
        DateTime startTime = DateTime.Now;

        long maxGCD = 0;
        long x = 0;
        long y = 0;

        for (long i = L; i <= R; i++)
        {
            for (long j = i + 1; j <= R; j++)
            {
                long gcd = GCD(i, j);
                if (gcd > maxGCD)
                {
                    maxGCD = gcd;
                    x = i;
                    y = j;
                }
            }
        }

        DateTime endTime = DateTime.Now;
        TimeSpan executionTime = endTime - startTime;

        Console.WriteLine($"Пара чисел с наибольшим НОД: {x}, {y}");
        Console.WriteLine($"Время выполнения программы: {executionTime.TotalMilliseconds} мс");
    }
}