#include <iostream>
#include <vector>
#include <cmath>

int main() {
    int n;
    std::cin >> n;

    std::vector<double> sides;
    double maxSide = 0;
    int maxSideIdx = 0;

    int xPrev, yPrev;
    std::cin >> xPrev >> yPrev;
    int xStart = xPrev;
    int yStart = yPrev;
    double total = 0;
    double prev = 0;

    for (int i = 0; i < n; i++) {
        int x, y;
        if (i == n - 1) {
            x = xStart;
            y = yStart;
        }
        else {
            std::cin >> x >> y;
        }
        double side = std::sqrt(std::pow((x - xPrev), 2) + std::pow((y - yPrev), 2));
        if (side > maxSide) {
            maxSide = side;
            maxSideIdx = sides.size();
        }
        sides.push_back(side);
        xPrev = x;
        yPrev = y;
    }

    sides.erase(sides.begin() + maxSideIdx);
    double sumSides = 0;
    for (double side : sides) {
        sumSides += side;
    }

    std::cout << sumSides << std::endl;

    return 0;
}
