from math import sqrt, ceil

def solve(l, r):
    results = []
    limit = ceil(sqrt(r))
    delta = r - l

    if limit > delta:
        results = range(delta, 0, -1)
    else:
        results = (r // f for f in range(r // delta, limit))

    for result in results:
        biggest = r - r % result
        if l <= biggest - result:
            return biggest - result, biggest


i, j = [int(x) for x in input().split()]

print(*solve(i, j))