
def count_probabilities(N, K):
    prob = [0] * (N * K + 1)

    for i in range(1, K + 1):
        prob[i] = 1 / K

    for _ in range(1, N):
        new_prob = [0] * (N * K + 1)

        for i in range(1, N * K + 1):
            for j in range(1, K + 1):
                if i >= j:
                    new_prob[i] += (prob[i - j] / K)

        prob = new_prob

    return prob


def main():
    N = int(input())
    K = int(input())
    S1 = int(input())
    S2 = int(input())

    prob = count_probabilities(N, K)

    if prob[S1] > prob[S2]:
        print("First")
    elif prob[S1] < prob[S2]:
        print("Second")
    else:
        print("Equal")


if __name__ == "__main__":
    main()