def register_users(q, queries):
    registered_users = {}
    result = []

    for query in queries:
        if query in registered_users:
            counters = registered_users[query]
            count = 1
            name = query + str(count)
            while name in result:
                count += 1
                name = query + str(count)
            counters.add(count)
        else:
            registered_users[query] = {1}
            name = query

        result.append(name)
        registered_users[name] = set()

    return result


q = int(input())
queries = []
for _ in range(q):
    queries.append(input())

result = register_users(q, queries)
for name in result:
    print(name)
