/*
   Moon and sun, fear and love
   Everything a part of love
   Head, heart, light against dark
   Uh, everything a part of love
   Uh, everything a part of love
   Earth, star, everything falls
   Everything a part of love
   Rain and snow
   Everything a part of what you are
   Love, love, love, love
   Everything a part of love
   Love, two as one, fall in love
   Everything a part of love
   One, one, two, one, two
   Everything a part of you
   Everything a part of you
   Love is one, everything there always was, us

   I want it, I-I-I want it
   I want it, I want it
   I-I-Iconic, iconic
   I want it, I-I-I want it
   I want it, I want it
   I-I-Iconic
   I love it, I want it
   I-I-I love it
   I love it, I want it
   I-I-Iconic
*/

// #pragma GCC optimize("Ofast,unroll-loops")
#ifdef LOCAL
#include "debug.h"
#else
#include <bits/stdc++.h>
#define debug(x...)
#endif

using namespace std;

// #define int ll

typedef long long ll;
typedef long double ld;
#define sz(x) int((x).size())

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif

const int N = 1e3 + 10;
const int MOD = 1e9 + 7;
// const int MOD = 998244353;
const ld eps = 5e-8;
const pair<int, int> dir[] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

int n, m, k;
char a[N][N];

int color[N][N];

void dfs_color(int i, int j, int c) {
    color[i][j] = c;

    for (auto [dx, dy] : dir) {
        int x = i + dx, y = j + dy;
        if (x >= 0 && x < n && j >= 0 && j < m && a[x][y] == '.' && color[x][y] == -1) {
            dfs_color(x, y, c);
        }
    }
}

vector<int> g[N * N];
int d[N * N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout << fixed << setprecision(9);
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;

    memset(color, -1, sizeof color);
    int c = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '.' && color[i][j] == -1) {
                dfs_color(i, j, c++);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (auto [dx, dy] : dir) {
                int x = i + 2 * dx, y = j + 2 * dy;
                if (x < 0 || x >= n || y < 0 || y >= m) continue;

                int c1 = color[x][y], c2 = color[i][j];
                if (c1 == -1 || c2 == -1) continue;

                if (c1 != c2) {
                    g[c1].push_back(c2);
                    g[c2].push_back(c1);
                }
            }
        }
    }

    for (int i = 0; i < c; ++i) {
        sort(g[i].begin(), g[i].end());
        g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
    }

    --dx, --dy, --ax, --ay;
    int src = color[dx][dy], dest = color[ax][ay];

    fill(d, d + N * N, 1e9);
    set<pair<int, int>> s;
    s.insert({0, src});
    d[src] = 0;

    while (!s.empty()) {
        int u = s.begin()->second;
        s.erase(s.begin());

        debug(u, d[u]);

        for (int v : g[u]) {
            if (d[v] > d[u] + 1) {
                s.erase({d[v], v});
                d[v] = d[u] + 1;
                s.insert({d[v], v});
            } 
        }
    }

    debug(d[dest]);

    if (d[dest] <= k) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }

    return 0;
}