fun main() {
    val n = readLine()!!.toInt()
    val k = readLine()!!.toInt()
    val s1 = readLine()!!.toInt()
    val s2 = readLine()!!.toInt()

    val expectedValue1 = expectedValue(n, k, s1)
    val expectedValue2 = expectedValue(n, k, s2)

    when {
        expectedValue1 > expectedValue2 -> println("First")
        expectedValue1 < expectedValue2 -> println("Second")
        else -> println("Equal")
    }
}

fun expectedValue(n: Int, k: Int, s: Int): Double {
    val dp = Array(n + 1) { DoubleArray(s + 1) }

    for (j in 1..minOf(k, s)) {
        dp[1][j] = 1.0 / k
    }

    for (i in 2..n) {
        for (j in 1..s) {
            for (m in 1..minOf(k, j)) {
                dp[i][j] += dp[i - 1][j - m] / k
            }
        }
    }

    return dp[n][s]
}
