import java.io.BufferedReader;
import java.io.InputStreamReader;

public class E {
    private static final int MUL = 2520;

    public static void main(String[] args) throws Exception {
        try (var reader = new BufferedReader(new InputStreamReader(System.in))) {
            var nk = reader.readLine().split(" ");
            var n = Integer.parseInt(nk[0]);
            var k = Long.parseLong(nk[1]);

            var m = new MutableLong[11];
            for (int i = 1; i <= 10; i++) {
                m[i] = new MutableLong();
            }

            var s = reader.readLine().split(" ");
            var a = reader.readLine().split(" ");

            for (int i = 0; i < n; i++) {
                var sw = Integer.parseInt(s[i]);
                var aw = Long.parseLong(a[i]);
                var dlt = Math.abs(sw - aw);
                m[sw].add(dlt);
            }

            k *= MUL;
            if (calc(m) <= k) {
                System.out.println(0);
                return;
            }

            var res = 0L;
            for (int i = 1; i <= 10; i++) {
                var v = m[i];
                if (v.value <= 0) continue;

                var clc = calc(m);
                var cv = v.value * MUL / i;
                var clk = clc - k;
                if (clk > cv) {
                    res += v.value;
                    v.value = 0;
                } else {
                    long l = 0, r = v.value;
                    while (l <= r) {
                        var md = (l + r) >>> 1;
                        var cmp = Long.compare(md * MUL / i, clk);
                        if (cmp == 0) {
                            l = md;
                            break;
                        } else if (cmp > 0) {
                            r = md - 1;
                        } else {
                            l = md + 1;
                        }
                    }
                    res += l;
                    break;
                }
            }

            System.out.println(res);
        }
    }

    private static long calc(MutableLong[] m) {
        var res = 0L;
        for (int i = 1; i <= 10; i++) {
            var v = m[i];
            if (v.value > 0) {
                res += v.value * MUL / i;
            }
        }
        return res;
    }

    static class MutableLong {
        private long value;

        public MutableLong(long v) {
            value = v;
        }

        public MutableLong() {
            this(0);
        }

        public long getValue() {
            return value;
        }

        public long getAndIncrement() {
            return value++;
        }

        public void add(long v) {
            value += v;
        }
    }
}
