#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

#define MAX_D 1000000000.0

#define cin std::cin
#define cout std::cout

#define nn std::endl

#define ffor(n) for (int i = 0; i < n; i++)
#define bfor(n) for (int i = n; i > 0; i++)

#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min(a,b) (((a) < (b)) ? (a) : (b))

typedef long long ll;
typedef long double ld;

typedef std::vector<int> vector_i;
typedef std::vector<double> vector_d;

int main() {
	int n; cin >> n;
	ld res = .0;

	int px, py, fx, fy;
	cin >> fx >> fy;
	px = fx; py = fy;

	double mlen = -MAX_D;

	ffor(n - 1) {
		int x, y;
		cin >> x >> y;
		double clen = sqrt(pow(abs(x - px), 2) + pow(abs(y - py), 2));
		if (clen > mlen) mlen = clen;
		res += clen;
		px = x; py = y;
	}

	cout.precision(8);
	cout << res + sqrt(pow(abs(fx - px), 2) + pow(abs(fy - py), 2)) - mlen << nn;

	return 0;
}