#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double lld;
#define nn "\n"
#define haha ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)

int n = 1000, m = 1000, k = 1000;

vector<vector<int>> dirs = {
        vector<int>{0, 1},
        vector<int>{1, 0},
        vector<int>{0, -1},
        vector<int>{-1, 0},
};

bool in_border(int i, int j) {
    if (i < 0 || i >= n) return false;
    if (j < 0 || j >= m) return false;

    return true;
}

int main() {
    haha;

    int start_i, start_j;
    int end_i, end_j;

    cin >> n >> m >> k;

    vector<vector<int>> visited;
    vector<vector<char>> a;

    a.resize(n, vector<char> (m));
    visited.resize(n, vector<int> (m, -1));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) cin >> a[i][j];

    cin >> start_i >> start_j;
    cin >> end_i >> end_j;

    start_i--; start_j--;
    end_i--; end_j--;

    queue<vector<int>> q;
    q.push(vector<int>{start_i, start_j});

    visited[start_i][start_j] = 0;

    while (!q.empty()) {
        vector<int> cur = q.front();
        q.pop();

        int i = cur[0], j = cur[1];

        if (a[i][j] == '#') continue;

        for (auto& dir: dirs) {
            int ii = i + dir[0];
            int jj = j + dir[1];

            if (!in_border(ii, jj)) continue;

            if (a[ii][jj] == '#') {
                ii = i + dir[0] * 2;
                jj = j + dir[1] * 2;

                if (!in_border(ii, jj)) continue;

                if (a[ii][jj] == '#') continue;

                if (visited[ii][jj] == -1 || visited[ii][jj] > visited[i][j] + 1) {
                    visited[ii][jj] = visited[i][j] + 1;
                    q.push(vector<int>{ii, jj});
                    continue;
                }
            }
            else {
                if (visited[ii][jj] == -1 || visited[ii][jj] > visited[i][j]) {
                    visited[ii][jj] = visited[i][j];
                    q.push(vector<int>{ii, jj});
                }
            }
        }
    }

    if (visited[end_i][end_j] <= k) cout << "YES";
    else cout << "NO";
}