import java.util.Arrays;
import java.util.Scanner;
public class Task_F {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        double[] edges = new double[n];
        long x;
        long y;
        long start_x = scanner.nextLong();
        long start_y = scanner.nextLong();
        long prev_x = start_x;
        long prev_y = start_y;
        double max = 0;
        for (int i = 0; i < n-1; i++) {
            x = scanner.nextLong();
            y = scanner.nextLong();
            edges[i] = Math.sqrt(Math.pow(x - prev_x, 2) + Math.pow(y - prev_y, 2));
            if (edges[i] > max) {
                max = edges[i];
            }
            prev_x = x;
            prev_y = y;
        }
        edges[n-1] = Math.pow(prev_x - start_x, 2) + Math.pow(prev_y - start_y, 2);
        if (edges[n-1] > max) {
            max = edges[n-1];
        }

        double sum = Arrays.stream(edges).sum();
        System.out.println(sum - max);
    }
}
