import java.util.Scanner;

public class Task_G {
    // Функция для вычисления наибольшего общего делителя (НОД) двух чисел
    public static long gcd(long a, long b) {
        while (b != 0) {
            long temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        long L = scanner.nextLong();
        long R = scanner.nextLong();

        long maxGCD = 0;
        long num1 = 0, num2 = 0;

        // Перебор всех возможных пар чисел в заданном диапазоне и нахождение НОД
        for (long i = L; i <= R; i++) {
            for (long j = i + 1; j <= R; j++) {
                long currentGCD = gcd(i, j);
                if (currentGCD > maxGCD) {
                    maxGCD = currentGCD;
                    num1 = i;
                    num2 = j;
                }
            }
        }

        System.out.println(num1 + " " + num2);
    }
}