import java.util.HashMap;
import java.util.Scanner;

public class Task_H {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int Q = scanner.nextInt();
        scanner.nextLine();  // Считываем символ новой строки после числа запросов

        HashMap<String, Integer> users = new HashMap<>();

        for (int i = 0; i < Q; i++) {
            String name = scanner.nextLine().trim();  // Считываем запрос и удаляем лишние пробелы

            if (!users.containsKey(name)) {
                users.put(name, 1);  // Если пользователя нет в HashMap, добавляем его с счетчиком 1
                System.out.println(name);  // Выводим имя пользователя
            } else {
                int count = users.get(name);
                while (users.containsKey(name + count)) {
                    count++;
                }
                users.put(name + count, 1);  // Добавляем нового пользователя с уникальным именем
                System.out.println(name + count);  // Выводим имя пользователя с уникальным суффиксом
            }
        }
    }
}