#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

int N = 30000, T = 600;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<long double> diffs(n);
    vector<pair<int, int>> nums(n);
    long double sum = 0, max_diff = 0;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        nums[i] = {x, y};
        if (i > 0) {
            int x1 = nums[i - 1].first, y1 = nums[i - 1].second;
            diffs[i] = sqrt(pow(x - x1, 2) + pow(y - y1, 2));
            sum += diffs[i];
            max_diff = max(max_diff, diffs[i]);
        }
    }
    int x1 = nums[0].first, y1 = nums[0].second;
    int x = nums[n - 1].first, y = nums[n - 1].second;
    diffs[0] = sqrt(pow(x - x1, 2) + pow(y - y1, 2));
    sum += diffs[0];
    max_diff = max(max_diff, diffs[0]);

    cout << sum - max_diff;
}