#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;
using ull = unsigned long long;
using ll = long long;

bool pred(ll m, ll L, ll R) {
    ll K_1 = R / m;
    ll K_0 = K_1 - 1;
    return m * K_1 <= R && m * K_0 >= L && m * K_1 >= L && m * K_0 <= R;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ull L, R;
    cin >> L >> R;
    ull max_m = 0;
    for (ull i = 1; i <= R - L; i++) {
        if (pred(i, L, R))
            max_m = max(max_m, i);
    }
    cout << (R / max_m - 1) * max_m << " " << R / max_m * max_m;
}