﻿#include <iostream>
#include <vector>

int main() {
    int N, K, S1, S2;
    std::cin >> N >> K >> S1 >> S2;

    std::vector<int> sums(K * N - N + 1, 0);

    for (int i = 0; i < pow(K, N); i++) {
        int sum = 0;
        int num = i;
        for (int j = 0; j < N; j++) {
            sum += num % K + 1;
            num /= K;
        }
        sums[sum - N]++;
    }

    double p1 = static_cast<double>(sums[S1 - N]) / pow(K, N);
    double p2 = static_cast<double>(sums[S2 - N]) / pow(K, N);


    if (p1 > p2)
        std::cout << "First";
    else if (p2 > p1)
        std::cout << "Second";
    else
        std::cout << "Equal";

    return 0;
}