#include <iostream>

int count_split_options(size_t sum, size_t max_num);

int main()
{
	size_t spin_times = 1;
	size_t max_num = 1;
	size_t first_player_sum = 1;
	size_t second_player_sum = 1;

	std::cin >> spin_times >> max_num >> first_player_sum >> second_player_sum;

#if 1
	double average = 0.0;
	for (int i = 1; i <= max_num; i++)
	{
		average += double(i);
	}
	average /= 2;
	average *= spin_times;

	double first_diff = std::abs(first_player_sum - average);
	double second_diff = std::abs(second_player_sum - average);

	if (first_diff < second_diff)
	{
		std::cout << "First";
	}
	else if (first_diff > second_diff)
	{
		std::cout << "Second";
	}
	else
	{
		std::cout << "Equal";
	}

	return 0;
#else


	int first_option_count = count_split_options(first_player_sum, max_num);
	int second_option_count = count_split_options(second_player_sum, max_num);

	if (first_option_count == second_option_count)
	{
		std::cout << "Equal";
	}
	else if (first_option_count < second_option_count)
	{
		std::cout << "Second";
	}
	else
	{
		std::cout << "First";
	}

	return 0;

#endif
}


int count_split_options(size_t sum, size_t max_num)
{
	if (0 == sum && 0 == max_num)
	{
		return 1;
	}
	if (0 == max_num)
	{
		return 0;
	}
	
	if (max_num <= sum)
	{
		return count_split_options(sum, max_num - 1)
			+ count_split_options(sum - max_num, max_num);
	}
	return count_split_options(sum, max_num);
}
