﻿#include <iostream>
#include <vector>
using namespace std;

struct Point {
    int x;
    int y;
};

struct Line {
    int x1, y1;
    int x2, y2;
    double dlina;

    Line(int q, int w, int e, int r) {
        x1 = q;
        y1 = w;
        x2 = e;
        y2 = r;
        dlina = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
    }
};

void main()
{
    int n;
    int x1, x2;
    cin >> n;
    vector<Point> place;
    double total1 = 0;
    double total2 = 0;
    Point point;
    while (place.size() != n) {
        cin >> point.x >> point.y;
        place.push_back(point);
    }
    if (n % 2 == 0) {
        for (int i = 0; i < place.size() - 1; i++) {
            Line line(place[i].x, place[i].y, place[i + 1].x, place[i + 1].y);
            total1 += line.dlina;
        }
        printf("%lf", total1);
    }
    else {
        Line line(place[0].x, place[0].y, place[n-1].x, place[n-1].y);
        total2 += line.dlina;

        for (int i = 0, j = n-1; i < place.size() - 1 || j >= 2; i++, j--) {
            if (j == 2) {
                Line line2(place[j].x, place[j].y, place[j - 1].x, place[j - 1].y);
                total2 += line2.dlina;
            }
            Line line1(place[i].x, place[i].y, place[i + 1].x, place[i + 1].y);
            total1 += line1.dlina;
        }
        printf("%lf", (total1 < total2) ? total1 : total2);
    }
}
