﻿#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

struct Point {
    int x;
    int y;
    int mark;
};

struct Line {
    int x1, y1;
    int x2, y2;
    double dlina;

    Line(int q, int w, int e, int r) {
        x1 = q;
        y1 = w;
        x2 = e;
        y2 = r;
        dlina = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
    }
    Line() {
        x1 = INT32_MAX;
        y1 = INT32_MAX;
        x2 = INT32_MAX;
        y2 = INT32_MAX;
        dlina = INT32_MAX;
    }
};



int main()
{
    int n;
    int x1, x2;
    cin >> n;
    vector<Point> place;
    double total1 = 0;
    double total2 = 0;
    Point point;

    while (place.size() != n) {
        cin >> point.x >> point.y;
        place.push_back(point);
    }

        int min = INT32_MAX;
        int max = INT32_MIN;
        Line min_line;

        int i_start_point = 0;
        Point point1;
        Point point2;
        for (int i = 0; i < place.size() - 1; i++) {
            Line test_line(place[i].x, place[i].y, place[i+1].x, place[i+1].y);
            if (test_line.dlina < min_line.dlina) {
                i_start_point = i;
                point1.x = place[i].x;
                point1.y = place[i].y;
                point2.x = place[i + 1].x;
                point2.y = place[i + 1].y;
                min_line.dlina = test_line.dlina;
            }
        }

        for (int i = i_start_point; i < place.size()-1 + i_start_point; i++) {
            Line line1(place[i% place.size()].x, place[i% place.size()].y, place[(i + 1)% place.size()].x, place[(i + 1)% place.size()] .y);
            total1 += line1.dlina;
        }

        for (int j = place.size() - 1 + i_start_point; j >= i_start_point; j--) {
            Line line2(place[j % place.size()].x, place[j % place.size()].y, place[(j - 1) % place.size()].x, place[(j - 1) % place.size()].y);
            total2 += line2.dlina;
        }
        printf("%lf", (total1 < total2) ? total1 : total2);

    return 0;
}


