﻿#include <iostream>

int del(int a, int b) {
    while (a != 0 && b != 0) {
        if (a > b) {
            a -= b;
        }
        else {
            b -= a;
        }
    }
    return a + b;
}

std::pair<int, int> max_del(int a, int b) {
    int max = 0;
    std::pair<int, int> result;
    for (int i = a; i <= b; i++) {
        for (int j = i + 1; j <= b; j++) {
            int g = del(i, j);
            if (g > max) {
                max = g;
                result = std::make_pair(i, j);
            }
        }
    }
    return result;
}

int main()
{
    int x, y;
    std::cin >> x >> y;
    std::pair<int, int> result = max_del(x, y);
    std::cout << result.first << " " << result.second << std::endl;
}