#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

void Solve() {
    long long L, R;
    cin >> L >> R;
    if(L == 0){
        cout << L << " " << R;
    }
    else if(L >= R - 2){
        cout << L << " " << R;
    }
    else if(L*2 <= R){
        cout << R/2 << " " << R/2*2;
    }
    else{
        long long d = (R-L+1)/2;
        for(long long i = d+1; i < (R-L+1); ++i){
            if ((L%i)*(R%i) == 0){
                d = i;
            }
            else if(L + i-L%i < R-R%i){
                d = i;
            }
        }
        if(!(L%d)){
            cerr << d << " ";
            cout<< L << " " << R - R%d;
        }
        else if(!(R%d)){
            cout << R-d << " " << R;
        }
        else{
            cout << L + d - L%d << " " << R - R%d;}
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}
