#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <cmath>
#include <deque>
#include <set>

#define int long long

using namespace std;

void Solve() {
    int t;
    long long n;
    cin >> n;
    vector <int>  v(n, 0), a(n, 0);
    vector <vector<pair<int, int>>> g(n);
    for(int i = 1; i <= n - 2; ++i){
        cin >> v[i];
    }
    for(int i = 0; i < n; ++i){
        if(v[i]) {
            a[i] = a[i-v[i]];
        }
        else{
            a[i] = i;
        }
    }
//    for (const auto& x : a) {
//        cout << x << " ";
//    }
//    cout << "\n";
    for(int i = 0; i < n; ++i){
        if(v[i] == 0){
            g[i].push_back({a[min(i+1, n-1)],1});
            g[i].push_back({a[min(i+2, n-1)],1});
            g[i].push_back({a[min(i+3, n-1)],1});
            g[i].push_back({a[min(i+4, n-1)],1});
            g[i].push_back({a[min(i+5, n-1)],1});
            if (i + 6 >= n - 1) {
                g[i].push_back({a[min(i+6, n-1)],1});
            } else {
                g[i].push_back({a[min(i + 6, n - 1)], 0});
            }
        }
    }
    int cnt = 0;
//    for (const auto& v : g) {
//        cout << cnt << "\n";
//        ++cnt;
//        for (const auto& [x, y] : v) {
//            cout << x << " " << y << "\n";
//        }
//        cout << "\n";
//    }
    int s = 0;
    const int INF = 5 * n;
    vector<int> d(n, INF);
    set<pair<int, int>> q;
    d[s] = 0;
    q.insert({d[s], s});
    while (q.size() > 0) {
        int u = q.begin()->second;
        q.erase(q.begin());
        for (const auto& [v, w] : g[u]) {
            if (d[v] > d[u] + w) {
                q.erase({d[v], v});
                d[v] = d[u] + w;
                q.insert({d[v], v});
            }
        }
    }
//    for (const auto& x : d) {
//        cout << x << " ";
//    }
//    cout << "\n";
    if (d[n - 1] != INF) {
        cout << d[n - 1] << "\n";
    } else {
        cout << "-1\n";
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}