#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;
unordered_map<string, int> counts;

string getuName(const string& name) {
    string uName = name;
    while (counts.count(uName) > 0)
        uName = name + to_string(counts[name]++);
    counts[uName]++;
    return uName;
}

int main() {
    int q;
    cin >> q;
    vector<string> results;
    for (int i = 0; i < q; i++)
    {
        string name;
        cin >> name;
        string uName = getuName(name);
        results.push_back(uName);
    }
    for (const string& name : results)
        cout << name;
    return 1;
}
