#include <iostream>
#include <unordered_map>
#include <vector>
using namespace std;

unordered_map<string, int> myCounts;

string getuName(const string& name) {
    string uName = name;
    while (myCounts.count(uName) > 0) {
        uName = name + to_string(myCounts[name]++);
    }
    myCounts[uName]++;
    return uName;
}

int main() {
    int q;
    cin >> q;

    vector<string> res;

    for (int i = 0; i < q; i++) {
        string name;
        cin >> name;
        string uName = getuName(name);
        res.push_back(uName);
    }

    // Вывод результатов
    for (const string& name : res) {
        cout << name << endl;
    }

    return 0;
}