#include <iostream>
#include <map>
#include <set>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

void solve() {
	map<string, set<int>> mex;
	set<string> names;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        string s;
        cin >> s;
        if (!names.count(s)) {
            names.insert(s);
            mex[s].insert(1);
            cout << s << "\n";
        }
        else {
            int m = *mex[s].begin();
            // mex[s].erase(m);
            s += to_string(m);
            if (!names.count(s + "1")) {
                mex[s].insert(1);
            }
            names.insert(s);
            cout << s << "\n";
        }
        int suff = 0;
        int pw = 1;
        while (s.length() > 0) {
            suff = (s.back() - '0') * pw + suff;
            pw *= 10;
            s.pop_back();
            if (s.length() > 0) {
                if (mex[s].count(suff)) {
                    mex[s].erase(suff);
                    if (!names.count(s + to_string(suff + 1))) {
                        mex[s].insert(suff + 1);
                    }
                }
            }
        }
    }
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
