N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

dp = [[0] * (N * K + 1) for _ in range(N + 1)]
dp[0][0] = 1

for i in range(1, N + 1):
    for j in range(1, N * K + 1):
        dp[i][j] = sum(dp[i - 1][j - k] for k in range(1, K + 1) if j - k >= 0)

p1 = dp[N][S1]
p2 = dp[N][S2]

if p1 > p2:
    print("First")
elif p1 < p2:
    print("Second")
else:
    print("Equal")