from math import comb


def calc(N, K, S):
    return comb(S + N - 1, N - 1) * pow(K, N, 10**9 + 7) % (10**9 + 7)


def solve(N, K, S1, S2):
    first = calc(N, K, S1)
    second = calc(N, K, S2)

    if first > second:
        return "First"
    elif second > first:
        return "Second"
    else:
        return "Equal"

N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = solve(N, K, S1, S2)
print(result)
