#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main() {
    int N, K;
    cin >> N >> K;

    vector<int> s(N), a(N);
    for (int i = 0; i < N; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < N; i++) {
        cin >> a[i];
    }

    int count = 0;
    vector<double> lensp(N), lensm(N);
    double sum = 0.0;

    int max_lensp_index = 0, max_lensm_index = 0;

    for (int i = 0; i < N; i++) {
        lensp[i] = (static_cast<double>(a[i])/s[i]-1) - (static_cast<double>(a[i]-1)/s[i]-1);
        lensm[i] = (static_cast<double>(a[i])/s[i]-1) - (static_cast<double>(a[i]+1)/s[i]-1);

        sum += static_cast<double>(a[i])/s[i] - 1.0;

        if (lensp[i] > lensp[max_lensp_index]) max_lensp_index = i;
        if (lensm[i] > lensm[max_lensm_index]) max_lensm_index = i;
    }

    while (abs(sum) > K) {
        if (sum > K) {

            sum -= lensp[max_lensp_index];
            a[max_lensp_index] -= 1;
            lensp[max_lensp_index] = (static_cast<double>(a[max_lensp_index])/s[max_lensp_index]-1) -
                                     (static_cast<double>(a[max_lensp_index]-1)/s[max_lensp_index]-1);

            max_lensp_index = max_element(lensp.begin(), lensp.end()) - lensp.begin();
        } else {

            sum -= lensm[max_lensm_index];
            a[max_lensm_index] += 1;
            lensm[max_lensm_index] = (static_cast<double>(a[max_lensm_index])/s[max_lensm_index]-1) -
                                     (static_cast<double>(a[max_lensm_index]+1)/s[max_lensm_index]-1);

            max_lensm_index = max_element(lensm.begin(), lensm.end()) - lensm.begin();
        }
        count++;
    }

    cout << count << endl;

    return 0;
}