#include <iostream>

long long findGCD(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main() {
    long long L, R;
    std::cin >> L >> R;

    long long x = L;
    long long y = L + 1;
    long long maxGCD = 1;

    for (long long i = L; i < R; i++) {
        for (long long j = i + 1; j <= R; j++) {
            long long currentGCD = findGCD(i, j);
            if (currentGCD > maxGCD) {
                maxGCD = currentGCD;
                x = i;
                y = j;
            }
        }
    }

    std::cout << x << " " << y << std::endl;

    return 0;
}