#include <iostream>
#include <unordered_map>


std::string compute_name(std::unordered_map<std::string, int>& count_map, std::string& name) {
    std::string new_name = name;

    while (count_map.count(new_name) != 0) {
        new_name = name + std::to_string(count_map[name]);
        count_map[name]++;
    }

    count_map[new_name]++;
    return new_name;
}


int main() {
    int count_names;
    std::unordered_map<std::string, int> count_map;
    std::string curr_name;

    std::cin >> count_names;
    for (int i = 0; i < count_names; i++) {
        std::cin >> curr_name;
        std::string name = compute_name(count_map, curr_name);
        std::cout << name << std::endl;
    }

    return 0;
}