#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2")

using namespace std;
typedef long long ll;
typedef long double ld;

ld len_of(ll x1, ll y1, ll x2, ll y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

int main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, x, y;
    cin >> n;
    ld l, ans = 0, ml = 0;
    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x >> y;
        a[i] = make_pair(x, y);
    }
    ll x1, y1, x2, y2;
    for (ll i = 0; i < n; ++i) {
        x1 = a[i].first;
        y1 = a[i].second;
        x2 = a[(i + 1) % n].first;
        y2 = a[(i + 1) % n].second;
        l = len_of(x1, y1, x2, y2);
        ml = max(ml, l);
        ans += l;
    }
    ans -= ml;
    cout << ans;
    return 0;
}
