#include <iostream>
#include <cstdio>

unsigned long long factorial(const unsigned long long n)
{
    unsigned long long f = 1;
    for (unsigned long long i=1; i<=n; ++i)
        f *= i;
    return f;
}


long double math_c(const unsigned long long k, const unsigned long long n){

    return (long double) (factorial(n)) / (long double) (factorial(k) * factorial(n-k));
}

int main(int argc, char **argv) {

    unsigned long long n = 0;
    unsigned long long k = 0;
    unsigned long long s1 = 0;
    unsigned long long s2 = 0;

    std::cin >> n;
    std::cin >> k;
    std::cin >> s1;
    std::cin >> s2;

    long double test1 = math_c(k, k*s1) / math_c(k, k*n);
    long double test2 = math_c(k, k*s2) / math_c(k, k*n);

    if(test1 == test2){
        std::cout << "Equal";
    }
    else if(test1 > test2) {
        std::cout << "First";

    } else if(test1 < test2) {
        std::cout << "Second";
    }

    return 0;
}
