# Step 1: Parse the input data
A = int(input())
B = int(input())

# Step 2: Check for errors in the input data
if A < B:
    print("Error")
elif A == B:
    # If Alice and Bob have the same points, it's impossible to determine the outcome.
    print("Undefined")
else:
    # Step 3: Calculate the number of rounds Alice and Bob won and the number of draws
    total_rounds = (A + B) // 2
    alice_won = total_rounds - B
    bob_won = total_rounds - alice_won - 1
    draws = min(A, B)

    # Step 4: Output the result
    print(alice_won)
    print(bob_won)
    print(draws)
