def roulette_game(N, K, S1, S2):
    # Среднее значение для каждого запуска рулетки
    avg = (K + 1) / 2

    # Ожидаемая сумма после N запусков
    expected_sum = N * avg

    # Разница между ожидаемой суммой и ставками игроков
    diff1 = abs(expected_sum - S1)
    diff2 = abs(expected_sum - S2)

    # Определение победителя
    if diff1 < diff2:
        return "First"
    elif diff1 > diff2:
        return "Second"
    else:
        return "Equal"


n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

print(roulette_game(n, k, s1, s2))
