def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def find_pair_with_largest_gcd(L, R):
    max_gcd = 0
    pair = (0, 0)
    
    for x in range(L, R+1):
        for y in range(x+1, R+1):
            current_gcd = gcd(x, y)
            if current_gcd > max_gcd:
                max_gcd = current_gcd
                pair = (x, y)
    
    return pair

L, R = map(int, input().split())
pair = find_pair_with_largest_gcd(L, R)
print(pair[0], pair[1])
