def generate_username(usernames, username):
    if username not in usernames:
        usernames.add(username)
        return username
    else:
        i = 1
        while True:
            new_username = f"{username}{i}"
            if new_username not in usernames:
                usernames.add(new_username)
                return new_username
            i += 1

def process_usernames(Q, queries):
    usernames = set()
    result = []

    for i in range(Q):
        username = queries[i]
        result.append(generate_username(usernames, username))

    return result

# Считываем количество запросов
Q = int(input())

# Считываем запросы
queries = []
for _ in range(Q):
    query = input().strip()
    queries.append(query)

# Обрабатываем запросы
result = process_usernames(Q, queries)

# Выводим результат
for username in result:
    print(username)
