import math


def math_comb(s, n, k):
    return math.comb(s+n-1, n-1) % (10**9 + 7)

def probs(n, k, s1, s2):
    total_combinations = math.pow(k, n)
    p1 = sum(math_comb(s1, n, k) for s1 in range(s1, s1 + n)) / total_combinations
    p2 = sum(math_comb(s2, n, k) for s2 in range(s2, s2 + n)) / total_combinations
    return p1, p2

def check(n, k, s1, s2):
    p1, p2 = probs(n, k, s1, s2)
    if p1 > p2:
        return "First"
    elif p2 > p1:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

res = check(N, K, S1, S2)

print(res)
