def GCD(a, b):
    if b == 0:
        return a
    return GCD(b, a % b)


def findMaxGCDPair(L, R):
    max_gcd = 1
    pair = (L, L + 1)

    for x in range(R, L, -1):
        for y in range(R, L, -1):
            if x != y:
                current_gcd = GCD(x, y)
                if current_gcd > max_gcd:
                    max_gcd = current_gcd
                    pair = (x, y)
                    if max_gcd == R - L:
                        return pair

    return pair


tmp = input().split()
L = int(tmp[0])
R = int(tmp[1])

result = findMaxGCDPair(L, R)
print(result[0], result[1])