#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    ll n, k;
    cin >> n >> k;
    vector<double> s(n);
    vector<double> a(n);
    priority_queue<pair<double, int>> pq;
    for(int i = 0; i<n; i++){
        cin >> s[i];
        pq.push(make_pair(-s[i], i));
    }
    double sum = 0;
    for(int i = 0; i<n; i++){
        cin >> a[i];
        sum += abs(a[i]*1.0 - s[i])*1.0/(1.0*s[i]);
        a[i] = abs(a[i]*1.0 - s[i]);
    }
    ll ans = 0;
    while(sum > k){
        double razn = sum - k;
        double curr = -pq.top().first, curr_i = pq.top().second;
        double XD = min(a[curr_i], razn*curr);
        sum -= XD/curr;
        a[curr_i] -= XD;
        pq.pop();
        ans+=ceil(XD);
    }
    cout << ans;
    return 0;
}