#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;

void dfs(int x, int y,vector<string>& adj, vector<vector<bool>>& was, int curr, int k){
    if(was[y][x]) return;
    was[y][x] = true; 
    if(curr == k){
        if(x+1<adj[0].size() && adj[y][x+1] != '#')
            dfs(x+1, y, adj, was, curr, k);
        if(y+1<adj.size() && adj[y+1][x] != '#')
            dfs(x, y+1, adj, was, curr, k);
        if(x-1>=0 && adj[y][x-1] != '#')
            dfs(x-1, y, adj, was, curr, k);
        if(y-1>=0 && adj[y-1][x] != '#')
            dfs(x, y-1, adj, was, curr, k);
    }
    else{
        if(x+1<adj[0].size() && adj[y][x+1] != '#')
            dfs(x+1, y, adj, was, curr, k);
        else if(x+2<adj[0].size() && adj[y][x+2] != '#')
            dfs(x+2, y, adj, was, curr+1, k);

        if(y+1<adj.size() && adj[y+1][x] != '#')
            dfs(x, y+1, adj, was, curr, k);
        else if(y+2<adj.size() && adj[y+2][x] != '#')
            dfs(x, y+2, adj, was, curr+1, k);

        if(x-1>=0 && adj[y][x-1] != '#')
            dfs(x-1, y, adj, was, curr, k);
        else if(x-2>=0 && adj[y][x-2] != '#')
            dfs(x-2, y, adj, was, curr+1, k);

        if(y-1>=0 && adj[y-1][x] != '#')
            dfs(x, y-1, adj, was, curr, k);
        else if(y-2>=0 && adj[y-2][x] != '#')
            dfs(x, y-2, adj, was, curr+1, k);
    }
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> adj(n);
    for(int i = 0; i<n; i++)
        cin >> adj[i];
    int dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;
    vector<vector<bool>> was(n, vector<bool>(m, false));
    int q = 0;
    dfs(dx-1, dy-1, adj, was, q, k);
    // for(int i = 0; i<n; i++){
    //     for(int j = 0; j<m; j++)
    //         cout << was[i][j] << ' ';
    //     cout << '\n';
    // }
    if(was[ax-1][ay-1]) cout << "YES\n";
    else cout << "NO\n";
    return 0;
}