#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;

void dfs(int x, int y,const vector<string>& adj, vector<vector<char>>& visited, int k)
{
    if (x < 0 || y < 0 || x >= adj.size() || y >= adj[0].size())
        return;
    if (adj[x][y] == '#')
        return;
    if (visited[x][y] || k < 0) 
        return;
    
    visited[x][y] = 1;
    dfs(x, y-1, adj, visited, k);
    dfs(x, y+1, adj, visited, k);
    dfs(x+1, y, adj, visited, k);
    dfs(x-1, y, adj, visited, k);

    dfs(x+2, y, adj, visited, k-1);
    dfs(x-2, y, adj, visited, k-1);
    dfs(x, y-2, adj, visited, k-1);
    dfs(x, y+2, adj, visited, k-1);
}

int main()
{
    ll n, m, k;
    cin >> n >> m >> k;

    vector<string> adj(n);
    for (int i = 0; i < n; i++)
        cin >> adj[i];

    int ax,ay,dx,dy;
    cin >> dx >> dy >> ax >> ay;
    dx--; dy--; ax--; ay--;

    vector<vector<char>> visited(n, vector<char>(m,0));
    dfs(dx,dy, adj, visited, k);

    cout << (visited[ax][ay] ? "YES\n" : "NO\n");

    return 0;
}