import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.math.min

fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

fun solve() {
    val h = readInt()
    val w = readInt()
    val pop = Array(h) {
        br.readLine()
    }
    var count = intArrayOf(0, 0)
    for (row in pop) {
        for (c in row) {
            count[c - '0']++
        }
    }
    out.println(min(h * w - count[0], h * w - count[1]))
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}
