import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.math.min

fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b
//*1*1*1
fun solve() {
    val n = readLong()
    val k = readLong()
    var l = 1L
    var r = n
    while (r - l > 1) {
        val mid = (r + l) / 2
        val count = (n - mid + 1) / (mid - 1)
        if (count >= k) {
            l = mid
        } else {
            r = mid
        }
    }
    out.println(l)
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}
