import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.math.abs
import kotlin.math.min
import kotlin.math.sqrt

fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

//***11***11
fun solve() {
    val n = readLong()
    val k = readLong()
    val s1 = readLong()
    val s2 = readLong()
    val eps = 1e-18
    val navg = ((k + 1.0) * n) / 2
    val fdist = abs(s1 - navg)
    val sdist = abs(s2 - navg)
    if (abs(fdist - sdist) < eps) {
        out.println("Equal")
    } else if (fdist < sdist) {
        out.println("First")
    } else {
        out.println("Second")
    }
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}
