import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.math.BigInteger
import java.util.*
import kotlin.math.abs
fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

//***11***11
fun solve() {
    val n = readLong().toBigInteger()
    val k = readLong().toBigInteger()
    val two = 2
    val s1 = readLong().toBigInteger() * two.toBigInteger()
    val s2 = readLong().toBigInteger() * two.toBigInteger()
    val one = 1
    val navg = ((k + one.toBigInteger()) * n)
    val fdist = (s1 - navg).abs()
    val sdist = (s2 - navg).abs()
    if (fdist == sdist) {
        out.println("Equal")
    } else if (fdist < sdist) {
        out.println("First")
    } else {
        out.println("Second")
    }
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}