import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.collections.HashMap
import kotlin.math.abs
import kotlin.math.min
import kotlin.math.sqrt

fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

fun solve() {
    var q = readInt()
    var users = HashMap<String, Int>()
    while (q --> 0) {
        val inp = read()
        val cnt = users[inp]?.toString() ?: ""
        out.println(inp + cnt)
        users[inp] = (users[inp]?:0) + 1
    }
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}
