#include <chrono>
#include <iostream>
#include <map>
#include <set>
#include <sstream>
#include <algorithm>
#include <stack>
#include <string>
#include <unordered_map>
#include <iomanip>
#include <vector>
#include <cmath>

using namespace std;

const int INF = (int) 1e9;

signed main() {
#ifdef LOCAL
    freopen("/Users/dmitrykutsenko/CLionProjects/cpp/input.txt", "r", stdin);
    freopen("/Users/dmitrykutsenko/CLionProjects/cpp/output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 1; i < n - 1; i++) {
        cin >> p[i];
    }
    vector<int> go(n);
    for(int i = 1; i < n - 1; i++){
        go[i] = i;
        go[i] = go[max(0, i - p[i])];
    }
    vector<int> dp(n, INF);
    dp[0] = 0;
    for(int i = 1; i < n; i++){

                if (i != n - 1) {
                for (int j = 1; j <= min(5, i); j++) {
                    dp[go[i]] = min(dp[i - j] + 1, dp[go[i]]);
                }
                if (i >= 6) {
                    dp[go[i]] = min(dp[go[i]], dp[i - 6]);
                }
            } else {
                for (int j = 1; j <= min(6, i); j++) {
                    dp[i] = min(dp[i - j] + 1, dp[i]);
                }
            }

    }
    if(dp[n - 1] == INF) {
        cout << -1;
        return 0;
    }
    cout<<dp[n - 1];
}

