#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;


ll c_n_k(ll n, ll k) {
    ll n_f = 1;
    ll k_f = 1;
    ll n_k_f = 1;
    for (int i = 1; i <= n; ++i) {
        n_f *= i;
        if (i <= k) k_f *= i;
        if (i <= n - k) n_k_f *= i;
        assert(n_f > 0);
        assert(n_k_f > 0);
        assert(k_f > 0);
    }
    return n_f * (n_k_f * k_f);
}


void solve(){
    ll n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;
    ll k1 = c_n_k(s1, k);
    ll k2 = c_n_k(s2, k);
    if (k1 == k2) {
        cout << "Equal";
    } else if (k1 > k2) {
        cout << "First";
    } else {
        cout << "Second";
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
//	gen.seed(time(0));
//	cout << fixed;
//	cout.precision(15);
//    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
