#define popcnt(x) __builtin_popcountll(x)
#define pub push_back
#define pob pop_back
#define be(a) a.begin(), a.end()
#define rbe(a) a.rbegin(), a.rend()
#define L(x, s, e) for (int x = s; x < e; ++x)
#define cin(a) for (auto &i : a) cin >> i
#define cout(a, x) for (auto &i : a) cout << i << x; cout << '\n'
#define F first
#define S second
#include<bits/stdc++.h>
using namespace std;
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef pair <int, int> pii;
typedef unsigned int ui;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template <class T> bool if_less(T &a, T b) {return a < b ? a = b, 1 : 0;};
template <class T> bool if_greater(T &a, T b) {return a > b ? a = b, 1 : 0;};
template <class T> using oset = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T> using pqueue = priority_queue <T, vector <T>, less <T>>;
//I love my wife - Elizaveta Minchakova

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;
    char a[n][m];
    for (auto &i : a) {
        cin(i);
    }
    int comp[n][m], cnt = 0;
    memset(comp, -1, sizeof(comp));
    int q[n * m], l, r;
    int dx[4] = {-1, 0, 0, 1},
        dy[4] = {0, -1, 1, 0};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '#' && comp[i][j] == -1) {
                comp[i][j] = cnt++;
                r = 1;
                q[l = 0] = (i << 10) | j;
                while (l < r) {
                    int x = q[l++], y = x & 1023;
                    x >>= 10;
                    for (int k = 0; k < 4; k++) {
                        x += dx[k];
                        y += dy[k];
                        if (
                            0 <= x && x < n &&
                            0 <= y && y < m &&
                            a[x][y] != '#' &&
                            comp[x][y] == -1
                        ) {
                            comp[x][y] = comp[i][j];
                            q[r++] = (x << 10) | y;
                        }
                        x -= dx[k];
                        y -= dy[k];
                    }
                }
            }
        }
    }
    int dx2[4] = {-2, 0, 0, 2},
        dy2[4] = {0, -2, 2, 0};
    vector <int> g[cnt];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '#') {
                for (int k = 0; k < 4; k++) {
                    int x = i + dx2[k], y = j + dy2[k];
                    if (
                        0 <= x && x < n &&
                        0 <= y && y < m &&
                        a[x][y] != '#' &&
                        comp[x][y] != comp[i][j]
                    ) {
                        g[comp[i][j]].pub(comp[x][y]);
                        g[comp[x][y]].pub(comp[i][j]);
                    }
                }
            }
        }
    }
    int sx, sy, fx, fy;
    cin >> sx >> sy >> fx >> fy;
    sx--;
    sy--;
    fx--;
    fy--;
    int d[cnt];
    memset(d, 0x3f, sizeof(d));
    d[comp[sx][sy]] = 0;
    r = 1;
    q[l = 0] = comp[sx][sy];
    while (l < r) {
        int v = q[l++];
        for (int u : g[v]) {
            if (if_greater(d[u], d[v] + 1)) {
                q[r++] = u;
            }
        }
    }
    if (d[comp[fx][fy]] <= k) {
        cout << "YES";
    } else {
        cout << "NO";
    }

    return 0;
}

