#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

const int maxn = 200500;

int p[maxn];
int to[maxn];
int used[maxn];
int dp[maxn];

void dfs(int v) {
    if (used[v]) {
        return;
    }
    if (p[v] == 0) {
        to[v] = v;
        return;
    }
    used[v] = 1;
    dfs(v - p[v]);
    to[v] = to[v - p[v]];
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n - 1; ++i) {
        cin >> p[i];
    }
    for (int i = 0; i < n; ++i) {
        dfs(i);
    }
    memset(dp, 0x3f, sizeof dp);
    dp[0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int k = 1; k <= 5; ++k) {
            dp[to[i + k]] = min(dp[to[i + k]], dp[i] + 1);
        }
        dp[to[i + 6]] = min(dp[to[i + 6]], dp[i]);
    }
    int ans = 1e9;
    for (int k = 0; k <= 6; ++k) {
        ans = min(ans, dp[n - 1 + k]);
    }
    if (ans == 1e9) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    solve();
}