#define popcnt(x) __builtin_popcountll(x)
#define pub push_back
#define pob pop_back
#define be(a) a.begin(), a.end()
#define rbe(a) a.rbegin(), a.rend()
#define L(x, s, e) for (int x = s; x < e; ++x)
#define cin(a) for (auto &i : a) cin >> i
#define cout(a, x) for (auto &i : a) cout << i << x; cout << '\n'
#define F first
#define S second
#include<bits/stdc++.h>
using namespace std;
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef pair <int, int> pii;
typedef unsigned int ui;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template <class T> bool if_less(T &a, T b) {return a < b ? a = b, 1 : 0;};
template <class T> bool if_greater(T &a, T b) {return a > b ? a = b, 1 : 0;};
template <class T> using oset = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T> using pqueue = priority_queue <T, vector <T>, less <T>>;
//I love my wife - Elizaveta Minchakova

void max_path(int v, int depth, int &ans_v, int &ans_depth, vector <int> g[]) {
    if (ans_depth < depth) {
        ans_depth = depth;
        ans_v = v;
    }
    for (int u : g[v]) {
        max_path(u, depth + 1, ans_v, ans_depth, g);
    }
}

void make_bamboo(vector <int> a[], int pa[], int n, vector <pii> &reroot, vector <int> &parents) {
    int ans_v = 0, ans_depth = 1;
    max_path(0, 1, ans_v, ans_depth, a);
    int v = ans_v;
    bool bamboo_used[n] = {};
    int cnt_bamboo_used = ans_depth;
    for (int i = 0; i < ans_depth; i++) {
        bamboo_used[ans_v] = true;
        ans_v = pa[ans_v];
    }
    while (cnt_bamboo_used != n) {
        for (int i = 0; i < n; i++) {
            if (bamboo_used[i]) {
                int not_bamboo_child = -1;
                for (int j = 0; j < a[i].size(); j++) {
                    if (!bamboo_used[a[i][j]]) {
                        not_bamboo_child = j;
                        break;
                    }
                }
                if (not_bamboo_child == -1) {
                    continue;
                }
                ans_v = a[i][not_bamboo_child];
                ans_depth = 1;
                max_path(ans_v, ans_depth, ans_v, ans_depth, a);
                reroot.pub({a[i][not_bamboo_child], v});
                parents.pub(i);
                pa[a[i][not_bamboo_child]] = v;
                a[v].pub(a[i][not_bamboo_child]);
                swap(a[i][not_bamboo_child], a[i].back());
                a[i].pop_back();
                v = ans_v;
                cnt_bamboo_used += ans_depth;
                for (int i = 0; i <= ans_depth; i++) {
                    bamboo_used[ans_v] = true;
                    ans_v = pa[ans_v];
                }
                break;
            }
        }
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    int pa[n];
    pa[0] = -1;
    vector <int> a[n];
    for (int i = 1; i < n; i++) {
        cin >> pa[i];
        a[pa[i]].pub(i);
    }
    vector <pii> reroot_a;
    vector <int> parents_a;
    make_bamboo(a, pa, n, reroot_a, parents_a);
    int pb[n];
    pb[0] = -1;
    vector <int> b[n];
    for (int i = 1; i < n; i++) {
        cin >> pb[i];
        b[pb[i]].pub(i);
    }
    vector <pii> reroot_b;
    vector <int> parents_b;
    make_bamboo(b, pb, n, reroot_b, parents_b);
    int vs_a[n], v = 0, p = -1;
    vs_a[0] = 0;
    for (int i = 1; i < n; i++) {
        int u = v;
        v = a[v][a[v][0] == p];
        p = u;
        vs_a[i] = v;
    }
    int vs_b[n];
    vs_b[0] = 0;
    v = 0;
    p = -1;
    for (int i = 1; i < n; i++) {
        int u = v;
        v = b[v][b[v][0] == p];
        p = u;
        vs_b[i] = v;
    }
    int renum[n];
    for (int i = 0; i < n; i++) {
        renum[vs_b[i]] = vs_a[i];
    }
    for (int i = 0; i < reroot_b.size(); i++) {
        reroot_a.pub({renum[reroot_b[i].F], renum[parents_b[i]]});
    }
    cout << reroot_a.size() << '\n';
    for (pii &x : reroot_a) {
        cout << x.F << ' ' << x.S << '\n';
    }

    return 0;
}

