import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Main {
    public static void main(String[] args) throws IOException {
        FastScanner scanner = new FastScanner(System.in);

        int alicePoints = scanner.nextInt();
        int bobPoints = scanner.nextInt();

        if ((alicePoints + bobPoints) % 2 != 0) {
            System.out.println("Error");
            return;
        }

        if ((alicePoints - bobPoints) == 0) {
            System.out.println("Undefined");
            return;
        }

        int aliceWins = alicePoints / 2;
        int bobWins = bobPoints / 2;

        int draws = aliceWins % 2;

        System.out.println(aliceWins);
        System.out.println(bobWins);
        System.out.println(draws);
    }

    private static class FastScanner {
        BufferedReader br;
        StringTokenizer in;

        public FastScanner(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream));
        }

        public String nextToken() throws IOException {
            while (in == null || !in.hasMoreTokens()) {
                in = new StringTokenizer(br.readLine());
            }
            return in.nextToken();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(nextToken());
        }
    }

}