#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

using ll = long long;

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    ll n; cin >> n;
    ll k; cin >> k;
    ll s1; cin >> s1;
    ll s2; cin >> s2;

    bool fool1 = s1 > n*k || s1 < k;
    bool fool2 = s2 > n*k || s2 < k;

    if (fool1 && fool2) {
        cout << "Equal";
        exit(0);
    }

    if (fool1) {
        cout << "Second";
        exit(0);
    }

    if (fool2) {
        cout << "First";
        exit(0);
    }
    
    s1 *= 2;
    s2 *= 2;

    ll s = (n + 1) * k;

    ll d1 = s > s1 ? s - s1 : s1 - s;
    ll d2 = s > s2 ? s - s2 : s2 - s;

    if (d1 < d2) {
        cout << "First";
    } else if (d2 < d1) {
        cout << "Second";
    } else {
        cout << "Equal";
    }

}