#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

struct vertice {
    double x, y;
};

int main() {
    int n; cin >> n;

    std::vector<vertice> figure(n);

    for (int i = 0; i < n; ++i) {
        cin >> figure[i].x >> figure[i].y;
    }

    figure.push_back(figure[0]);

    double p, maximum;

    for (size_t i = 0; i < figure.size(); ++i) {
        double edge = sqrt(pow(figure[i].x - figure[i+1].x, 2) + pow(figure[i].y - figure[i+1].y, 2));
        maximum = max(maximum, edge);
        p += edge;
    }

    std::cout << p - maximum;
}