#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

struct vertice {
    long long x, y;
};

int main() {
    int n; cin >> n;

    vector<vertice> figure(n);

    for (int i = 0; i < n; ++i) {
        cin >> figure[i].x >> figure[i].y;
    }

    figure.push_back(figure[0]);

    double p = 0, maximum = -999999;

    for (size_t i = 0; i < figure.size(); ++i) {
        double edge = sqrt((figure[i].x - figure[i+1].x)*(figure[i].x - figure[i+1].x) + (figure[i].y - figure[i+1].y)*(figure[i].y - figure[i+1].y));
        maximum = max(maximum, edge);
        p += edge;
    }

    std::cout << p - maximum;
}