#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

struct vertice {
    long long x, y;
};

int main() {
    int n; cin >> n;

    vector<vertice> figure(n);

    for (int i = 0; i < n; ++i) {
        cin >> figure[i].x >> figure[i].y;
    }

    figure.push_back(figure[0]);

    double p = 0;
    double maximum = -999999;

    for (size_t i = 0; i < figure.size()-1; ++i) {
        long long left_diff = (figure[i].x - figure[i+1].x);
        long long right_diff = (figure[i].y - figure[i+1].y);
        double edge = sqrt(left_diff*left_diff + right_diff*right_diff);
        maximum = std::max(maximum, edge);
        p += edge;
    }

    std::cout << p - maximum;
}