#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>
#include <cassert>
#include <random>
#include <ctime>
#include <queue>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
greater<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;*/
using namespace std;

#define fr first
#define sc second
#define be begin()
#define en end()
#define pb push_back
#define pp pair<int, int>
#define quick ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define fixed cout << fixed; cout.precision(14)

/*#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll INF = 1e18 + 7, SIZE = 2e5 + 5, MOD = 998244353, C = 20, P = 101;
const long double EPS = 1e-7;

long double rand01(){
    return (long double)(rand()) / RAND_MAX;
}

mt19937 rnd(time(0));

void solve(){

    int n;
    cin >> n;
    multiset <ld> s;
    pair <ld, ld> pred;
    pair <ld, ld> frp;
    cin >> pred.fr >> pred.sc;
    frp = pred;
    pair <ld, ld> co;
    for (int i = 0; i < n - 1; ++i){
        ld x, y;
        cin >> x >> y;
        //cout << sqrt( (x - pred.fr)*(x - pred.fr) + (y - pred.sc)*(y - pred.sc)) << endl;
        s.insert( sqrt( (x - pred.fr)*(x - pred.fr) + (y - pred.sc)*(y - pred.sc) ));
        pred = make_pair(x, y);
        co = pred;
    }
    //cout << sqrt( (co.fr - .fr)*(co.fr - pred.fr) + (co.sc - pred.sc)*(co.sc - pred.sc) ) << endl;
    s.insert( sqrt( (co.fr - frp.fr)*(co.fr - frp.fr) + (co.sc - frp.sc)*(co.sc - frp.sc) ) );
    //cout << s.size() << endl;
    ld ans = 0;
    auto cit = --s.en;
    for (auto it = s.be; it != cit; ++it){
        //cout << *it << endl;
        ans += *it;
    }
    cout << ans << endl;
}

int main(){

    quick;
    fixed;
    srand(time(0));

    int test = 1;
    //cin >> test;
    while (test--){
        solve();
    }

    return 0;
}
