#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937_64 rnd(441225); // ddly^^

#define double long double

const int inf = 1e17, MOD = 1e9 + 7;

vector<int> dx = {0, 1, 0 ,-1};
vector<int> dy = {1, 0, -1, 0};
vector<int> meg_x = {0, 2, 0, -2};
vector<int> mag_y = {2, 0, -2, 0};
vector<vector<bool>> used;
int n, m, k;
int from_x, from_y, tox, toy;
vector<vector<char>> a;

bool valid(int x, int y){
    if (x >= 0 && x < n && y >= 0 && y < m) return true;
    return false;
}



void dfs(int x, int y, int k_cur){
    if (x == tox && y == toy){
        cout << "YES";
        exit(0);
    }
    used[x][y] = true;
    for (int i = 0; i < 4; ++i){
        int to_x = x + dx[i], to_y = y + dy[i];
        if (valid(to_x, to_y) && !used[to_x][to_y] && a[to_x][to_y] == '.'){
            dfs(to_x, to_y, k_cur);

        }
    }
    if (k_cur < k){
        for (int i = 0; i < 4; ++i){
            int to_x = x + meg_x[i], to_y = y + mag_y[i];
            if (valid(to_x, to_y) && !used[to_x][to_y] && a[to_x][to_y] == '.'){
                dfs(to_x, to_y, k_cur + 1);
            }
        }
    }

}


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    cin >> n >> m >> k;
    used.resize(n, vector<bool>(m, false));
    a.resize(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }
    cin >> from_x >> from_y >> tox >> toy;
    from_x--, from_y--, toy--, tox--;
    dfs(from_x, from_y, 0);
    cout << "NO";
}