#include <iostream>
#include <cmath>

using namespace std;

const long double eps = 1e-18;

long double bin_pow(long double x, long long n)
{
	long long prom1, prom2;
	if (n == 0)
	{
		return 1;
	}
	if (n % 2 == 0)
	{
		prom1 = bin_pow(x, n / 2);
		return (prom1 * prom1);
	}
	else
	{
		prom2 = bin_pow(x, n - 1);
		return (prom2 * x);
	}
}

int main()
{
    long long n, k, s1, s2;
    cin >> n >> k >> s1 >> s2;
    if (s1 > n * k || s1 < n)
    {
        if (s2 > n * k || s2 < n)
        {
            cout << "Equal";
            return 0;
        }
        else
        {
            cout << "Second";
            return 0;
        }
    }
    else
    {
        if (s2 > n * k || s2 < n)
        {
            cout << "First";
            return 0;
        }
    }
    long double e1 = 1, e2 = 1;
    for (long long i = 1; i <= s1 - k; i++)
    {
        e1 *= i;
    }
    for (long long i = 1; i <= s2 - k; i++)
    {
        e2 *= i;
    }
    
    //cout << e1 << ' ' << e2 << endl;
    
    if (e1 == e2)
    {
        cout << "Equal";
        return 0;
    }
    if (e1 > e2)
    {
        cout << "First";
        return 0;
    }
    cout << "Second";
}
