#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <queue>
#define all(x) x.begin(), x.end()
#define vec vector
using namespace std;
typedef long long ll;
typedef long long nt;

const nt MAXN = 1e4 + 13;
const long long INF = 1e18 + 13;
const double EPS = 0.0000001;

struct point {
	double x, y;
};

double dist(point a, point b) {
	return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	point pmax = { INF, INF };
	nt n;
	cin >> n;
	vector<point> a(n, {0 ,0});
	for (nt i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
	double maxD = 0;
	double sum = 0;
	for (nt i = 0; i < n; ++i) {
		nt j = (i + 1) % n;
		sum += dist(a[i], a[j]);
		if (dist(a[i], a[j]) > maxD) {
			maxD = dist(a[i], a[j]);
		}
	}
	cout << setprecision(8) << fixed << sum - maxD << "\n";
	
}