#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <cassert>
#include <numeric>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define lll __int128
#define ull unsigned long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vi vector<int>
int INF = 2e18 + 100;
int MOD = 998244353;
string YES = "YES\n";
string NO = "NO\n";
int N = 1e6 + 500;

void cinvec(vector<int> &vec) {
    for (int &el : vec) {
        cin >> el;
    }
}

vector<int> fact;

void fact_precnt() {
    fact.resize(N + 1);
    fact[0] = 1;
    for (int i = 1; i <= N; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
}

int fast_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        return fast_pow(a * a % MOD, b / 2);
    }
    return a * fast_pow(a, b - 1) % MOD;
}

int inv(int x) {
    return fast_pow(x, MOD - 2);
}

int c(int n, int k) {
    if (k > n) {
        return 0;
    }
    return fact[n] * inv(fact[k] * fact[n - k] % MOD) % MOD;
}

void solve() {
    int a, b; cin >> a >> b;
    if ((a % 2) != (b % 2)) {
        cout << "Error\n";
        return;
    }
    if (min(a, b) >= 2) {
        cout << "Undefined\n";
        return;
    }
    cout << a / 2 << '\n';
    cout << b / 2 << '\n';
    cout << (int)(a % 2 != 0) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    //fact_precnt();
    //int q; cin >> q;
    //while (q--)
    solve();
    return 0;
}