#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <cassert>
#include <numeric>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define lll __int128
#define ull unsigned long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vi vector<int>
int INF = 2e18 + 100;
int MOD = 998244353;
string YES = "YES\n";
string NO = "NO\n";
int N = 1e6 + 500;

void cinvec(vector<int> &vec) {
    for (int &el : vec) {
        cin >> el;
    }
}

vector<int> fact;

void fact_precnt() {
    fact.resize(N + 1);
    fact[0] = 1;
    for (int i = 1; i <= N; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
}

int fast_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        return fast_pow(a * a % MOD, b / 2);
    }
    return a * fast_pow(a, b - 1) % MOD;
}

int inv(int x) {
    return fast_pow(x, MOD - 2);
}

int c(int n, int k) {
    if (k > n) {
        return 0;
    }
    return fact[n] * inv(fact[k] * fact[n - k] % MOD) % MOD;
}

void solve() {
    int n; cin >> n;
    vector<int> dp(n + 1, 0), a(n + 1, 0);
    dp[n - 1] = 0;
    for (int i = 1; i < n - 1; ++i) {
        cin >> a[i];
    }
    for (int i = n - 2; i >= 0; --i) {
        dp[i] = -1;
        for (int j = i + 1; j <= n && j <= (i + 6); ++j) {
            if (a[j] == 0 && dp[j] != -1) {
                if (dp[i] == -1) {
                    dp[i] = dp[j] + 1;
                } else {
                    dp[i] = min(dp[i], dp[j] + 1);
                }
            }
        }
        if (n - i >= 6) {
            int j = i + 6;
            while (j > i && a[j] != 0) {
                j -= a[j];
            }
            if (j > i) {
                if (dp[j] != -1) {
                    if (dp[i] == -1) {
                        dp[i] = dp[j];
                    } else {
                        dp[i] = min(dp[i], dp[j]);
                    }
                }
            }
        }
        if (dp[i] == 0) {
            dp[i] = 1;
        }
    }
    cout << dp[0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    //fact_precnt();
    //int q; cin >> q;
    //while (q--)
    solve();
    return 0;
}