#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <cassert>
#include <numeric>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define lll __int128
#define ull unsigned long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vi vector<int>
int INF = 2e18 + 100;
int MOD = 998244353;
string YES = "YES\n";
string NO = "NO\n";
int N = 1e6 + 500;

void cinvec(vector<int> &vec) {
    for (int &el : vec) {
        cin >> el;
    }
}

vector<int> fact;

void fact_precnt() {
    fact.resize(N + 1);
    fact[0] = 1;
    for (int i = 1; i <= N; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
}

int fast_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        return fast_pow(a * a % MOD, b / 2);
    }
    return a * fast_pow(a, b - 1) % MOD;
}

int inv(int x) {
    return fast_pow(x, MOD - 2);
}

int c(int n, int k) {
    if (k > n) {
        return 0;
    }
    return fact[n] * inv(fact[k] * fact[n - k] % MOD) % MOD;
}
int n;
vector<vector<vector<int>>> g;
vector<vector<int>> p;

vector<int> invalids;

void invalide(int u) {
    if (!g[0][u].empty()) {
        for (int v : g[0][u]) {
            invalide(v);
        }
    }
    invalids.push_back(u);
}

void compare(int u0, int u1) {
    //cout << u0 << " " << u1 << "\n";
    if (g[0][u0].size() != g[1][u1].size()) {
        int d = (int)g[0][u0].size() - (int)g[1][u1].size();
        for (int i = 0; i < d; ++i) {
            int v = g[0][u0][g[0][u0].size() - i - 1];
            invalide(v);
        }
    }
    for (int i = 0; i < min(g[0][u0].size(), g[1][u1].size()); ++i) {
        int v0 = g[0][u0][i];
        int v1 = g[0][u1][i];
        compare(v0, v1);
    }
}

int find_dif(int u0, int u1) {
    //cout << "find_dif: " << u0 << ' ' << u1 << endl;
    if (g[0][u0].size() != g[1][u1].size()) {
        int d = (int)g[0][u0].size() - (int)g[1][u1].size();
        if (d < 0) {
            return u0;
        }
    }
    for (int i = 0; i < min(g[0][u0].size(), g[1][u1].size()); ++i) {
        int v0 = g[0][u0][i];
        int v1 = g[1][u1][i];
        int ans = find_dif(v0, v1);
        if (ans != -1) {
            return ans;
        }
    }
    return -1;
}

void solve() {
    cin >> n;
    g.resize(2, vector<vi>(n + 1));
    p.resize(2, vector<int>(n + 1, 0));
    for (int j = 0; j < 2; ++j) {
        for (int i = 1; i < n; ++i) {
            int t; cin >> t;
            p[j][i] = t;
            g[j][t].push_back(i);
        }
    }
    compare(0, 0);
    vector<pair<int,int>> ans;
    for (int i : invalids) {
        int u = find_dif(0, 0);
        //cout << i << " " << u << endl;
        ans.push_back({i, u});
        auto it1 = find(all(g[0][p[0][i]]), i);
        g[0][p[0][i]].erase(it1);
        g[0][u].push_back(i);
        p[0][i] = u;
    }
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x << ' ' << y << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    //fact_precnt();
    //int q; cin >> q;
    //while (q--)
    solve();
    return 0;
}