#include <bits/stdc++.h>

using namespace std;

struct Node {
  Node* l = nullptr;
  Node* r = nullptr;
  Node* parent = nullptr;
  int idx = 0;
  long long sz = 1;
};

const int N = 1e3 + 500;
int n, p[N];

Node* nodes[N];
Node* nodes1[N];

int idx[N];

void dfs(Node* v, Node* parent) {
  v->parent = parent;
  if (v->l != nullptr) {
    dfs(v->l, v);
    v->sz += v->l->sz;
  }

  if (v->r != nullptr) {
    dfs(v->r, v);
    v->sz += v->r->sz;
  }

  if (v->r == nullptr && v->l != nullptr)
    swap(v->l, v->r);

  if (v->r != nullptr && v->l != nullptr && v->l->sz > v->r->sz)
    swap(v->l, v->r);

}

void dfs2(Node* v1, Node* v2) {
  idx[v2->idx] = v1->idx;
  if (v1->r != nullptr)
    dfs2(v1->r, v2->r);
}

// v, u, parent
vector<array<int, 3> > f(Node* root) {

  vector<array<int, 3> > res;
  Node* cur = root;
  Node* leaf = root;

  while (leaf->r != nullptr) leaf = leaf->r;

  while (cur->r != nullptr) {
    if (cur->l == nullptr && cur->r != nullptr)
      cur = cur->r;
    else {
      leaf->r = cur->l;
      res.push_back({cur->l->idx, leaf->idx, cur->idx});
      cur->l = nullptr;

      cur = cur->r;
    }

    while (leaf->r != nullptr) leaf = leaf->r;
  }

  return res;
}

int main() {

  cin >> n;

  for (int i = 0; i < n; i++) {
    nodes[i] = new Node();
    nodes[i]->idx = i;
  }

  for (int i = 1; i < n; i++) {
    int x;
    cin >> x;
    if (nodes[x]->l == nullptr)
      nodes[x]->l = nodes[i];
    else nodes[x]->r = nodes[i];
  }

  dfs(nodes[0], nullptr);

  auto vec1 = f(nodes[0]);

  for (int i = 0; i < n; i++) {
    nodes1[i] = new Node();
    nodes1[i]->idx = i;
  }

  for (int i = 1; i < n; i++) {
    int x;
    cin >> x;
    if (nodes1[x]->l == nullptr)
      nodes1[x]->l = nodes1[i];
    else nodes1[x]->r = nodes1[i];
  }

  dfs(nodes1[0], nullptr);

  auto vec2 = f(nodes1[0]);

  cout << vec1.size() + vec2.size() << '\n';
  for (auto[a, b, c] : vec1) cout << a << ' ' << b << '\n';
  //cout << endl;
  //for (auto[a, b, c] : vec2) cout << a << ' ' << b << ' ' << c << '\n';

  reverse(vec2.begin(), vec2.end());

  dfs2(nodes[0], nodes1[0]);

  for (auto[a, b, c] : vec2) {
    cout << idx[a] << ' ' << idx[c] << '\n';
  }
}
