import java.math.BigDecimal;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    private void solve(Scanner sc) {
        BigDecimal n = BigDecimal.valueOf(sc.nextLong()), k = BigDecimal.valueOf(sc.nextLong());
        BigDecimal s1 = BigDecimal.valueOf(sc.nextLong()), s2 = BigDecimal.valueOf(sc.nextLong());
        BigDecimal matOjidanie = n.multiply(k.add(BigDecimal.ONE)).divide(BigDecimal.valueOf(2L));
        BigDecimal a = matOjidanie.subtract(s1).abs();
        BigDecimal b = matOjidanie.subtract(s2).abs();
        if(!good(n,k,s1) && !good(n,k,s2)){
            System.out.println("Equal");
            return;
        }
        if(!good(n,k,s1)){
            System.out.println("Second");
            return;
        }
        if(!good(n,k,s2)){
            System.out.println("First");
            return;
        }
        if (a.compareTo(b) < 0) {
            System.out.println("First");
        } else if (a.compareTo(b) > 0) {
            System.out.println("Second");
        } else {
            System.out.println("Equal");
        }
    }

    private boolean good(BigDecimal n, BigDecimal k, BigDecimal s) {
        return n.compareTo(s) <= 0 && (n.multiply(k)).compareTo(s) >= 0;
    }
}