import java.io.BufferedInputStream
import java.math.BigDecimal
import kotlin.math.abs
import kotlin.random.Random


class D {
    companion object {
        @JvmStatic
        fun main(args: Array<String>) {
            solve()
//            test()
        }

        private fun test() {
            val random = Random
            while (true) {
                val max = 1_000_000_000
                val n = random.nextInt(1, max)
                val k = random.nextInt(1, max)
                val ss1 = random.nextInt(1, max)
                val ss2 = random.nextInt(1, max)
                val answer1 = getAnswer(n, k, ss1, ss2)
                val answer2 = getAnswer1(n, k, ss1, ss2)
                if (answer1 != answer2) {
                    println("$n $k $ss1 $ss2")
                    println(answer1)
                    println(answer2)
                    break
                }
            }
        }

        private fun solve() {
            val fs = FastScanner()
            val n = fs.nextInt()
            val k = fs.nextInt()
            val s1 = fs.nextInt()
            val s2 = fs.nextInt()
            val answer = getAnswer(n, k, s1, s2)
            println(answer)
//            val answer1 = getAnswer1(n, k, s1, s2)
//
        }

        private fun getAnswer1(nn: Int, kk: Int, ss1: Int, ss2: Int): String {
            val n: BigDecimal = BigDecimal.valueOf(nn.toLong())
            val k: BigDecimal = BigDecimal.valueOf(kk.toLong())
            val s1: BigDecimal = BigDecimal.valueOf(ss1.toLong())
            val s2: BigDecimal = BigDecimal.valueOf(ss2.toLong())
            val big : BigDecimal = n.multiply(k)
            val matOjidanie = min((n.add(big)).divide(BigDecimal.valueOf(2L)),BigDecimal.valueOf(1_000_000_000L))
            val a = matOjidanie.subtract(s1).abs()
            val b = matOjidanie.subtract(s2).abs()
            if ((s1 < n || s1 > big) && (s2 < n || s2 > big)) {
                return "Equal"
            }
            if (s1 < n || s1 > big) {
                return "Second"
            }
            if (s2 < n || s2 > big) {
                return "First"
            }
            return if (a < b) {
                "First"
            } else if (a > b) {
                "Second"
            } else {
                "Equal"
            }
        }

        private fun min(a: BigDecimal, b: BigDecimal): BigDecimal {
            if (a < b) {
                return a
            }
            return b
        }

        private fun getAnswer(n: Int, k: Int, s1: Int, s2: Int): String {
            val big = n * k
            if (n.toFloat() > 2_000_000_000L.toFloat() / (k + 1)) {
                if (s1 < n && s2 < n) {
                    return "Equal"
                }
                if (s1 < n) {
                    return "Second"
                }
                if (s2 < n) {
                    return "First"
                }
                if (s1 == s2) {
                    return "Equal"
                }
                if (s1 < s2) {
                    return "Second"
                }
                return "First"
            }
            val mid = (n + big).toFloat() / 2
            val abs1 = abs(s1 - mid)
            val abs2 = abs(s2 - mid)
            if ((s1 < n || s1 > n * k) && (s2 < n || s2 > n * k)) {
                return "Equal"
            }
            if (s1 < n || s1 > n * k) {
                return "Second"
            }
            if (s2 < n || s2 > n * k) {
                return "First"
            }
            if (abs1 < abs2) {
                return "First"
            } else if (abs1 == abs2) {
                return "Equal"
            } else {
                return "Second"
            }
        }
    }

    class FastScanner {
        private val BS = 1 shl 16
        private val NC = 0.toChar()
        private val buf = ByteArray(BS)
        private var bId = 0
        private var size = 0
        private var c = NC
        private var `in`: BufferedInputStream? = null

        private val char: Char
            get() {
                while (bId == size) {
                    size = try {
                        `in`!!.read(buf)
                    } catch (e: Exception) {
                        return NC
                    }
                    if (size == -1) return NC
                    bId = 0
                }
                return buf[bId++].toInt().toChar()
            }

        fun nextInt(): Int {
            var neg = false
            if (c == NC) c = char
            while (c < '0' || c > '9') {
                if (c == '-') neg = true
                c = char
            }
            var res = 0
            while (c in '0'..'9') {
                res = (res shl 3) + (res shl 1) + (c - '0')
                c = char
            }
            return if (neg) -res else res
        }

        init {
            `in` = BufferedInputStream(System.`in`, BS)
        }
    }
}