#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
 
using namespace std;
 
int main() {
    int n, k;
     
    cin >> n >> k;
 
    vector<pair<long long, long long>> standart(n);
    vector<bool> used(10);
    long long lcm = 1;
    long long sum = 0;
 
    for (int i = 0; i < n; ++i) {
        cin >> standart[i].first;

        if (!used[standart[i].first]) {
            lcm *= standart[i].first;
            used[standart[i].first] = true;
        }
    }
 
    for (int i = 0; i < n; ++i) {
        cin >> standart[i].second;
        sum += abs(standart[i].second - standart[i].first) * lcm / standart[i].first;
    }
    k *= lcm;
    sort(standart.begin(), standart.end());
 
    if (sum < k) {
        cout << 0 << endl;
        return 0;
    }
 
    long long time = 0;
    for (int i = 0; i < n; ++i) {
        long long single_weight = lcm / standart[i].first;
        long long diff = abs(standart[i].second - standart[i].first) * single_weight;
 
        if (sum - diff <= k) {
            time += (sum - k - 1) / single_weight + 1;
            break;
        }
        time += abs(standart[i].second - standart[i].first);
        sum -= diff;
    }
 
    cout << time << endl;
    return 0;
}
