#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
 
using namespace std;
 
unsigned long long calc_gcd(unsigned long long a, unsigned long long b) {
    if (b == 0) {
        return a;
    }
    return calc_gcd(b, a % b);
}

int main() {
    int n, k;
     
    cin >> n >> k;
 
    vector<pair<long long, long long>> standart(n);
    vector<bool> used(11);
    unsigned long long lcm = 1;
    unsigned long long sum = 0;
 
    for (int i = 0; i < n; ++i) {
        cin >> standart[i].first;

        if (!used[standart[i].first]) {
            long long gcd = calc_gcd(lcm, standart[i].first);
            lcm *= standart[i].first;
            used[standart[i].first] = true;
            lcm /= gcd;
        }
    }

    for (int i = 0; i < n; ++i) {
        cin >> standart[i].second;
        sum += abs(standart[i].second - standart[i].first) * (lcm / standart[i].first);
    }
    k *= lcm;
    sort(standart.begin(), standart.end());
 
    if (sum <= k) {
        cout << 0 << endl;
        return 0;
    }
 
    unsigned long long time = 0;
    for (int i = 0; i < n; ++i) {
        unsigned long long single_weight = lcm / standart[i].first;
        unsigned long long diff = abs(standart[i].second - standart[i].first) * single_weight;
 
        if (sum - diff < k) {
            time += (sum - k - 1) / single_weight + 1;
            break;
        }
        time += abs(standart[i].second - standart[i].first);
        sum -= diff;
    }
 
    cout << time << endl;
    return 0;
}
