#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

const long double eps = 0.000000000001;

int main() {
	int n;
	long double k;
	
	cin >> n >> k;

	vector<pair<long long, long long>> standart(n);
	long double sum = 0;

	for (int i = 0; i < n; ++i) {
		cin >> standart[i].first;
	}

	for (int i = 0; i < n; ++i) {
		cin >> standart[i].second;
		sum += abs(standart[i].second - standart[i].first) * 1.0 / (standart[i].first * 1.0);
	}
	sort(standart.begin(), standart.end());

	if (abs(sum - k) <= eps) {
		cout << 0 << endl;
		return 0;
	}

	long long time = 0;
	for (int i = 0; i < n; ++i) {
		long double single_weight = 1.0 / (standart[i].first * 1.0);
		long double diff = abs(standart[i].second - standart[i].first) * 1.0 * single_weight;

		if (sum - diff - k <= eps) {
			time += ceil((sum - k) / single_weight);
			break;
		}
		time += abs(standart[i].second - standart[i].first);
		sum -= diff;
	}

	cout << time << endl;
	return 0;
}
