#include <iostream>
#include <algorithm>
#include <vector>

#pragma GCC optimize("Ofast")

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    long long N, K;
    std::cin >> N >> K;
    std::vector<int> S(N);
    std::vector<long long> A(N);
    std::vector<double> delta(N);
    double deltaSum = 0;
    for (int i = 0; i < N; ++i) {
        std::cin >> S[i];
    }
    for (int i = 0; i < N; ++i) {
        std::cin >> A[i];
        delta[i] = std::abs(A[i] - S[i]);
        deltaSum += delta[i] / S[i];
    }
    std::sort(S.begin(), S.end());
    int ans = 0;
    int cur_index = 0;
    while (deltaSum > K) {
        while (delta[cur_index] == 0) {
            cur_index++;
        }
        deltaSum -= (1 / S[cur_index]);
        delta[cur_index]--;
        ans++;
    }
    std::cout << ans << std::endl;
    return 0;
}