#include <iostream>
#include <vector>
#include <string>

using namespace std;


int main() {
    int N;
    cin >> N;
    vector<int> field(N + 2);
    for (int i = 0; i < N - 2; i++) {
        cin >> field[i + 1];
    }
    vector<int> pre_count(N);
    for (int i = 1; i < N; i++) {
        pre_count[i] = i;
        pre_count[i] = pre_count[i - field[i]];
    }


    int current_cell = 0;
    int steps = 0;


    while (true) {

        if (current_cell + 6 < N) {
            if (pre_count[current_cell + 6] > current_cell) {
                current_cell = pre_count[current_cell + 6];
                continue;
            }
            int current_max = current_cell;
            bool found = false;
            for (int i = 5; i > 0; --i) {
                if (pre_count[current_cell + i] > current_max) {
                    current_max = pre_count[current_cell + i];
                    found = true;
                }
            }
            if (!found) {
                cout << -1;
                return 0;
            }

            current_cell = current_max;
            steps++;
        } else {
            break;
        }
    }



    cout << steps + 1 << endl;

}