#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }

    return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
    return a * b / gcd(a, b);
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<pll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].ft;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].sc;
    }
    sort(all(a));

    ll g = 1;

    for (int i = 0; i < n; i++) {
        g = lcm(g, a[i].ft);
    }

    k *= g;

    ll sum = 0;

    ll ans = 0;

    for (int i = 0; i < n; i++) {
        sum += abs(a[i].ft - a[i].sc) * g / a[i].ft;
    }

    for (int i = 0; i < n; i++) {
        ll del = g / a[i].ft;
        ll mns = min((max(0LL, sum - k) + del - 1) / del, abs(a[i].ft - a[i].sc));
        sum -= del * mns;
        ans += mns;
    }

    cout << ans << "\n";    
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin); 
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
