#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

int sfx[4] = {1, -1, 0 , 0};
int sfy[4] = {0, 0, -1, 1};
int bfx[4] = {2, -2, 0, 0};
int bfy[4] = {0, 0, 2, -2};

void solve() {
    int n, m, k; cin >> n >> m >> k;
    vector<string> v(n);
    for (int i = 0; i < n; ++i){
        cin >> v[i];
    }
    int dx, dy, ax, ay; cin >> dx >> dy >> ax >> ay;
    deque<pair<int, int> > q;
    q.push_back(make_pair(dx-1, dy-1));
    vector<vector<bool> > used(n, vector<bool>(m));
    vector<vector<int> > dist(n, vector<int>(m, 1e9));
    dist[dx-1][dy-1] = 0;
    int nx, ny;
    pair<int, int> np;
    while (!used[ax-1][ay-1] && !q.empty()){
        np = q.front();
        nx = np.first;
        ny = np.second;
        q.pop_front();
        used[nx][ny] = true;
        for (int i = 0; i < 4; ++i){
            if (nx + sfx[i] >= 0 && nx + sfx[i] < n && ny + sfy[i] >= 0 && ny + sfy[i] < m && v[nx + sfx[i]][ny + sfy[i]] != '#'){
                if (!used[nx + sfx[i]][ny + sfy[i]] && dist[nx + sfx[i]][ny + sfy[i]] > dist[nx][ny]){
                    dist[nx + sfx[i]][ny + sfy[i]] = dist[nx][ny];
                    q.push_front(make_pair(nx + sfx[i], ny + sfy[i]));
                }
            }
        }
        for (int i = 0; i < 4; ++i){
            if (nx + bfx[i] >= 0 && nx + bfx[i] < n && ny + bfy[i] >= 0 && ny + bfy[i] < m && v[nx + bfx[i]][ny + bfy[i]] != '#'){
                if (!used[nx + bfx[i]][ny + bfy[i]] && dist[nx + bfx[i]][ny + bfy[i]] > dist[nx][ny] + 1){
                    dist[nx + bfx[i]][ny + bfy[i]] = dist[nx][ny] + 1;
                    q.push_back(make_pair(nx + bfx[i], ny + bfy[i]));
                }
            }
        }
    }
    if (dist[ax-1][ay-1] > k) cout << "NO";
    else cout << "YES";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin); 
    // freopen("", "w", stdout);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
