#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve() {
    ll n;
    cin >> n;
    vector<ll> p(n + 7, 0);
    vector<vector<ll>> dp(n + 7,vector<ll>(7, INT_MAX));
    vector<ll> pos(n + 7);
    for (int i = 0; i < n + 7; i++) {
        pos[i] = i;
    }
    for (int i = 1; i < n - 1; i++) {
        cin >> p[i];
    }
    for (int i = 0; i < n + 7; i++){
        pos[i] = pos[max(0LL, i - p[i])];
    }
    for (int i = 1; i <= 5; i++) {
        dp[0][i] = 0;
    }
    for (int i = 0; i < n - 1; i++) {
        for (int j = 1; j <= 6; j++) {
            for (int k = 1; k <= 6; k++) {
                dp[pos[i + k]][k] = min(dp[pos[i + k]][k], dp[i][j] + (j == 6 ? 0 : 1));
            }
        }
    }

    ll ans = INT_MAX;

    /*for (int i = 0; i < n + 7; i++) {
        for (int j = 0; j < 7; j++) {
            cout << dp[i][j] << " ";
        }
        cout << "\n";
    }*/

    for (int i = 0; i < 6; i++) {
        for (int j = 0; j < 6; j++) {
            ans = min(ans, dp[n - 1 + i][j]);
        }
    }

    cout << (ans == INT_MAX ? -1 : ans) << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin); 
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
