#include <bits/stdc++.h>

using namespace ::std;

void solve();
int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  solve();
}
typedef long long ll;


//#define enld '\n'
#define vec vector
void solve() {

  int n, m, k;
  cin >> n >> m >> k;
  vec<vec<char>> field(n, vec<char>(m));
  for(int i = 0 ; i < n; ++i){
    for(int j = 0; j < m; ++j){
      cin >> field[i][j];
    }
  }
  pair<int, int> start, finish;
  cin >> start.first >> start.second;
  --start.first, --start.second;
  cin >> finish.first >> finish.second;
  --finish.first, --finish.second;

  int t = -1;
  vec<vec<int>> comps(n, vec<int>(m, -1));
  for(int i = 0 ; i < n; ++i){
    for(int j = 0; j < m; ++j){

      if(field[i][j] == '#' || comps[i][j] != -1)
        continue;

      /// BFS
      ++t;
      comps[i][j] = t;
      queue<pair<int, int>> q;
      q.push({ i, j });
      while(q.size()){
        int x = q.front().first;
        int y = q.front().second;
        q.pop();
        vec<pair<int,int>> of = { {0, 1},{1, 0},{-1, 0},{0, -1}, };
        for(auto p : of){
          if(p.first + x < 0 || p.first + x >= n)
            continue;
          if(p.second + y < 0 || p.second + y >= m)
            continue;
          if(comps[p.first + x][p.second + y] != -1)
            continue;
          if(field[p.first + x][p.second + y] == '#')
            continue;
          comps[p.first + x][p.second + y] = t;
          q.push({ p.first + x, p.second + y });
        }
      }
      ///////
    }
  }
  bool debug = 0;
if(debug){
  for(int i = 0 ; i < n; ++i){
    for(int j = 0; j < m; ++j) {
      cout << (int)(comps[i][j] + 1) << ' ';
    }
    cout << endl;
  }
}
  vec<vec<int>> graph(t + 1);
  for(int i = 0; i < n; ++i){
    for(int j = 0; j < m; ++j){

      if(field[i][j] == '.')
        continue;
      if(i - 1 >= 0 && i + 1 < n && field[i - 1][j] == '.'&& field[i + 1][j] == '.'
      && comps[i - 1][j] != comps[i + 1][j]){

        graph[comps[i - 1][j]].push_back(comps[i + 1][j]);
        graph[comps[i + 1][j]].push_back(comps[i - 1][j]);
      }
      if(j - 1 >= 0 && j + 1 < m && field[i][j - 1] == '.' && field[i][j + 1] == '.'
          && comps[i][j - 1] != comps[i][j + 1]){

        graph[comps[i][j - 1]].push_back(comps[i][j + 1]);
        graph[comps[i][j + 1]].push_back(comps[i][j - 1]);
      }
    }
  }

  if(debug){
    for(int i = 0 ; i < t; ++i){
      for(int u : graph[i]) {
        cout << u << ' ';
      }
      cout << endl;
    }
  }

  /// Dijkstra
  vec<int> d(t + 1,1e9);
  d[comps[start.first][start.second]] = 0;
  set<pair<int, int>> setik;
  setik.insert({ 0, comps[start.first][start.second] });
  while(setik.size()){
    int w = setik.begin()->first;
    int v = setik.begin()->second;
    setik.erase(setik.begin());
    for(int u : graph[v]){
      if(d[v] + 1 < d[u]){
        setik.erase({ d[u], u });
        d[u] = d[v] + 1;
        setik.insert({ d[u], u });
      }
    }
  }

  if(debug){
    for(int i = 0 ; i < t + 1; ++i){
      cout << d[i] << ' ';

    }
    cout << endl;
  }

  if(d[comps[finish.first][finish.second]] <= k)
    cout << "YES";
  else
    cout << "NO";

}

