#include <bits/stdc++.h>


#define all(a) a.begin(), a.end()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

// #define int long long


using namespace std;

void solve(){
    int n;
    double K;
    cin >> n >> K;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].first;
    for (int i = 0; i < n; i++)
        cin >> a[i].second;
    sort(all(a));

    double currK = 0;
    for (int i = 0; i < n; i++)
        currK += ((double)(abs(a[i].first - a[i].second)) / a[i].first);

    queue<pair<int, int>> q;
    for (int i = 0; i < n; i++)
        q.push(a[i]);

    ll ans = 0;
    while (q.size()){
        if (currK <= K)
            break;
        auto p = q.front();
        q.pop();
        double d = abs(p.first - p.second);
        double couldBeChanged = d/p.first;
        if (currK - couldBeChanged > K){
            currK -= couldBeChanged;
            ans += d;
        } else {
            double shouldBeChanged = currK - K;
            int tm = ceil(shouldBeChanged * p.first);
            ans += tm;
            currK = K;
        }
    }

    cout << ans;
}

/*
 3 0
 1 2 1
 2 4 3
 */
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }

    return 0;
}

