#include <bits/stdc++.h>

using namespace std;

bool bfs(vector<vector<bool>> &a, vector<vector<bool>> &u, deque<pair<int, int>> &c, deque<pair<int, int>> &nc, int ax, int ay) {
  while (!c.empty()) {
    auto [x, y] = c.front();
    c.pop_front();
    nc.push_back(make_pair(x, y));
    if (x == ax && y == ay) {
      return true;
    }
    if (x > 0 && a[x-1][y] && !u[x-1][y]) {
      c.push_back(make_pair(x-1, y));
      u[x-1][y] = true;
    }
    if (x < a.size()-1 && a[x+1][y] && !u[x+1][y]) {
      c.push_back(make_pair(x+1, y));
      u[x+1][y] = true;
    }
    if (y > 0 && a[x][y-1] && !u[x][y-1]) {
      c.push_back(make_pair(x, y-1));
      u[x][y-1] = true;
    }
    if (y < a[0].size()-1 && a[x][y+1] && !u[x][y+1]) {
      c.push_back(make_pair(x, y+1));
      u[x][y+1] = true;
    }
  }
  return false;
}

void megajump(vector<vector<bool>> &a, vector<vector<bool>> &u, deque<pair<int, int>> &c, deque<pair<int, int>> &nc) {
  while (!nc.empty()) {
    auto [x, y] = nc.front();
    nc.pop_front();
    if (x > 1 && a[x-2][y] && !u[x-2][y]) {
      c.push_back(make_pair(x-2, y));
      u[x-2][y] = true;
    }
    if (x < a.size()-2 && a[x+2][y] && !u[x+2][y]) {
      c.push_back(make_pair(x+2, y));
      u[x+2][y] = true;
    }
    if (y > 1 && a[x][y-2] && !u[x][y-2]) {
      c.push_back(make_pair(x, y-2));
      u[x][y-2] = true;
    }
    if (y < a[0].size()-2 && a[x][y+2] && !u[x][y+2]) {
      c.push_back(make_pair(x, y+2));
      u[x][y+2] = true;
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
  int n, m, k;
  cin >> n >> m >> k;
  vector<vector<bool>> a(n, vector<bool> (m));
  char ch;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cin >> ch;
      a[i][j] = ch == '.';
    }
  }
  int dx, dy, ax, ay;
  cin >> dx >> dy >> ax >> ay;
  dx--; dy--; ax--; ay--;
  vector<vector<bool>> u(n, vector<bool> (m, false));
  u[dx][dy] = true;
  bool f;
  deque<pair<int, int>> c, nc;
  c.push_back(make_pair(dx, dy));
  for (int i = 0; i < k + 1; i++) {
    f = bfs(a, u, c, nc, ax, ay);
    if (f) {
      cout << "YES\n";
      return 0;
    } else if (i < k) {
      megajump(a, u, c, nc);
    }
  }
  cout << "NO\n";
}
