#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;

int main() {
#define int long long
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int N, K;
    cin >> N >> K;
    int left = 1;
    int right = N;
    int mid = (left + right + 1) / 2;
    while (left < right) {
        int count;
        if (K % 2 == 0) {
            count = mid + mid * K / 2;
        } else {
            count = mid;
            if (mid % 2 == 0) {
                count += K * mid / 2;
            } else {
                count += K * (mid - 1) / 2 + K / 2 + 1;
            }
        }
        if (count > N) {
            right = mid - 1;
        } else {
            left = mid;
        }
        mid = (left + right + 1) / 2;
    }

    cout << mid;

    return 0;
}