#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>

using namespace std;

template<class T>
T read() {
    T t;
    std::cin >> t;
    return t;
}

#define ll long long
#define ull unsigned ll

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n = read<int>();
    int nums = read<int>();
    int first = read<int>();
    int second = read<int>();

    long double exp = 0;
    for (int i = 1; i <= nums; ++i) {
        exp += i;
    }
    exp *= n;
    exp /= nums;

    if (abs(first - exp) < abs(second - exp)) {
        cout << "First";
    } else if (abs(first - exp) > abs(second - exp)) {
        cout << "Second";
    } else {
        cout << "Equal";
    }
    return 0;
}