#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>

using namespace std;

template<class T>
T read() {
    T t;
    std::cin >> t;
    return t;
}

#define ll long long
#define ull unsigned ll

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll n = read<ll>();
    ll nums = read<ll>();
    ll first = read<ll>();
    ll second = read<ll>();

    long double exp = 0;
    exp += ((long double)nums * (nums + 1)) / 2;
    exp *= n;
    exp /= nums;
    long double eps = 1e-9;
    if (abs(first - exp) - abs(second - exp) < eps) {
        cout << "First";
    } else if (eps < abs(second - exp) - abs(first - exp)) {
        cout << "Second";
    } else {
        cout << "Equal";
    }
    return 0;
}