#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <ext/pb_ds/assoc_container.hpp>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;
int main() {
    int n,m,h,w;
    double res = 0, k;
    cin>>n>>k;
    vector<pair<int, int>> vec(n, pair<int,int>(0,0));
    for (int i = 0; i < n; ++i) {
        cin>>m;
        vec[i].first = m;
    }
    for (int i = 0; i < n; ++i) {
        cin>>m;
        vec[i].second = m;
    }
    std::sort(vec.begin(), vec.end());
    for (int i = 0; i < n; ++i) {
        res += (double )abs(vec[i].second-vec[i].first) / vec[i].first;
    }
    int point = 0;
    int minutes = 0;
    int amount = 0;
    while (k < res){
        amount = abs(vec[point].first-vec[point].second);
        if (amount>0){
            if (res - amount*(1.0/vec[point].first) > k){
                res-=amount*(1.0/vec[point].first);
                minutes += amount;
                if (vec[point].second>vec[point].first)
                    vec[point].second = vec[point].first;
                else
                    vec[point].second = vec[point].second;
            } else {
                while (k<res){
                    res-=1.0/vec[point].first;
                    ++minutes;
                }
            }
        } else {
            ++point;
        }
    }
    cout<<minutes;
    return 0;
}