#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>

using namespace std;

template<class T>
T read() {
    T t;
    std::cin >> t;
    return t;
}

#define ll long long
#define ull unsigned ll

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    unordered_map<string, ll> bd;
    ll n = read<ll>();
    string str;
    for (ll i = 0; i < n; i++) {
        str = read<string>();
        if (bd.find(str) != bd.end()) {
            cout << str << '\n';
            bd[str] = 1;
        } else {
            cout << str << bd[str]++ << '\n';
        }
    }
    return 0;
}