#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <ext/pb_ds/assoc_container.hpp>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;
int n, point = 0, amount = 11111110;
bool ans = false;
vector<bool> checked;
vector<int> vec;

void Go(int pos, int curr){
    checked[pos] = true;
    int plussix;
    while (pos<n-1){
        if (pos+6==n-1){
            ans = true;
            amount = min(amount,curr);
            return;
        }
        if (pos+6>n-1){
            ++curr;
            ans = true;
            amount = min(amount,curr);
            return;
        }
        plussix = pos+6;
        while (true){
            plussix -= vec[plussix];
            if (plussix<=0){
                break;
            }
            if (checked[plussix] or vec[plussix] == 0){
                if (vec[plussix]==0){
                    checked[plussix] = true;
                    Go(plussix, curr);
                }
                break;
            }
            checked[plussix] = true;
        }
        bool found = false;
        for (int i = pos+5; i > pos; --i) {
            if (vec[i] == 0){
                found = true;
                pos = i;
                curr++;
                break;
            }
        }
        if (!found){
            break;
        }
    }
}

int main() {
    cin>>n;
    checked.resize(n);
    vec.resize(n);
    checked[0] = true;
    vec[0] = 0;
    vec.back() = 0;
    for (int i = 1; i < n-1; ++i) {
        cin>>vec[i];
    }
    Go(0, 0);
    if (ans){
        cout<<amount;
    } else {
        cout<<-1;
    }
    return 0;
}
