//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using ld = long double;
typedef complex<ld> cmplx;
const ld PI = acosl(-1);
const int MOD = 998244353;



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout << fixed << setprecision(20);

    int n, k;
    cin >> n >> k;
    k *= 2520;
    vector<pair<int, int>> p(n);
    int cur = 0;
    for (int i = 0; i < n; ++i) cin >> p[i].first;
    for (int i = 0; i < n; ++i) {
        cin >> p[i].second;
        cur += 2520 * abs(p[i].first - p[i].second) / p[i].first;
    }
    sort(ALL(p));

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int d = 2520 / p[i].first;
        int mx = abs(p[i].first - p[i].second);
        if (cur > k) {
            int need = (cur - k + d - 1) / d;
            ans += min(mx, need);
            cur -= min(mx, need) * d;
        } else {
            break;
        }
    }

    cout << ans;

    return 0;
}