#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = int64_t;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    ll n, k;

    cin >> n >> k;

    if (k % 2 == 0) {
        cout << max(n / ((k / 2) + 1ll), 1ll);
    } else {
        cout << max(n / ((k / 2) * 2 + 3) * 2ll, 1ll);
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
