#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = uint64_t;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    ll l, r;
    cin >> l >> r;

    const ll dmax = 1e6 + 10;
    for (int x = dmax; x >= 1; x--) {
        ll x1 = ((l - 1) / x + 1) * x;
        ll x2 = x1 + x;
        if (x2 >= l && x2 <= r && x1 >= l && x1 <= r) {
            cout << x1 << " " << x2;
            return;
        }
    }
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
