#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

double dist(pll x, pll y) {
    return sqrt(pow(x.first - y.first, 2) + pow(x.second - y.second, 2));
}

int main() {
    int n;
    cin >> n;
    vector<pll> coords;
    for (int i = 0; i  <n;++i) {
        int x, y;
        cin >>x  >> y;
        coords.emplace_back(x, y);
    }
    vector<double> sides;
    for (int i = 0 ; i < n; ++i) {
        sides.push_back(dist(coords[i], coords[(i + 1) % n]));
    }
    sort(sides.begin(), sides.end());
    double ans = 0;
    for (int i = 0; i < sides.size() - 1; ++i) {
        ans += sides[i];
    }
    cout.precision(8);
    cout << ans << endl;
}