#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

#define pb push_back
#define ff first
#define ss second
#define pp pair
#define int long long
#define ll long long
#define dl long double

ostream &operator<<(ostream &out, const pair<int, int> &a) {
    out << a.ff << ' ' << a.ss;
    return out;
}

istream &operator>>(istream &in, pair<int, int> &a) {
    in >> a.ff >> a.ss;
    return in;
}


const int maxn = 1e5 + 100, inf = 1e18;


void solve() {
    int l, r;
    cin >> l >> r;
    int M = 1e6 + 10;
    pair<int, int> ans;
    for (int i = 1 ; i < M ; i++) {
        if (l % i == 0) {
            if (l + i <= r) {
                ans = {l, l + i};
            }
        } else {
            int x = l - l % i + i;
            if (x + i <= r) {
                ans = {x, x + i};
            }
        }
    }
    cout << ans;
}

signed main() {
#ifdef Local
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
#ifndef Local
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
//    cout << fixed << setprecision(15);
//    cin >> tests;
    while (tests--) solve();
#ifdef Local
//    cout << "\nruntime = " << clock() / 1000.0 << '\n';
#endif
//    cerr << "amogus";
}