#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2,avx")
#pragma GCC optimize("unroll-loops")
using namespace std;

typedef long long ll;
const ll maxn = 1e6 + 5;
ll a[maxn];


ll gcd(ll a, ll b) {
    if (a == 0) return b;
    if (b == 0) return a;

    ll az = __builtin_ctzll(a);
    ll bz = __builtin_ctzll(b);
    ll shift = std::min(az, bz);
    b >>= bz;

    while (a != 0) {
        a >>= az;
        ll diff = b - a;
        az = __builtin_ctzll(diff);
        b = std::min(a, b);
        a = std::abs(diff);
    }

    return b << shift;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);

    ll l, r;
    cin >> l >> r;

    for (int i = 0; i < r - l + 1; i++) {
        a[i] = l + i;
    }

    ll best = 0;
    ll ans[2];

    for (int i = 0; i < r - l + 1; ++i) {
        for (int j = 0; j < i; ++j) {
            ll t = gcd(a[i], a[j]);
            if (t > best) {
                best = max(best, t);
                ans[0] = a[i];
                ans[1] = a[j];
            }
        }
    }

    cout << ans[0] << " " << ans[1] << endl;
}