#include <bits/stdc++.h>


void set_connection_1(std::vector<std::vector<int>> &matrix, int x, int y, int N, int M, int K);

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(false);


    int N, M, K, dx, dy, ax, ay;
    std::cin >> N >> M >> K;

    std::vector<std::vector<int>> matrix = std::vector<std::vector<int>>(N, std::vector<int>(M));

    std::string newString;



    for (int i = 0; i < N; i++) {
        std::cin >> newString;
        for (int j = 0; j < M; j++) {
            if (newString[j] == '.') {
                matrix[i][j] = K + 50;
            } else {
                matrix[i][j] = -1;
            }
        }
    }



    std::cin >> dx >> dy >> ax >> ay;
    dx--;
    dy--;
    ax--;
    ay--;

    matrix[dx][dy] = 0;
    set_connection_1(matrix, dx, dy, N, M, K);
    if (matrix[ax][ay] <= 50) {
        std::cout << "YES\n";
    } else {
        std::cout << "NO\n";
    }
}

void set_connection_1(std::vector<std::vector<int>> &matrix, int x, int y, int N, int M, int K) {
    int a = matrix[x][y];
    bool K_off = false;

    if (a == K) {
        K_off = true;
    }

    if (x > 0) {
        if (matrix[x - 1][y] > a) {
            matrix[x - 1][y] = a;
            set_connection_1(matrix, x - 1, y, N, M, K);
        } else if (x > 1 && matrix[x - 1][y] == -1 && !K_off) {
            if (matrix[x-2][y] > a + 1) {
                matrix[x - 2][y] = a + 1;
                set_connection_1(matrix, x - 2, y, N, M, K);
            }
        }
    }

    if (x < N - 1) {
        if (matrix[x + 1][y] > a) {
            matrix[x + 1][y] = a;
            set_connection_1(matrix, x + 1, y, N, M, K);
        } else if (x < N - 2 && matrix[x + 1][y] == -1 && !K_off) {
            if (matrix[x + 2][y] > a + 1) {
                matrix[x + 2][y] = a + 1;
                set_connection_1(matrix, x + 2, y, N, M, K);
            }
        }
    }

    if (y > 0) {
        if (matrix[x][y - 1] > a) {
            matrix[x][y - 1] = a;
            set_connection_1(matrix, x, y - 1, N, M, K);
        } else if (y > 1 && matrix[x][y - 1] == -1 && !K_off) {
            if (matrix[x][y - 2] > a + 1) {
                matrix[x][y - 2] = a + 1;
                set_connection_1(matrix, x, y - 2, N, M, K);
            }
        }
    }

    if (y < M - 1) {
        if (matrix[x][y + 1] > a) {
            matrix[x][y + 1] = a;
            set_connection_1(matrix, x, y + 1, N, M, K);
        } else if (y < M - 2 && matrix[x][y + 1] == -1 && !K_off) {
            if (matrix[x][y + 2] > a + 1) {
                matrix[x][y + 2] = a + 1;
                set_connection_1(matrix, x, y + 2, N, M, K);
            }
        }
    }
}