#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int N, K;
    cin >> N >> K;
    vector<pair<int, int>> d(N);

    int s;
    for (int i = 0; i < N; i++) {
        cin >> s;
        d[i].first = s;
    }

    int a;
    double diff = 0;
    for (int i = 0; i < N; i++) {
        cin >> a;
        d[i].second = a;
        diff += (double) abs(d[i].second - d[i].first) / d[i].first;
    }

    auto cmp = [&] (pair<int, int> a, pair<int, int> b) {
        return a.first < b.first;
    };
    sort(d.begin(), d.end(), cmp);

    long long sum = 0;
    for (auto const& p: d) {
        double cur_d = (double) abs(p.first - p.second) / p.first;
        if (diff - cur_d > K) {
            sum += abs(p.first - p.second);
            diff -= cur_d;
        } else {
            sum += ceil((double) abs(diff - K) * p.first);
            break;
        }
    }

    cout << sum << '\n';
}
