#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;

#ifndef LOCAL
    #define endl '\n'
#endif

int bpow(int x, int y, int M = INF) {
    if (y == 0) {
        return 1;
    } else if (y % 2 == 0) {
        int tmp = bpow(x, y / 2, M);
        return (((tmp * tmp) % M) + M) % M;
    } else {
        int tmp = bpow(x, y - 1, M);
        return (((x * tmp) % M) + M) % M;
    }
}

template <typename T, typename os>
os& operator<<(os& out, const vector<T>& v) {
    for (auto & el : v) {
        out << el << " ";
    }
    out << endl;
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto & el : v) {
        cin >> el.first >> el.second;
    }
    ld ans = 0;
    ld mx = 0.0;
    for (int i = 0; i < n; i++) {
        ld tmp = sqrtl((v[i].first - v[(i + 1) % n].first) * (v[i].first - v[(i + 1) % n].first)
                     + (v[i].second - v[(i + 1) % n].second) * (v[i].second - v[(i + 1) % n].second));
        mx = max(mx, tmp);
        ans += tmp;
    }
    cout << fixed << setprecision(20);
    cout << ans - mx << endl;
}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();


    //int nt = 1;
    //    cin >> nt;
    //while (nt--) {
        //solve();
        //        cout << "--" << endl;
    //}
}
