#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;


int bpow(int x, int y, int M = INF) {
    if (y == 0) {
        return 1;
    } else if (y % 2 == 0) {
        int tmp = bpow(x, y / 2, M);
        return (((tmp * tmp) % M) + M) % M;
    } else {
        int tmp = bpow(x, y - 1, M);
        return (((x * tmp) % M) + M) % M;
    }
}

template <typename T, typename os>
os& operator<<(os& out, const vector<T>& v) {
    for (auto & el : v) {
        out << el << " ";
    }
    out << endl;
    return out;
}

void solve() {
    int nq;
    cin >> nq;
    set<string> v1; // have ?
    map<string, int> v2; // root -> lastI
    while (nq--) {
        string s;
        cin >> s;

        if (v1.find(s) == v1.end()) {
            cout << s << endl;
            v1.insert(s);
            v2[s] = 0;
        } else {
            // have s

            // root?
            if (v2.find(s) != v2.end()) {
                // root
                for (int j = v2[s] + 1; ; j++) {
                    string cur = s + to_string(j);
                    if (v1.find(cur) == v1.end()) {
                        v1.insert(cur);
                        cout << cur << endl;
                        v2[s] = j;
                        break;
                    }
                }
            } else {
                for (int j = 1; ; j++) {
                    string cur = s + to_string(j);
                    if (v1.find(cur) == v1.end()) {
                        v1.insert(cur);
                        cout << cur << endl;
                        v2[s] = j;
                        break;
                    }
                }
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int nt = 1;
    //cin >> nt;

    while (nt--) {
        solve();
    }
}
