#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;


int bpow(int x, int y, int M = INF) {
    if (y == 0) {
        return 1;
    } else if (y % 2 == 0) {
        int tmp = bpow(x, y / 2, M);
        return (((tmp * tmp) % M) + M) % M;
    } else {
        int tmp = bpow(x, y - 1, M);
        return (((x * tmp) % M) + M) % M;
    }
}

template <typename T, typename os>
os& operator<<(os& out, const vector<T>& v) {
    for (auto & el : v) {
        out << el << " ";
    }
    out << endl;
    return out;
}

int n, m;
vector<vector<bool>> used;
vector<vector<bool>> t;
vector<vector<int>> comp;
vector<pii> d = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};


set<pii> s;


void dfs(pii v, int c) {
    used[v.first][v.second] = true;
    comp[v.first][v.second] = c;
    for (pii diff : d) {
        pii to = {v.first + diff.first, v.second + diff.second};
        if (!(0 <= to.first && to.first < n)) continue;
        if (!(0 <= to.second && to.second < m)) continue;
        if (!t[to.first][to.second]) continue;
        if (used[to.first][to.second]) continue;
        used[to.first][to.second] = true;
        comp[to.first][to.second] = c;
        dfs(to, c);
    }
}

vector<vector<int>> g;

void dfs2(pii v) {
    used[v.first][v.second] = true;
    for (pii diff : d) {
        pii to = {v.first + diff.first, v.second + diff.second};
        if (!(0 <= to.first && to.first < n)) continue;
        if (!(0 <= to.second && to.second < m)) continue;
        if (!t[to.first][to.second]) continue;
        if (used[to.first][to.second]) continue;
        used[to.first][to.second] = true;
        dfs2(to);
    }

    for (pii diff : d) {
        pii to = {v.first + 2 * diff.first, v.second + 2 * diff.second};
        if (!(0 <= to.first && to.first < n)) continue;
        if (!(0 <= to.second && to.second < m)) continue;
        if (!t[to.first][to.second]) continue;
        if (used[to.first][to.second]) continue;
        used[to.first][to.second] = true;
        int vx = v.first; int vy = v.second; int tox = to.first; int toy = to.second;
        if (comp[vx][vy] != comp[tox][toy]) {
            if (s.find({comp[vx][vy], comp[tox][toy]}) == s.end()) {
                s.insert({comp[vx][vy], comp[tox][toy]});
                s.insert({comp[tox][toy], comp[vx][vy]});
                g[comp[vx][vy]].push_back(comp[tox][toy]);
                g[comp[tox][toy]].push_back(comp[vx][vy]);
            }
        }
        dfs2(to);
    }
}

void solve() {
    int k;
    cin >> n >> m >> k;
    used = vector<vector<bool>> (n, vector<bool> (n, false));
    t = vector<vector<bool>> (n, vector<bool>(m, true));
    comp = vector<vector<int>>(n, vector<int> (m, -1));
    //cout << "KEK" << endl;
    for (int i = 0; i < n;++i){
        for (int j = 0; j <m; ++j){
            char c;
            cin >> c;
            if (c == '#') {
                t[i][j] = false;
            }
        }
    }
    int ccc = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (t[i][j] && !used[i][j]) {
                dfs({i, j}, ccc);
                ++ccc;
            }
        }
    }
//    cout << "KEK" << n  <<' ' << m << endl;
//    for (int i = 0 ; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            if (t[i][j]) {
//                cout << comp[i][j];
//            } else cout << '#';
//        } cout << '\n';
//    }

    //cout << "KEK" << endl;
    g = vector<vector<int>> (ccc);
    used = vector<vector<bool>> (n, vector<bool> (m, false));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (t[i][j] && !used[i][j]) {
                dfs2({i, j});
            }
        }
    }

//    cout << "KEK" << endl;
//    cout << "KEK\n";
//    int kek = 0;
//    for (auto& i : g) {
//        cout << kek << ": ";
//        kek++;
//        for (auto& j : i) {
//            cout << j << ' ';
//        } cout << '\n';
//    }

//    cout << "LOL\n";
    int stx, sty, fx, fy;
    cin >> stx >> sty >> fx >> fy;
    stx--;
    sty--;
    fx--;
    fy--;
    vector<int> dist(ccc, INF);
    dist[comp[stx][sty]] =0;
    queue<int> q;
    q.push(comp[stx][sty]);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto& to : g[v]) {
            if (dist[to] == INF) {
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
    if (dist[comp[fx][fy]] <= k) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    //for (auto & i : dist) cout << i << ' ';
}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int nt = 1;
    //cin >> nt;

    while (nt--) {
        solve();
    }
}
