#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;


int bpow(int x, int y, int M = INF) {
    if (y == 0) {
        return 1;
    } else if (y % 2 == 0) {
        int tmp = bpow(x, y / 2, M);
        return (((tmp * tmp) % M) + M) % M;
    } else {
        int tmp = bpow(x, y - 1, M);
        return (((x * tmp) % M) + M) % M;
    }
}

template <typename T, typename os>
os& operator<<(os& out, const vector<T>& v) {
    for (auto & el : v) {
        out << el << " ";
    }
    out << endl;
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n, 0);
    for (int i = 1; i < n - 1; ++i) {
        cin >> a[i];
    }
    vector<int> dist(n, INF);
    dist[0] = 0;
    deque<int> q;
    q.push_back(0);
    while (!q.empty()) {
        int v = q.front();
        //cout << v << ' ';
        q.pop_front();
        if (a[v] == 0) {
            for (int i = 1; i < min((int)7, n - v); ++i) {
                if (v + i == n - 1) {
                    dist[v+i] = min(dist[v + i], dist[v] + 1);
                    continue;
                }
                if (dist[v + i] <= dist[v]) continue;
                if (i < 6) {
                    dist[v+i] = dist[v] + 1;
                    q.push_back(v+i);
                } else {
                    dist[v+i] = dist[v] + ((v + i) == n - 1);
                    q.push_front(v+i);
                }
            }
        } else {
            if (dist[v -a[v]] <= dist[v]) continue;
            dist[v - a[v]] = dist[v];
            q.push_front(v - a[v]);
        }
    }
    //cout << endl;
    //for (auto& i : dist) cout << i << ' ';
    //cout << endl;
    if (dist[n-1] == INF) {
        cout <<  -1;
    } else {
        cout << dist[n-1];
    }



}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int nt = 1;
    //cin >> nt;

    while (nt--) {
        solve();
    }
}
