#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;


int bpow(int x, int y, int M = INF) {
    if (y == 0) {
        return 1;
    } else if (y % 2 == 0) {
        int tmp = bpow(x, y / 2, M);
        return (((tmp * tmp) % M) + M) % M;
    } else {
        int tmp = bpow(x, y - 1, M);
        return (((x * tmp) % M) + M) % M;
    }
}

template <typename T, typename os>
os& operator<<(os& out, const vector<T>& v) {
    for (auto & el : v) {
        out << el << " ";
    }
    out << endl;
    return out;
}

//vector<pii> diff = {{0, 1}, {0, -1}, {-1, 0}, {1, 0}};

vvi g1;
vvi g2;

int dfs(int va, int vb, bool alreadyDif = false) {
    if (alreadyDif) {
        // спускаемся влево до фулла
        if (g1[va].size() == 0) {
            return va;
        }
        return dfs(g1[va][0], vb, alreadyDif);
    }
    if (g1[va].size() == 2 && g2[vb].size() == 2) {
        int ans = -1;
        ans = max(ans, dfs(g1[va][0], g2[vb][0], alreadyDif));
        ans = max(ans, dfs(g1[va][1], g2[vb][1], alreadyDif));
        return ans;
    }
    if (g1[va].size() == 1 && g2[vb].size() == 1) {
        return dfs(g1[va][0], g2[vb][0], alreadyDif);
    }
    if (g1[va].size() == 0) return -1;

    if (g1[va].size() == 2) {
        return dfs(g1[va][1], vb, true);
    }
    if (g2[vb].size() == 0) {
        return dfs(g1[va][0], vb, true);
    }

    return dfs(g1[va][0], g1[vb][0], true);

    /*int ans = -1;
    if (g1[va].size() >= 1 && g2[vb].size() >= 1) {
        ans = max(ans, dfs(g1[va][0], g2[vb][0], alreadyDif));
    }
    if (ans != -1) return ans;

    if (g1[va].size() < 2) return -1;

    if (g2[vb].size() < g1[va].size()) {
        return dfs(g1[va][1], vb, true);
    } else {
        return dfs(g1[va][1], g2[vb][1], alreadyDif);
    }
    */
}

int get_kek() {
    return dfs(0, 0, false);
}

bool changedA = false;

vector<pair<int, int>> ans;

void dfs2(int va, int vb, int v) {
    if (changedA) return;

    if (g1[va].size() == 1 && g2[vb].size() == 1) {
        dfs2(g1[va][0], g2[vb][0], v);
        return;
    }
    if (g1[va].size() == 2 && g2[vb].size() == 2) {
        dfs2(g1[va][0], g2[vb][0], v);
        dfs2(g1[va][1], g2[vb][1], v);
        return;
    }
    if (g2[vb].size() == 0) return;

    if (g1[va].size() < g2[vb].size()) {
        g1[va].push_back(v);
        ans.push_back({va, v});
        changedA = true;
        return;
    } else {
        // a > b
        if (g2[vb].size() >= 1) {
            // 2 1
            dfs2(g1[va][0], g2[vb][0], v);
        } else {
            return;
        }
    }
//    if (g1[va].size() >= 1 && g2[vb].size() >= 1) {
//        dfs2(g1[va][0], g2[vb][0], v);
//    }
//    if (changedA) return;
//
//    if (g1[va].size() == 2 && g2[vb].size() == 2) {
//        dfs2(g1[va][1], g2[vb][1], v);
//    }
//    if (g1[va].size() < g2[vb].size()) {
//       g1[va].push_back(v);
//       ans.push_back({va, v});
//       changedA = true;
//    }
}

void tl() {
    int ans = 0;
    for (int i = 1; i <= 1e12; i++) {
       for (int j = 1; j <= 1e12; j++) {
            if (i % j == 0 || j % i == 0 || i % 3 == 0 || j % 5 == 0) {
                ans++;
            }
       }
    }
    cout << ans;
}

void solve() {
    int n;
    cin >> n;
    g1.resize(n);
    vector<int> parent_g1(n + 1);
    for (int i = 1; i <= n - 1; i++) {
        int p;
        cin >> p;
        g1[p].push_back(i);
        parent_g1[i] = p;
    }
    g2.resize(n);
    for (int i = 1; i <= n - 1; i++) {
        int p; cin >> p;
        g2[p].push_back(i);
    }

    while (true) {
        int v = get_kek();
        if (v == -1) break;

        int p = parent_g1[v];

        bool contains = false;
        for (auto & el : g1[p]) {
            if (el == v) contains = true;
        }
        if (!contains) tl();

        g1[p].erase(find(all(g1[p]), v));

        changedA = false;
        dfs2(0, 0, v);
        assert(changedA);
    }

//    for (int i = 0; i < n; i++) {
//        for (auto & el : g1[i]) {
//            cout << el << " ";
//        }
//        cout << "|||";
//        for (auto & el : g2[i]) {
//            cout << el << " ";
//        }
//        cout << endl;
//    }

    cout << ans.size() << endl;
    for (auto & el : ans) {
        cout << el.second << " " << el.first << endl;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int nt = 1;
    //cin >> nt;

    while (nt--) {
        solve();
    }
}
