#include <bits/stdc++.h>
#define int long long
using namespace std;

double dist(pair<int, int> a, pair<int, int> b) {
    return sqrt((a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second));
}

void solve() {
    int n; cin >> n;
    vector<pair<int, int>> poly(n);
    for (int i = 0; i < n; ++i) cin >> poly[i].first >> poly[i].second;
    double len = 0;
    for (int i = 0; i < n; ++i) {
        len += dist(poly[i], poly[(i + 1) % n]);
    }
    double res = 1e18;
    for (int i = 0; i < n; ++i) {
        res = min(res, len - dist(poly[i], poly[(i + 1) % n]));
    }
    cout << fixed << res << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(12);

    solve();
}