#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

// #define int long long

using namespace std;

vector<vector<pair<int, int>>> G;

int num(int i, bool f) {
    return 2 * i + f;
}

void add_edge(int v, int u, int w) {
    G[v].push_back({u, w});
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 1; i < n - 1; i++)
        cin >> p[i];
    vector<int> go(n);
    for (int i = 0; i < n; i++) {
        if (p[i] == 0) {
            go[i] = i;
        } else {
            go[i] = go[i - p[i]];
        }
    }
    // cerr << "go: ";
    // for (int i : go)
    //     cerr << i << " ";
    // cerr << "\n";

    G.resize(2 * n);
    for (int i = 0; i < n; i++) {
        add_edge(num(i, 1), num(i, 0), 0);
        for (int k = 1; k <= 6; k++) {
            int j = go[min(i + k, n - 1)];
            add_edge(num(i, 0), num(j, 0), 1);
            add_edge(num(i, 1), num(j, (k == 6)), 0);
            if (k == 6)
                add_edge(num(i, 0), num(j, 1), 1);
        }
    }
    vector<int> d(2 * n, 1e9);
    int s = num(0, 0);
    d[s] = 0;
    deque<int> que;
    que.push_back(s);
    while (!que.empty()) {
        int v = que.front();
        que.pop_front();
        for (auto [to, w] : G[v]) {
            if (d[v] + w < d[to]) {
                d[to] = d[v] + w;
                if (w == 0)
                    que.push_front(to);
                else
                    que.push_back(to);
            }
        }
    }
    int res = d[num(n - 1, 0)];
    if (res == 1e9)
        res = -1;
    cout << res << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef dimss
        freopen("test.txt", "r", stdin);
    #endif

    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
        #ifdef dimss
            cerr << "--------\n";
        #endif
    }
    return 0;
}
