#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

// #define int long long

using namespace std;

int n;
vector<vector<int>> A, B;
vector<bool> used;
vector<pair<int, int>> ans;

int get_trash() {
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = true;
            return i;
        }
    }
    assert(false);
}

void dfs(int v, int u) {
    // cerr << "dfs: " << v << " " << u << "\n";
    used[v] = true;
    while (A[v].size() < B[u].size()) {
        int x = get_trash();
        // cerr << "deb: " << v << " " << x << "\n";
        ans.push_back({x, v});
        A[v].push_back(x);
    }
    A[v].resize(B[u].size());
    for (int i = 0; i < A[v].size(); i++) {
        int x = A[v][i];
        int y = B[u][i];
        dfs(x, y);
    }
}

void solve() {
    cin >> n;
    A.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        A[p].push_back(i);
    }
    B.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        B[p].push_back(i);
    }
    used.resize(n);
    dfs(0, 0);
    cout << ans.size() << "\n";
    for (auto [v, u] : ans)
        cout << v << " " << u << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef dimss
        freopen("test.txt", "r", stdin);
    #endif

    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
        #ifdef dimss
            cerr << "--------\n";
        #endif
    }
    return 0;
}
