#include <bits/stdc++.h>
using namespace std;
 
#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i,a,b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()
 
using ll = long long;
using pll = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;
 
const double EPS = 1e-5;
 
mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());
 
void solve() {
    ll n, k; cin >> n >> k;
 
    vector<pll> ls(n, {0, 0}); rep(i, n) cin >> ls[i].first;
    rep(i, n) cin >> ls[i].second;
 
    sort(all(ls));
    long double cur = 0;
    rep(i, n) {
        cur += abs(ls[i].first - ls[i].second) / (long double) ls[i].first;
    }
 
    ll ans = 0;
    rep(i, n) {
        long double d = abs(ls[i].first - ls[i].second) / (long double) ls[i].first;
        long double ifik = cur - d;
 
        if (ifik - k <= EPS) {
            ll l = -1, r = abs(ls[i].first - ls[i].second);
            while (r - l > 1) {
                ll m = (l + r) >> 1;
                long double nw = cur - m / (long double) ls[i].first;
                if ((nw - k) <= EPS) {
                    r = m;
                } else {
                    l = m;
                }
            }
            ans += r;
            break;
        }
        cur = ifik;
        ans += abs(ls[i].first - ls[i].second);
    }
 
    cout << ans << '\n';
     
 
 
}
 
int main() {
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(0);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}