#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i,a,b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()

using ll = long long;
using pll = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;

mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

string itos(int x) {
    string s = "";
    while (x > 0) {
        char c = '0' + x % 10;
        s = c + s;
        x /= 10;
    }

    return s;
}

void solve() {
	int n; cin >> n;
    map<string, int> last;
    set<string> used;

    rep(i, n) {
        string s; cin >> s;
        int x = last[s];
        while (used.find(s + itos(x)) != used.end()) x++;
        cout << s << itos(x) << '\n';
        used.insert(s + itos(x));
        last[s]++;
    }
}


int main() {
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
    cin.tie(0);
	int t = 1; // cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}