#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define ld long double
#define pb push_back
#define ll long long
using namespace std;

const int INF = 1e9 + 7;

char a[1005][1005];
int used[1005][1005];

deque<pair<int, int> > d;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k, xs, ys, xf, yf;
    cin >> n >> m >> k;
    for(int i = 0; i < n; ++i)
    {
        for(int j = 0; j < m; ++j)
        {
            cin >> a[i][j];
            used[i][j] = INF;
        }

    }
    cin >> xs >> ys >> xf >> yf;
    xs--;
    ys--;
    xf--;
    yf--;
    used[xs][ys] = 0;
    d.push_back({xs, ys});
    while(!d.empty())
    {
        pair<int, int> p = d.front();
        d.pop_front();
        if(p.x - 1 >= 0 && a[p.x - 1][p.y] == '.' && used[p.x - 1][p.y] > used[p.x][p.y])
        {
            used[p.x - 1][p.y] = used[p.x][p.y];
            d.push_front({p.x - 1, p.y});
        }
        if(p.y - 1 >= 0 && a[p.x][p.y - 1] == '.' && used[p.x][p.y - 1] > used[p.x][p.y])
        {
            used[p.x][p.y - 1] = used[p.x][p.y];
            d.push_front({p.x, p.y - 1});
        }
        if(p.x + 1 < n && a[p.x + 1][p.y] == '.' && used[p.x + 1][p.y] > used[p.x][p.y])
        {
            used[p.x + 1][p.y] = used[p.x][p.y];
            d.push_front({p.x + 1, p.y});
        }
        if(p.y + 1 < m && a[p.x][p.y + 1] == '.' && used[p.x][p.y + 1] > used[p.x][p.y])
        {
            used[p.x][p.y + 1] = used[p.x][p.y];
            d.push_front({p.x, p.y + 1});
        }

        if(p.x - 2 >= 0 && a[p.x - 2][p.y] == '.' && used[p.x - 2][p.y] > used[p.x][p.y] + 1)
        {
            used[p.x - 2][p.y] = used[p.x][p.y] + 1;
            d.push_back({p.x - 2, p.y});
        }
        if(p.y - 2 >= 0 && a[p.x][p.y - 2] == '.' && used[p.x][p.y - 2] > used[p.x][p.y] + 1)
        {
            used[p.x][p.y - 2] = used[p.x][p.y] + 1;
            d.push_back({p.x, p.y - 2});
        }
        if(p.x + 2 < n && a[p.x + 2][p.y] == '.' && used[p.x + 2][p.y] > used[p.x][p.y] + 1)
        {
            used[p.x + 2][p.y] = used[p.x][p.y] + 1;
            d.push_back({p.x + 2, p.y});
        }
        if(p.y + 2 < m && a[p.x][p.y + 2] == '.' && used[p.x][p.y + 2] > used[p.x][p.y] + 1)
        {
            used[p.x][p.y + 2] = used[p.x][p.y] + 1;
            d.push_back({p.x, p.y + 2});
        }
    }
    if(used[xf][yf] <= k)
        cout << "YES\n";
    else
        cout << "NO\n";

    return 0;
}








