import java.io.*;
import java.util.Scanner;

public class C2 {

    public static void main(String[] args) throws IOException {
        var in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        var out = new BufferedWriter(new OutputStreamWriter(System.out));

        int n = in.nextInt();
        int k = in.nextInt();

        int l = 2;
        int r = n;
        while (l < r) {
            int mid = (l + r + 1) / 2;
            if (mid * k <= 2 * (n - mid)) {
                l = mid;
            } else {
                r = mid - 1;
            }
        }
        out.write(Integer.toString(l));
        out.close();
    }
}
