#include <bits/stdc++.h>
#include <ctime>
#pragma GCC optimize("O3,fast-math")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,bmi2,tune=native")
#ifdef KOK
#include "debug_output.h"
#define dbg(x)                                                                 \
    cerr << "\n" << #x << ":\n ";                                              \
    debug::print(x);                                                           \
    cerr << "\n"
#else
#define dbg(x) ;
#endif

#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define rep(i, k, n) for (int i = k; i < n; i++)
#define rrep(i, k, n) for (int i = n - 1; i >= k; i--)
#define frl(i, x) for (auto &i : x)
#define forall(i, x) frl(i, x)
#define pb push_back
#define eb emplace_back
#define F first
#define S second

using ll = long long;
using ld = long double;
using dd = double;

using namespace std;

const int maxn = 2e5 + 10;
int a[maxn];
char used[maxn];
int kuda[maxn];

void dfs(int i) {
    if (used[i]) {
        return;
    }
    if (a[i] == 0) {
        used[i] = 1;
        kuda[i] = i;
        return;
    }
    used[i] = 1;
    dfs(i - a[i]);
    kuda[i] = kuda[i - a[i]];
}

int dist[maxn];

void solve() {
    int n;
    cin >> n;
    rep(i, 1, n - 1) cin >> a[i];
    rep(i, 0, n) {
        if (used[i])
            continue;
        dfs(i);
    }
    deque<pair<int, bool>> q;
    q.push_back({0, 1});
    memset(dist, -1, sizeof dist);
    dist[0] = 0;
    while (!q.empty()) {
        auto [cur, flag] = q.front();
        q.pop_front();
        int dx = 6;
        int res = kuda[min(cur + dx, n - 1)];
        if (dist[res] == -1) {
            dist[res] = dist[cur] + flag;
            if (flag) {
                q.push_back({res, 0});
            } else {
                q.push_front({res, 0});
            }
        }
        for (int dx = 1; dx <= 5; dx++) {
            int res = kuda[min(cur + dx, n - 1)];
            if (dist[res] == -1) {
                dist[res] = dist[cur] + flag;
                if (flag) {
                    q.push_back({res, 1});
                } else {
                    q.push_front({res, 1});
                }
            }
        }
    }
    cout << dist[n - 1];
}

signed main() {
    cin.tie(0)->ios::sync_with_stdio(0);
    int tt = 1;
    // cin >> tt;
    cout << setprecision(15) << fixed;
    while (tt--)
        solve();

#ifdef KOK
    cerr << setprecision(6) << fixed;
    cerr << "\nTime: " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
    return 0;
}