#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const long long GCD = 2520;

long long calc_diff(vector<pair<long long, long long>>& s) {
    long long ans = 0;
    for (const auto& p: s) {
        ans += abs(p.first - p.second) * GCD / p.first;
    }
    return ans;
} 

int main()
{
    long long r, l;
    cin >> l >> r;
    for (long long t = r - l; t >= 1; t--) {
        long long y = (r / t) * t;
        if (y - t >= l) {
            cout << y - t << " " << y << '\n';
            return 0;
        }
    }
}
