#include <iostream>
#include <unordered_set>

#define int_t long long

std::unordered_set<std::string> words;

std::string get(std::string const& s) {
    if (words.find(s) == words.end()) {
        words.insert(s);
        return s;
    }
    std::string new_s;
    for (int_t i = 1; true; i++) {
        new_s = s + std::to_string(i);
        if (words.find(new_s) == words.end()) {
            words.insert(new_s);
            return new_s;
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("/home/mavlyut/CLionProjects/untitled1/in", "r", stdin);
    freopen("/home/mavlyut/CLionProjects/untitled1/out", "w", stdout);
#endif
    std::ios_base::sync_with_stdio(false);

    int_t q;
    std::string s, new_s;
    std::cin >> q;
    for (int_t i = 0; i < q; i++) {
        std::cin >> s;
        std::cout << get(s) << '\n';
    }

}
