#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int INF = 1e9;

int main()
{
    int n;
    cin >> n;
    vector<int> p(n);
    vector <int> dp(n, INF);
    for (int i = 1; i < n - 1; i++) {
        cin >> p[i];
    }
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        if (p[i] != 0) {
            continue;
        }
        for (int j = 1; j <= 6; j++) {
            int pos = i + j;
            pos = min(pos, n - 1);
            while (pos > 0 && p[pos] != 0) {
                pos = pos - p[pos];
            }
            p[min(i + j, n - 1)] = i + j - pos;
            dp[pos] = min(dp[pos], dp[i] + (j == 6 ? 0 : 1));
        }
    }
    if (dp[n - 1] == INF) {
        cout << -1 << '\n';
    } else {
        cout << dp[n - 1] << '\n';
    }
}
