#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int INF = 1e9;

int main()
{
    int n;
    cin >> n;
    vector<int> p(n);
    vector <int> dp(n, INF);
    for (int i = 1; i < n - 1; i++) {
        cin >> p[i];
    }
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        if (p[i] != 0) {
            continue;
        }
        for (int j = 1; j <= 6; j++) {
            int cur_pos = min(i + j, n - 1);
            int first_jump = cur_pos;
            while (cur_pos > 0 && p[cur_pos] != 0) {
                cur_pos = cur_pos - p[cur_pos];
            }
            cur_pos = max(cur_pos, 0);
            p[first_jump] = first_jump - cur_pos;
            dp[cur_pos] = min(dp[cur_pos], dp[i] + ((j == 6 && cur_pos != n - 1) ? 0 : 1));
        }
    }
    if (dp[n - 1] == INF) {
        cout << -1 << '\n';
    } else {
        cout << dp[n - 1] << '\n';
    }
}
