#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef vector<vii> vvii;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 2e9;

struct bor {
    bool exist = false;
    int value = 0;
    bor *next[10];
};

void update(bor* node) {
    int res = INF;
    for (int i = 0; i < 10; ++i) {
        if (node->next[i] == nullptr) {
            res = min(res, 10 + i);
            break;
        } else {
            string kek = to_string(node->next[i]->value).substr(1);
            kek = "1" + to_string(i) + kek;
            res = min(res, stoi(kek));
        }
    }
    node->value = res;
}

void create(string &s, int k, bor* node) {
    if (k < s.size()) {
        if (node->next[s[k] - '0'] == nullptr) {
            node->next[s[k] - '0'] = new bor();
            node->next[s[k] - '0']->exist = false;
            forn(i, 10) {
                node->next[s[k] - '0']->next[i] = nullptr;
            }
        }
        create(s, k + 1, node->next[s[k] - '0']);
        update(node);
    } else {
        node->exist = true;
        update(node);
    }
}

string add(string &s, int k, bor* node) {
    if (k < s.size()) {
        if (node->next[s[k] - '0'] == nullptr) {
            node->next[s[k] - '0'] = new bor();
            node->next[s[k] - '0']->exist = false;
            forn(i, 10) {
                node->next[s[k] - '0']->next[i] = nullptr;
            }
        }
        string result = add(s, k + 1, node->next[s[k] - '0']);
        update(node);
        return result;
    } else {
        int res = INF;
        if (node->exist) {
            for (int i = 1; i < 10; ++i) {
                if (node->next[i] == nullptr) {
                    res = 10 + i;
                    break;
                }
                string kek = to_string(node->next[i]->value).substr(1);
                kek = "1" + to_string(i) + kek;
                res = min(res, stoi(kek));
            }
            string lol = to_string(res).substr(1);
            create(lol, 0, node);
            update(node);
            return lol;
        } else {
            node->exist = true;
            update(node);
            return "";
        }

    }
}


void solve() {
    int n;
    cin >> n;
    map<string, bor *> mapa;
    forn(_, n) {
        string s;
        cin >> s;
        int i = s.size();
        while (i > 0 && isdigit(s[i - 1])) {
            i--;
        }
        string num = s.substr(i);
        s = s.substr(0, i);
        if (mapa.find(s) == mapa.end()) {
            mapa[s] = new bor();
            mapa[s]->exist = false;
            forn(i, 10) {
                mapa[s]->next[i] = nullptr;
            }
        }
        bor *cur = mapa[s];
        string suf = add(num, 0, cur);
        cout << s << num << suf << endl;
    }
    cout << endl;
}

signed main() {
#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}