#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <iomanip>
#include <deque>
#include <random>
#include <ctime>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> ii;
typedef pair<int, ii> iii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef vector<vii> vvii;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 2e9;

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vvi wall(n + 4, vi(m + 4, 1));
    vvi dist(n + 4, vi(m + 4, INF));
    vvi used1(n + 4, vi(m + 4));
    vvi used2(n + 4, vi(m + 4));
    forn(i, n) {
        forn(j, m) {
            char x;
            cin >> x;
            wall[i + 2][j + 2] = ((x == '#') ? 1 : 0);
        }
    }
    ll dx, dy, ax, ay;
    cin >> dx >> dy >> ax >> ay;
    dx += 1;
    dy += 1;
    ax += 1;
    ay += 1;
    dist[dx][dy] = 0;
    queue<ii> que;
    queue<ii> megaQue;
    megaQue.emplace(dx, dy);
    while (!megaQue.empty()) {
        que.swap(megaQue);
        while (!que.empty()) {
            ll curx, cury;
            tie(curx, cury) = que.front();
            que.pop();
            used1[curx][cury] = 1;
            used2[curx][cury] = 1;
            vii kek1 = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
            vii kek2 = {{0, 2}, {0, -2}, {2, 0}, {-2, 0}};
            for (auto p : kek1) {
                if (!used1[curx + p.first][cury + p.second] && !wall[curx + p.first][cury + p.second]) {
                    used1[curx + p.first][cury + p.second] = 1;
                    dist[curx + p.first][cury + p.second] = min(dist[curx + p.first][cury + p.second], dist[curx][cury]);
                    que.emplace(curx + p.first, cury + p.second);
                }
            }
            for (auto p : kek2) {
                if (!used1[curx + p.first][cury + p.second] && !used2[curx + p.first][cury + p.second] && !wall[curx + p.first][cury + p.second]) {
                    used2[curx + p.first][cury + p.second] = 1;
                    dist[curx + p.first][cury + p.second] = min(dist[curx + p.first][cury + p.second], dist[curx][cury] + 1);
                    megaQue.emplace(curx + p.first, cury + p.second);
                }
            }
        }
    }
    /*for (int i = 2; i <= n + 1; i++) {
        for (int j = 2; j <= m + 1; j++) {
            cout << dist[i][j] << ' ';
        }
        cout << endl;
    }*/
    if (dist[ax][ay] <= k) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}

signed main() {
#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}