#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <iomanip>
#include <deque>
#include <random>
#include <ctime>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> ii;
typedef pair<int, ii> iii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef vector<vii> vvii;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 2e9;

class tree {
private:
    struct node {
        int parent;
        vector<int> childs;
    };
public:
    tree(const vector<int>& v) : data(v.size() + 1) {
        for (int i = 0; i < v.size(); i++) {
            data[i + 1].parent = v[i];
            data[data[i + 1].parent].childs.push_back(i + 1);
        }
    }

    friend vector<pair<int, int>> remade(tree& from, tree& to) {
        set<int> free;
        for (int i = 1; i < from.data.size(); i++) {
            free.insert(i);
        }
        vector<pair<int, int>> res;
        rem(0, 0, free, res, from.data, to.data);
        return res;
    }
private:
    static void rem(int from, int to, set<int>& free, vector<pair<int, int>>& res, vector<node>& from_v, vector<node>& to_v) {
        for (int i = 0; i < to_v[to].childs.size(); i++) {
            if (i >= from_v[from].childs.size()) {
                auto it = free.begin();
                int free_i = *it;
                free.erase(it);
                if (from_v[from_v[free_i].parent].childs[0] == free_i) {
                    from_v[from_v[free_i].parent].childs.erase(from_v[from_v[free_i].parent].childs.begin());
                } else {
                    from_v[from_v[free_i].parent].childs.erase(++(from_v[from_v[free_i].parent].childs.begin()));
                }
                from_v[free_i].parent = from;
                from_v[from].childs.push_back(free_i);
                res.push_back(pair<int, int>(free_i, from));
            } else {
                free.erase(from_v[from].childs[i]);
            }
            rem(from_v[from].childs[i], to_v[to].childs[i], free, res, from_v, to_v);
        }
    }

    vector<node> data;
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> a[i];
    }
    tree from(a);
    for (int i = 0; i < n - 1; i++) {
        cin >> a[i];
    }
    tree to(a);
    auto r = remade(from, to);
    cout << r.size() << "\n";
    for (int i = 0; i < r.size(); i++) {
        cout << r[i].first << " " << r[i].second << "\n";
    }
}

signed main() {
#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}