#include <bits/stdc++.h>
using namespace std;
#define int ll
typedef long long ll;
typedef long double ld;
typedef long long var;
typedef pair<int, int>prii;
typedef pair<ll, ll>prll;
typedef vector<int>veci;
typedef vector<ll>vecl;
typedef vector<veci> graph;
typedef map<int, int> mapii;
typedef set<int> seti;
typedef bitset<64> bits;
typedef string str;
#define vec vector
#define fir first
#define sec second
#define $ '\n' //'
#define $$ endl
#define MAX LONG_LONG_MAX
#define INF LONG_LONG_MAX
#define MIN LONG_LONG_MIN
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define len(o) ((int)o.size())
#define psh push_back
template <typename T> istream& operator >> (istream &in, vector<T> &v) { 
    for (T &t : v) in >> t;
    return in;
}
template <typename T> ostream& operator << (ostream &out, const vector<T> &v) {
    for (const T &t : v) out << t << ' ';
    return out;
}
template <typename T> ostream& operator << (ostream &out, const set<T> &v) {
    for (const T &t : v) out << t << ' ';
    return out;
}

const int MOD = 1'000'000'007;
inline void solve();
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
  //  freopen("biconv.in", "r", stdin);
  //  freopen("biconv.out", "w", stdout);

    solve();
    cout.flush();
    cerr << "\nTime: " << setprecision(2) <<
        int(1000 * (double)clock() / CLOCKS_PER_SEC) << " ms\n";
    return 0;
}

////////////////////////////////////////////////////////////////////////////////

template <class T> T rmin(T &a, const T &b) { return (a = min(a, b)); }
template <class T> T rmax(T &a, const T &b) { return (a = max(a, b)); }
template <class T> T reql(T &a, const T &b) { return (a = b); }

int n;

bool ok(vec<prii> d, int t, int k) {

    for (int i = 0; i < n; i++) {
        if (t > d[i].sec) {
            t -= d[i].sec;
        } else {
            d[i].sec -= t;
            t = 0;
            break;
        }
        d[i].sec = 0;
    }

//    ld dev = 0.0;
//    for (int i = 0; i < n; i++)
//      dev += d[i].sec / d[i].fir;
//    return dev <= k;
    int sm = 1;
    for (int i = 0; i < n; i++) {
        sm *= d[i].fir;
    }
    

    int dev = 0;
    for (int i = 0; i < n; i++) {
        dev += d[i].sec * sm / d[i].fir;
    }
    return dev <= k * sm;
}

inline void solve() {
    int k;
    cin >> n >> k;
    vec<prii> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i].fir;
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i].sec;
        d[i].sec = abs(d[i].sec - d[i].fir);
    }
    sort(all(d), [=](const prii &x, const prii &y) {
        return make_pair(x.sec, x.fir) < make_pair(y.sec, y.fir);
    });
    
    
    int l = -1, r = 1e18;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (ok(d, m, k)) {
            r = m;
        } else {
            l = m;
        }
    }

    cout << r << $;
}
/*


 
*/
