#include <bits/stdc++.h>
using namespace std;
#define int ll
typedef long long ll;
typedef long double ld;
typedef long long var;
typedef pair<int, int>prii;
typedef pair<ll, ll>prll;
typedef vector<int>veci;
typedef vector<ll>vecl;
typedef vector<veci> graph;
typedef map<int, int> mapii;
typedef set<int> seti;
typedef bitset<64> bits;
typedef string str;
#define vec vector
#define fir first
#define sec second
#define $ '\n' //'
#define $$ endl
#define MAX LONG_LONG_MAX
#define INF LONG_LONG_MAX
#define MIN LONG_LONG_MIN
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define len(o) ((int)o.size())
#define psh push_back
template <typename T> istream& operator >> (istream &in, vector<T> &v) { 
    for (T &t : v) in >> t;
    return in;
}
template <typename T> ostream& operator << (ostream &out, const vector<T> &v) {
    for (const T &t : v) out << t << ' ';
    return out;
}
template <typename T> ostream& operator << (ostream &out, const set<T> &v) {
    for (const T &t : v) out << t << ' ';
    return out;
}

const int MOD = 1'000'000'007;
inline void solve();
signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
  //  freopen("biconv.in", "r", stdin);
  //  freopen("biconv.out", "w", stdout);

    solve();
    cout.flush();
//    cerr << "\nTime: " << setprecision(2) <<
//        int(1000 * (double)clock() / CLOCKS_PER_SEC) << " ms\n";
    return 0;
}

////////////////////////////////////////////////////////////////////////////////

template <class T> T rmin(T &a, const T &b) { return (a = min(a, b)); }
template <class T> T rmax(T &a, const T &b) { return (a = max(a, b)); }
template <class T> T reql(T &a, const T &b) { return (a = b); }


int n, m, k;
const vec<prii> steps = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

vec<str> city;
vec<veci> used;

bool ok(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

void dfs(int x, int y, int k, int mul = 1) {
//    cout << " : "<<x << " " << y << $;
//    if (mul == 2) {
//        cout << k << " <" << $;
//    }
    used[x][y] = 1;
    bool escape = false;
    for (const prii& s : steps) {
        int nx = x + s.fir * mul;
        int ny = y + s.sec * mul;
        if (!ok(nx, ny)) continue;
        if (used[nx][ny]) continue;
        if (city[nx][ny] == '.') {
            escape = true;
            dfs(nx, ny, k);
        }
    }
    if (!escape && k > 0) {
        dfs(x, y, k - 1, 2);
    }
}

void bfs(int x, int y, int k, int mul = 1) {
    queue<prii> q;
    queue<int> ks;
    q.push({x, y});
    ks.push(k);
    used[x][y] = 1;
    
    while (!q.empty()) {
        prii c = q.front();
        q.pop();
        int curk = ks.front();
        ks.pop();

        bool escape = false;

        for (const prii& s : steps) {
            int nx = c.fir + s.fir;
            int ny = c.sec + s.sec;
            if (!ok(nx, ny)) continue;
            if (used[nx][ny]) continue;
            if (city[nx][ny] == '.') {
                used[nx][ny] = 1;
                escape = true;
                q.push({nx, ny});
                ks.push(curk);
            }
        }
        
        if (escape) continue;
        if (curk <= 0) continue;

        for (const prii& s : steps) {
            int nx = c.fir + 2 * s.fir;
            int ny = c.sec + 2 * s.sec;
            if (!ok(nx, ny)) continue;
            if (used[nx][ny]) continue;
            if (city[nx][ny] == '.') {
                used[nx][ny] = 1;
                escape = true;
                q.push({nx, ny});
                ks.push(curk - 1);
            }
        }
    }
}

inline void solve() {
    cin >> n >> m >> k;
    city = vec<str>(n);
    used = vec<veci>(n, veci(m));
    for (int i = 0; i < n; i++) cin >> city[i];
    int dx, dy; cin >> dx >> dy; --dx; --dy;
    int ax, ay; cin >> ax >> ay; --ax; --ay;
    bfs(dx, dy, k);
    cout << (used[ax][ay] ? "YES" : "NO") << $;
}
/*
*/ 
