from sys import setrecursionlimit


def dfs(y, x, k_count):
    visited[x][y] = True
    can_leave = False
    if y == ay - 1 and x == ax - 1:
        print("YES")
        quit()
    if x > 0 and Burg[x - 1][y] != '#' and not visited[x - 1][y]:
        can_leave = True
        dfs(y, x - 1, k_count)
    if x < N - 1 and Burg[x + 1][y] != '#' and not visited[x + 1][y]:
        can_leave = True
        dfs(y, x + 1, k_count)
    if y > 0 and Burg[x][y - 1] != '#' and not visited[x][y - 1]:
        can_leave = True
        dfs(y - 1, x, k_count)
    if y < M - 1 and Burg[x][y + 1] != '#' and not visited[x][y + 1]:
        can_leave = True
        dfs(y + 1, x, k_count)

    if not can_leave and k_count < K:
        if x > 1 and Burg[x - 2][y] != '#' and not visited[x - 2][y]:
            dfs(y, x - 2, k_count + 1)
        if x < N - 2 and Burg[x + 2][y] != '#' and not visited[x + 2][y]:
            dfs(y, x + 2, k_count + 1)
        if y > 1 and Burg[x][y - 2] != '#' and not visited[x][y - 2]:
            dfs(y - 2, x, k_count + 1)
        if y < M - 2 and Burg[x][y + 2] != '#' and not visited[x][y + 2]:
            dfs(y + 2, x, k_count + 1)


def bfs(y0, x0, k_count0):
    visited[x0][y0] = True

    queue.append([x0, y0, k_count0])

    while queue:
        m = queue.pop()
        x = m[0]
        y = m[1]
        k_count = m[2]
        visited[x][y] = True
        X1Y0 = False
        X2Y0 = False
        X0Y1 = False
        X0Y2 = False

        if y == ay - 1 and x == ax - 1:
            print("YES")
            quit()

        if x > 0 and Burg[x - 1][y] != '#' and not visited[x - 1][y]:
            X1Y0 = True
            queue.append([x - 1, y, k_count])
        if x < N - 1 and Burg[x + 1][y] != '#' and not visited[x + 1][y]:
            X2Y0 = True
            queue.append([x + 1, y, k_count])
        if y > 0 and Burg[x][y - 1] != '#' and not visited[x][y - 1]:
            X0Y1 = True
            queue.append([x, y - 1, k_count])
        if y < M - 1 and Burg[x][y + 1] != '#' and not visited[x][y + 1]:
            X0Y2 = True
            queue.append([x, y + 1, k_count])

        if k_count < K:
            if not X1Y0 and x > 1 and Burg[x - 2][y] != '#' and not visited[x - 2][y]:
                queue.append([x, y + 1, k_count + 1])
            if not X2Y0 and x < N - 2 and Burg[x + 2][y] != '#' and not visited[x + 2][y]:
                queue.append([x, y + 1, k_count + 1])
            if not X0Y1 and y > 1 and Burg[x][y - 2] != '#' and not visited[x][y - 2]:
                queue.append([x, y + 1, k_count + 1])
            if not X0Y2 and y < M - 2 and Burg[x][y + 2] != '#' and not visited[x][y + 2]:
                queue.append([x, y + 1, k_count + 1])



setrecursionlimit(100000000)
N, M, K = map(int, input().split(" "))
Burg = [[] for _ in range(N)]
visited = [[False for _ in range(M)] for _ in range(N)]
canLeave = [[False for _ in range(M)] for _ in range(N)]
queue = []

dx = 0
dy = 0
ax = 0
ay = 0
# N == x, M == y

for i in range(N):
    Burg[i] = list(input())

dx, dy = map(int, input().split(" "))
ax, ay = map(int, input().split(" "))

bfs(dy - 1, dx - 1, 0)

if not visited[ax - 1][ay - 1]:
    print("NO")
    quit()

