#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <queue>
#include <bitset>
#include "cmath"

using namespace std;

typedef long long ll;
typedef long double ld;

bool multitest = false;

void solve() {
    int n;
    cin >> n;
    vector< pair<ll, ll> > dots(n);
    ld ans = 0;
    ld max_dst = 0;
    ld x1, y1;
    cin >> x1 >> y1;
    ld f = x1, s = y1;
    ld x2, y2;
    for (int i = 1; i < n; ++i) {
        cin >> x2 >> y2;
        ld dst = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
        ans += dst;
        max_dst = max(max_dst, dst);
        x1 = x2;
        y1 = y2;
    }
    ld dst = sqrt((f-x1)*(f-x1) + (s-y1)*(s-y1));
    ans += dst;
    max_dst = max(max_dst, dst);
    cout << ans - max_dst;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout.precision(10);
    int t = 1;
    if (multitest) {
        cin >> t;
    }
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}