#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

typedef long long ll;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> a(n);
    vector<vector<int>> d(n, vector<int>(m, 1e9));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int x1, y1, x2, y2;
    cin >> x1 >> y1 >> x2 >> y2;
    x1--, y1--, x2--, y2--;
    set<pair<int, pair<int, int>>> q;
    q.insert({0, {x1, y1}});
    d[x1][y1] = 0;
    vector<int> di = {0, 0, 1, -1}, dj = {1, -1, 0, 0};
    while (!q.empty()) {
        auto p = *q.begin();
        q.erase(p);
        int x = p.second.first, y = p.second.second;
        for (int i = 0; i < 4; ++i) {
            int x3 = x + di[i], y3 = y + dj[i];
            if (min(x3, y3) >= 0 && x3 < n && y3 < m) {
                if (a[x3][y3] == '.' && d[x3][y3] > d[x][y]) {
                    q.erase({d[x3][y3], {x3, y3}});
                    d[x3][y3] = d[x][y];
                    q.insert({d[x3][y3], {x3, y3}});
                }
            }
            int x4 = x + 2 * di[i], y4 = y + 2 * dj[i];
            if (min(x4, y4) >= 0 && x4 < n && y4 < m) {
                if (a[x4][y4] == '.' && d[x4][y4] > d[x][y] + 1) {
                    q.erase({d[x4][y4], {x4, y4}});
                    d[x4][y4] = d[x][y] + 1;
                    q.insert({d[x4][y4], {x4, y4}});
                }
            }
        }
    }
    cout << (d[x2][y2] <= k ? "YES" : "NO") << '\n';
    return 0;
}
