#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n - 2; ++i) {
        cin >> a[i + 1];
    }
    vector<int> f(n);
    f[n - 1] = n - 1;
    for (int i = 1; i < n - 1; ++i) {
        if (a[i] == 0) {
            f[i] = i;
        } else {
            f[i] = f[i - a[i]];
        }
    }
    set<pair<pair<int, int>, int>> prq;
    prq.insert({{0, 1}, 0});
    vector<pair<int, int>> d(n, {1e9, 1});
    d[0] = {0, 1};
    while (!prq.empty()) {
        auto p = *prq.begin();
        prq.erase(p);
        int i = p.second;
        int d1 = p.first.first;
        int add = p.first.second;
        for (int x = 1; x <= 6; ++x) {
            int y = f[min(i + x, n - 1)];
            int d2 = d1 + add;
            int add1 = (x == 6 ? 0: 1);
            if (d1 < d[y].first || (d1 == d[y].first && add1 < d[y].second)) {
                prq.erase({{d1, add}, y});
                d[y] = {d2, add1};
                prq.insert({{d2, add1}, y});
            }
        }
    }
    cout << (d[n - 1].first == 1e9 ? -1 : d[n - 1].first) << '\n';
    return 0;
}
