#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<queue>
#include<ctime>
#include<bitset>

using namespace std;
#define int long long
const int _1e9 = 1'000'000'000;
const int mod = _1e9 + 7;
typedef long long ll;

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	vector<vector<int>>a(n);
	vector<vector<int>>b(n);
	vector<int>pred_a(n);
	vector<int>pred_b(n);
	set<int>free_a;
	set<int>free_b;
	for (int i = 1; i < n; ++i) {
		int x;
		cin >> x;
		pred_a[i] = x;
		a[x].push_back(i);
		free_a.insert(i);
		free_a.erase(x);
	}
	for (int i = 1; i < n; ++i) {
		int x;
		cin >> x;
		pred_b[i] = x;
		b[x].push_back(i);
		free_b.insert(i);
		free_b.erase(x);
	}
	vector<int>poly1(n, -1);
	vector<int>poly2(n, -1);
	queue<pair<int, int>>q;
	vector<pair<int, int>>ans1;
	vector<pair<int, int>>ans2;
	q.push({ 0,0 });
	poly1[0] = 0;
	poly2[0] = 0;
	while (q.size()) {
		int x = q.front().first;
		int y = q.front().second;
		for (int t : a[x]) {
			free_a.erase(t);
		}
		for (int t : b[y]) {
			free_b.erase(t);
		}
		q.pop();
		while (a[x].size() < b[y].size()) {
			int t = *free_a.begin();
			free_a.erase(t);
			for (int i = 0; i < a[pred_a[t]].size(); ++i) {
				if (a[pred_a[t]][i] == t) {
					a[pred_a[t]].erase(a[pred_a[t]].begin() + i, a[pred_a[t]].begin() + i + 1);
					break;
				}
			}
			if (poly1[pred_a[t]] == -1 && a[pred_a[t]].size() == 0) {
				free_a.insert(pred_a[t]);
			}
			pred_a[t] = x;
			ans1.push_back({ t,x });
			a[x].push_back(t);
		}

		while (a[x].size() > b[y].size()) {
			int t = *free_b.begin();
			free_b.erase(t);
			for (int i = 0; i < b[pred_b[t]].size(); ++i) {
				if (b[pred_b[t]][i] == t) {
					b[pred_b[t]].erase(b[pred_b[t]].begin() + i, b[pred_b[t]].begin() + i + 1);
					break;
				}
			}
			if (poly2[pred_b[t]] == -1 && b[pred_b[t]].size() == 0) {
				free_b.insert(pred_b[t]);
			}
			ans2.push_back({ t,pred_b[t] });
			pred_b[t] = y;
			b[y].push_back(t);
		}

		for (int i = 0; i < a[x].size(); ++i) {
			q.push({ a[x][i],b[y][i] });
			free_a.erase(a[x][i]);
			free_b.erase(b[y][i]);
			poly1[a[x][i]] = b[y][i];
			poly2[b[y][i]] = a[x][i];
		}

	}
	cout << ans1.size() + ans2.size() << '\n';
	for (auto p : ans1) {
		cout << p.first << ' ' << p.second << '\n';
	}
	reverse(ans2.begin(), ans2.end());
	for (auto p : ans2) {
		cout << poly2[p.first] << ' ' << poly2[p.second] << '\n';
	}
	return 0;
}