#include <bits/stdc++.h>
#define forn(i, n) for (ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
typedef long long ll;
typedef long double ld;
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ld k;
    cin >> n >> k;
    vector<ll> s(n), a(n);
    forn(i, n) {
        cin >> s[i];
    }

    forn(i, n) {
        cin >> a[i];
    }


    vector<pair<ld, ll>> v(n);
    forn(i, n) {
        v[i] = {ld(1.0)/s[i], abs(s[i]-a[i])};
    }
    sort(all(v));
    reverse(all(v));
 
    vector<ld> vc(n);
    vector<ld> vcp(n+1, 0);
    forn(i, n) {
        vc[i] = v[i].first*v[i].second;
    }
    forn(i, n) {
        vcp[i+1] = vcp[i] + vc[i];
    }

    if (vcp[n] <= k) {
        cout << "0\n";
        return 0;
    }

    ll l = 0, r = 2000000000;
    while (r-l > 1){
        ll m = (l+r)/2;
        //check can we do it with m minutes
        ll ml = m;
        ld sm = 0;
        forn(i, n) {
            ll us = min(ml, v[i].second);
            sm += us * v[i].first;
            ml -= us;
            if (vcp[n] - k <= sm) {
                break;
            }
        }
        if (vcp[n] - k <= sm) {
            // we can it ok
            r = m;
        } else {
            l = m;
        }
    }

        ll ml = l;
        ld sm = 0;
        forn(i, n) {
            ll us = min(ml, v[i].second);
            sm += us * v[i].first;
            ml -= us;
            if (vcp[n] - k <= sm) {
               break;
            }
        }

        if (vcp[n] - k <= sm) {
            r = l;
        }

    cout << r << "\n";

    return 0;
}