#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<int> arr(200007, 0);

int f(int index) {
    if (arr[index - arr[index]] > 0) {
        arr[index] = -arr[index] + f(index - arr[index]);
    } else if (arr[index - arr[index]] == 0) {
        arr[index] = -arr[index];
        return arr[index];
    } else if (arr[index - arr[index]] < 0) {
        arr[index] = -arr[index] + arr[index - arr[index]];
    }
    return arr[index];
}

int main() {
    int n;
    cin >> n;
    if (n == 2) {
        cout << "1\n";
        return 0;
    }
    for (int i = 1; i < n - 1; i++) {
        cin >> arr[i];
    }

    vector<int> dp(n, INT_MAX);
    dp[0] = 0;

    for (int i = n - 1; i > 0; i--) {
        if (arr[i] > 0) {
            f(i);
        }
    }


//    for (int i = 0; i < n; i++) {
//        cout << arr[i] << " ";
//    }
//    cout << endl;

    for (int i = 0; i < n; i++) {
        if (arr[i] != 0) {
            continue;
        }
        for (int j = 1; j <= 5; j++) {
            if (i + j < n) {
                if (arr[i + j] == 0) {
                    dp[i + j] = min(dp[i] + 1, dp[i + j]);
                } else {
                    dp[i + j + arr[i + j]] = min(dp[i] + 1, dp[i + j + arr[i + j]]);
                }
            } else {
                dp[n - 1] = min(dp[n - 1], dp[i] + 1);
            }

            if (i + 6 < n - 1) {
                if (arr[i + 6] == 0) {
                    dp[i + 6] = min(dp[i], dp[i + 6]);
                } else {
                    dp[i + 6 + arr[i + 6]] = min(dp[i], dp[i + 6 + arr[i + 6]]);
                }
            } else {
                dp[n - 1] = min(dp[n - 1], dp[i] + 1);
            }
        }
    }

//    cout << dp[n - 1] << endl;
    if (dp[n - 1] != INT_MAX && dp[n - 1] > 0) {
        cout << dp[n - 1] << endl;
    } else {
        cout << "-1\n";
    }

    return 0;
}