#include <bits/stdc++.h>
using namespace std;

#define int long long
#define double long double
#define ld double

#define all(x) x.begin(), x.end()

const int INF = 2e9 + 5;
const int SZ = 1 << 18;
const double eps = 1e-10;

struct Point {
    int x, y;
};

void solve(){

    int n;
    cin >> n;
    vector<Point> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i].x >> a[i].y;
    }
    a.push_back(a.front());

    double ans = 0;
    double mx = 0;
    for (int i = 0; i < n; i++){
        Point z{a[i].x - a[i + 1].x, a[i].y - a[i + 1].y};
        double cur = sqrtl(z.x*z.x + z.y*z.y);
        mx = max(mx, cur);
        ans += cur;
    }

    cout << ans - mx;

}

signed main(){

    // freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cout << fixed << setprecision(10);

    int t = 1;
    // cin >> t;

    while (t--){
        solve();
        cout << '\n';
    }

}