#include <bits/stdc++.h>
using namespace std;
 
#define int long long
#define double long double
#define ld double
 
#define all(x) x.begin(), x.end()
 
const int INF = 2e9 + 5;
const int SZ = 1 << 18;
const double eps = 1e-10;

int n;
int p[SZ];
vector<int> g[SZ];
int q[SZ];
vector<int> h[SZ];

int color[SZ];

vector<int> top_sort;
void dfs(int cur = 0, int c2 = 0){
    auto it = h[c2].begin();
    for (int next : g[cur]){
        int n2 = n;
        if (it != h[c2].end()){
            n2 = *it;
            it++;
            color[next]++;
        }
        dfs(next, n2);
    }
    if (!color[cur]){
        top_sort.push_back(cur);
    }
}

vector<pair<int, int>> ans;
void dfs2(int c2 = 0, int cur = 0, int lol = -1){
    auto it = g[cur].begin();
    for (int n2 : h[c2]){
        int next = n;
        int kek = cur;
        if (it != g[cur].end()){
            next = *it;
            it++;
            kek = next;
        }else{
            while (color[top_sort.back()]){
                top_sort.pop_back();
            }
            ans.push_back({top_sort.back(), lol});
            kek = top_sort.back();
            top_sort.pop_back();
        }
        dfs2(n2, next, kek);
    }
}

void solve(){

    cin >> n;
    for (int i = 1; i < n; i++){
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i < n; i++){
        cin >> q[i];
        h[q[i]].push_back(i);
    }

    color[0] = 1;
    dfs();
    reverse(all(top_sort));
    dfs2();

    cout << ans.size() << '\n';
    for (auto e : ans){
        cout << e.first << ' ' << e.second << '\n';
    }

}
 
signed main(){
 
    // freopen("input.txt", "r", stdin);
 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    cout << fixed << setprecision(10);
 
    int t = 1;
    // cin >> t;
 
    while (t--){
        solve();
        cout << '\n';
    }
 
}