#include<bits/stdc++.h>
#define ll long long
using namespace std;
int cnt = 1;
int n, m, kk;
char a[2010][2010];
int k[2010][2010];

set<int> g[2000050];
int dp[2000500];

void dfs(int i, int j, int c)
{
	if (a[i][j] != '.')
		return;
	
	// cerr << "i j = " << i << j <<  "c = " << c << endl;
	k[i][j] = c;

	if (i-1 > 0 && k[i-1][j] == 0)
		dfs(i-1, j, c);
	
	if (i+1 <= n && k[i+1][j] == 0)
		dfs(i+1, j, c);
	
	if (j-1 > 0 && k[i][j-1] == 0)
		dfs(i, j-1, c);
	
	if (j+1 <= m && k[i][j+1] == 0)
		dfs(i, j+1, c);
	
}

const int inf = 1e9;

void bfs(int v)
{
	fill(dp, dp+2000050, inf);
	queue<int> q;
	q.push(v);

	dp[v] = 0;

	while(!q.empty())
	{
		int cur = q.front();
		q.pop();

		for(auto to: g[cur])
		{
			// cerr << "cur = " << cur << "to = " << to << endl;
			if (dp[to] > dp[cur]+1)
			{
				dp[to] = dp[cur]+1;
				q.push(to);
			}
		}
	}

}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);	
	cout.tie(0);

	
	cin >> n >> m >> kk;

	for (int i = 1; i <= n; i++)
	{
		string s;
		cin >> s;
		for (int j = 1; j <= m; j++)
			a[i][j] = s[j-1];
	}

	int ax, ay, bx, by;
	cin >> ax >> ay >> bx >> by;

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			if (a[i][j] == '.' && k[i][j] == 0)
				dfs(i, j, cnt++);

	// cerr << "cnt = " << cnt << endl;
	// for (int i = 1; i <= n; i++)
	// {
	// 	for (int j = 1; j <= m; j++)
	// 		cerr << k[i][j] << ' ';
	// 	cerr << endl;
	// }

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
		{
			if (a[i][j] != '.')
				continue;

			if (a[i+2][j] == '.')
			{
				if(k[i][j] != k[i+2][j])
				{
					g[k[i][j]].insert(k[i+2][j]);
					g[k[i+2][j]].insert(k[i][j]);	
				}
			}

			if (a[i-2][j] == '.')
			{
				if(k[i][j] != k[i-2][j])
				{
					g[k[i][j]].insert(k[i-2][j]);
					g[k[i-2][j]].insert(k[i][j]);	
				}
			}

			if (a[i][j+2] == '.')
			{
				if(k[i][j] != k[i][j+2])
				{
					g[k[i][j]].insert(k[i][j+2]);
					g[k[i][j+2]].insert(k[i][j]);	
				}
			}

			if (a[i][j-2] == '.')
			{
				if(k[i][j] != k[i][j-2])
				{
					g[k[i][j]].insert(k[i][j-2]);
					g[k[i][j-2]].insert(k[i][j]);	
				}
			}
		}

	// cerr << "k[ax][ay] = " << k[ax][ay] << " k[bx][by] = " << k[bx][by] << endl;

	if (k[ax][ay] == k[bx][by])
	{
		cout << "YES";
		return 0;
	}

	bfs(k[ax][ay]);

	// cerr << "dp[k[bx][by]] = " << dp[k[bx][by]]<< endl;
// 
	if (dp[k[bx][by]] == inf || dp[k[bx][by]] > kk)
	{
		cout << "NO";
	}
	else
		cout << "YES";



}
