#include <bits/stdc++.h>
using namespace std;


vector<vector<int>> was;
vector<vector<char>> field;
pair<int, int> endPoint;
int n, m, k;

bool find_way(int x, int y, int k){

    if(k < 0)
        return false;

    if(x < 0 or x >= m)
        return false;

    if(y < 0 or y >= n)
        return false;
    
    if(field[y][x] == '#')
        return false;
    
    if(x == endPoint.first && y == endPoint.second){
    //     cout << "x:" << x << " y:" << y << ' ' << k << "\n";
        return true;
    }

    if(was[y][x])
        return false;

    was[y][x] = 1;
    

    
 //   cout << "x:" << x << " y:" << y << "\n";
    vector<pair<int, int>> directions = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

    for(auto dir : directions){
        if(find_way(x+dir.first, y + dir.second, k))
            return true;
        if(find_way(x+dir.first*2, y + dir.second*2, k-1))
            return true;
    }

    was[y][x] = 0;

    return false;

}

void solve(){
    cin >> n >> m >> k;
    was.resize(n);
    field.resize(n);
    for(int i = 0; i < n; i++){
        field[i].resize(m);
        was[i].resize(m);
        string curStr;
        cin >> curStr;
        for(int j = 0; j < m; j++)
            field[i][j] = curStr[j];
    }
    
    pair<int, int> startPoint;
    cin >> startPoint.second >> startPoint.first;
    startPoint.first--;
    startPoint.second--;
    cin >> endPoint.second >> endPoint.first;
    endPoint.first--;
    endPoint.second--;
    //cout << "endpoint " << endPoint.first << ' ' << endPoint.second << '\n';
    if(find_way(startPoint.first, startPoint.second, k))
        cout << "YES\n";
    else
        cout << "NO\n";
    
}

int main()
{
    solve();
    return 0;
}