#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back

#ifndef LOCAL
#define cerr                                                                                                           \
	if (0)                                                                                                             \
	cerr
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vi> vvi;

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> &p) {
	out << "(" << p.ff << ", " << p.ss << ")";

	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> &v) {
	out << "[";
	for (T &e : v)
		out << e << ", ";
	out << "]";

	return out;
}

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}

	return 0;
}

const ld inf = 1e20;

bool inRange(ll a, ll l, ll r)
{
	return a >= l && a <= r;
}

void solve() {
	ll n, k, s1, s2;
	cin >> n >> k >> s1 >> s2;

	ld l = n, r = n*k;
	ld m = (r + l) / 2.0;


	ld r1 = abs(m - s1), r2 = abs(m - s2);

	if(s1 < l || s1 > r) r1 = inf;
	if(s2 < l || s2 > r) r2 = inf;

	cerr << r1 << " " << r2 << endl;

	if(n == 1)
	{
		if(!(inRange(s1, 1, k) ^ inRange(s2, 1, k)))
		{
			cout << "Equal";
		}
		else if(inRange(s1, 1, k))
		{
			cout << "First";
		}
		else
		{
			cout << "Second";
		}

		return;
	}

	if(abs(r2 - r1) < 1e-6)
	{
		cout << "Equal";
	}
	else if(r1 < r2)
	{
		cout << "First";
	}
	else
	{
		cout << "Second";
	}
}

