#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back

#ifndef LOCAL
#define cerr                                                                                                           \
	if (0)                                                                                                             \
	cerr
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vi> vvi;

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> &p) {
	out << "(" << p.ff << ", " << p.ss << ")";

	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> &v) {
	out << "[";
	for (T &e : v)
		out << e << ", ";
	out << "]";

	return out;
}

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}

	return 0;
}

struct point
{
	ld x, y;
	point() = default;
	point(ld x, ld y)
	: x(x), y(y)
	{}
};

ld dist(point& a, point& b)
{
	return sqrt((b.x - a.x)*(b.x - a.x) + (b.y - a.y)*(b.y - a.y));
}

void solve() {
	int n;
	cin >> n;

	vector<point> v(n);
	for(int i = 0; i < n; i++) cin >> v[i].x >> v[i].y;

	ld res = 0.0;
	for(int i = 0; i < n; i++) res += dist(v[i], v[(i+1)%n]);

	ld m = 1e18;
	for(int i = 0; i < n; i++)
	{
		ld cur = dist(v[i], v[(i+1)%n]);
		if(m - cur > 1e-9)
			m = cur;
	}

	res -= m;

	cout.precision(8);
	cout << fixed << res;
}

