#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back

#ifndef LOCAL
#define cerr                                                                                                           \
	if (0)                                                                                                             \
	cerr
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vi> vvi;

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> &p) {
	out << "(" << p.ff << ", " << p.ss << ")";

	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> &v) {
	out << "[";
	for (T &e : v)
		out << e << ", ";
	out << "]";

	return out;
}

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}

	return 0;
}

const int N = 1e7;
int lp[N+1];
vector<int> pr;
 
void erat()
{
	for (int i=2; i<=N; ++i) {
		if (lp[i] == 0) {
			lp[i] = i;
			pr.push_back (i);
		}
		for (int j=0; j<(int)pr.size() && pr[j]<=lp[i] && i*pr[j]<=N; ++j)
			lp[i * pr[j]] = pr[j];
	}
}

void solve() {
	ll l, r;
	cin >> l >> r;

	erat();

	ll ansa = l, ansb = l+1;
	ll ans = 1;
	for(ll prime : pr)
	{
		if(r < prime * 2ll) continue;
		
		ll a = ((ll)(r / prime)) * (prime - 1ll);
		ll b = ((ll)(r / prime)) * prime;

		if(a >= l)
		{
			if(ans < (ll)(r/prime))
			{
				ans = max(ans, r/prime);
				ansa = a, ansb = b;
			}
		}
	}

	cout << ansa << " " << ansb;
}

