#include <bits/stdc++.h>

using namespace std;
#define fi first
#define se second
#define pb push_back

const int INF = 2e9;
const int maxn = 2e6;

vector<pair<int,int>> g[maxn];
int used[maxn];
vector<int> d(maxn, INF);

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    int P = max(n, m);
    vector<vector<char>> a(n, vector<char>(m));
    for(int i = 0 ; i < n; i++){
        for(int j  = 0; j < m; j++){
            cin >> a[i][j];
        }
    }

    pair<int,int> s, f;
    cin >> s.fi >> s.se;
    s.fi--; s.se--;
    cin >> f.fi >> f.se;
    f.fi--; f.se--;
    int ss = P*s.fi + s.se;
    int ff = P*f.fi + f.se;

    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(a[i][j] == '#') continue;

            if(i-1 >= 0 && a[i-1][j] != '#')
                g[P*i + j].pb({P*(i-1) + j, 0});
            if(i+1 < n && a[i+1][j] != '#')
                g[P*i + j].pb({P*(i+1) + j, 0});
            if(j-1 >= 0 && a[i][j-1] != '#')
                g[P*i + j].pb({P*i + j-1, 0});
            if(j+1 < m && a[i][j+1] != '#')
                g[P*i + j].pb({P*i + j+1, 0});

            if(i-2 >= 0 && a[i-2][j] != '#')
                g[P*i + j].pb({P*(i-2) + j, 1});
            if(i+2 < n && a[i+2][j] != '#')
                g[P*i + j].pb({P*(i+2) + j, 1});
            if(j-2 >= 0 && a[i][j-2] != '#')
                g[P*i + j].pb({P*i + j-2, 1});
            if(j+2 < m && a[i][j+2] != '#')
                g[P*i + j].pb({P*i + j+2, 1});
        }
    }

    d[ss] = 0;
    deque<int> q;
    q.push_front(ss);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto edge : g[v]) {
            int u = edge.first;
            int w = edge.second;
            if (d[v] + w < d[u]) {
                d[u] = d[v] + w;
                if (w == 1)
                    q.push_back(u);
                else
                    q.push_front(u);
            }
        }
    }

    cout << (d[ff] > k ? "NO\n" : "YES\n");
    

    return 0;
}