#include <bits/stdc++.h>
using namespace std;
 
template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
      os << vec[i] << " \n"[i + 1 == vec.size()];
   return os;
}
 
template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}
 
typedef long long ll;
typedef long double ld;
#define endl "\n"

const int INF = 1e9 + 1000;

const int M = 50000;
const int N = 21;
const ld eps = 1e-9;
const ld PI = atan2l(0, -1);
 
struct point
{
	ld x, y;
	point() = default;
	point(ld x, ld y): x(x), y(y){}
 
	friend istream& operator>>(istream& in, point &a)
	{
		in >> a.x >> a.y;
		return in;
	}
 
	friend ostream& operator<<(ostream& os, point &a)
	{
		os << a.x << " " << a.y << endl;
		return os;
	}
 
	ld len()
	{
		return sqrt(x*x + y*y);
	}
 
	ld operator*(point &a)
	{
		ld c;
		c = x * a.x + y * a.y;
		return c;
	}

	point operator+(point &a)
	{
		point c;
		c.x = x + a.x;
		c.y = y + a.y;

		return c;
	}
};
 
bool equal(ld a, ld b)
{
	return (abs(a - b) < eps);
}
 
 
 
 
ll my_pow(ll a, ll p){
    if (p == 0)
        return 1;
    if(p % 2 == 0)
        return my_pow(a * a, p / 2);
    return my_pow(a, p - 1) * a;
}
 
void solve()
{
	int n;
	cin >> n;
	point a;
	cin >> a;
	double ans = 0;
	point b = a, c;
	long double mx = 0;
	for (int i = 1; i < n; i++) {
		cin >> c;
		point k(c.x - b.x, c.y - b.y);
		ans += k.len();
		mx = max(mx, k.len());
		b = c; 
	}
	point k(c.x - a.x, c.y - a.y);
	ans += k.len();
	mx = max(k.len(), mx);
	ans -= mx;
	printf("%.6f\n", ans);
}
 
signed main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
   #ifndef LOCAL
   // freopen("disttosegment.in", "r", stdin);
   // freopen("disttosegment.out", "w", stdout);
   // #else
   // freopen("mincut.in", "r", stdin);
   // freopen("mincut.out", "w", stdout);
   #endif
 
   int t = 1;
   // cin >> t;
   while(t--)
   {
      // cout << t << endl;
      solve();
   }
   return 0;
}