#include <bits/stdc++.h>

using namespace std;

const int K = 62;

int getAlphNum(char x) {
    if (isdigit(x)) {
        return 52 + x - '0';
    } else if (isupper(x)) {
        return 26 + x - 'A';
    }
    return x - 'a';
}

struct node {
    node* links[K]{};
    bool term = false;
    char sign;
    int repeat = 0;

}; node* root = new node();

string add(string &str, node* start) {

    node* current = start;

    for (char i : str) {
        int ind = getAlphNum(i);
        if (!current->links[ind]) {
            current->links[ind] = new node();
            current->links[ind]->sign = i;
        }
        current = current->links[ind];
    }

    if (current->repeat) {
        current->repeat++;
        string num = to_string(current->repeat - 1);
        return str + add(num, current);
    } else {
        current->repeat++;
        return str;
    }

}

int main() {
    int q;
    cin >> q;

    while (q--) {
        string str;
        cin >> str;

        cout << add(str, root) << endl;
    }
}