#include <iostream>
#include <vector>
#include <deque>

using namespace std;

vector<int> snake;
int n;
const int INF = 1'000'000'000;
int move_snake(int x, int am) {
    if (x + am >= snake.size()) {
        return snake.size() - 1;
    }
    if (snake[x + am] == 0) {
        return x + am;
    }
    return snake[x + am] - 1;
}
int main() {
    cin >> n;
    snake.push_back(0);
    for (int i = 0; i < n - 2; i++) {
        int a;
        cin >> a;
        snake.push_back(a);
    }
    snake.push_back(0);
    for (int i = 0; i < n; ++i) {
        if (snake[i] == 0) {
            continue;
        }
        if (snake[i - snake[i]] != 0) {
            snake[i] = snake[i - snake[i]];
        } else {
            snake[i] = i - snake[i] + 1;
        }
    }
    vector<int> dp(snake.size(), INF);
    dp[0] = 0;
    for (int i = 0; i < dp.size(); ++i) {
        if (dp[i] == INF) {
            continue;
        }
        int n6 = i;
        while (true) {
            for (int j = 1; j < 6; ++j) {
                dp[move_snake(n6, j)] = min(dp[move_snake(n6, j)], dp[i] + 1);
            }
            n6 = move_snake(n6, 6);
            if (dp[n6] == dp[i]) {
                break;
            }
            if (n6 == n - 1) {
                dp[n6] = dp[i] + 1;
                break;
            } else {
                dp[n6] = dp[i];
            }
        }
    }
    cout << (dp[n - 1] == INF ? -1 : dp[n - 1]);
}