#include "bits/stdc++.h"

using namespace std;

#define mkp make_pair
#define mkt make_tuple
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define isz(x) (int) x.size()
#define xx first
#define yy second

using ll = long long;

const int N = (int) 2e5 + 1;
const int MOD = (int) 1e9 + 7;
const int INF = (int) 1e9 + 1;
const ll INFll = (ll) 2e18 + 1;
const double EPS = 1e-8;
// const int MEM = (int)2.5e8;

// int mpos = 0;
// uint8_t mem[MEM];

// void* operator new(size_t n) {
//     uint8_t* res = mem + mpos;
//     mpos += n;
//     assert(mpos <= MEM);
//     return (void*)res;
// }

// void operator delete(void*) {}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v)
        in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) {
        out << i << " ";
    }
    return out;
}

template<class T, class TT> istream& operator>>(istream& in, pair<T, TT>& p) {
    in >> p.first >> p.second;
    return in;
}

template<class T, class TT> ostream& operator<<(ostream& out, const pair<T, TT>& p) {
    out << p.first << " " << p.second;
    return out;
}

template<class T> inline bool inmax(T& x, T y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
}

template<class T> inline bool inmin(T& x, T y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
}

#ifdef __MAC_11_1
    #define check(x) cerr << (#x) << " = " << x << "\n"
    #define TBOUND(x) assert(clock() / (double)CLOCKS_PER_SEC < x)

    template<class T> inline void check_mass(T* a, int sz) {
        for (int i = 0; i < sz; ++i) cerr << a[i] << " ";
        cerr << "\n";
    }
#else
    #define check(x) 17
    #define TBOUND(x) 16

    template<class T> inline void check_mass(T* a, int sz) {}
#endif

// #define int ll

mt19937 rnd(3);

inline int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed << setprecision(10);

    int t = 1;
//      t = 500;
    // cin >> t;
    while (t--) assert(!solve());
    return 0;
}

/*-------------------------------------------------------------------------------------------------------------------------------*/



vector<pair<int, int>> d{
    {0, 1}, {0, -1}, {1, 0}, {-1, 0}
};

vector<pair<int, int>> jump{
    {0, 2}, {0, -2}, {2, 0}, {-2, 0}
};

int n, m, k, sx, sy, fx, fy;
char a[2001][2001];

inline bool in_borders(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

bool used[1001][1001];

bool dfs(int x, int y, int curk) {
//    check(x);
//    check(y);
//
//    if (x == 154 && y == 71) {
//
//    }
    bool res = 0;
    used[x][y] = 1;

    if (x == fx && y == fy) return res;
    
    for (int i = 0; i < 4; ++i) {
        int cx = x + d[i].first, cy = y + d[i].second;
        if (in_borders(cx, cy) && !used[cx][cy] && a[cx][cy] != '#') {
            res |= dfs(cx, cy, curk);
        }
    }
    if (!res && curk) {
        for (int i = 0; i < 4; ++i) {
            int cx = x + jump[i].first, cy = y + jump[i].second;
            if (in_borders(cx, cy) && !used[cx][cy] && a[cx][cy] != '#') {
                res |= dfs(cx, cy, curk - 1);
            }
        }
    }
    return res;
}

inline int solve() {
    // n = rnd() % 998 + 2, m = rnd() % 998 + 2, k = rnd() % (int)1e6;
    assert(cin >> n >> m >> k);
    for (int i = 0; i < n; ++i) fill(used[i], used[i] + m, false);
    // for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) a[i][j] = ((rnd() & 1) ? '.' : '#');
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) assert(cin >> a[i][j]);

    // sx = rnd() % n + 1, sy = rnd() % m + 1, fx = rnd() % n + 1, fy = rnd() % m + 1;
    assert(cin >> sx >> sy >> fx >> fy);
    --sx, --sy, --fx, --fy;

    dfs(sx, sy, k);
    if (used[fx][fy]) cout << "YES\n";
    else cout << "NO\n";
    return 0;
}

