#include "bits/stdc++.h"

using namespace std;

#define check(x) cerr << (#x) << " = " << x << "\n"

#define mkp make_pair
#define mkt make_tuple
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define isz(x) (int) x.size()
#define xx first
#define yy second

using ll = long long;

const int N = (int) 2e5 + 1;
const int MOD = (int) 1e9 + 7;
const int INF = (int) 1e9 + 1;
const ll INFll = (ll) 2e18 + 1;
const double EPS = 1e-8;
// const int MEM = (int)2.5e8;

// int mpos = 0;
// uint8_t mem[MEM];

// void* operator new(size_t n) {
//     uint8_t* res = mem + mpos;
//     mpos += n;
//     assert(mpos <= MEM);
//     return (void*)res;
// }

// void operator delete(void*) {}

inline int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//      t = 500;
    // cin >> t;
    while (t--) assert(!solve());
    return 0;
}

/*-------------------------------------------------------------------------------------------------------------------------------*/

mt19937 rnd(3);

int n, m, k, sx, sy, fx, fy;

pair<int, int> d[]{ {0, 1}, {0, -1}, {1, 0}, {-1, 0} };
pair<int, int> jump[]{ {0, 2}, {0, -2}, {2, 0}, {-2, 0} };    

inline bool in_borders(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

// bool used[1001][1001];
std::vector<std::vector<bool>> used;

int dfs(int x, int y, int curk) {
    int res = 0;
    used[x][y] = 1;
    // check(x);
    // check(y);
    // check(res);
    if (x == fx && y == fy) {
        res = 1;
        // check(res);
        return res;
    }

    for (int i = 0; i < 4; ++i) {
        int cx = x + d[i].first, cy = y + d[i].second;
        if (0 <= cx && cx < n && 0 <= cy && cy < m && !used[cx][cy]) {
            res |= dfs(cx, cy, curk);
            // check(res);
        }
    }
    // check(res);
    if (!res && curk) {
        for (int i = 0; i < 4; ++i) {
            int cx = x + jump[i].first, cy = y + jump[i].second;
            if (0 <= cx && cx < n && 0 <= cy && cy < m && !used[cx][cy]) {
                if (dfs(cx, cy, curk - 1)) {
                    res |= 1;
                    // check(res);
                    return res;
                }
            }
        }
    }
    // check(res);
    return res;
}

inline int solve() {
    n = rnd() % 998 + 2, m = rnd() % 998 + 2, k = rnd() % (int)1e6;
    assert(cin >> n >> m >> k);
    used = vector<vector<bool>>(n, vector<bool>(m));
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) {
        char c;
        c = ((rnd() & 1) ? '.' : '#');
        assert(cin >> c);
        if (c == '#') used[i][j] = 1;
    }

    sx = rnd() % n + 1, sy = rnd() % m + 1, fx = rnd() % n + 1, fy = rnd() % m + 1;
    assert(cin >> sx >> sy >> fx >> fy);
    --sx, --sy, --fx, --fy;

    // dfs(sx, sy, k);
    int ans = dfs(sx, sy, k);
    // check(ans);
    if (ans) cout << "YES\n";
    else cout << "NO\n";
    return 0;
}

