#include <iostream>

int fX, fY;
int n;
int m;
int k;

bool dfs(int* visited, std::string* list, int i, int j, int k1) {
    if (i == fX and j == fY) {
        return true;
    }
    visited[i * m + j] = 1;
    if (i + 1 < n && list[i + 1][j] == '.' && visited[(i + 1) * m + j] == 0) {
        return dfs(visited, list, i + 1, j, k1);
    }
    if (j + 1 < m && list[i][j + 1] == '.' && visited[i * m + (j + 1)] == 0) {
        return dfs(visited, list, i, j + 1, k1);
    }
    if (j - 1 >= 0 && list[i][j - 1] == '.' && visited[i * m + (j - 1)] == 0) {
        return dfs(visited, list, i, j - 1, k1);
    }
    if (i - 1 >= 0 && list[i - 1][j] == '.' && visited[(i - 1) * m + j] == 0) {
        return dfs(visited, list, i - 1, j, k1);
    }
    if (i - 2 >= 0 && list[i - 2][j] == '.' && visited[(i - 2) * m + j] == 0 && k1 < k) {
        return dfs(visited, list, i - 2, j, ++k1);
    }
    if (j - 2 >= 0 && list[i][j - 2] == '.' && visited[i * m + j - 2] == 0 && k1 < k) {
        return dfs(visited, list, i, j - 2, ++k1);
    }
    if (i + 2 < n && list[i + 2][j] == '.' && visited[(i + 2) * m + j] == 0 && k1 < k) {
        return dfs(visited, list, i + 2, j, ++k1);
    }
    if (j + 2 < m && list[i][j + 2] == '.' && visited[i * m + (j + 2)] == 0 && k1 < k) {
        return dfs(visited, list, i, j + 2, ++k1);
    }

    return false;
}

int main() {
    std::cin >> n >> m >> k;
    std::string list[n];
    for (int it = 0; it < n; ++it) {
        std::cin >> list[it];
    }
    int stX, stY;

    std::cin >> stX >> stY >> fX >> fY;
    --stX;
    --stY;
    --fX;
    --fY;

    int visited[n * m];
    for (int i = 0; i < n * m; ++i) {
        visited[i] = 0;
    }

    int k1 = 0;
    if (dfs(visited, list, stX, stY, k1)) {
        std::cout << "YES";
    } else {
        std::cout << "NO";
    }
}