#include <bits/stdc++.h>

using namespace std;

int n, m, k;
char mx[1001][1001];

bool check(int i, int j) {
    return (i >= 0 && j >= 0 && i < n && j < m);
}

int di[4] = {0, 0, -1, 1};
int dj[4] = {1, -1, 0, 0};

int main() {

    cin >> n >> m >> k;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mx[i][j];
        }
    }

    int sx, sy;
    cin >> sx >> sy;
    sx--; sy--;
    int fx, fy;
    cin >> fx >> fy;
    fx--; fy--;

    vector<pair<int, int>> gr[n * m];
    vector<int> dist(n * m);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dist[i * n + j] = 1000000000;
            if (mx[i][j] == '#')
                continue;
            for (int d = 0; d < 4; d++) {
                if (check(i + di[d], j + dj[d]) && mx[i + di[d]][j + dj[d]] == '.') {
                    gr[i * n + j].emplace_back((i + di[d]) * n + (j + dj[d]), 0);
                }
                if (check(i + 2 * di[d], j + 2 * dj[d]) && mx[i + 2 * di[d]][j + 2 * dj[d]] == '.') {
                    gr[i * n + j].emplace_back((i + 2 * di[d]) * n + (j + 2 * dj[d]), 1);
                }
            }
        }
    }

    deque<int> q;
    dist[sx * n + sy] = 0;
    q.push_back(sx * n + sy);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto x : gr[v]) {
            int u = x.first;
            int w = x.second;
            if (dist[u] == 1000000000) {
                dist[u] = dist[v] + w;
                if (w == 0)
                    q.push_front(u);
                else
                    q.push_back(u);

            }
        }
    }

    if (dist[fx * n + fy] <= k) {
        cout << "YES";
    } else {
        cout << "NO";
    }

}