def count_ways(N, K, S):
    # Создаем массив dp для хранения количества способов получить сумму
    dp = [[0] * (S + 1) for _ in range(N + 1)]

    # Базовые значения: 1 способ получить сумму 0 (ничего не крутили)
    dp[0][0] = 1

    # Заполняем массив dp
    for i in range(1, N + 1):
        for j in range(S + 1):
            for k in range(1, K + 1):
                if j - k >= 0:
                    dp[i][j] += dp[i - 1][j - k]

    return dp[N][S]


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вычисляем количество способов для обоих игроков
count_ways_S1 = count_ways(N, K, S1)
count_ways_S2 = count_ways(N, K, S2)

# Сравниваем количество способов и выводим результат
if count_ways_S1 > count_ways_S2:
    print("First")
elif count_ways_S1 < count_ways_S2:
    print("Second")
else:
    print("Equal")
