def count_ways(N, K, S, memo):
    if N == 0 and S == 0:
        return 1
    if N <= 0 or S <= 0:
        return 0
    if (N, S) in memo:
        return memo[(N, S)]

    ways = 0
    for i in range(1, K + 1):
        ways += count_ways(N - 1, K, S - i, memo)

    memo[(N, S)] = ways
    return ways


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

memo = {}  # Словарь для мемоизации

count_ways_S1 = count_ways(N, K, S1, memo)
count_ways_S2 = count_ways(N, K, S2, memo)

if count_ways_S1 > count_ways_S2:
    print("First")
elif count_ways_S1 < count_ways_S2:
    print("Second")
else:
    print("Equal")
