import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) throws IOException {
//        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        Scanner scanner = new Scanner(System.in);
        long l, r;
        l = scanner.nextInt();
        r = scanner.nextInt();
//        l = Long.parseLong(bufferedReader.readLine());
//        r = Long.parseLong(bufferedReader.readLine());
        List<Pair> list = new ArrayList<>();
        int[] primes = new int[]{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293};
        for (long i = r; i > Math.max(l, r - 1000); i--) {
            for (int j = 0; j < primes.length - 1; j++) {
                if (i % primes[j] == 0) {
                    list.add(new Pair(i / primes[j], i));
                }
            }
        }

        list.sort((o1, o2) -> {
            if (o1.getA() < o2.getA()) {
                return 1;
            } else if (o1.getA() > o2.getA()) {
                return -1;
            }
            return 0;
        });

        System.out.println(list.get(0));

    }
}

class Pair {
    private long a;
    private long b;

    public Pair(long a, long b) {
        this.a = a;
        this.b = b;
    }

    public long getA() {
        return a;
    }

    public long getB() {
        return b;
    }

    @Override
    public String toString() {
        return this.a + " " + this.b;
    }
}
