def win_probability(N, K, S1, S2):
    dp = [[0] * (K * N + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for i in range(1, N + 1):
        for j in range(1, K * N + 1):
            for k in range(1, K + 1):
                if j - k >= 0:
                    dp[i][j] += dp[i - 1][j - k] / K

    probability_player1 = dp[N][S1]
    probability_player2 = dp[N][S2]

    if probability_player1 > probability_player2:
        return "First"
    elif probability_player1 < probability_player2:
        return "Second"
    else:
        return "Draw"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = win_probability(N, K, S1, S2)
print(result)