def roulette_game(N, K, S1, S2):
    try:
        dp = [[0] * (N * K + 1) for _ in range(N+1)]
        dp[0][0] = 1

        for i in range(1, N+1):
            for j in range(1, N * K + 1):
                for k in range(1, K+1):
                    if j >= k:
                        dp[i][j] += dp[i-1][j-k]

        if dp[N][S1] > dp[N][S2]:
            return "First"
        elif dp[N][S1] < dp[N][S2]:
            return "Second"
        else:
            return "Equal"
    except IndexError:
        exit()


# Пример использования
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = roulette_game(N, K, S1, S2)
print(result)
