import java.util.Scanner;

public class Main {

    public static int gcd(int a, int b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }

    public static int[] findMaxGcd(int L, int R) {
        int maxGcd = 0;
        int[] ans = new int[2];

        for (int i = L; i < R; i++) {
            for (int j = i + 1; j <= R; j++) {
                int currentGcd = gcd(i, j);
                if (currentGcd > maxGcd) {
                    maxGcd = currentGcd;
                    ans[0] = i;
                    ans[1] = j;
                }
            }
        }

        return ans;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int L = scanner.nextInt();
        int R = scanner.nextInt();

        int[] result = findMaxGcd(L, R);

        System.out.println(result[0] + " " + result[1]);
    }
}