fun distance(x1 : Long, y1 : Long, x2 : Long, y2 : Long) : Double {
    return Math.sqrt(
        Math.pow((x1 - x2).toDouble(), 2.0) +
                Math.pow((y1 - y2).toDouble(), 2.0)
    );
}

fun main(args: Array<String>) {
    val eyesCount = readLine()!!.toInt();
    val lines = mutableListOf<List<Long>>();

    for(i in 1 .. eyesCount)
    {
        val line = readLine()!!.split(' ').map(String::toLong);
        lines.add(line);
    }

    var resultDistance : Double = 0.0;

    for(index in 1 .. lines.size - 1) {
        val (x1, y1) = lines[index - 1];
        val (x2, y2) = lines[index];

        val distance = distance(x1, y1, x2, y2);
        resultDistance += distance;
    }

    println(resultDistance);
}