fun gcd(a: Long, b: Long): Long {
    if (b == 0L) {
        return a
    }
    return gcd(b, a % b)
}

fun findMaxGCDPair(L: Long, R: Long): Pair<Long, Long> {
    var maxGCD = -1L
    var resultPair = Pair(0L, 0L)

    for (x in L until R) {
        for (y in x + 1 until R) {
            val currentGCD = gcd(x, y)
            if (currentGCD > maxGCD) {
                maxGCD = currentGCD
                resultPair = Pair(x, y)
                break;
            }
        }
    }

    return resultPair
}

fun main() {
    val (L, R) = readLine()!!.split(' ').map{ it.toLong() };

    val resultPair = findMaxGCDPair(L, R)
    println("${resultPair.first} ${resultPair.second}")
}