#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <utility>
#include <functional>
#include <cmath>
#include <map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_map>
#include <cassert>
#include <iomanip>
#include <cstring>
#include <numeric>
#include <random>

#define ll long long
#define dbl double
#define ld long double
#define str std::string

#define pb push_back
#define eb emplace_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

ll const inf = 1'000'000'000'000;
ll const mod = 1'000'000'007;

struct pi {
  ll s;
  ll a;
  ld value;
  ld diff;
};

void solution() {
  ll n, k;
  ll ans = 0;

  cin >> n >> k;

  ld dk = (ld)k, s = 0.0;

  vector<pi> p(n);

  for (ll i = 0; i < n; i++) {
    cin >> p[i].s;
  }

  for (ll i = 0; i < n; i++) {
    cin >> p[i].a;

    p[i].value = (ld)1.0 / (ld)p[i].s;
    p[i].diff = (ld)abs(p[i].s - p[i].a) / (ld)p[i].s;

    s += p[i].diff;
  }

  sort(all(p), [](pi &a, pi &b) {
    return a.value > b.value;
  });

  for (ll i = 0; i < n; i++) {
    if (dk <= s - p[i].diff) {
      ans += abs(p[i].s - p[i].a);
      s -= p[i].diff;
    } else {
      ld cnt = (s - dk) * (ld)p[i].s;

      ans += (ll)ceil(cnt);

      break;
    }
  }

  cout << ans << "\n";
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  ll n = 1;

  // cin >> n;

  for (ll i = 0; i < n; i++) {
    solution();
  }

  return 0;
}
