#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

struct Name {
  string s;
  int id;

  Name(string _s, int _id) : s(_s), id(_id) {}
};

Name split(string s) {
  int i = s.size() - 1;
  while (isdigit(s[i])) {
    --i;
  }
  return Name(
      s.substr(0, i + 1),
      i == s.size() - 1 ? -1 : atoi(s.substr(i + 1, s.size() - 1 - i).c_str()));
}

map<string, int> mem;
unordered_set<string> r;

void run_solve() {
  int q;
  cin >> q;
  while (q--) {
    string s;
    // s = "x";
    cin >> s;
    if (r.count(s)) {
      int x = mem[s] + 1;
      while (r.count(s + to_string(x))) {
        ++x;
      }
      mem[s] = x;
      r.insert(s + to_string(x));
      cout << s + to_string(x) << '\n';
    } else {
      r.insert(s);
      cout << s << '\n';
    }
  }
}