#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int INF = 1e9 + 7;
const int N = DEB ? 15 : 2e5 + 7;
const int K = 6;

int n;
int p[N];
vector<pair<int, int>> g[2 * N];
int dist[2 * N];

int rec(int i) {
  static map<int, int> mem;
  if (mem.count(i)) {
    return mem[i];
  }
  auto& res = mem[i];
  if (p[i] == 0) {
    return res = i;
  } else {
    return res = rec(i - p[i]);
  }
}

void run_solve() {
  cin >> n;
  for (int i = 1; i < n - 1; ++i) {
    cin >> p[i];
  }
  for (int i = 0; i < n; ++i) {
    for (int k = 1; k <= K; ++k) {
      int j = rec(min(i + k, n - 1));
      g[2 * i].push_back({2 * j + (k == K), 1});
      g[2 * i + 1].push_back({2 * j + (k == K), 0});
    }
  }
  fill(dist, dist + 2 * n, INF);
  deque<int> q;
  dist[0] = 0;
  q.push_back(0);
  while (!q.empty()) {
    int v = q.front();
    q.pop_front();
    for (auto e : g[v]) {
      if (dist[e.first] > dist[v] + e.second) {
        dist[e.first] = dist[v] + e.second;
        if (e.second == 0) {
          q.push_front(e.first);
        } else {
          q.push_back(e.first);
        }
      }
    }
  }
  int ans = min(dist[2 * (n - 1)], dist[2 * (n - 1) + 1]);
  if (ans == INF) {
    cout << "-1\n";
  } else {
    cout << ans << '\n';
  }
}