#include <iostream>
#include <vector>
#include <cmath>
#include <chrono>

int main() {
    int N, K;
    std::cin >> N >> K;

    std::vector<int> s(N);
    for (int i = 0; i < N; i++) {
        std::cin >> s[i];
    }

    std::vector<int> a(N);
    for (int i = 0; i < N; i++) {
        std::cin >> a[i];
    }

    int alld = 0;
    for (int i = 0; i < N; i++) {
        alld += std::abs(a[i] - s[i]);
    }

    auto start = std::chrono::high_resolution_clock::now();

    int min = (alld + K - 1) / (2 * K) + 1;

    auto end = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double> duration = end - start;

    std::cout << min << std::endl;
    //std::cout << "Time taken by function: " << duration.count() << " seconds" << std::endl;

    return 0;
}
