#include<iostream>


using namespace std;

bool isUndefined(int A, int B) {
    int max_rounds = (A + B) / 2;
    int validCombinations = 0;

    for (int a_wins = 0; a_wins <= max_rounds; ++a_wins) {
        for (int draws = 0; draws <= max_rounds - a_wins; ++draws) {
            int b_wins = max_rounds - a_wins - draws;
            if (2 * a_wins + draws == A && 2 * b_wins + draws == B) {
                validCombinations++;
                if (validCombinations > 1) {
                    return true;
                }
            }
        }
    }

    return false;
}

void solveTC() {

    int A, B;
    cin >> A >> B;

    int a_win = A / 2;
    int b_win = B / 2;

    int draws_required = (A + B) - (a_win + b_win) * 2;
    if (isUndefined(A,B)) {
        cout << "Undefined" << endl;
    } else if (a_win * 2 + b_win * 2 + draws_required != A + B || draws_required < 0 || draws_required % 2 != 0) {
        cout << "Error" << endl;
    } else {
        cout  << a_win << endl;
        cout  << b_win << endl;
        cout  << draws_required / 2 << endl;
    }

    return;
}

int main() {

    solveTC();
}