//
// Created by a on 06.03.2022.
//
// clang-format off

#include <algorithm>
#include <cstdio>
#pragma GCC optimize("Os")
#pragma GCC optimize("Ofast", "no-stack-protector", "inline")
#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("avx,avx2,fma")


#include <bits/stdc++.h>
//#include <ext/rope>

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;

//template<typename T>
// #define ordered_set tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>

#define endl "\n"
#define int long long
#define ui unsigned int
#define ll long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mall(a) a.mutable_begin(), a.mutable_end()
#define X first
#define Y second
#define pii pair<int, int>
#define ull unsigned ll
#define double long double
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator>>(istream& in, const pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

constexpr int FACT = 1ll * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10;

void solve() {
    int n, k1;
    cin >> n >> k1;

    int k = k1 * FACT;

    __int128 sum = 0;

    priority_queue<pii> all_values;

    vector<int> s(n);
    cin >> s;

    vector<int> a(n);
    cin >> a;

    for (int i = 0; i < n; i++) {
        __int128 val = FACT / s[i];

        sum += abs(a[i] - s[i]) * val;
        if (a[i] != s[i]) {
            all_values.push({val, abs(a[i] - s[i])});
        }
    }

    int time = 0;
    while (sum > k) {
        auto v = all_values.top();
        all_values.pop();

        int val = v.X;
        int cnt = v.Y;

        if (sum - val * cnt > k) {
            time += cnt;
            sum -= val * cnt;
            continue;
        }

        int f = (sum - k + val - 1) / val;
        time += f;
        break;
    }

    cout << time << endl;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#if defined(LOCAL)
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;

    while (t--)
        solve();
}