#pragma GCC optimize("Os")
#pragma GCC optimize("Ofast", "no-stack-protector", "inline")
#pragma comment(linker, "/stack:200000000")
// #pragma GCC target("avx,avx2,fma")


#include <bits/stdc++.h>
//#include <ext/rope>

#include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tre_policy.hpp>
using namespace __gnu_pbds;

//template<typename T>
// #define ordered_set tre<int, null_type, less_equal<>, rb_tre_tag, tre_order_statistics_node_update>

#define endl "\n"
// #define int long long
#define ui unsigned int
#define ll long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mall(a) a.mutable_begin(), a.mutable_end()
#define X first
#define Y second
#define pii pair<int, int>
#define ull unsigned ll
#define double long double
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator>>(istream& in, const pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

struct node {
    int l;
    int r;
    int mi;
    ll cnt;
};

const int MAXN = 5e7;
node tre[MAXN];
int ind = 0;

int create_vertex(ll tl = 0) {
    tre[ind] = {-1, -1, 0, tl};
    return ind++;
}

void update(int &v, ll tl, ll tr, ll pos) {
    if (tl >= tr || tl > pos || tr <= pos) {
        return;
    }

    if (v == -1) {
        v = create_vertex(tl);
    }


    if (tl + 1 == tr) {
        tre[v].mi = 1;
        tre[v].cnt = tl;
        return;
    }

    ll tm = (tl + tr) / 2;

    update(tre[v].l, tl, tm, pos);
    update(tre[v].r, tm, tr, pos);

    if (tre[v].l == -1) {
        tre[v].mi = 0;
        tre[v].cnt = tl;
        return;
    } else if (tre[v].r == -1) {

        if (tre[tre[v].l].mi == 0) {
            tre[v].mi = 0;
            tre[v].cnt = tre[tre[v].l].cnt;
        } else {
            tre[v].mi = 0;
            tre[v].cnt = tm;
        }

        return;
    }

    tre[v].mi = min(tre[tre[v].l].mi, tre[tre[v].r].mi);

    if (tre[tre[v].l].mi == tre[v].mi) {
        tre[v].cnt = tre[tre[v].l].cnt;
    } else {
        tre[v].cnt = tre[tre[v].r].cnt;
    }
}

const ll INF = 1e12;

void solve() {
    unordered_map<string, unordered_map<string, int>> string_to_tre;
    unordered_set<string> were;

    int n;
    cin >> n;

    while (n--) {
        string f;
        cin >> f;

        string gh = "";

        while (f.size() > 0 && isdigit(f.back())) {
            gh += f.back();
            f.pop_back();
        }

        reverse(all(gh));

        ll number = 0;

        for (auto &it : gh) {
            number = number * 10 + it - '0';
        }

        string ans = "";

        if (were.find(f + gh) == were.end()) {
            number = 0;
            ans = f + gh;
        } else {
            assert(string_to_tre[f].find(gh) != string_to_tre[f].end());
            number = tre[string_to_tre[f][gh]].cnt;
            ans = f + gh + to_string(number);
        }

        cout << ans << endl;
        were.insert(ans);

        string fg = "";
        if (string_to_tre[f].find("") == string_to_tre[f].end()) {
            string_to_tre[f][""] = create_vertex(0);
        }

        if (number != 0) {
            gh += to_string(number);
        }

        number = 0;
        ll pow = 1;

        int cnt_of_null = 0;
        for (auto &it : gh) {
            if (it != '0') {
                break;
            } else {
                cnt_of_null++;
            }
        }

        while (gh.size() > cnt_of_null) {
            if (string_to_tre[f].find(gh) == string_to_tre[f].end()) {
                string_to_tre[f][gh] = create_vertex(0);
            }

            update(string_to_tre[f][gh], 0, INF, number);
            number += pow * (gh.back() - '0');
            pow *= 10;
            gh.pop_back();

        }

        if (string_to_tre[f].find(gh) == string_to_tre[f].end()) {
            string_to_tre[f][gh] = create_vertex(0);
        }


        update(string_to_tre[f][gh], 0, INF, number);
    }
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#if defined(LOCAL)
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;

    while (t--)
        solve();
}