//
// Created by a on 06.03.2022.
//
// clang-format off

#include <algorithm>
#include <cstdio>
#pragma GCC optimize("Os")
#pragma GCC optimize("Ofast", "no-stack-protector", "inline")
#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("avx,avx2,fma")


#include <bits/stdc++.h>
//#include <ext/rope>

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;

//template<typename T>
// #define ordered_set tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>

#define endl "\n"
#define int long long
#define ui unsigned int
#define ll long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mall(a) a.mutable_begin(), a.mutable_end()
#define X first
#define Y second
#define pii pair<int, int>
#define ull unsigned ll
#define double long double
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator>>(istream& in, const pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

void solve() {
    int n;
    std::cin >> n;
    std::vector <int> a(n, 0);
    for (int i = 1; i < n - 1; ++i) {
        std::cin >> a[i];
    }
    std::vector <int> d(n, 1e9);
    std::vector <int> used(n, 0);
    std::set <pair <int, int>> b;
    d[0] = 0;
    b.insert({0, 0});
    while (!b.empty()) {
        auto [k, u] = *b.begin();
        b.erase(b.begin());
        //std::cout << u << ' ' << k << ' ' << a[u] << '\n';
        if (used[u]) {
            continue;
        }
        used[u] = 1;
        if (a[u] == 0) {
            for (int i = 1; i <= 5; ++i) {
                if (i + u < n) {
                    if (!used[u + i] && k + 1 < d[u + i]) {
                        d[u + i] = k + 1;
                        b.insert({d[u + i], u + i});
                    }
                }
            }
            int i = 6;
            if (i + u < n) {
                if (!used[u + i] && k + 0 < d[u + i]) {
                    d[u + i] = k + 0;
                    b.insert({d[u + i], u + i});
                }
            }
        }
        if (a[u] > 0) {
            if (!used[u - a[u]] && d[u - a[u]] > k) {
                d[u - a[u]] = k;
                b.insert({d[u - a[u]], u - a[u]});
            }
        }
    }
    if (d[n - 1] == 1e9) {
        std::cout << -1;
    }
    else if (d[n - 1] == 0) {
        std::cout << 1;
    }
    else {
        std::cout << d[n - 1];
    }
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#if defined(LOCAL)
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;

    while (t--)
        solve();
}