def calculate_introverts(N, K):
    X = N - ((K + 3) // 2)  # используем целочисленное деление для получения целого числа
    return max(0, X)  # убеждаемся, что возвращаемое значение неотрицательное

if __name__ == "__main__":
    try:
        N = int(input("Введите общее количество мест за столом N: "))
        K = int(input("Введите количество мест, занятых экстравертами K: "))
        if 3 <= N <= 10**9 and 1 <= K <= N - 2:
            max_introverts = calculate_introverts(N, K)
            print(f"Максимальное количество интровертов, которых можно посадить за стол: {max_introverts}")
        else:
            print("Пожалуйста, введите корректные данные в соответствии с условиями задачи.")
    except ValueError:
        print("Пожалуйста, введите целые числа в качестве входных данных.")
