def roulette_game(N, K, S1, S2):
    MOD = 10**9 + 7
    dp = [[0] * (N * K + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for i in range(1, N + 1):
        for j in range(1, N * K + 1):
            for k in range(1, K + 1):
                if j - k >= 0:
                    dp[i][j] = (dp[i][j] + dp[i - 1][j - k]) % MOD

    ways_first = dp[N][S1]
    ways_second = dp[N][S2]

    if ways_first > ways_second:
        return "First"
    elif ways_first < ways_second:
        return "Second"
    else:
        return "Equal"


# Пример использования функции
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())
print(roulette_game(N, K, S1, S2))
