def roulette_game(N, K, S1, S2):
    MOD = 10**9 + 7
    dp = [0] * (N * K + 1)
    dp[0] = 1

    for i in range(1, N + 1):
        new_dp = [0] * (N * K + 1)
        for j in range(1, N * K + 1):
            for k in range(1, K + 1):
                if j - k >= 0:
                    new_dp[j] = (new_dp[j] + dp[j - k]) % MOD
        dp = new_dp

    ways_first = dp[S1]
    ways_second = dp[S2]

    if ways_first > ways_second:
        return "First"
    elif ways_first < ways_second:
        return "Second"
    else:
        return "Equal"


# Пример использования функции
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())
print(roulette_game(N, K, S1, S2))
