def roulette_game(N, K, S1, S2):
    def nCr(n, r):
        res = 1
        for i in range(1, r + 1):
            res = res * (n - i + 1) // i
        return res

    def probability_sum(N, K, S):
        if S > N * K or S < N:
            return 0
        total = nCr(N, S - N)
        for i in range(1, N + 1):
            total *= nCr(S - i * 1, 1)
            total //= (K - 1)
        return total

    prob_first = probability_sum(N, K, S1)
    prob_second = probability_sum(N, K, S2)

    if prob_first > prob_second:
        return "First"
    elif prob_first < prob_second:
        return "Second"
    else:
        return "Equal"


# Считывание входных данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вызов функции и вывод результата
print(roulette_game(N, K, S1, S2))
