# Задача D
def main(n, k, s1, s2):
    if dice_probability(n, s1, k) > dice_probability(n, s2, k):
        return "First"
    elif dice_probability(n, s1, k) == dice_probability(n, s2, k):
        return "Equal"
    else:
        return "Second"


def dice_probability(int_dice_number: int, int_number_to_find: int, c_int_side_dice: int) -> float:
    list_values, list_interm_probability = list_values_and_interm_probabilities(int_dice_number, c_int_side_dice)
    if int_number_to_find < list_values[0] or int_number_to_find > list_values[-1]:
        result_out: float = 0.0
    else:
        for i in range(len(list_values)):
            if list_values[i] == int_number_to_find:
                result_out: float = list_interm_probability[i] / (c_int_side_dice ** int_dice_number)
                break
    return result_out


def list_values_and_interm_probabilities(int_dice_number: int, c_int_side_dice: int) -> tuple[list[int], list[int]]:
    list_values = [i for i in range(int_dice_number, c_int_side_dice * int_dice_number + 1)]
    list_interm_probability = [1] * c_int_side_dice
    for i in range(int_dice_number - 1):
        list_interm_probability = multiply_by_ones(list_interm_probability, c_int_side_dice)

    return list_values, list_interm_probability


def multiply_by_ones(list_in: list[int], c_int_side_dice: int) -> list[int]:
    list_dummy: list[list[int]] = []
    for i in range(c_int_side_dice):
        list_dummy.append([0] * i)

    list_for_sum: list[list[int]] = []
    for i in range(c_int_side_dice):
        list_for_sum.append(list_dummy[i] + list_in + list_dummy[c_int_side_dice - i - 1])
    list_out: list[int] = []
    for i in range(len(list_for_sum[0])):
        sum_out: int = 0
        for j in range(c_int_side_dice):
            sum_out += list_for_sum[j][i]
        list_out.append(sum_out)
    return list_out


print(main(int(input()), int(input()), int(input()), int(input())))