import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {
    public static int findNod(int a, int b) {
        if (b == 0) {
            return a;
        } else {
            return findNod(b, a % b);
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int start = Integer.parseInt(reader.readLine());
        int end = Integer.parseInt(reader.readLine());

        int maxGCD = 1;
        int num1 = -1;
        int num2 = -1;

        for (int i = start; i < end; i++) {
            for (int j = end; j > i; j--) {
                int gcd = findNod(i, j);
                if (gcd > maxGCD) {
                    maxGCD = gcd;
                    num1 = i;
                    num2 = j;
                    if(maxGCD == j-i) {
                        break;
                    }
                }
            }
        }
        System.out.println(num1 + " " + num2);
    }
}
