import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    private static List<String> users = new ArrayList<>();

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int numUsers = Integer.parseInt(scanner.nextLine());

        for (int i = 0; i < numUsers; i++) {
            String name = scanner.nextLine();
            if (!users.contains(name)) {
                users.add(name);
                System.out.println(name);
            } else {
                register(name + "1", 1);
            }
        }
    }

    private static void register(String name, int prefix) {
        if (!users.contains(name)) {
            users.add(name);
            System.out.println(name);
        } else {
            name = name.substring(0, name.length() - 1) + prefix;
            register(name, prefix + 1);
        }
    }
}