def min_moves_to_win(N, p):
    # Создаем массив для хранения минимального количества ходов для каждой клетки
    dp = [float('inf')] * N
    dp[0] = 0  # Нулевые ходы для первой клетки

    for i in range(1, N):
        # Обрабатываем клетки с телепортами
        for j in range(max(0, i - p[i-1]), i):
            dp[i] = min(dp[i], dp[j] + 1)

    return dp[N-1] if dp[N-1] != float('inf') else -1

# Чтение входных данных
N = int(input())
p = list(map(int, input().split()))

# Вызываем функцию и выводим результат
result = min_moves_to_win(N, p)
print(result)
