#include <algorithm>
#include <bitset>
#include <chrono>
#include <cmath>
#include <cstring>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <limits>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

// #include "json.hpp" // lib for json, dont forget to coment on contests
// #include <curl/curl.h> // lib for curl, dont forget to coment on contests
// #include <bit>
// #include "optimization.h"

// using json = nlohmann::json; // namespace for json, dont forget to coment on
// contests
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define ld long double
#define f first // TODO: remove
#define s second
#define eb emplace_back
#define pb push_back

// #define FAST_ALLOCATOR_MEMORY 1e8
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag,
             tree_order_statistics_node_update>
    ordered_set;

const int INF = 1e9 + 10;
const int MOD1 = 1e9 + 7;
const int P = 31;
const int P1 = 43;
const int MOD = 1e9;
const ld EPS = 1e-7;

const int MAX_BITSET = 123;

// void solve() {
//     int n, k;
//     cin >> n >> k;
//     int s1, s2;
//     cin >> s1 >> s2;
//     if (min(s1, s2) < n && max(s1, s2) > n * k) {
//         cout << "Equal\n";
//         return;
//     }
//     if (s1 < n && n <= s2 && s2 <= n * k) {
//         cout << "Second\n";
//         return;
//     }
//     if (s2 < n && n <= s1 && s1 <= n * k) {
//         cout << "First\n";
//         return;
//     }
//     if (s1 > n * k && n <= s2 && s2 <= n * k) {
//         cout << "Second\n";
//         return;
//     }
//     if (s2 > n * k && n <= s1 && s1 <= n * k) {
//         cout << "First\n";
//         return;
//     }
//     if (n == 1 || k == 1) {
//         cout << "Equal\n";
//         return;
//     }
//     int mid = n * (k - 1);
//     int fi, se;
//     if ((n * k - n + 1) % 2 == 1) {
//         mid /= 2;
//         mid += n;
//         // cout << mid << '\n';
//         fi = abs(s1 - mid);
//         se = abs(s2 - mid);
//     } else {
//         int mid1 = mid / 2 + n;
//         int mid2 = (mid + 1) / 2 + n;
//         // cout << mid1 << ' ' << mid2 << '\n';
//         fi = min(abs(s1 - mid2), abs(s1 - mid1));
//         se = min(abs(s2 - mid2), abs(s2 - mid1));
//     }
//     // cout << fi << ' ' << se << '\n';
//     if (fi == se) {
//         cout << "Equal";
//     } else if (fi < se) {
//         cout << "First";
//     } else {
//         cout << "Second";
//     }
// }

string s[2000];
pair<int, int> d[2000][2000];
int used[2000][2000];

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    int x1, y1;
    cin >> x1 >> y1;
    x1--;
    y1--;
    int x2, y2;
    cin >> x2 >> y2;
    x2--;
    y2--;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            d[i][j] = {INF, INF};
        }
    }
    set<pair<pair<int, int>, pair<int, int>>> q;
    d[x1][y1] = {0, 0};
    q.insert({{0, 0}, {x1, y1}});
    vector<pair<int, int>> p1 = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
    vector<pair<int, int>> p2 = {{2, 0}, {0, 2}, {-2, 0}, {0, -2}};

    while (q.size()) {
        pair<int, int> p = (*q.begin()).s;
        used[p.f][p.s] = 1;
        q.erase(q.begin());
        for (auto it : p1) {
            int p1 = p.f + it.f;
            int p2 = p.s + it.s;
            if (p1 < n && p1 >= 0 && p2 < m && p2 >= 0 && s[p1][p2] != '#') {
                if (!used[p1][p2] && (d[p1][p2].f > d[p.f][p.s].f ||
                                      (d[p1][p2].f == d[p.f][p.s].f &&
                                       d[p1][p2].s > d[p.f][p.s].s + 1))) {
                    q.erase({d[p1][p2], {p1, p2}});
                    d[p1][p2] = {d[p.f][p.s].f, d[p.f][p.s].s + 1};
                    q.insert({d[p1][p2], {p1, p2}});
                }
            }
        }
        for (auto it : p2) {
            int p1 = p.f + it.f;
            int p2 = p.s + it.s;
            if (p1 < n && p1 >= 0 && p2 < m && p2 >= 0 && s[p1][p2] != '#' &&
                d[p.f][p.s].f + 1 <= k) {
                if (!used[p1][p2] && (d[p1][p2].f > d[p.f][p.s].f + 1 ||
                                      (d[p1][p2].f == d[p.f][p.s].f + 1 &&
                                       d[p1][p2].s > d[p.f][p.s].s + 1))) {
                    q.erase({d[p1][p2], {p1, p2}});
                    d[p1][p2] = {d[p.f][p.s].f + 1, d[p.f][p.s].s + 1};
                    q.insert({d[p1][p2], {p1, p2}});
                }
            }
        }
    }
    if (d[x2][y2].f == INF && d[x2][y2].s == INF)
        cout << "NO\n";
    else
        cout << "YES\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    int t = 1;
    // cin >> t;
    //    t = readInt();
    while (t--) {
        solve();
        // solve1();
    }

    // while (!isEof()){
    //     solve();
    // }

    return 0;
}