#include <stdio.h>
#include <float.h>
#include <stdlib.h>
struct detal {
	long nado;
	long real;
	double otkl;
	double new_delta_otkl;
};
int main(void) {
	long count, dopus_deviation, ves;
	if (scanf("%ld", &count) != 1) return 1;
	if (scanf("%ld", &dopus_deviation) != 1) return 1;
	struct detal *detals = (struct detal *)malloc(sizeof(struct detal) * count);
	size_t *fixes = (size_t *)malloc(sizeof(size_t) * count);
	size_t fixes_count = 0;
	for (size_t i = 0; i < count; ++i) {
		scanf("%ld", &ves);
		detals[i].nado = ves;
	}
	long index = 0;
	double otkl_sum = 0;
	long max_delta = 0;
	for (size_t i = 0; i < count; ++i) {
		scanf("%ld", &ves);
		detals[i].real = ves;
		detals[i].otkl = (double)labs(detals[i].real - detals[i].nado) / detals[i].nado;
		detals[i].new_delta_otkl = detals[i].otkl - (double)labs(detals[i].real - detals[i].nado + (detals[i].real > detals[i].nado ? -1 : 1)) / detals[i].nado;
		if (detals[i].new_delta_otkl >= (1 - DBL_EPSILON)) {
			fixes[fixes_count++] = i;
		}
		if (detals[i].new_delta_otkl > max_delta) {
			max_delta = detals[i].new_delta_otkl;
			index = i;
		}
		otkl_sum += detals[i].otkl;
	}
	long steps = 0;
	size_t fixes_iter = 0;
	while (otkl_sum > dopus_deviation && fixes_iter < fixes_count) {
		size_t index2 = fixes[fixes_iter++];
		otkl_sum -= detals[index2].otkl;
		detals[index2].real += (detals[index2].real > detals[index2].nado ? -1 : 1);
		detals[index2].otkl = (double)labs(detals[index2].real - detals[index2].nado) / detals[index2].nado;
		detals[index2].new_delta_otkl = detals[index2].otkl - (double)labs(detals[index2].real - detals[index2].nado + (detals[index2].real > detals[index2].nado ? -1 : 1)) / detals[index2].nado;
		otkl_sum += detals[index2].otkl;
		steps += 1;
	}
	bool need_fint_index = fixes_iter > 0 ? true : false;
	while (otkl_sum > dopus_deviation) {
		if (need_fint_index == true) {
			max_delta = detals[0].new_delta_otkl;
			for (size_t i = 0; i < count; ++i) {
				if (detals[i].new_delta_otkl >= (1 - DBL_EPSILON)) {
					index = i;
					break;
				} else if (detals[i].new_delta_otkl > max_delta) {
					max_delta = detals[i].new_delta_otkl;
					index = i;
				}
			}
		} else {
			need_fint_index = true;
		}
		// for (size_t i = 0; i < count; ++i) {
		// 	printf("%ld  %ld  %lf  %lf  %s\n", detals[i].nado, detals[i].real, detals[i].otkl, detals[i].new_delta_otkl, i == index ? "(selected)" : "");
		// }
		// printf("\n");
		otkl_sum -= detals[index].otkl;
		detals[index].real += (detals[index].real > detals[index].nado ? -1 : 1);
		detals[index].otkl = (double)labs(detals[index].real - detals[index].nado) / detals[index].nado;
		detals[index].new_delta_otkl = detals[index].otkl - (double)labs(detals[index].real - detals[index].nado + (detals[index].real > detals[index].nado ? -1 : 1)) / detals[index].nado;
		if (detals[index].new_delta_otkl >= (1 - DBL_EPSILON)) {
			need_fint_index = false;
		}
		otkl_sum += detals[index].otkl;
		steps += 1;
	}
	printf("%ld\n", steps);
	return 0;
}
