N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Создаем массив для хранения количества способов получить каждую сумму
dp = [[0] * (S1 + S2 + 1) for _ in range(N + 1)]

# Изначально есть один способ получить сумму 0 - ничего не делать
dp[0][0] = 1

# Заполняем массив dp
for i in range(1, N + 1):
    for j in range(S1 + S2 + 1):
        for k in range(1, min(K, j) + 1):
            dp[i][j] += dp[i - 1][j - k]

# Подсчитываем количество способов для каждого игрока
count_S1 = dp[N][S1]
count_S2 = dp[N][S2]

if count_S1 > count_S2:
    print("First")
elif count_S2 > count_S1:
    print("Second")
else:
    print("Equal")
