N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

def nCr(n, r):
    # Функция для вычисления сочетаний "n по r"
    if n < r:
        return 0
    if r == 0:
        return 1
    return nCr(n - 1, r - 1) + nCr(n - 1, r)

def calculate_probability(N, K, S):
    total_outcomes = K ** N
    favorable_outcomes = 0

    for i in range(N, min(N * K, S) + 1):
        favorable_outcomes += nCr(N, i) * nCr(K * N - i, S - i)

    return favorable_outcomes / total_outcomes

count_S1 = calculate_probability(N, K, S1)
count_S2 = calculate_probability(N, K, S2)

if count_S1 > count_S2:
    print("First")
elif count_S2 > count_S1:
    print("Second")
else:
    print("Equal")
