def gcd(a, b):
    while b:
        a, b = b, a % b
    return a

# Чтение вводных данных
L, R = map(int, input().split())

# Инициализация наибольшего НОД и соответствующей пары
max_gcd = 0
result = (L, R)

# Перебираем числа в обратном порядке, начиная с минимального НОД
for x in range(R, L, -1):
    for y in range(x - 1, L - 1, -1):
        current_gcd = gcd(x, y)
        if current_gcd > max_gcd:
            max_gcd = current_gcd
            result = (x, y)
            if max_gcd == min(x, y):
                break

# Вывод пары с наибольшим НОД
print(result[0], result[1])
