﻿#include <iostream>
#include <vector>

using namespace std;

int countWays(int N, int K, int sum) {
    vector<vector< long long>> kol(N + 1, vector< long long>(sum + 1, 0));

    kol[0][0] = 1;

    for (int n = 1; n <= N; n++) {
        for (int s = 0; s <= sum; s++) {
            for (int k = 1; k <= K; k++) {
                if (s - k >= 0) {
                    kol[n][s] += kol[n - 1][s - k];
                }
            }
        }
    }

    return kol[N][sum];
}

int main() {
    int N, K, S1, S2;
    cin >> N >> K >> S1 >> S2;

     int ways1 = countWays(N, K, S1);
     int ways2 = countWays(N, K, S2);

    if (ways1 > ways2) {
        cout << "First";
    }
    else if (ways2 > ways1) {
        cout << "Second";
    }
    else {
        cout << "Equal";
    }

    return 0;
}
