﻿#include <iostream>
#include <cmath>

using namespace std;

int search(int a, int b)
{
    while (b != 0) 
    {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main() {
    int L, R;
    cin >> L >> R;

    int max = -1;
    int x1, y1;

    for (int x = L; x < R; x++) 
    {
        for (int y = x + 1; y <= R; y++)
        {
            int current_gcd = search(x, y);
            if (current_gcd > max)
            {
                max = current_gcd;
                x1 = x;
                y1 = y;
            }
        }
    }

    cout << x1 << " " << y1;

    return 0;
}
