﻿#include <iostream>
#include <cmath>

using namespace std;

long long search(long long a, long long b)
{
    while (b != 0) 
    {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main() {
    long long L, R;
    cin >> L >> R;

    long long max = -1;
    long long x1, y1;

    for (long long x = L; x < R; x++) 
    {
        for (long long y = x + 1; y <= R; y++)
        {
            long long temp = search(x, y);
            if (temp > max)
            {
                max = temp;
                x1 = x;
                y1 = y;
            }
        }
    }

    cout << x1 << " " << y1;

    return 0;
}
