#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <iterator>
#include <utility>

using namespace std;
using ll = long long;
using db = long double;


#define ndl "\n"
const db eps = 1e-64;
const db pi = 3.14159265358979323846;

ll mod (ll a, ll b)
{
    return (a + (abs(a)/b + 1)*b) % b;
}

ll fpow(ll n, ll a)
{
    ll res = 1;
    while (a)
    {
        if (a & 1)
            res*=n;
        n*=n;
        a>>=1;
    }
    return res;
}

bool prime(ll n)
{
    ll k = ((n % 2) ? 2 : 1), st = ((n % 2) ? 3 : 2);
    if (n <= 1)
        return false;
    if (n == 2 || n == 3)
        return true;
    for(ll i = st; i * i <= n;i+=k)
    {
        if (n % i == 0)
            return false;
    }
    return true;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll a, b; cin >> a >> b;
    if ((a+b) % 2 == 1) {
        cout << "Error" << ndl;
    } else if (a >= 2 && b >= 2) {
        cout << "Undefined" << ndl;
    } else {
        cout << a/2 << ndl << b / 2 << ndl <<  1 << ndl;
    }
}