#include <iostream>
#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
using namespace std;

string s;

map<int, int> m;

void config_io()
{
    cin.tie(NULL);
    cout.tie(NULL);
    cout.sync_with_stdio(false);       

#ifdef _deb
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#endif

}

double dist(pair<int, int> p1, pair<int, int> p2){
    int dx = p1.first - p2.first;
    int dy = p1.second - p2.second;
    return sqrt((double)(dx*dx + dy*dy));
}


int main(){
    config_io();
    
    int n;
    cin >> n;
    double ans = 0;

    vector<pair<int, int>> dots(n);
    int x, y;
    for(int i = 0; i < n; i++){
        cin >> x >> y;
        dots[i] = {x, y};
    }

    double max_dist = -1;
    double cur_dist;
    for(int i = 1; i < n; i++){
        cur_dist = dist(dots[i], dots[i-1]);
        max_dist = max(max_dist, cur_dist);
        ans += cur_dist;
    }

    ans += dist(dots[0], dots[n-1]);
    max_dist = max(max_dist, dist(dots[0], dots[n-1]));

    cout << ans - max_dist << flush;
    return 0;
}

