#include <iostream>
#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
using namespace std;
 
pair<int, int> dorm;
pair<int, int> airp;

int n, m;

list<pair<int, int>> neighbors(int x, int y){
    list<pair<int, int>> ret = {};
    if(x-1 >= 0){
        ret.push_back({x-1, y});
    }
    if(x+1 < m){
        ret.push_back({x+1, y});
    }
    if(y-1 >= 0){
        ret.push_back({x, y-1});
    }
    if(y+1 < n){
        ret.push_back({x, y+1});
    }

    return ret;
}

list<pair<int, int>> far_neighbors(int x, int y){
    list<pair<int, int>> ret;
    if(x-2 >= 0){
        ret.push_back({x-2, y});
    }
    if(x+2 < m){
        ret.push_back({x+2, y});
    }
    if(y-2 >= 0){
        ret.push_back({x, y-2});
    }
    if(y+2 < n){
        ret.push_back({x, y+2});
    }

    return ret;
}
 


void rec(pair<int, int> cur, int cur_k, vector<vector<bool>>& b, 
    pair<int, int> prev){
    //cout << cur.first << ' ' << cur.second << '\n';
    if(cur == airp){
        cout << "YES" << flush;
        exit(0);
    }
    auto nei = neighbors(cur.first, cur.second);
    for(auto x: nei){
        if(b[x.second][x.first] && prev != x){
            rec(x, cur_k, b, cur);
        }
    }
    if(cur_k > 0){
        nei = far_neighbors(cur.first, cur.second);
        for(auto x: nei){
            if(b[x.second][x.first] && prev != x){
                rec(x, cur_k-1, b, cur);
            }
            
        }
    }
}

void config_io()
{
    cin.tie(NULL);
    cout.tie(NULL);
    cout.sync_with_stdio(false);       
 
#ifdef _deb
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#endif
 
}
 
 
int main(){
    config_io();
     
    int k, x, y;
    

    cin >> n >> m >> k;

    vector<vector<bool>> b;
    vector<vector<bool>> v;

    string tmp;
    for(int i = 0; i < n; i++){
        cin >> tmp;
        vector<bool> t, q;
        for(int j = 0; j < m; j++){
            if(tmp[j] == '.'){
                t.push_back(true);
            }
            else{
                t.push_back(false);
            }
            q.push_back(false);
        }
        b.push_back(t);
        v.push_back(q);
    }

    cin >> y >> x;
    dorm = {x-1, y-1};
    
    cin >> y >> x;
    airp = {x-1, y-1};

    rec(dorm, k, b, {-1, -1});

    cout << "NO" << flush;

    return 0;
}