#include <iostream>
#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
using namespace std;
 
pair<int, int> dorm;
pair<int, int> airp;

int n, m;

list<pair<int, int>> neighbors(int x, int y){
    list<pair<int, int>> ret = {};
    if(x-1 >= 0){
        ret.push_back({x-1, y});
    }
    if(x+1 < m){
        ret.push_back({x+1, y});
    }
    if(y-1 >= 0){
        ret.push_back({x, y-1});
    }
    if(y+1 < n){
        ret.push_back({x, y+1});
    }

    return ret;
}

list<pair<int, int>> far_neighbors(int x, int y){
    list<pair<int, int>> ret;
    if(x-2 >= 0){
        ret.push_back({x-2, y});
    }
    if(x+2 < m){
        ret.push_back({x+2, y});
    }
    if(y-2 >= 0){
        ret.push_back({x, y-2});
    }
    if(y+2 < n){
        ret.push_back({x, y+2});
    }

    return ret;
}
 


void rec(pair<int, int> cur, int cur_k, vector<vector<bool>>& b, 
    pair<int, int> prev){
    //cout << cur.first << ' ' << cur.second << '\n';
    if(cur == airp){
        cout << "YES" << flush;
        exit(0);
    }
    auto nei = neighbors(cur.first, cur.second);
    for(auto x: nei){
        if(b[x.second][x.first] && prev != x){
            rec(x, cur_k, b, cur);
        }
    }
    if(cur_k > 0){
        nei = far_neighbors(cur.first, cur.second);
        for(auto x: nei){
            if(b[x.second][x.first] && prev != x){
                rec(x, cur_k-1, b, cur);
            }
            
        }
    }
}

void config_io()
{
    cin.tie(NULL);
    cout.tie(NULL);
    cout.sync_with_stdio(false);       
 
#ifdef _deb
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#endif
 
}
 
 
int main(){
    config_io();
     
    int n;
    cin >> n;

    vector<int> required(n, INT32_MAX-1);
    vector<int> transport_to(n, 0);

    vector<int> tp(n+1);

    for(int i = 0; i < n-2; i++){
        cin >> tp[i+1];
    }

    list<int> cur;
    for(int i = 1; i < n; i++){
        if(tp[i] == 0){
            transport_to[i] = i;        }
        else{
            transport_to[i] = transport_to[i - tp[i]];
        }
    }

    required[0] = 0;
    int index;
    for(int i = 0; i < n; i++){
        if(tp[i] == 1){
            continue;
        }
        for(int c = 1; c <= 6 && i + c < n; c++){
            index = transport_to[i + c];
            if(c == 6){
                required[index] = min(required[i], required[index]);
            }
            else{
                required[index] = min(required[i]+1, required[index]);
            }
        }
    }
    if(required[n-1] == INT32_MAX-1){
        cout << -1 << flush;
    }
    else{
        cout << required[n-1] << flush;
    }
    

    return 0;
}