#include <iostream>
#include <vector>
#include <string>
#include <utility>
#include <cmath>
#include <algorithm>
#include <iomanip>

long double distance(std::pair<long double, long double> p1, std::pair<long double, long double>p2){
    return sqrt(std::pow(p1.first - p2.first, 2) + std::pow(p1.second - p2.second, 2));
}

int main() {
    size_t n;
    std::cin >> n;
    std::vector<std::pair<long double, long double>> points;
    for (size_t i = 0; i < n; ++i){
        long double x,y;
        std::cin >> x >> y;
        points.push_back({x, y});
    }

    long double res = 0;
    for (size_t i = 1; i < n; ++i){
        res += distance(points[i-1], points[i]);
    }
    std::cout << std::fixed << std::setprecision(6) << res;
}