#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
using namespace std;

#define ll long long

int main()
{
	ll N;
	long double result = 0, max = 0;
	cin >> N;

	vector<pair<ll, ll>> coords(N);

	for (ll i = 0; i < N; ++i)
	{
		cin >> coords[i].first >> coords[i].second;
		if (i > 0)
		{
			long double temp = sqrt(pow((coords[i - 1].first - coords[i].first), 2) + pow((coords[i - 1].second - coords[i].second), 2));
			result += temp;
			if (max < temp)
				max = temp;
		}
	}

	long double temp = sqrt(pow((coords[0].first - coords[coords.size()-1].first), 2) + pow((coords[0].second - coords[coords.size()-1].second), 2));
	result += temp;
	if (max < temp)
		max = temp;

	result -= max;

	cout << fixed << setprecision(8) << result;
}