/******************************************************************************

                              Online C++ Compiler.
               Code, Compile, Run and Debug C++ program online.
Write your code in this editor and press "Run" button to compile and execute it.

*******************************************************************************/

/*
#include <iostream>

using namespace std;

int main()
{
    long long N,K,S1,S2;
    std::cin>>N>>K>>S1>>S2;
    
    long long expected_sum = N * (K + 1) / 2;

    if (S1 == expected_sum && S2 == expected_sum || S1==S2) {
    cout << "Equal" << endl;
    } 
    else if (S1 == expected_sum && S1>S2 || S1 > S2) {
    cout << "First" << endl;
    } 
    else {
    cout << "Second" << endl;
    }

    return 0;
}
*/

/*
#include <iostream>
#include <cmath>
using namespace std;

int main() {
long long N, K, S1, S2;
cin >> N >> K >> S1 >> S2;

long long expected = N * (K + 1) / 2;

long long diff1 = abs(S1 - expected);
long long diff2 = abs(S2 - expected);

if (diff1 < diff2) {
cout << "First" << endl;
} else if (diff2 < diff1) {
cout << "Second" << endl;
} else {
cout << "Equal" << endl;
}

return 0;
}
*/

#include <iostream>
#include <cmath>
using namespace std;

int main() {
long long N, K, S1, S2;
cin >> N >> K >> S1 >> S2;

long long minSum = N;
long long maxSum = N * K;

long long closerToS1 = 0;
long long closerToS2 = 0;

for (long long i = minSum; i <= maxSum; i++) {
if (abs(i - S1) < abs(i - S2)) {
closerToS1++;
} else if (abs(i - S1) > abs(i - S2)) {
closerToS2++;
}
}

if (closerToS1 > closerToS2) {
cout << "First" << endl;
} else if (closerToS2 > closerToS1) {
cout << "Second" << endl;
} else {
cout << "Equal" << endl;
}

return 0;
}