﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	int n, time = 0;
	float k;
	cin >> n >> k;
	
	vector<int> stdWeight{};
	vector<int> realWeight{};

	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		stdWeight.push_back(a);
	}
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		realWeight.push_back(a);
	}

	float sumK = 0;

	std::vector<std::pair<int, int>> pairedVector;
	for (int i = 0; i < stdWeight.size(); ++i) {
		pairedVector.push_back(std::make_pair(stdWeight[i], i));
	}


	std::sort(pairedVector.begin(), pairedVector.end());


	std::vector<int> sortedFirstVector;
	std::vector<int> sortedSecondVector;

	for (const auto& pair : pairedVector) {
		sortedFirstVector.push_back(pair.first);
		sortedSecondVector.push_back(realWeight[pair.second]);
	}


	stdWeight = sortedFirstVector;
	realWeight = sortedSecondVector;

	for (int i = 0; i < n; i++) {
		sumK += (float)abs(stdWeight[i] - realWeight[i]) / stdWeight[i];
	}

	int i = 0;
	while (sumK > k) {
		if (realWeight[i] != stdWeight[i]) {
			sumK-= (float)abs(stdWeight[i] - realWeight[i]) / stdWeight[i];
			if (realWeight[i] > stdWeight[i]) {
				time+= realWeight[i] - stdWeight[i];
				realWeight[i] -= realWeight[i] - stdWeight[i];
			}
			else {
				time += stdWeight[i] - realWeight[i];
				realWeight[i] += stdWeight[i] - realWeight[i];
			}
			sumK+= (float)abs(stdWeight[i] - realWeight[i]) / stdWeight[i];
		}
		else {
			i++;
		}
	}

	if (sumK < k) {
		time -= std::round(k-sumK);
	}

	cout << time;


}