def max_guests(N, K):
    if K == 0:
        return N, 'G' * N  
    seats = ['-'] * N
    guests = 1
    current_seat = 0  
    seats[current_seat] = 'G'
    while current_seat < N:
        next_seat = current_seat + K
        if next_seat < N:
            guests += 1
            seats[next_seat] = 'G'
            current_seat = next_seat + 1 
        else:
            break

    return guests, ''.join(seats)

N = int(input())
K = int(input())
guests, seating = max_guests(N, K)
print(guests)

