#include <iostream>
#include <string>
#include <unordered_map>
using namespace std;

class NoSQL {
public:
    NoSQL() {
        users = unordered_map<string, int>();
    }

    string check(const string& user, int k) {
        string key = user + (k == 0 ? "" : to_string(k));
        if (users.find(key) != users.end()) {
            return check(user, k + 1);
        } else {
            users[key] = 1;
            return key;
        }
    }

private:
    unordered_map<string, int> users;
};

int main() {
    NoSQL obj;
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        string user;
        cin >> user;
        cout << obj.check(user, 0) << endl;
    }

    return 0;
}
