#include <iostream>
#include <string>
#include <unordered_map>
using namespace std;

class NoSQL {
public:
    NoSQL() {
        users = unordered_map<string, int>();
    }

    string check(const string& user) {
        if (users.find(user) == users.end()) {
            users[user] = 1;
            return user;
        }
        else {
            int k = users[user];
            string updatedUser = user + to_string(k);
            while (users.find(updatedUser) != users.end()) {
                k++;
                updatedUser = user + to_string(k);
            }
            users[user] = k + 1;
            users[updatedUser] = 1;
            return updatedUser;
        }
    }

private:
    unordered_map<string, int> users;
};

int main() {
    NoSQL obj;
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        string user;
        cin >> user;
        cout << obj.check(user) << endl;
    }

    return 0;
}

