def find_winner(N, K, S1, S2):
    dp1 = [[0] * (S1 + 1) for _ in range(N + 1)]
    dp2 = [[0] * (S2 + 1) for _ in range(N + 1)]

    dp1[0][0] = 1
    dp2[0][0] = 1

    for i in range(1, N + 1):
        for j in range(1, S1 + 1):
            dp1[i][j] = sum(dp1[i - 1][j - k] for k in range(1, K + 1) if 0 <= j - k <= S1)

        for j in range(1, S2 + 1):
            dp2[i][j] = sum(dp2[i - 1][j - k] for k in range(1, K + 1) if 0 <= j - k <= S2)

    if dp1[N][S1] > dp2[N][S2]:
        return "First"
    elif dp2[N][S2] > dp1[N][S1]:
        return "Second"
    else:
        return "Equal"

# Ввод данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вызываем функцию и выводим результат
result = find_winner(N, K, S1, S2)
print(result)
