def minimize_deviation(N, K, standards, weights):
    # Создадим список отклонений
    deviations = [abs(standards[i] - weights[i]) / standards[i] for i in range(N)]
    
    # Отсортируем детали по уменьшению отклонения
    sorted_indices = sorted(range(N), key=lambda i: deviations[i], reverse=True)
    
    total_minutes = 0
    for i in sorted_indices:
        deviation = abs(standards[i] - weights[i]) / standards[i]
        if deviation > K:
            # Увеличиваем или уменьшаем вес детали
            diff = abs(standards[i] - weights[i])
            total_minutes += (diff + K - 1) // K  # Округление вверх
    
    return total_minutes

# Ввод данных
N, K = map(int, input().split())
standards = list(map(int, input().split()))
weights = list(map(int, input().split()))

# Вызываем функцию и выводим результат
result = minimize_devvation(N, K, standards, weights)
print(result)
