import math


def distance(p1, p2):
    return math.sqrt((p2[0] - p1[0]) ** 2 + (p2[1] - p1[1]) ** 2)


def find_perimeter(points):
    perimeter = 0
    surplus = 0
    for i in range(-1, len(points) - 1):
        d = distance(points[i], points[i + 1])
        perimeter += d
        if d > surplus:
            surplus = d
    return perimeter - d


n = int(input())
points = []
for _ in range(n):
    x, y = map(int, input().split())
    points.append((x, y))

print(find_perimeter(points))