#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <queue>
#include <iterator>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

long long gcd(long long a,long long b){
    while (a && b)
        if (a > b) a%=b;
        else b%=a;
    return a+b;
}

int main()
{
    ios_base::sync_with_stdio(false);
    ld n, k1, sum, sum1, v1(1), v2(1);
    cin >> n >> k1 >> sum >> sum1;
    if(sum < n || sum > n * k1){
        v1 = 0;
    }
    if(sum1 < n || sum1 > n * k1){
        v2 = 0;
    }
    if (v1 == 0 && v2 != 0){
        cout << "Second";
        return 0;
    }
    if (v1 != 0 && v2 == 0){
        cout << "First";
        return 0;
    }
    if (v1 == 0 && v2 == 0){
        cout << "Equal";
        return 0;
    }
    if (v1 != 0 && v2 != 0){
        vector <ld> cur(n * k1 + 1, 0), prev(n * k1 + 1, 0);
        vector <ld> cur1(n * k1 + 1, 0), prev1(n * k1 + 1, 0);
        cur[0] = 1;
        cur1[0] = 1;
        for (int i(1); i <= n; i++){
            swap(prev, cur);
            for (int j(0);j <= sum; j++){
                cur[j] = 0;
                for (int k (1);k <= k1;k++) if (j-k >= 0) cur[j] += prev[j-k];
                cur[j] /= k1;
            }
        }
        for (int i(1); i <= n; i++){
            swap(prev1, cur1);
            for (int j(0);j <= sum1; j++){
                cur1[j] = 0;
                for (int k (1);k <= k1;k++) if (j-k >= 0) cur1[j] += prev1[j-k];
                cur1[j] /= k1;
            }
        }
        //if(cur[sum]>0.001) cout << fixed << setprecision(5) << cur[sum];
        //else cout << cur[sum];
        if (cur1[sum1] < cur[sum]){
            cout << "Second";
        }
        else if (cur1[sum1] < cur[sum]){
            cout << "First";
        }
        else if (cur1[sum1] == cur[sum]){
            cout << "Equal";
        }
    }
}
