#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <queue>
#include <iterator>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

long long gcd(long long a,long long b){
    while (a && b)
        if (a > b) a%=b;
        else b%=a;
    return a+b;
}

int main()
{
    ios_base::sync_with_stdio(false);
    ll n, k;
    cin >> n >> k;
    vector <ld> v1(n), v2(n);
    for (int i(0); i<n; i++){
        cin >> v1[i];
    }
    for (int i(0); i<n; i++){
        cin >> v2[i];
    }
    ld sum(0);
    for (int i(0); i<n; i++){
        sum += (abs (v2[i] - v1[i])) / v1[i];
    }
    if (sum <= k){
        cout << 0;
    }
    else {
        cout << ceil (sum - k);
    }
}
