#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <queue>
#include <iterator>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(false);
    ld mxdl(0), dl(0);
    int n;
    cin >> n;
    vector <pair <ld, ld>> v(n);
    for (int i(0); i<n; i++){
        cin >> v[i].first >> v[i].second;
    }
    for (int i(1); i<n; i++){
        ld d = sqrt (pow (v[i].first - v[i-1].first, 2) + pow (v[i].second - v[i-1].second, 2));
        dl += d;
        if (d > mxdl){
            mxdl = d;
        }
    }
    ld d = sqrt (pow (v[n-1].first - v[0].first, 2) + pow (v[n-1].second - v[0].second, 2));
    dl += d;
    if (d > mxdl){
        mxdl = d;
    }
    cout << fixed << setprecision(6) << dl - mxdl;
}
