from collections import deque

def findCombinations(n, target, result, curr=deque(), start_num=1, allowed=set()):
    if len(curr) > n or target < 0:
        return

    if len(curr) == n and target == 0:
        result.append(list(curr))
        return

    for i in range(start_num, 10):
        if i in allowed:
            curr.append(i)
            findCombinations(n, target - i, result, curr, i, allowed)
            curr.pop()

def find_combinations(n, target, allowed):
    result = []
    findCombinations(n, target, result, allowed=set(allowed))
    return result

if __name__ == '__main__':
    n = int(input())
    k = int(input())
    allowed = []
    for i in range(1, k + 1):
        allowed.append(i)

    pl1 = find_combinations(n, int(input()), set(allowed))
    pl2 = find_combinations(n, int(input()), set(allowed))
    if len(pl1) > len(pl2):
        print("First")
    if len(pl1) < len(pl2):
        print("Second")
    if len(pl1) == len(pl2):
        print("Equal")




