#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define fi first
#define se second

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    ll n;
    cin >> n;

    vector<ll> p(n, 0);
    for (ll i = 1; i < n - 1; ++i) {
        cin >> p[i];
    }

    vector<ll> col(n);

    col[0] = 0;
    col[n - 1] = n - 1;

    for (ll i = 1; i < n - 1; ++i) {
        if (p[i] == 0) {
            col[i] = i;
        }
        col[i] = col[i - p[i]];
    }

    vector<pair<ll, ll>> dp(n, {1e10, 1e10});
    dp[0] = {0, 1};

    for (int k = 0; k < 2; ++k) {
        for (ll i = 1; i < n; ++i) {
            for (ll j = 1; j <= 6; ++j) {
                if (i - j >= 0 && p[i - j] == 0) {
                    if (j == 6) {
                        dp[col[i]].se = min(dp[col[i]].se, dp[i - j].se);
                    }
                    dp[col[i]].fi = min({dp[col[i]].fi, dp[i - j].se + 1, dp[i - j].fi + 1});
                }
            }
        }
    }

    for (int j = n - 2; j >= n - 7 && j >= 0; --j) {
        if (p[j]) continue;

        dp[n - 1].se = min(dp[n - 1].se, dp[j].se);
        dp[n - 1].fi = min(dp[n - 1].fi, dp[j].fi + 1);
    }

    if (min(dp[n - 1].fi, dp[n - 1].se) >= (ll) 1e10) {
        cout << "-1\n";
        return 0;
    }

    cout << min(dp[n - 1].fi, dp[n - 1].se) << '\n';

    return 0;
}
