#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define fi first
#define se second

void bfs(ll cur, ll n, vector<ll> &comps, vector<pair<ll, ll>> &ans, map<pair<ll, ll>, bool> &visited) {
    vector<ll> next;

    for (ll j = 1; j <= 6; ++j) {
        ll to = min(cur + j, n - 1);
        if (j == 6) {
            ans[comps[to]].se = min(ans[comps[to]].se, ans[cur].se);
        }
        ans[comps[to]].fi = min({ans[comps[to]].fi, ans[cur].se + 1, ans[cur].fi + 1});
        next.push_back(comps[to]);
    }

    for (const ll &to: next) {
        if (cur != to && visited.find({cur, to}) == visited.cend()) {
            visited[{cur, to}] = true;
            bfs(to, n, comps, ans, visited);
        }
    }

}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    ll n;
    cin >> n;

    vector<ll> p(n, 0);
    for (ll i = 1; i < n - 1; ++i) cin >> p[i];

    vector<ll> comps(n);
    comps[0] = 0;
    comps[n - 1] = n - 1;
    for (ll i = 1; i < n - 1; ++i) {
        if (p[i] == 0) comps[i] = i;
        comps[i] = comps[i - p[i]];
    }

    vector<pair<ll, ll>> ans(n, {1e10, 1e10});
    ans[0] = {0, 1};
    map<pair<ll, ll>, bool> visited;
    bfs(0, n, comps, ans, visited);

    if (min(ans[n - 1].fi, ans[n - 1].se) >= (ll) 1e10) {
        cout << "-1\n";
        return 0;
    }

    cout << min(ans[n - 1].fi, ans[n - 1].se) << '\n';
    return 0;
}
