from math import sqrt, ceil


def highest_GCD(l, r):
    limit = ceil(sqrt(r))
    diff = r - l
    if limit < diff:
        elems = (r // factor for factor in range(r // diff, limit))
    else:
        elems = range(diff, 0, -1)
    for elem in elems:
        higher = r - r % elem
        if l <= higher - elem:
            return higher - elem, higher


l, r = map(int, input().split())
print(*highest_GCD(l, r))