from collections import defaultdict


def neibors(x, y, n, m, flag):
    ans = []
    if flag:
        for i in [(x + 1, y), (x, y + 1), (x - 1, y), (x, y - 1)]:
            if 0 <= i[0] <= m - 1 and 0 <= i[1] <= n - 1:
                ans.append(i)
    else:
        for i in [(x + 1, y), (x, y + 1), (x - 1, y), (x, y - 1), (x + 2, y), (x, y + 2), (x - 2, y), (x, y - 2)]:
            if 0 <= i[0] <= m - 1 and 0 <= i[1] <= n - 1:
                ans.append(i)
    return ans


n, m, max_k = map(int, input().split())  # высота и длина
lab = ''
for i in range(n):
    lab += ''.join(input().split())

ss = defaultdict(dict)
ss1 = defaultdict(dict)
for i in range(n):
    for j in range(m):
        cell = lab[i * m + j]
        if cell == '#':
            continue
        for k in neibors(j, i, n, m, True):
            if lab[k[1] * m + k[0]] == '.':
                ss[i * m + j][k[1] * m + k[0]] = 1

for i in range(n):
    for j in range(m):
        cell = lab[i * m + j]
        if cell == '#':
            continue
        for k in neibors(j, i, n, m, False):
            if lab[k[1] * m + k[0]] == '.':
                ss1[i * m + j][k[1] * m + k[0]] = 1

def dfs(visited, now, k = 0):
    visited[now] = 1
    if k < max_k:
        cur_neibs = ss1[now]
    else:
        cur_neibs = ss[now]
    for neig in cur_neibs:
        if not visited[neig]:
            dfs(visited, neig, k + 1)


visited = [False for i in range(n * m)]
start = list(map(int, input().split()))
finish = list(map(int, input().split()))
dfs(visited, (start[0] - 1) * m + start[1] - 1)
print( 'YES' if visited [ (finish[0] - 1) * m + finish[1] - 1 ] else 'NO')
