def count_ways(n, x, k):
    dp = [[0] * (x + 1) for _ in range(n + 1)]
    dp[0][0] = 1

    for i in range(1, n + 1):
        for j in range(1, x + 1):
            for p in range(1, k + 1):
                if j - p >= 0:
                    dp[i][j] += dp[i - 1][j - p]

    return dp[n][x]


n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())
result_1 = count_ways(n, s1, k)
result_2 = count_ways(n, s2, k)
if result_1 > result_2:
    print('First')
elif result_2 > result_1:
    print('Second')
else:
    print('Equal')
