def find_winner(N, K, S1, S2):
    dp = [[0] * (max(S1, S2) + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for i in range(1, N + 1):
        for j in range(1, max(S1, S2) + 1):
            for k in range(1, K + 1):
                if j - k >= 0:
                    dp[i][j] += dp[i - 1][j - k]

    if dp[N][S1] > dp[N][S2]:
        return "First"
    elif dp[N][S1] < dp[N][S2]:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

print(find_winner(N, K, S1, S2))
