def count_decompositions(number, K, M):
    # Создаем таблицу для хранения результатов
    dp = [[0] * (number + 1) for _ in range(K + 1)]
    dp[0][0] = 1  # Базовый случай: один способ разложить 0 на 0 слагаемых

    for k in range(1, K + 1):
        for n in range(1, number + 1):
            for i in range(1, min(n, M) + 1):
                dp[k][n] += dp[k - 1][n - i]

    return dp[K][number]

K = int(input())  # число запусков рулетки
M = int(input())  # количество чисел на рулетке
number = int(input())  # сумма, на которую поставил первый игрок
number2 = int(input())  # сумма, на которую поставил второй игрок

count = count_decompositions(number, K, M)
count2 = count_decompositions(number2, K, M)
if count > count2:
    print('First')
elif count < count2:
    print('Second')
else:
    print('Equal')
