def count_decompositions(number, K, M):
    # Используем два массива для хранения результатов
    prev_dp = [0] * (number + 1)
    current_dp = [0] * (number + 1)
    prev_dp[0] = 1  # Базовый случай: один способ разложить 0 на 0 слагаемых

    for k in range(1, K + 1):
        for n in range(1, number + 1):
            current_dp[n] = 0  # Обнуляем текущее значение
            for i in range(1, min(n, M) + 1):
                current_dp[n] += prev_dp[n - i]

        # Обновляем массивы
        prev_dp, current_dp = current_dp, prev_dp

    return prev_dp[number]


K = int(input())  # число запусков рулетки
M = int(input())  # количество чисел на рулетке
number = int(input())  # сумма, на которую поставил первый игрок
number2 = int(input())  # сумма, на которую поставил второй игрок

count = count_decompositions(number, K, M)
count2 = count_decompositions(number2, K, M)
if count > count2:
    print('First')
elif count < count2:
    print('Second')
else:
    print('Equal')
