def calculate_winning_chances(N, K, S1, S2):
    dp1 = [0] * (N * K + 1)
    dp2 = [0] * (N * K + 1)
    dp1[0] = 1
    dp2[0] = 1

    for i in range(1, N + 1):
        for s in range(i, i * K + 1):
            dp1[s] = 0
            dp2[s] = 0
            for j in range(1, K + 1):
                if s - j >= 0:
                    dp1[s] += dp2[s - j]
                    dp2[s] += dp1[s - j]

    if dp1[S1] > dp2[S2]:
        return 'First'
    elif dp1[S1] < dp2[S2]:
        return 'Second'
    else:
        return 'Equal'

# Вводим значения N, K, S1 и S2
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = calculate_winning_chances(N, K, S1, S2)
print(result)
