import math

def euclidean_algorithm(a, b):
    while b:
        a, b = b, a % b
    return a

def find_pair_with_max_gcd(L, R):
    max_gcd = 1  # Изначально устанавливаем максимальный НОД как 1
    result_pair = (L, L + 1)  # Изначально устанавливаем пару чисел как (L, L+1)

    for x in range(L, R + 1):
        for y in range(x + 1, R + 1):
            gcd = euclidean_algorithm(x, y)  # Находим НОД для пары чисел (x, y)
            if gcd > max_gcd:
                max_gcd = gcd
                result_pair = (x, y)

    return result_pair

L, R = map(int, input().split())

result = find_pair_with_max_gcd(L, R)
print (result[0], result[1])