def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def find_pair_with_max_gcd(L, R):
    max_gcd = 0
    max_gcd_pair = None

    for x in range(L, R+1):
        f_x = 0
        for y in range(L, R+1):
            if x != y:
                current_gcd = gcd(x, y)
                if current_gcd > f_x:
                    f_x = current_gcd
        if f_x > max_gcd:
            max_gcd = f_x
            max_gcd_pair = (x, f_x)

    return max_gcd_pair

L, R = list(map(int, input().split()))

pair = find_pair_with_max_gcd(L, R)
print(* pair)