import math

def distance(x1, y1, x2, y2):
    return math.sqrt((x1 - x2) ** 2 + (y1 - y2) ** 2)

n = int(input())

perimeter = 0
max_side_length = 0

x1, y1 = map(float, input().split())
first_x, first_y = x1, y1

for i in range(n - 1):
    x2, y2 = map(float, input().split())
    side_length = distance(x1, y1, x2, y2)
    perimeter += side_length
    max_side_length = max(max_side_length, side_length)
    x1, y1 = x2, y2


last_side_length = distance(x1, y1, first_x, first_y)
perimeter += last_side_length
max_side_length = max(max_side_length, last_side_length)

print(format(perimeter-max_side_length, '.6f'))

