

#include <iostream>
#include <algorithm>
using namespace std;
uint64_t L, R;

uint64_t foo(uint64_t n) {
    uint64_t k = n / 2;
    while (n % k != 0) k--;
    if (k != 1) return k;
    return 0;
}

uint64_t bin_search(uint64_t l, uint64_t r, uint64_t key) {
    while (l < r) {
    uint64_t mid = (l + r) / 2; // считываем срединный индекс отрезка [l,r]
    if (mid > key) r = mid; // проверяем, какую часть нужно отбросить с поиска
    else l = mid + 1;
    }
    r--; // уменьшаем на один 
    if (r == key) return r; 
    else return -1;
}

int main() {
    cin >> L >> R;
    for (int i = R; i >= L; --i) {
        uint64_t temp = foo(i);
        if (temp != -1) {
            if (temp >= L) {
                //cout << bin_search(L, temp, temp);
                cout << temp << ' ' << i << '\n';
                return 0;
            } else {
                for (int j = L; j < i; ++j) {
                    if (j % temp == 0) {
                        cout << j << ' ' << i << '\n';
                        return 0;
                    }
                }
            } 
        }
    }
    return 0;
}    


