def generate_username(input_strings):
    user_counts = {}
    output_usernames = []

    for string in input_strings:
        if string in user_counts:
            user_counts[string] += 1
            modified_username = f"{string}{user_counts[string]}"
            while modified_username in user_counts:
                user_counts[string] += 1
                modified_username = f"{string}{user_counts[string]}"
            user_counts[modified_username] = 0
            output_usernames.append(modified_username)
        else:
            user_counts[string] = 0
            output_usernames.append(string)

    return output_usernames

n = int(input())
input_strings = []
for i in range(n):
    r = input()
    input_strings.append(r)
output_usernames = generate_username(input_strings)

for i in range(n):
    print(output_usernames[i], sep="")
