#include <iostream>
#include <vector>

using namespace std;
using Point = pair<int, int>;

int N, M;
uint32_t K;
Point S;
Point F;

vector<vector<char>> field;
vector<vector<char>> visited;
vector<Point> one = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
vector<Point> two = {{0, 2}, {0, -2}, {2, 0}, {-2, 0}};

void foo(int x, int y, uint32_t ctr) {
    if (visited[F.first - 1][F.second - 1]) {
        return;
    } else {
        visited[x][y] = true;
        for (size_t dir = 0; dir < 4; ++dir) {
            int oneX = x + one[dir].first;
            int oneY = y + one[dir].second;
            int twoX = x + two[dir].first;
            int twoY = y + two[dir].second;
            if (0 <= oneX && oneX < N && 0 <= oneY && oneY < M && 
                field[oneX][oneY] == '.' && !visited[oneX][oneY]) {
                    foo(oneX, oneY, ctr);
            }
            if (0 <= twoX && twoX < N && 0 <= twoY && twoY < M && 
                field[twoX][twoY] == '.' && !visited[twoX][twoY] && ctr > 0) {
                    foo(twoX, twoY, --ctr);
            }
        }
    }
    return;
}
int main() {
    cin >> N >> M >> K;
    field.resize(N);
    for (size_t i = 0; i < N; ++i) {
        field[i].resize(M);
        for (size_t j = 0; j < M; ++j) {
            cin >> field[i][j];
        }
    }
    cin >> S.first >> S.second;
    cin >> F.first >> F.second;
    visited.assign(N, vector<char>(M));
    foo(S.first - 1, S.second - 1, K);
    if ((bool)visited[F.first - 1][F.second - 1]) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
    return 0;
}