#include <bits/stdc++.h>

using namespace std;

#define ll long long

void solve() {
    ll N, K;
    cin >> N >> K;
    vector<ll> si;
    vector<ll> ai;

    for (int i = 0; i < N; i++) {
        int temp;
        cin >> temp;
        si.push_back(temp);
    }
    for (int i = 0; i < N; i++) {
        ll temp;
        cin >> temp;
        ai.push_back(temp);
    }

    map<ll, ll> costs;
    ll res = 0;

    ll diver = 0;
    for (int i = 0; i < N; i++) {
        ll path = abs(ai[i] - si[i]);
        int step = si[i];
        diver += path/step;
        ll cost1 = (1 + path) % step;
        if (path < step) {
            cost1 = 0;
        }
        ll h = (path - cost1) / step;
        if (path < step) {
            h = 0;
        }

        costs[step] += h;

        if (cost1 > 0) {
            costs[cost1] ++;
        }
//        cout << "path " << path << endl;
//        cout << "step " << step << endl;
//        cout << "cost1 " << cost1 << endl;
//        cout << "h " << h << endl;
//        cout << endl;
    }

    K = diver - K;
    if (K <= 0) {
        cout << 0 << endl;
        return;
    }
    for (auto el : costs) {
//        cout << "map: " << el.first << " " << el.second << endl;
        ll _k = min(K, el.second);
        res += _k * el.first;
        K -= _k;
        if (K == 0) {
            break;
        }
    }
    cout << res << endl;

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
