#include <iostream>
#include <vector>
#include <cmath>

#define ull unsigned long long
#define ll long long

double sqr(double x)
{
	return x * x;
}

int main()
{
	int n;
	std::cin >> n;
	std::vector<std::pair<ll, ll>> coords(n);
	for (int i = 0; i < n; ++i)
	{
		std::cin >> coords[i].first >> coords[i].second;
	}
	std::vector<double> lenghts(n);
	double maxL = 0;
	int indOfL;
	for (int i = 0; i < n - 1; ++i)
	{
		lenghts[i] = sqrt(sqr(static_cast<double>(coords[i].first - coords[i + 1].first))
				+ sqr(static_cast<double>(coords[i].second - coords[i + 1].second)));
		if (lenghts[i] > maxL)
		{
			maxL = lenghts[i];
			indOfL = i;
		}
	}
	lenghts[n - 1] = sqrt(sqr(static_cast<double>(coords[0].first - coords[n - 1].first))
			                  + sqr(static_cast<double>(coords[0].second - coords[n - 1].second)));
	if (lenghts[n - 1] > maxL)
	{
		indOfL = n - 1;
	}
	lenghts[indOfL] = 0;
	double sum = 0;
	for (int i = 0; i < n; ++i)
	{
		sum += lenghts[i];
	}
	std::cout << sum;
}