#include <iostream>
#include <vector>

#define ull unsigned long long
#define ll long long

int main()
{
	int n;
	std::cin >> n;
	std::vector<int> way(n);
	std::vector<int> zeros;
	for (int i = 0; i < n - 2; ++i)
	{
		std::cin >> way[i];
		if (way[i] == 0) zeros.push_back(i);
	}
	int cur_pos = -1;
	int moves = 1;
	int last_zero = -2;
	while (n - cur_pos > 6)
	{
		if (way[cur_pos + 6] != 0)
		{
			int new_pos = cur_pos + 6 - way[cur_pos + 6];
			if (new_pos > cur_pos)
			{
				while (way[new_pos] != 0 && new_pos > cur_pos)
				{
					new_pos -= way[new_pos];
				}
			}
			if (new_pos == last_zero)
			{
				
				std::cout << -1;
				return 0;
			}
			if (way[new_pos] == 0) last_zero = new_pos;
			if (new_pos <= cur_pos)
			{
				bool isFound = false;
				for (int i = zeros.size() - 1; i >= 0; --i)
				{
					if (zeros[i] >= cur_pos && zeros[i] < cur_pos + 6)
					{
						cur_pos = zeros[i];
						++moves;
						isFound = true;
						break;
					}
					if (zeros[i] < cur_pos) break;
				}
				if (!isFound)
				{
					std::cout << -1;
					return 0;
				}
			}
			else
			{
				cur_pos = new_pos;
			}
		}
		else
		{
			cur_pos += 6;
			last_zero = cur_pos;
		}
	}
	std::cout << moves;
}