///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

const int MAXN = 1e3 + 10;

vector<int> g[MAXN]; //	on road
vector<int> h[MAXN]; // aim

vector<int> red;

void addRed(int v) {
	for (auto to : g[v]) {
		addRed(to);
	}
	red.push_back(v);
}

void dfs(int v, int u) {
	int i = 0;
	for (; i < sz(g[v]) && i < sz(h[u]); i++) {
		dfs(g[v][i], h[u][i]);
	}
	while (i < sz(g[v])) {
		addRed(g[v][i]);
		g[v][i] = -1;
		i++;
	}
}

vector<pii> ans;

void dfsRes(int v, int u) {
	int i = 0;
	for (; i < sz(g[v]) && i < sz(h[u]) && g[v][i] != -1; i++) {
		dfsRes(g[v][i], h[u][i]);
	}
	while (i < sz(h[u])) {
		if (sz(g[v]) == i) g[v].push_back(-1);
		if (g[v][i] == -1) {
			g[v][i] = red.back();
			ans.push_back({red.back(), v});
			red.pop_back();
		}
		dfsRes(g[v][i], h[u][i]);
		i++;
	}
}

void solve() {
    int n;
    cin >> n;
    int p;
    for (int i = 1; i < n; i++) {
    	cin >> p;
    	g[p].push_back(i);
    }

    for (int i = 1; i < n; i++) {
    	cin >> p;
    	h[p].push_back(i);
    }
    dfs(0, 0);
    reverse(all(red));
    dfsRes(0, 0);
    cout << sz(ans) << '\n';
    for (auto el : ans) {
    	cout << el.f _ el.s << '\n';
    }
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        