///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

const ld PI = (ld) 3.141592653589793115997963468544;
const ld EPS = 1.0-9;
const ld INF = 1e18;

struct Point {
	int x, y;

	Point() {}
	Point(int x, int y): x(x), y(y) {}

	bool in_triangle(const Point &A, const Point &B, const Point &C) const;
};

istream & operator >> (istream &in, Point &P) {
	return in >> P.x >> P.y;
}

inline ld dist(const Point &A, const Point &B) {
	return sqrtl(1ll * (A.x - B.x) * (A.x - B.x) + 
		1ll * (A.y - B.y) * (A.y - B.y));
}

struct Vector {
	int x, y;

	Vector() {}
	Vector(int x, int y): x(x), y(y) {}
	Vector(Point A, Point B): x(B.x - A.x), y(B.y - A.y) {}
};

ll operator ^ (const Vector &v1, const Vector &v2) {
	return 1ll * v1.x * v2.x + 1ll * v1.y * v2.y;
}

ll operator % (const Vector &v1, const Vector &v2) {
	return 1ll * v1.x * v2.y - 1ll * v1.y * v2.x;
}

bool Point::in_triangle(const Point &A, const Point &B, const Point &C) const {
	Vector AB(A, B), BC(B, C), CA(C, A);
	Vector AP(A, Point(x, y)),
		   BP(B, Point(x, y)),
		   CP(C, Point(x, y));

	ll a = AB % AP, b = BC % BP, c = CA % CP;
	return (a >= 0 && b >= 0 && c >= 0) ||
		(a <= 0 && b <= 0 && c <= 0);
}

struct Segment {
	Point A, B;

	Segment() {}
	Segment(Point A, Point B): A(A), B(B) {}
};

struct Line {
	ll A, B, C;

	Line() {}
	Line(Point M, Point N): A(M.y - N.y), B(N.x - M.x), C(-A * M.x - B * M.y) {}

	ll operator () (const Point &P) const;
};

ll Line::operator () (const Point &P) const {
	return 1ll * A * P.x + 1ll * B * P.y + C;
}

struct Polygon {
	vector<Point> points;

	Polygon() {}
	Polygon(int n) {
		points.resize(n);
	}

	void reorder() {
		int n = points.size(), s = 0;
		for (int i = 1; i < n; ++i) {
			if (points[i].y < points[s].y ||
				(points[i].y == points[s].y &&
					points[i].x < points[s].x)) {
				s = i;
			}
		}
		vector<Point> npoints;
		for (int i = s; i < n; ++i) {
			npoints.push_back(points[i]);
		}
		for (int i = 0; i < s; ++i) {
			npoints.push_back(points[i]);
		}
		points.swap(npoints);
	}

	size_t size() {
		return points.size();
	}

	Point & operator [] (size_t index);

	ll areaX2() {
		ll area = 0;
		for (int i = 1; i < sz(points) - 1; ++i) {
			Vector v1(points[0], points[i]),
				   v2(points[0], points[i + 1]);
			area += llabs(v1 % v2);
		}
		return area;
	}

	ld perim() {
		ld p = 0;
		for (int i = 0, n = sz(points); i < n; ++i) {
			p += dist(points[i], points[(i + 1) % n]);
		}
		return p;
	}

	bool contains(const Point &P) {
		int n = points.size();
		int lef = 0, rig = n;
		Vector v(points[0], P);
		while (lef + 1 < rig) {
			int mid = (lef + rig) / 2;
			Vector u(points[0], points[mid]);
			if (u % v >= 0) {
				lef = mid;
			} else {
				rig = mid;
			}
		}
		for (int i = max(1, lef - 1); i <= min(n - 2, rig + 1); ++i) {
			if (P.in_triangle(points[0], points[i], points[i + 1])) {
				return true;
			}
		}
		return false;
	}
};

istream & operator >> (istream &in, Polygon &p) {
	for (auto &P : p.points) {
		in >> P;
	}
	return in;
}

Point & Polygon::operator [] (size_t index) {
	return points[index];
}

inline ld dist(const Point &P, const Line &l) {
	return (ld) llabs(l(P)) / sqrtl(1ll * l.A * l.A + 1ll * l.B * l.B);
}

inline ld dist(const Point &P, const Segment &s) {
	ld ans = min(dist(P, s.A), dist(P, s.B));
	Vector AB(s.A, s.B), AP(s.A, P),
		   BA(s.B, s.A), BP(s.B, P);
	if ((AB ^ AP) > 0 && (BA ^ BP) > 0) {
		ans = min(ans, dist(P, Line(s.A, s.B)));
	}
	return ans;
}

int sign(ll x) {
	if (x == 0) return 0;
	return x / abs(x);
}

pii getTangent(Point& point, Polygon& polygon) {
	Vector v(point, polygon[0]);

	int l = -1, r = polygon.size() - 1, mid;
	//find up tangent
	//sign l > 0
	while (r - l > 1) {
		mid = (l + r) / 2;
		Vector to(point, polygon[mid]);
		if (v % to < 0) {
			r = mid;
			continue;
		}
		Vector next(point, polygon[(mid + 1) % polygon.size()]);
		if (to % next > 0) {
			l = mid;
		} else {
			r = mid;
		}
		// cout << "lr" _ l _ r << endl;
	}
	
	pii ans = {r, -1};
	l = -1, r = polygon.size();
	//sign r >= 0, r is answer
	while (r - l > 1) {
		mid = (l + r) / 2;
		Vector to = Vector(point, polygon[mid]);
		if (v % to >= 0) {
			l = mid;
			continue;
		}
		Vector next(point, polygon[(mid + 1) % polygon.size()]);
		if (to % next > 0) {
			r = mid;
		} else {
			l = mid;
		}
	}
	ans.s = r % polygon.size();
	return ans;
}

inline ll dist2(const Point &A, const Point &B) {
	return 1ll * (A.x - B.x) * (A.x - B.x) + 
		1ll * (A.y - B.y) * (A.y - B.y);
}

inline ld dist(Point &point, Polygon &polygon) {
	int s = polygon.size();
	
	if (polygon.size() < 5) {
		ld ans = INF;
		for (int c = 0; c < polygon.size(); c++) {
			ans = min(ans, dist(point, 
				Segment(
					polygon[c % s],
					polygon[(c +  1 + s) % s])
				)
			);
		}
		return ans;	
	}
	pii tang = getTangent(point, polygon);
	// cout << "tang" _ point.x _ point.y _ tang.f _ tang.s << endl; 
	int l = 0;
	int r = (tang.s - tang.f + 1 + polygon.size()) % polygon.size();
	int mid;
	
	while (r - l > 1) {
		mid = (l + r) / 2;
		int i = (tang.f + mid) % s;
		ll dstI = dist2(point, polygon[i]);
		ll dstNext = dist2(point, polygon[(i + 1) % s]);
		if (dstI > dstNext) {
			l = mid;
		} else {
			r = mid;
		}
	}

	ld ans = INF;
	for (int c = l - 2; c < l + 3; c++) {
		ans = min(ans, dist(point, 
			Segment(
				polygon[(tang.f + c + s) % s],
				polygon[(tang.f + c + 1 + s) % s])
			)
		);
	}	
	return ans;
}

void solve() {
	int n;
    cin >> n;
    Polygon p(n);
    cin >> p;

    p.reorder();

    ll sX2 = p.areaX2();
    ld s = (ld) sX2 / 2, pr = p.perim();

    int q;
    cin >> q;

    for (int i = 1; i <= q; ++i) {
    	Point P;
    	cin >> P.x >> P.y;

    	if (p.contains(P)) {
    		cout << "0\n";
    		continue;
    	}

    	ld d = dist(P, p);
    	// cout << "i" _ i _ "d" _ d << endl;
    	ld ns = d * d * PI + d * pr;

    	int lef = -1, rig = 30;
    	while (lef + 1 < rig) {
    		int mid = (lef + rig) / 2;
    		if (s * (1ll << mid) -EPS >= ns) {
    			rig = mid;
    		} else {
    			lef = mid;
    		}
    	}

    	cout << rig << "\n";
    }
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        