#pragma region Template
//#define ANGRY_FAST
//#define ANGRY_LONG
//#define ANGRY_LONG128
//#define CUSTOM_RAND
//#define MT_RAND
//#define LOCAL
//#define _GLIBCXX_DEBUG 1
//#pragma optimize( "", on )
//#pragma GCC optimize("Ofast")
//#define FAST_MEM
//#include <sys/mman.h>
#ifdef ANGRY_FAST
#pragma optimize( "", on )
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
//#pragma GCC ivdep
#pragma GCC optimize "Ofast"
#define FAST_MEM
#define NDEBUG
#endif
#include <iostream>
#include <climits>
#include <chrono>
#include <cassert>
#include <list>
#include <iomanip>
#include <iterator>
#include <map>
#include <set>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <list>
#include <unordered_map>
#include <fstream>
#include <memory>
#include <random>
#include <sstream>
#include <deque>
#include <variant>
#include <any>
#include <utility>
#define div DIV_____

using namespace std;

#define PPIIPII pair<PII,PII>
//#define map unordered_map
#define cont continue
// #define int128 int128_t
//#define int128 __int128
#ifndef ANGRY_FAST
#define int long long
#endif
#ifdef ANGRY_LONG
#define int long long
#define float ld
#endif
#ifdef ANGRY_LONG128
#undef int
#define int int128
#endif
#define endl '\n'
#define endlf '\n'<<flush
#define pb push_back
#define pf push_front
#define ins insert
#define x first
#define sz size
#define era erase
#define pp pop_back
#define ppf pop_front
#define y second
#define fori(i, n) for(int i=0;i<(n);++i)
#define fori1(i, n) for(int i=1;i<(n);++i)
#define forir(i, n) for(int i=(n-1);i>=(0);--i)
#define foris(i, n) for(int i=0;i<(n.sz());++i)
#define foriab(i, a, b) for(int i=(a);i<(b);++i)
#define forirab(i, a, b) for(int i=(b)-1;i>=(a);--i)
#define VI vector<int>
#define DI deque<int>
#define VVI vector<VI>
#define VVVI vector<VVI>
#define MSLD map<string, ld>
#define SI set<int>
#define SPII set<PII>
#define VSPII vector<SPII>
#define VPSI vector<PSI>
#define PSI pair<string,int>
#define SP set<PAR>
#define MII map<int, int>
#define MSI map<string, int>
#define PII pair<int, int>
#define PAR PII
#define PIVI pair<int,VI>
#define VPIVI vector<PIVI>
#define VP vector<PAR>
#define PPIII pair<PII,int>
#define VPPIII vector<PPIII>
#define byte unsigned char
#define VB vector<byte>
#define VVB vector<VB>
#define VVP vector<VP>
#define MPIIVVI map<PII,VVI>
#define MPIIPII map<PII,PII>
#define VB vector<byte>
#define VVSI vector<VSI>
#define VSB vector<SB>
#define VVS vector<VS>
#define INF 2000000000000000000LL
#define BIG 1000000LL
#define EPS 1e-8
#define MIMII map<int, MII>
#define VMII vector<MII>
#define MIVI map<int, VI>
#define MISI map<int, SI>
#define MIPII map<int, PII>
#define PILD pair<int,ld>
#define MIVPII map<int, VPII>
#define UMIPII unordered_map<int, PII>
#define wall(x) ((x).begin()), ((x).end())
#define ld long double
//#define MOD 1000000007LL
//#undef MOD
#define MOD 998244353LL
//#define MOD 1000000009LL
#define VPII vector<PII>
#define DPII deque<PII>
#define VVPII vector<VPII>
#define VMIPII vector<MIPII>
#define VUMIPII vector<UMIPII>
#define MPIII map<PII, int>
#define VDB vector<DB>
#define VPIPII vector<PIPII>
#define PIPII pair<int, PII>
#define ava(X) cout<<(X)<<endl;exit(0);
#define VS vector<string>
#define VSI vector<SI>
#define MPIPIII map<PIPII, int>
#define VC vector<char>
#define MBB map<byte, byte>
#define SB set<byte>
#define ret return
#define VPIB vector<PIB>
#define PIB pair<int,byte>
#define VVPIPII vector<VPIPII>
#define DI deque<int>
#define DB deque<byte>
#define DDI deque<DI>
#define DDB deque<DB>
#define MPIISI map<PII,SI>
#define VPN vector<Node*>
#define sstream stringstream
#define what(X) cerr<<(#X)<<" = "<<X<<endlf;

#define abs LCC_ABS
#ifdef MT_RAND
#define rand MT_RAND_RAND
random_device MT_RAND_RD;
mt19937 MT_RAND_GEN(MT_RAND_RD());
uniform_int_distribution<int> MT_RAND_DIST(0, LONG_MAX);
int rand() {
	ret MT_RAND_DIST(MT_RAND_GEN);
}
#endif

#ifdef FAST_MEM
const signed MAX_MEM = 100000000;
signed mpos = 0;
char mem[MAX_MEM];
inline void* operator new(size_t n) {
	mpos += n;
	assert(mpos <= MAX_MEM);
	ret(void*)(mem + mpos - n);
}
void operator delete(void*)noexcept {}
void operator delete(void*, size_t)noexcept {}
#endif

template<class A> bool is_sorted(const A& arr) {
	fori1(i, arr.sz()) {
		if (arr[i - 1] > arr[i]) {
			ret 0;
		}
	}
	ret 1;
}
template<class I> I emgcd(I a, I b, I& x, I& y) {
	pair<I, I> Va({ 1,0 });
	pair<I, I> Vb({ 0,1 });
	while (b) {
		Va.x -= a / b * Vb.x;
		Va.y -= a / b * Vb.y;
		a %= b;
		swap(a, b);
		swap(Va, Vb);
	}
	x = Va.x;
	y = Va.y;
	ret a;
}
template<class I> I mgcd(I a, I b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	ret a;
}
template<class I> I egcd(I a, I b, I& x, I& y) {
	bool as, bs;
	as = bs = 0;
	if (a < 0) {
		a = -a;
		as = 1;
	}
	if (b < 0) {
		b = -b;
		bs = 1;
	}
	I ans = emgcd(a, b, x, y);
	if (as) {
		x = -x;
	}
	if (bs) {
		y = -y;
	}
	ret ans;
}
template<class I> I gcd(I a, I b) {
	if (a < 0) {
		a = -a;
	}
	if (b < 0) {
		b = -b;
	}
	ret mgcd(a, b);
}
template<class I> I lcm(I a, I b) {
	if (a < 0) {
		a = -a;
	}
	if (b < 0) {
		b = -b;
	}
	ret a / gcd(a, b) * b;
}
template<class I> I lcm(I a, I b, I c) {
	ret lcm(lcm(a, b), c);
}
template<class I> I gcd(I a, I b, I c) {
	ret gcd(gcd(a, b), c);
}
template<class A, class B> bool rmax(A& a, const B& b) {
	A t = b;
	if (a < t) {
		a = move(t);
		ret 1;
	}
	ret 0;
}
template<class A, class B> bool rmin(A& a, const B& b) {
	A t = b;
	if (a > t) {
		a = move(t);
		ret 1;
	}
	ret 0;
}
template<class A, class B> bool rset(A& a, const B& b) {
	A t = b;
	if (a != t) {
		a = move(t);
		ret 1;
	}
	ret 0;
}
/*istream& operator>>(istream& i, int128& v) {
	long long x;
	i >> x;
	v = x;
	ret i;
}*/
template<class T, class U> istream& operator>>(istream& i, pair<T, U>& v) {
	ret i >> v.x >> v.y;
}
template<class T, class U> ostream& operator<<(ostream& i, const pair<T, U>& v) {
	ret i << v.x << ' ' << v.y << endl;
}
template<class T> istream& operator>>(istream& i, deque<T>& v) {
	for (auto& x : v) {
		i >> x;
	}
	ret i;
}
template<class T> istream& operator>>(istream& i, vector<T>& v) {
	for (auto& x : v) {
		i >> x;
	}
	ret i;
}
/*ostream& operator<<(ostream& i, const int128& v) {
	long long x = v;
	ret i << x;
}*/
template<class T> ostream& operator<<(ostream& i, const set<T>& v) {
	for (auto& x : v) {
		i << x << ' ';
	}
	ret i << endl;
}
template<class T> ostream& operator<<(ostream& i, const vector<T>& v) {
	for (auto& x : v) {
		i << x << ' ';
	}
	ret i << endl;
}
template<class T> ostream& operator<<(ostream& i, const deque<T>& v) {
	for (auto& x : v) {
		i << x << ' ';
	}
	ret i << endl;
}
template<class T> vector<T>& operator+=(vector<T>& a, const vector<T>& b) {
	for (const auto& x : b) {
		a.pb(x);
	}
	ret a;
}
template<class T> set<T> merge(const set<T>& a, const set<T>& b) {
	set<T> ans;
	for (auto x : a) {
		ans.ins(x);
	}
	for (auto x : b) {
		ans.ins(x);
	}
	ret ans;
}
template<class T> set<T> intersect(const set<T>& a, const set<T>& b) {
	set<T> ans;
	if (a.sz() < b.sz()) {
		for (auto x : a) {
			if (b.count(x)) {
				ans.ins(x);
			}
		}
	}
	else {
		for (auto x : b) {
			if (a.count(x)) {
				ans.ins(x);
			}
		}
	}
	ret ans;
}
int isqrt(int _) {
	assert(_ >= 0);
	int l = 0;
	int r = 1LL << 30;
	while (r - l > 1) {
		int m = l + r >> 1;
		if (m * m <= _) {
			l = m;
		}
		else {
			r = m;
		}
	}
	ret l;
}
PII operator+(PII a, PII b) {
	ret{ a.x + b.x, a.y + b.y };
}
int fpowm(int i, int k) {
	if (k) {
		int t = fpowm((i * i) % MOD, k >> 1);
		if (k & 1) {
			t *= i;
			t %= MOD;
		}
		ret t;
	}
	ret 1;
}
int invm(int k) {
	ret fpowm(k, MOD - 2);
}
int fpow(int a, int b) {
	int _ = 1;
	while (b) {
		if (b % 2 == 1) {
			_ *= a;
		}
		a *= a;
		b /= 2;
	}
	ret _;
}
ld abs(ld x) {
	if (x < 0) {
		ret - x;
	}
	ret x;
}
int abs(int x) {
	if (x < 0) {
		ret - x;
	}
	ret x;
}
int delup(int a, int b) {
	int c = a / b;
	if (a % b) {
		++c;
	}
	ret c;
}
int fpowmod(int a, int k, int MOO) {
	a %= MOO;
	int _ = 1;
	while (k) {
		if (k % 2) {
			_ *= a;
			_ %= MOO;
		}
		k /= 2;
		a *= a;
		a %= MOO;
	}
	ret _;
}
int invmod(int k, int MOO) {
	ret fpowmod(k, MOO - 2, MOO);
}
#define YES cout<<"YES"<<endl;ret;
#define NO cout<<"NO"<<endl;ret;
#define NE1 cout<<"-1"<<endl;ret;
#define ZERO cout<<"0"<<endl;ret;
#define ANS(x) cout<<(x)<<endl;ret;
#define YESNO(x) if(x){YES;}NO;
#define First ANS("First")
#define Second ANS("Second")
#define FirstSecond(x) if(x){First}Second

PII limit_den(int m, int n, int l) {
	int a = n, b = m % n, p = 1, q = 0, r = m / n, s = 1, v = 1;
	while (0 < b && q + a / b * s <= l) {
		int na, nb, np, nq, nr, ns, nv;
		na = b;
		nb = a % b;
		np = r;
		nq = s;
		nr = p + a / b * r;
		ns = q + a / b * s;
		nv = -v;
		a = na;
		b = nb;
		p = np;
		q = nq;
		r = nr;
		s = ns;
		v = nv;
	}
	int t = p + (l - q) / s * r, u = q + (l - q) / s * s;
	if (2 * b * u <= n) {
		ret{ r, s };
	}
	ret{ t, u };
}
struct R {
	int a, b;
	R(int x, int y) {
		assert(y);
		a = x;
		b = y;
		norm();
	}
	R(int x, int y, bool) {
		a = x;
		b = y;
	}
	R(int x) {
		a = x;
		b = 1;
	}
	R() {
		a = 0;
		b = 1;
	}
	R& operator*=(const R& s) {
		a *= s.a;
		b *= s.b;
		ret norm();
	}
	R& operator/=(const R& s) {
		assert(s.a);
		a *= s.b;
		b *= s.a;
		ret norm();
	}
	R& operator+=(const R& s) {
		int x = b;
		a *= s.b;
		b *= s.b;
		a += s.a * x;
		ret norm();
	}
	R& operator-=(const R& s) {
		int x = b;
		a *= s.b;
		b *= s.b;
		a -= s.a * x;
		ret norm();
	}
	R& norm() {
		int d = gcd(a, b);
		a /= d;
		b /= d;
		if (b < 0) {
			a *= -1;
			b *= -1;
		}
		ret* this;
	}
	int intval() {
		ret a / b;
	}
	R& limit_den(int l) {
		PII aa = ::limit_den(a, b, l);
		a = aa.x;
		b = aa.y;
		ret* this;
	}
};
R operator+(R a, const R& b) {
	a += b;
	ret a;
}
R operator-(R a, const R& b) {
	a -= b;
	ret a;
}
R operator*(R a, const R& b) {
	a *= b;
	ret a;
}
R operator/(R a, const R& b) {
	a /= b;
	ret a;
}
bool operator==(const R& a, const R& b) {
	ret a.a == b.a && a.b == b.b;
}
bool operator!=(const R& a, const R& b) {
	ret a.a != b.a || a.b != b.b;
}
bool operator<(const R& a, const R& b) {
	ret a.a* b.b < b.a* a.b;
}
bool operator>(const R& a, const R& b) {
	ret b < a;
}
bool operator<=(const R& a, const R& b) {
	ret !(b < a);
}
bool operator>=(const R& a, const R& b) {
	ret b <= a;
}
ostream& operator<<(ostream& o, const R& r) {
	//ret o<<r.a<<'/'<<r.b<<endl;
	ret o << (((ld)(r.a)) / ((ld)(r.b)));
}
istream& operator>>(istream& i, R& r) {
	int x;
	i >> x;
	r.a = x;
	r.b = 1;
	ret i;
}

#define has holds_alternative
struct suset {
	set<R> sr;
	bool inv = 0;
	suset() {
	}
	suset(const set<R>& srr) {
		sr = srr;
	}
	suset(const set<R>& srr, bool invv) {
		sr = srr;
		inv = invv;
	}
	suset(R r) {
		sr.ins(r);
	}
	suset(R r, bool invv) {
		sr.ins(r);
		inv = invv;
	}
	void ins(R r) {
		if (inv) {
			sr.era(r);
		}
		else {
			sr.ins(r);
		}
	}
	void era(R r) {
		if (inv) {
			sr.ins(r);
		}
		else {
			sr.era(r);
		}
	}
};
suset merge(const suset& a, const suset& b) {
	if (a.inv || b.inv) {
		if (a.inv && b.inv) {
			return suset(intersect(a.sr, b.sr), 1);
		}
		if (a.inv) {
			suset ans = a;
			for (auto x : b.sr) {
				ans.sr.era(x);
			}
			ret ans;
		}
		else {
			suset ans = b;
			for (auto x : a.sr) {
				ans.sr.era(x);
			}
			ret ans;
		}
	}
	ret suset(merge(a.sr, b.sr));
}
suset intersect(suset a, suset b) {
	a.inv ^= 1;
	b.inv ^= 1;
	suset ans = merge(a, b);
	ans.inv ^= 1;
	ret ans;
}
suset invert(suset a) {
	a.inv ^= 1;
	ret a;
}
PII intersect(PII a, PII b) {
	rmin(a.y, b.y);
	rmax(a.x, b.x);
	ret a;
}
bool eq(ld a, ld b) {
	ret abs(a - b) < EPS;
}
bool lo(ld a, ld b) {
	ret a < b && !eq(a, b);
}
bool leq(ld a, ld b) {
	ret a <= b || eq(a, b);
}
bool gr(ld a, ld b) {
	ret a > b && !eq(a, b);
}
bool geq(ld a, ld b) {
	ret a >= b || eq(a, b);
}
void solve();
void precalc();
int intval(ld a) {
	int i = a;
	int d = abs(i - a);
	if (rmin(d, abs(i + 1 - a))) {
		++i;
	}
	if (rmin(d, abs(i - 1 - a))) {
		--i;
	}
	ret i;
}
int pokm(int a) {
	int k = 1;
	int b = a;
	while (b - 1) {
		b *= a;
		b %= MOD;
		++k;
	}
	ret k;
}
/*int phi(int n) {
	int k = __builtin_ctzll(n);
	n >>= k;
	int _ = 1 << k;
	_ -= _ / 2;
	for (int d = 3; d * d <= n; d += 2) {
		int pk = 1;
		while (n % d == 0) {
			n /= d;
			pk *= d;
		}
		_ *= pk - pk / d;
	}
	if (n - 1) {
		_ *= n - 1;
	}
	ret _;
}*/
int sq(int x) {
	ret x* x;
}

int mod(int a, int b) {
	ret(a % b + b) % b;
}
int sum(const VI& v) {
	int _ = 0;
	for (int x : v) {
		_ += x;
	}
	ret _;
}
#define PISI pair<int,SI>
int mex(const vector<int>& v) {
	vector<bool> s(v.size() + 1);
	for (const int& val : v)
		if (val <= v.size())
			s[val] = true;

	for (int i = 0; i < s.size(); ++i)
		if (!s[i]) return i;
	return 0; // v is empty
}

#define VLD vector<ld>
#define VVLD vector<VLD>
void sort(VI& a) {
	sort(wall(a));
}
void sort(PII& a) {
	if (a.y < a.x) {
		swap(a.y, a.x);
	}
}
PII sorted(PII a) {
	if (a.y < a.x) {
		swap(a.y, a.x);
	}
	ret a;
}
/*
int n;
VVI mul(const VVI&a,const VVI&b){
	int x=a.sz();
	int y=b.sz();
	int z=b.back().sz();
	VVI v(x,VI(z));
	fori(i,x){
		fori(j,z){
			fori(k,y){
				v[i][j]+=a[i][k]*b[k][j];
			}
			v[i][j]%=n;
		}
	}
	ret v;
}

VVI id(int n){
	VVI _(n,VI(n));
	fori(i,n){
		_[i][i]=1;
	}
	ret _;
}

VVI fpow(VVI a,int k){
	VVI _=id(a.sz());
	while(k){
		if(k%2){
			_=mul(_,a);
		}
		k/=2;
		a=mul(a,a);
	}
	ret _;
}
*/

#define MYES [](){YES}();
#define MNO [](){NO}();

bool is_prime(int n) {
	if (n < 2) {
		ret 0;
	}
	if (n == 2) {
		ret 1;
	}
	if (n % 2 == 0) {
		ret 0;
	}
	int d = n - 1;
	while (d % 2 == 0)d /= 2;
	int bases[] = { 2,3,5,7,11,13,17,19 };
	for (int a : bases) {
		if (a == n) {
			ret 1;
		}
		int t = d;
		int y = fpowmod(a, t, n);
		while (t - n + 1 && y - 1 && y - n + 1) {
			y = y * y % n;
			t <<= 1;
		}
		if (y != n - 1 && t % 2 == 0) {
			ret 0;
		}
	}
	ret 1;
}
#pragma endregion

///SOLUTION///

/*
int BG=2000000LL;
vector<signed> ps;
vector<bool> is_p;
*/
void precalc() {
	/*
	ret;
	is_p.resize(BG,1);
	ps.reserve(664579);
	is_p[0]=0;
	is_p[1]=0;
	for(signed i=4;i<BG;i+=2){
		is_p[i]=0;
	}
	ps.pb(2);
	for(signed i=3;i<BG;i+=2){
		if(is_p[i]){
			ps.pb(i);
			for(signed j=2*i;j<BG;j+=i){
				is_p[j]=0;
			}
		}
	}
	*/
	//ANS(ps.sz());
}
/*
struct Node {
	Node* l;
	Node* r;
	int s, e;
	int val, del;
	Node(int f, int t) {
		l = r = nullptr;
		s = f;
		e = t;
		val = del = 0;
	}
	int sz() {
		ret e - s;
	}
	void push() {
		if (!l) {
			int m = s + e >> 1;
			l = new Node(s, m);
			r = new Node(m, e);
		}
		l->val += l->sz() * del;
		r->val += r->sz() * del;
		l->del += del;
		r->del += del;
		del = 0;
	}
	void update() {
		val = l->val + r->val;
	}
	int get(int f, int t) {
		if (f >= e) {
			ret 0;
		}
		if (t <= s) {
			ret 0;
		}
		if (f <= s && e <= t) {
			ret val;
		}
		push();
		ret l->get(f, t) + r->get(f, t);
	}
	void add(int f, int t, int x) {
		if (f >= e) {
			ret;
		}
		if (t <= s) {
			ret;
		}
		if (f <= s && e <= t) {
			val += x * sz();
			del += x;
			ret;
		}
		push();
		l->add(f, t, x);
		r->add(f, t, x);
		update();
	}
};

VI pa, pb;

bool isT2(int v, const vector<set<int>>& children, const set<int>& lists) {
	return lists.count(*children[v].begin()) && lists.count(*(children[v].begin()++));
}

VPPIII solve_tree(const VI& t) {

	int n = t.size() + 1;
	set<int> lists, t1, t2;
	vector<set<int>> children(n);
	for (int i = 1; i < n; ++i)
		children[t[i]].insert(i);

	for (int i = 0; i < n; ++i) {
		if (children[i].size == 0)
			lists.insert(i);
	}

	for (int i = 0; i < n; ++i) {
		if (children[i].size == 1 && lists.count(*children[i].begin()))
			t1.insert(i);
		else if (children.size == 1) {
			if (isT2(i, children, lists))
				t2.insert(i);
		}
	}

	int curr = 0; // max

	while (!t1.empty() || !t2.empty()) {
		if (t1.size()) {
			int v = *t1.begin();
			t1.erase(v);
			int child = *children[v].begin();
			lists.erase(child);

			int parent = t[v];
			children[parent].erase(v);
			// Check parent
			if (children[parent].size() == 0) {
				lists.insert(parent);
				int grandParent = t[parent];
				if (children[grandParent].size == 1)
					t1.insert(grandParent);
				else if (isT2(grandParent))
					t2.insert(grandParent);
			}

			
		}
	}
}

*/
struct Node;
set<Node*> nb,nb1,nb2,nb3;
struct Node{
	int num;
	VPN kids;
	Node* p;
	Node(){
		p=nullptr;
	}
	int sz(){
		ret kids.sz();
	}
	Node* k(){
		if(sz()){
			ret kids.back();
		}
		ret nullptr;
	}
	bool t1(){
		ret nb.count(this)&&sz()==1&&k()->sz()==0;
	}
	bool t2(){
		ret nb.count(this)&&sz()==2&&kids[0]->sz()==0&&kids[1]->sz()==0;
	}
	bool t3(){
		ret nb.count(this)&&p&&!p->t2()&&!p->t1()&&!sz();
	}
	void era(Node* n){
		if(kids.back()!=n){
			swap(kids[0],kids[1]);
		}
		kids.pp();
	}
	void pb(Node* n){
		kids.pb(n);
		n->p=this;
	}
	void ins(Node* n) {
		pb(n);
	}
	Node* k(Node*n){
		if(!sz()){
			ret nullptr;
		}
		if(kids.back()!=n){
			ret kids.back();
		}
		ret kids[0];
	}
};

void CHECK(Node* X){
	nb1.era(X);
	nb2.era(X);
	nb3.era(X);
	if(nb.count(X)){
		if(X->t1()){
			nb1.ins(X);
		}else{
			if(X->t2()){
				nb2.ins(X);
			}else{
				if(X->t3()){
					nb3.ins(X);
				}
			}
		}
	}
}
VPPIII solve_tree(VI p,VPN&bamb){
	nb1.clear();
	nb2.clear();
	nb3.clear();
	nb.clear();
	int n=p.sz()+1;
	VPN v(n);
	fori(i,n){
		v[i]=new Node;
		nb.ins(v[i]);
		v[i]->num=i;
	}
	fori1(i,n){
		v[p[i-1]]->pb(v[i]);
	}
	Node* lf=nullptr;
	bamb.pb(v[0]);
	while(bamb.back()->sz()==2){
		bamb.pb(bamb.back()->k());
	}
	if(bamb.back()->sz()==1){
		lf=bamb.back()->k();
	}
	for(auto x:bamb){
		nb.era(x);
		for(auto y:x->kids){
			nb.era(y);
		}
	}
	for(auto x:nb){
		CHECK(x);
	}
	VPPIII ans;
	while(nb3.sz()||nb1.sz()||nb2.sz()){
		if(!lf){
			if(nb3.sz()){
				lf=*nb3.begin();
				auto oldp=lf->p;
				oldp->era(lf);
				bamb.back()->ins(lf);
				nb.era(lf);
				CHECK(lf);
				CHECK(oldp);
				CHECK(oldp->p);
				ans.pb(PPIII(PII(oldp->num,lf->p->num),lf->num));
			}else{
				if(nb2.sz()){
					lf=(*nb2.begin())->k();
					auto oldp=lf->p;
					oldp->era(lf);
					bamb.back()->ins(lf);
					nb.era(lf);
					CHECK(lf);
					CHECK(oldp);
					CHECK(oldp->p);
					ans.pb(PPIII(PII(oldp->num,lf->p->num),lf->num));
				}else{
					lf=(*nb1.begin())->k();
					auto oldp=lf->p;
					oldp->era(lf);
					bamb.back()->ins(lf);
					nb.era(lf);
					CHECK(lf);
					CHECK(oldp);
					CHECK(oldp->p);
					ans.pb(PPIII(PII(oldp->num,lf->p->num),lf->num));
				}
			}
		}else{
			if(nb2.sz()){
				lf=nullptr;
				auto x=*nb2.begin();
				auto oldp=x->p;
				oldp->era(x);
				bamb.back()->pb(x);
				bamb.pb(x);
				bamb.pb(x->k());
				nb.era(x);
				nb.era(x->kids[0]);
				nb.era(x->kids[1]);
				CHECK(x->kids[0]);
				CHECK(x->kids[1]);
				CHECK(x);
				CHECK(oldp);
				CHECK(oldp->p);
				ans.pb(PPIII(PII(oldp->num,x->p->num),x->num));
			}else{
				if(nb1.sz()){
					auto x=*nb1.begin();
					auto oldp=x->p;
					oldp->era(x);
					bamb.back()->pb(x);
					bamb.pb(x);
					lf=x->k();
					nb.era(x);
					nb.era(x->k());
					CHECK(x->k());
					CHECK(x);
					CHECK(oldp);
					CHECK(oldp->p);
					ans.pb(PPIII(PII(oldp->num,x->p->num),x->num));
				}else{
					auto x=*nb3.begin();
					auto oldp=x->p;
					oldp->era(x);
					bamb.back()->pb(x);
					bamb.pb(x);
					lf=nullptr;
					nb.era(x);
					CHECK(x);
					CHECK(oldp);
					CHECK(oldp->p);
					ans.pb(PPIII(PII(oldp->num,x->p->num),x->num));
				}
			}
		}
	}
	ret ans;

}
void solve() {
	//stringstream cin("7 0 3 0 1 3 4");
	//stringstream cin("12 4 0 8 0 2 7 4 2 1 1 8");
	//tringstream cin("12 4 0 8 0 2 7 4 2 1 1 8   8 5 4 2 0 1 5 0 6 2 4");
	int n;
	cin>>n;

	VI pa;
	VPN ba;
	VI pb;
	VPN bb;

	pa.resize(n-1);
	pb.resize(n-1);
	cin>>pa;
	cin>>pb;

	auto ans1 = solve_tree(pa,ba);
	auto ans2 = solve_tree(pb,bb);
	VPII p;
	foris(i,ba){
		p.pb({ba[i]->num,bb[i]->num});
	}
	fori(i,ba.sz()-1){
		p.pb({ba[i]->k(ba[i+1])->num,bb[i]->k(bb[i+1])->num});
	}
	if(ba.back()->sz()){
		p.pb({ba.back()->k()->num,bb.back()->k()->num});
	}
	MII m;
	for(auto x:p){
		m[x.x]=x.y;
	}
	reverse(ans2.begin(), ans2.end());
	for (auto& a : ans2) {
		swap(a.x.x,a.x.y);
		a.x.x=m[a.x.x];
		a.x.y=m[a.x.y];
		a.y=m[a.y];
	}
	ans1+=ans2;
	for (auto x : ans1) {
		cout << x.y << ' ' << x.x.y << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	precalc();
	signed t = 1;
	//cin>>t;
	//srand(time(0));
	//srand(239);
	while (t--) {
		solve();
	}
	ret 0;
}


