#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    long long n, k;
    cin >> n >> k;
    long long s[n], a[n];

    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    double diff = 0;
    for (int i = 0; i < n; i++) {
        diff += (double)labs(a[i] - s[i]) / (double) s[i];
    }

    diff -= (double) k;

    pair<long long, long long> x[n];
    for (int i = 0; i < n; i++) {
        x[i].first = s[i];
        x[i].second = labs(a[i] - s[i]);
    }

    sort(x, x + n);

    long long cnt = 0;
    int pos = 0;
    while (diff > 0) {
        if (diff * x[pos].first > x[pos].second) {
            diff -= (double) x[pos].second / (double) x[pos].first;
            cnt += x[pos].second;
            pos++;
            continue;
        }

        cnt += (long long)(diff * x[pos].first + 0.99999999);
        break;
    }

    cout << cnt << "\n";
}