#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    long long c = 2520;

    long long n, k;
    cin >> n >> k;
    long long s[n], a[n];

    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    long long diff = 0;
    for (int i = 0; i < n; i++) {
        diff += labs(a[i] - s[i]) * c / s[i];
    }

    diff -= k * c;

    pair<long long, long long> x[n];
    for (int i = 0; i < n; i++) {
        x[i].first = s[i];
        x[i].second = labs(a[i] - s[i]);
    }

    sort(x, x + n);

    long long cnt = 0;
    int pos = 0;
    while (diff > 0) {
        if (diff > x[pos].second * c / x[pos].first) {
            diff -= x[pos].second * c / x[pos].first;
            cnt += x[pos].second;
            pos++;
            continue;
        }
        long long y = c / x[pos].first;

        cnt += (diff + y - 1) / y;
        break;
    }

    cout << cnt << "\n";
}