#include <iostream>
#include <cmath>
#include <string>
#include <vector>

using namespace std;

struct vec
{
    double x;
    double y;

    vec(int _x, int _y) : x(_x), y(_y) {}

    vec operator-(vec o) { return vec(x - o.x, y - o.y); }
};

double dist(vec a, vec b)
{
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

double s(vec a, vec b, vec c)
{
    vec ab = a - b, ac = a - c;
    return abs(ab.x * ac.y - ab.y * ac.x);
}

int main()
{
    ios_base::sync_with_stdio(false);
    vector<vec> c;
    // vector<double> l;
    int n, x, y;
    double P = 0, mx = 0;

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> x >> y;
        c.push_back(vec(x, y));
        if (i) {
            double d = dist(c[i], c[i - 1]);
            // l.push_back(d);
            P += d;
            mx = max(mx, d);
        }
    }
    double d = dist(c[0], c[n - 1]);
    // l.push_back(d);
    P += d;
    mx = max(mx, d);

    cout << P - mx << endl;
}
