#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
 
using namespace std;
 
const double eps = 1e-8;
 
struct Point
{
    double x;
    double y;
};
 
 
int main () {
 
    int n; cin >> n;
    vector <Point> nods(n);
    double sum = 0, max_e = 0, x, y;
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        nods[i] = {x, y};
    }
 
    double e;
    for (int i = 0; i < n; i++) {
        int next = (i + 1) % n;
        e = (nods[i].x - nods[next].x) * (nods[i].x - nods[next].x) + (nods[i].y - nods[next].y) * (nods[i].y - nods[next].y);
        sum += sqrt(e);
        if (e - max_e > eps)
        max_e = max(e, max_e);
    }
 
    cout << setprecision(8) << fixed << sum - sqrt(max_e) << '\n';
 
    return 0;
}