#include <iostream>
#include <fstream>
#include <numeric>
#include <algorithm>
#include <utility>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>

#define inf 1e9
#define eps 1e-9

typedef long long ll;

using namespace std;


struct node {
    char val;
    int cnt;
    vector<node*> next;


    node(char _val, int _cnt = 1) : val(_val), cnt(_cnt)
    {}
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n, k;
    bool found, exists;
    node * root = new node('$'), * curNode;
    unordered_map<string, node*> created;
    string name, newName;

    queue<node*> q;

    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> name;    
        newName = name;

        curNode = root;

        for (k = 0; k < name.size(); k++) {
            found = false;
            for (auto kid : curNode->next) {
                if (name[k] == kid->val) {
                    found = true;
                    curNode = kid;
                    break;
                }
            }
            if (!found) break;
        }

        if (curNode == root) {
            for (int j = 0; j < name.size(); ++j) {
                curNode->next.push_back(new node(name[j]));
                curNode = curNode->next.back();
            }
        } else {
            if (k == name.size()) {
                exists = false;
                for (auto kid : curNode->next) {
                    if ('0' + curNode->cnt == kid->val)
                        curNode->cnt = kid->val - '0' + 1;
                }
                newName.push_back('0' + curNode->cnt);
                curNode->next.push_back(new node('0' + curNode->cnt));
                curNode->cnt += 1;
            } else {
                for (int j = k; j < name.size(); ++j) {
                    curNode->next.push_back(new node(name[j]));
                    curNode = curNode->next.back();
                }
            }
        }
        cout << newName << endl;
    }
}