#include <iostream>
#include <fstream>
#include <numeric>
#include <algorithm>
#include <utility>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>

#define inf 1e9
#define eps 1e-9

typedef long long ll;

using namespace std;


struct node {
    char val;
    int cnt;
    unordered_map<char,node*> next;

    node(char _val, int _cnt = 1) : val(_val), cnt(_cnt)
    {}
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n, k;
    node * root = new node('$'), * curNode;
    string name, newName;

    queue<node*> q;

    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> name;    
        newName = name;

        curNode = root;

        k = 0;

        while (k < name.size() && curNode->next[name[k]]) {
            curNode = curNode->next[name[k++]];
        }

        if (curNode == root) {
            for (int j = 0; j < name.size(); ++j) {
                curNode->next[name[j]] = new node(name[j]);
                curNode = curNode->next[name[j]];
            }
        } else {
            if (k == name.size()) {
            
                while (curNode->next['0' + curNode->cnt]) curNode->cnt++;

                newName.push_back('0' + curNode->cnt);
                curNode->next['0' + curNode->cnt] = new node('0' + curNode->cnt);
                curNode->cnt += 1;

            } else {
                for (int j = k; j < name.size(); ++j) {
                    curNode->next[name[j]] = new node(name[j]);
                    curNode = curNode->next[name[j]];
                }
            }
        }
        cout << newName << endl;
    }
}