#include <bits/stdc++.h>

using namespace std;
#define int long long
#define x first
#define y second
#define pt pair<int,int>
const double pi=acos(-1);
double dist(pt u,pt v)
{
    return sqrt(0.0+(u.x-v.x)*(u.x-v.x)+(u.y-v.y)*(u.y-v.y));
}
double sq(vector<pt> v)
{
    double res=0;int n=v.size();
    for(int i=0;i<n;++i)
    {
        res+=(v[i].x*v[(i+1)%n].y-v[(i+1)%n].x*v[i].y);
    }
    return res/2.0;
}
bool ok(pt o,vector<pt> v)
{
    double x=abs(sq({o,v[0],v[1]}))+abs(sq({o,v[1],v[2]}))+abs(sq({o,v[2],v[0]}));
    double y=sq(v);
    return abs(x-y)<1e-2;
}
int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int n;cin>>n;
    vector<pt> a(n);
    for(int i=0;i<n;++i) {cin>>a[i].x>>a[i].y;}
    auto ds=[&](pt o)->double
    {
        int cur=0;
        for(int k=20;k>=0;--k)
        {
            int cur1=(cur+(1<<k))%n;
            int cur2=(cur+(1<<k))%n;
            if(dist(a[cur1],o)<dist(a[cur],o)) cur=cur1;
            if(dist(a[cur2],o)<dist(a[cur],o)) cur=cur2;
        }
        return dist(a[cur],o);
    };
    double s=abs(sq(a));
    double x0=s;double x1=0;double x2=pi;
    for(int i=0;i<n;++i)
    {
        x1+=dist(a[i],a[(i+1)%n]);
    }
    double x[70]={0};
    x[0]=0;
    for(int i=1;i<70;++i)
    {
        double h=1;for(int j=0;j<i;++j) h*=2;
        double d=(-x1+sqrt(x1*x1+4*pi*s*(h-1)))/(2*pi);
        x[i]=d;
    }
    int q;cin>>q;
    while(q--)
    {
        pair<int,int> o;cin>>o.x>>o.y;
        {
        int low=1;int up=(n-1);
        while(up-low>1)
        {
            int mid=(low+up)/2.0;
            vector<pt> h={a[0],a[mid],o};
            if(sq(h)>0)
            {
                low=mid;
            }
            else
            {
                up=mid;
            }
        }
        vector<pt> h={a[0],a[low],a[up]};
        if(ok(o,h))
        {
            cout<<0<<'\n';continue;
        }
        }
        double u=ds(o);
        cout<<lower_bound(x+1,x+70,u)-x<<'\n';
    }
    return 0;
}
