#include <bits/stdc++.h>

using namespace std;
#define int long long
#define x first
#define y second
#define pt pair<int,int>
const double pi=acos(-1);
double dist(pt u,pt v)
{
    return sqrt(0.0+(u.x-v.x)*(u.x-v.x)+(u.y-v.y)*(u.y-v.y));
}
double dist2(pt u,pt v)
{
    return (u.x-v.x)*(u.x-v.x)+(u.y-v.y)*(u.y-v.y);
}
int sq(vector<pt> v)
{
    int res=0;int n=v.size();
    for(int i=0;i<n;++i)
    {
        res+=(v[i].x*v[(i+1)%n].y-v[(i+1)%n].x*v[i].y);
    }
    return res;
}
bool ok(pt o,vector<pt> v)
{
    int x=abs(sq({o,v[0],v[1]}))+abs(sq({o,v[1],v[2]}))+abs(sq({o,v[2],v[0]}));
    int y=abs(sq(v));
    return (x==y);
}
int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int n;cin>>n;
    vector<pt> a(n);
    for(int i=0;i<n;++i) {cin>>a[i].x>>a[i].y;}
    auto dist3=[&](int i,pt o)->double
    {
        i%=n;
        pt u=a[i];pt v=a[(i+1)%n];
        int h1=dist2(u,o);int h2=dist2(v,o);int h3=dist2(u,v);
        if(h1>=h2+h3)
        {
            return sqrt(h2);
        }
        if(h2>=h1+h3)
        {
            return sqrt(h1);
        }
        return abs(sq({o,u,v}))/sqrt(h3);
    };
    auto f=[&](int i,pt o)->double
    {
        pt u1={a[i].x-o.x,a[i].y-o.y};
        pt u2={a[0].x-o.x,a[0].y-o.y};
        return (u1.x*1.0*u2.y-u1.y*1.0*u2.x)/dist(a[i],o);
    };
    auto lef=[&](pt o)->double
    {
        int cur=0;
        for(int k=20;k>=0;--k)
        {
            int cur1=(cur+(1<<k))%n;
            int cur4=((cur-(1<<k))%n+n)%n;
            if(f(cur1,o)<f(cur,o)) cur=cur1;
            if(f(cur4,o)<f(cur,o)) cur=cur4;
        }
        return cur;
    };
    auto ri=[&](pt o)->double
    {
        int cur=0;
        for(int k=20;k>=0;--k)
        {
            int cur1=(cur+(1<<k))%n;
            int cur4=((cur-(1<<k))%n+n)%n;
            if(f(cur1,o)>f(cur,o)) cur=cur1;
            if(f(cur4,o)>f(cur,o)) cur=cur4;
        }
        return cur;
    };
    auto ds=[&](pt o)->double
    {
        int l=lef(o);int r=ri(o);
        if(l>r) r+=n;
        vector<int> in;
        {
        int l1=l;int r1=r;
        while(r1-l1>2)
        {
            int l2=(2*l1+r1)/3;int r2=(l1+2*r1)/3;
            if(dist3(l2,o)<dist3(r2,o))
            {
                r1=r2;
            }
            else
            {
                l1=l2;
            }
        }
        in.push_back(l1);in.push_back(l1+1);in.push_back(l1+2);
        }
        {
        l+=n;
        int l1=r;int r1=l;
        while(r1-l1>2)
        {
            int l2=(2*l1+r1)/3;int r2=(l1+2*r1)/3;
            if(dist3(l2,o)<dist3(r2,o))
            {
                r1=r2;
            }
            else
            {
                l1=l2;
            }
        }
        in.push_back(l1);in.push_back(l1+1);in.push_back(l1+2);
        }
        int cur=in[0];
        for(int i=1;i<in.size();++i)
        {
            if(dist3(in[i],o)<dist3(cur,o)) cur=in[i];
        }
        return dist3(cur,o);
    };
    double s=abs(sq(a))/2.0;
    double x0=s;double x1=0;double x2=pi;
    for(int i=0;i<n;++i)
    {
        x1+=dist(a[i],a[(i+1)%n]);
    }
    double x[70]={0};
    x[0]=0;
    for(int i=1;i<70;++i)
    {
        double h=1;for(int j=0;j<i;++j) h*=2;
        double d=(-x1+sqrt(x1*x1+4*pi*s*(h-1)))/(2*pi);
        x[i]=d;
    }
    int q;cin>>q;
    while(q--)
    {
        pair<int,int> o;cin>>o.x>>o.y;
        {
        int low=1;int up=(n-1);
        while(up-low>1)
        {
            int mid=(low+up)/2;
            vector<pt> h={a[0],a[mid],o};
            if(sq(h)>0)
            {
                low=mid;
            }
            else
            {
                up=mid;
            }
        }
        vector<pt> h={a[0],a[low],a[up]};
        if(ok(o,h))
        {
            cout<<0<<'\n';continue;
        }
        }
        double u=ds(o);
        //cout<<u<<" u "<<endl;
        cout<<lower_bound(x+1,x+70,u)-x<<'\n';
    }
    return 0;
}
/*
4
1 1
3 1
3 3
1 3
4
2 2
1 2
4 1
6 2
*/
/*
4
1 3
1 1
3 1
3 3
4
2 2
1 2
4 1
6 2
*/
