#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
using namespace std;
using dot = pair<double, double>;
using polygon = vector<pair<double, double>>;
double length(dot a, dot b){
  return sqrt((a.first- b.first) * (a.first- b.first) + (a.second- b.second) * (a.second- b.second));
}

int main(){
  int n; cin>>n;
  polygon p(n, {0, 0});
  for(int i=0; i<n; i++){
    cin>>p[i].first >> p[i].second;
  }


  double max = length(p[0], p[n-1]);
  double per = max;
  for(int i=1; i<n; i++){
    per+=length(p[i], p[i-1]);
    if (length(p[i], p[i-1]) > max){
      max = length(p[i], p[i-1]);
    }
  }
  cout<<per-max;

}