
def dfs(node, final, k):
    index = node[0]*n + node[1]
    if node == final:
        return True
    vec = [(1, 0), (0, 1), (-1, 0), (0, -1)]
    if node not in visited:
        visited[index] = True

        for i in range(4):
            new = [node[0]+vec[i][0], node[1]+vec[i][1]]
            if (0 <= new[0] < n) and (0 <= new[1] < m) and (not visited[new[0]*n + new[1]]) and maze[new[0]][new[1]] == '.':
                if dfs(new, final, k):
                    return True
        if k > 0:
            for i in range(4):
                new = [node[0] + vec[i][0] * 2, node[1] + vec[i][1] * 2]
                if (0 <= new[0] < n) and (0 <= new[1] < m) and (not visited[new[0] * n + new[1]]) and maze[new[0]][new[1]] == '.':
                    if dfs(new, final, k-1):
                        return True
        return False


n, m, k = map(int, input().split())
maze = [list(input()) for i in range(n)]
start = list(map(int, input().split()))
final = list(map(int, input().split()))

start[0] -= 1
start[1] -= 1
final[0] -= 1
final[1] -= 1
visited = [False] * (n * m)
res = dfs(start, final, k)

if res:
    print("YES")
else:
    print("NO")
