#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int INF = 1e9;

#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<pair<ll, ll>> sa(n);
    for (int i = 0; i < n; i++) {
        cin >> sa[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> sa[i].second;
    }
    double delta = 0;
    forn(i, n) {
        sa[i].second = abs(sa[i].first - sa[i].second);
        delta += sa[i].second * 1.0 / sa[i].first;
    }
    delta -= k;
    if (delta <= 0) {
        cout << "0\n";
        return;
    }
    sort(all(sa));
//    for(auto [s, a] : sa) cout << '\n' << s << " " << a << '\n';
//    cout << delta << '\n';
    ll ans = 0;
    forn(i, n) {
        if (delta - sa[i].second * 1.0 / sa[i].first <= 0) {
            delta *= sa[i].first;
//            cout << '\n' << ceil(delta) << '\n';
            ans += ceil(delta);
            break;
        }
        else {
            delta -= sa[i].second * 1.0 / sa[i].first;
//            cout << '\n' << sa[i].second << '\n';
            ans += sa[i].second;
        }
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}
