#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int INF = 1e9;

#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

void solve() {
    int n;
    cin >> n;
    vector<ll> dist(n), x(n), y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int i = 0; i < n; i++) {
        ll a = x[i] - x[(i + 1) % n];
        ll b = y[i] - y[(i + 1) % n];
        dist[i] = a * a + b * b;
    }
    sort(dist.begin(), dist.end());
    ld ans = 0;
    for (int i = 0; i < n - 1; i++) {
        ans += sqrt(dist[i]);
    }
    cout << fixed << setprecision(10) << ans;

}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}
