#define _CRT_SECURE_NO_WARNINGS
#define INF 1e9
#define ACC 1e-6
#define FAC_10 3628800
#define ll long long

#include <cassert>
#include <algorithm>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<pair<ll, ll>> a;

    for (int i = 0; i < n; i++) {
        ll s_inp;
        cin >> s_inp;
        a.push_back(make_pair(0, s_inp));
    }

    for (int i = 0; i < n; i++) {
        ll a_inp;
        cin >> a_inp;
        a[i].first = a_inp;
    }

    sort(a.begin(), a.end());

    ll sum = 0;
    for (int i = 0; i < n; i++)
        sum += abs(a[i].second - a[i].first) * (FAC_10 / a[i].second);

    long long res = 0;
    int ind = 0;

    while (sum > k * FAC_10) {
        if (a[ind].first != a[ind].second) {
            if (sum - abs(a[ind].first - a[ind].second) * (FAC_10 / a[ind].second) > k * FAC_10) {
                ll steps = abs(a[ind].first - a[ind].second);
                sum -= steps * (FAC_10 / a[ind].second);
                res += steps;
                a[ind].second = a[ind].first;
            }
            else {
                ll rest = sum - k * FAC_10;
                ll diff = rest / (FAC_10 / a[ind].second);
                res += rest / (FAC_10 / a[ind].second);
                sum -= diff * (FAC_10 / a[ind].second);
            }
        }
        else {
            ind++;
        }
    }

    cout << res;

}
