#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define ok(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)
#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& e : a) in >> e;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a)
{
    for (auto &e : a) {
        out << e << " ";
        if (typeid(T) != typeid(int) && typeid(T) != typeid(long long))
            out << "\n";
    }
    return out;
}

void solve()
{
    ll a, b;
    cin >> a >> b;

    if ((a + b) % 2 == 1)
    {
        cout << "Error\n";
        return;
    }
    ll games = (a + b) / 2;

    if (a >= 2 && b >= 2)
    {
        cout << "Undefined\n";
        return;
    }

    vector<array<ll, 3> > ans;
    for (int z = 0; z <= 1; z++)
    {
        ll dif = (a - b) / 2;
        ll sum = (a + b) - 2 * z;
        sum /= 2;

        if (sum % 2 == 0 && dif % 2 != 0) continue;
        if (sum % 2 != 0 && dif % 2 == 0) continue;
        ll x = (dif + sum) / 2;
        ll y = (sum - dif) / 2;
        if (x >= 0 && y >= 0)
        {
            ans.push_back({x, y, z});
            
        }
    }

    if (ans.size() == 0) cout << "Error\n";
    else if (ans.size() == 1) cout << ans[0][0] << "\n" << ans[0][1] << "\n" << ans[0][2] << "\n";
    else cout << "Undefined\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    double st = clock();
    #endif 

    int t = 1;
    #ifdef tests
    cin >> t;
    #endif
    while (t--)
    {
        solve();
    }

    #ifdef LOCAL
    cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
    #endif 
}
