#define _CRT_SECURE_NO_WARNINGS
#include <assert.h>

#include <algorithm>
#include <array>
#include <string_view>
#include <bitset>
#include <chrono>
#include <fstream>
#include <functional>
#include <iomanip>
#include <variant>
#include <iostream>
#include <map>
#include <numeric>
#include <optional>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <thread>
#include <unordered_map>
#include <unordered_set>
#include <variant>
#include <vector>

using namespace std;
const int MAXN = 3e6;
int Dx[4] = { 1, 0, -1, 0 };
signed main(int argc, char** argv)
{
	int n, k, m;
	cin >> n >> m >> k;
	vector<string> s(n);
	for (auto& e : s) cin >> e;
	int ax, ay, dx, dy;
	cin >> ax >> ay >> dx >> dy; --ax; --ay; --dx; --dy;
	queue<pair<int, int>> p;
	vector<vector<bool>> us(n, vector<bool>(m));
	auto bfs = [&](int ax, int ay) {
		vector<pair<int, int>> pp;
		us[ax][ay] = 1;
		p.push({ ax, ay });
		while (p.size()) {
			auto z = p.front();
			pp.push_back(z);
			p.pop();
			for (int i = 0; i < 4; ++i) {
				int nx = z.first + Dx[i];
				int ny = z.second + Dx[(i + 1) & 3];
				if (nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
				if (s[nx][ny] == '#' || us[nx][ny]) continue;
				us[nx][ny] = 1;
				p.push({ nx, ny });
			}
		}
		return pp;
	};
	bfs(ax, ay);
	vector<pair<int, int>> may;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (s[i][j] != '.' || us[i][j]) continue;
			for (int k = 0; k < 4; ++k) {
				int nx = i + 2 * Dx[k];
				int ny = j + 2 * Dx[(k + 1) & 3];
				if (nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
				if (s[nx][ny] == '#' || !us[nx][ny]) continue;
				may.push_back({ i, j });
			}
		}
	}
	for (int i = 0; i < k; ++i) {
		vector<pair<int, int>> new_may;
		for (auto& e : may) {
			for (auto& x : bfs(e.first, e.second)) {
				for (int i = 0; i < 4; ++i) {
					int nx = x.first + 2 * Dx[i];
					int ny = x.second + 2 * Dx[(i + 1) & 3];
					if (nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
					if (s[nx][ny] == '#' || us[nx][ny]) continue;
					new_may.push_back({ nx, ny });
				}
			}
		}
		swap(new_may, may);
	}
	if (us[dx][dy]) cout << "YES";
	else cout << "NO";
}