#define _CRT_SECURE_NO_WARNINGS
#include <assert.h>

#include <algorithm>
#include <array>
#include <string_view>
#include <bitset>
#include <chrono>
#include <fstream>
#include <functional>
#include <iomanip>
#include <variant>
#include <iostream>
#include <map>
#include <numeric>
#include <optional>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <thread>
#include <unordered_map>
#include <unordered_set>
#include <variant>
#include <vector>

using namespace std;

signed main(int argc, char** argv)
{
	int n;
	cin >> n;
	vector<int> p(n);
	for (int i = 1; i + 1 < n; i++)
	{
		cin >> p[i];
		if (p[i] != 0) p[i] = i - p[i];
		else p[i]--;
	}
	p[0] = -1, p[n - 1] = -1;

	vector<vector<pair<int, int> > > g(2 * n);
	for (int i = 0; i < n; i++)
	{
		if (p[i] == -1)
		{
			for (int j = 1; j <= 5; j++)
			{
				if (i + j < n)
				{
					g[i].push_back({ i + j, 1 });
				}
			}
			if (i + 6 < n)
			{
				g[i].push_back({ i + n + 6, 1 });
			}

			for (int j = 1; j <= 5; j++)
			{
				if (i + j < n)
				{
					g[i + n].push_back({ i + j, 0 });
				}
			}
			if (i + 6 < n)
			{
				g[i + n].push_back({ i + n + 6, 0 });
			}
		}
		else
		{
			g[i].push_back({ p[i], 0 });
			g[i + n].push_back({ p[i] + n, 0 });
		}
	}

	vector<int> dist(2 * n, -1);
	vector<int> prev(2 * n, -1);
	dist[0] = 0;
	deque<int> d;
	d.push_back(0);

	vector<int> vis(2 * n);

	while (d.size())
	{
		int x = d.front();
		d.pop_front();

		if (vis[x])
		{
			continue;
		}
		vis[x] = 1;

		for (auto e : g[x])
		{
			if (e.second == 0)
			{
				if (dist[e.first] == -1)
				{
					dist[e.first] = dist[x];
					prev[e.first] = x;
					d.push_front(e.first);
				}
				else if (dist[e.first] > dist[x])
				{
					dist[e.first] = dist[x];
					prev[e.first] = x;
					d.push_front(e.first);
				}
			}
			else
			{
				if (dist[e.first] == -1)
				{
					dist[e.first] = dist[x] + 1;
					prev[e.first] = x;
					d.push_back(e.first);
				}
			}
		}
	}
	/*
	for (int i = 0; i < n; i++) cout << dist[i] << " "; cout << "\n";
	for (int i = 0; i < n; i++) cout << dist[i + n] << " "; cout << "\n";
	cout << "\n";
	for (int i = 0; i < n; i++) cout << prev[i] << " "; cout << "\n";
	for (int i = 0; i < n; i++) cout << prev[i + n] << " "; cout << "\n";
	cout << "\n";
	*/

	int ans = 1e9;
	if (dist[n - 1] != -1) ans = min(ans, dist[n - 1]);
	if (dist[2 * n - 1] != -1) ans = min(ans, dist[2 * n - 1]);
	if (ans == 1e9) cout << -1 << "\n";
	else cout << ans << "\n";
}