#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const ll INF = 1e9 + 1;
const ll MOD = 1e9 + 7;
ll MAXN = 1e6 + 1;
const ll ALPH = 26;
const ld EPS = 1e-9;
 
#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()
 
void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {
    void solve() {
        ll n, k;
        cin >> n >> k;

        vector<ll> a(n), s(n);

        ll lcd = 1;
        for (int i = 0; i < n; i++) {
            cin >> s[i];
            lcd = (lcd * s[i]) / __gcd(s[i], lcd);
        }

        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        vector<ll> c(n);
        vector<pair<ll, ll> > res;
        ll sum = 0;
        k *= lcd;
        for (int i = 0; i < n; i++) {
            c[i] = lcd / s[i];
            sum += c[i] * abs(a[i] - s[i]);
            res.push_back({c[i], i});
        }
        

        sort(all(res));
        ll ans = 0;
        while (sum > k) {
            ll cur = res.back().first;
            ll idx = res.back().second;
            if (sum - cur * abs(a[idx] - s[idx]) >= k) {
                sum -= cur * abs(a[idx] - s[idx]);
                ans += abs(a[idx] - s[idx]);
            } else {
                ans += (k - sum + abs(a[idx] - s[idx]) - 1) / abs(a[idx] - s[idx]);
                break;
            }
            res.pop_back();
        }

        cout << ans;
    }
};
 
signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}