#include <bits/stdc++.h>
using namespace std;
#define X first
#define Y second

vector<int> bfs01(int s, int N, vector<vector<pair<int, int>>>& g) {
    vector<int> dist(N, 10000000);
    dist[s] = 0;
    deque<int> pending;
    pending.push_back(s);

    while (!pending.empty()) {
        int v = pending.front();
        pending.pop_front();
        for (auto [to, w] : g[v]) {
            if (dist[to] > dist[v] + w) {
                dist[to] = dist[v] + w;
                if (w == 0) {
                    pending.push_front(to);
                } else {
                    pending.push_back(to);
                }
            }
        }
    }

    return dist; 
}


int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> a(n);
    for (auto &i : a) cin >> i;
    pair<int, int> start, finish;
    cin >> start.X >> start.Y;
    cin >> finish.X >> finish.Y;
    start.X--;
    start.Y--;
    finish.X--;
    finish.Y--;
    map<pair<int, int>, int> q;
    vector<pair<int, int>> vertex;
    vector<vector<pair<int, int>>> g;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '.') {
                vertex.push_back({i, j});
                q[{i, j}] = (int)g.size();
                g.push_back({});
            }
        }
    }
    int N = (int)g.size();
    for (int i = 0; i < N; i++) {
        auto [s, t] = vertex[i];
        vector<pair<int, int>> moves0 = {{0, 1}, {0, -1}, {-1, 0}, {1, 0}};
        vector<pair<int, int>> moves1 = {{2, 0}, {0, -2}, {-2, 0}, {0, 2}};
        for (auto [u, v] : moves0) {
            if (q.find({s + u, t + v}) != q.end()) {
                g[i].push_back(make_pair(q[{s + u, t + v}], 0));
            }
        }
        for (auto [u, v] : moves1) {
            if (q.find({s + u, t + v}) != q.end()) {
                g[i].push_back(make_pair(q[{s + u, t + v}], 1));
            }
        }
    }
    vector<int> dist;
    dist = bfs01(q[start], N, g);
    if (dist[q[finish]] <= k) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
