
#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const ll INF = 1e9 + 1;
const ll MOD = 1e9 + 7;
ll MAXN = 1e6 + 1;
const ll ALPH = 26;
const ld EPS = 1e-9;
 
#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()
 
void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {
    vector<vector<int> > g1, g2;
    vector<int> used;
    vector<int> p1;
    vector<int> p2;
    vector<pair<int, int> > ans;

    set<int> leafs;

    void dfs(int v1, int v2) {
        int idx = 0;
        used[v1] = 1;
        cerr << v1 << ' ' << v2 << '\n';
        for (auto to : g2[v2]) {
            if (idx >= size(g1[v1])) {
                int cur = *leafs.begin();
                ans.push_back({v1, cur});
                leafs.erase(cur);

                if (p1[cur] != -1) {
                    g1[p1[cur]].erase(find(all(g1[p1[cur]]), cur));

                    if (size(g1[p1[cur]]) == 0) {
                        leafs.insert(p1[cur]);
                    }
                    g1[v1].push_back(cur);
                }
                dfs(to, cur);
            } else if (used[g1[v1][idx]]) {
                idx++;
                if (idx >= size(g1[v1])) {
                    int cur = *leafs.begin();
                    ans.push_back({v1, cur});
                    leafs.erase(cur);

                if (p1[cur] != -1) {
                    g1[p1[cur]].erase(find(all(g1[p1[cur]]), cur));

                    if (size(g1[p1[cur]]) == 0) {
                        leafs.insert(p1[cur]);
                        }
                    }

                    g1[v1].push_back(cur);
                    dfs(to, cur);
                }
            } else {
                dfs(g1[v1][idx], to);
            }
        }
    }

    void solve() {
        ll n;
        cin >> n;

        g1.resize(n);
        g2.resize(n);
        p1.resize(n, -1);
        p2.resize(n, -1);
        used.resize(n, 0);
        for (int i = 1; i < n; i++) {
            cin >> p1[i];
            g1[p1[i]].push_back(i);
        }

        for (int i = 1; i < n; i++) {
            cin >> p2[i];
            g2[p2[i]].push_back(i);
        }

        for (int i = 0; i < n; i++) {
            if (size(g1[i]) == 0) {
                leafs.insert(i);
            }
        }

        dfs(0, 0);
        
        
        cout << size(ans) << "\n";
        for (auto c : ans) {
            cout << c.second << " " << c.first << "\n";
        }
    }
};
 
signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
