﻿#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <sstream>
#include <numeric>
#include <queue>

using namespace std;

#define int long long

const int inf = 1LL << 60;
const int mod = 1000000007;

template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1, T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    map<string, int> m;
    for (int i = 0; i < q; i++) {
        string s;
        cin >> s;
        if (m.find(s) == m.end()) {
            m[s] = 1;
            cout << s << endl;
        }
        else {
            int x = m[s];
            string out = s;
            while (m.find(out) != m.end()) {
                stringstream ss;
                ss << s << x;
                out = ss.str();
                x++;
            }
            m[s] = x;
            m[out] = 1;
            cout << out << endl;
        }
    }
}