#include <stdio.h>  
#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
 
using namespace std;

struct pt {
	long double x, y;
};

long double dist(pt a, pt b) {
	return pow(pow((a.x - b.x), 2) + pow((a.y - b.y), 2), 0.5);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    long long s1, s2;
    cin >> s1 >> s2;
    s1 *= 2;
    s2 *= 2;
    long long low = 2 * n;
    long long high = 2 * k * n;
    if (n == 1) {
    	if (s1 <= high && s1 >= low && s2 <= high && s2 >= low) {
    		cout << "Equal";
    		return 0;
    	}
    	else if ((s1 < low || s1 > high) && (s2 < low || s2 > high)) {
    		cout << "Equal";
    		return 0;
    	}
    	else if (s1 < low || s1 > high) {
    		cout << "Second";
    		return 0;
    	}
    	else if (s2 < low || s2 > high) {
    		cout << "First";
    		return 0;
    	}
    }
    long long mid = (high + low) / 2; 
    long long diff1 = abs(s1 - mid);
    long long diff2 = abs(s2 - mid);
    // cout << mid << endl;
    if (diff1 > diff2) {
    	cout << "Second";
    }
    if (diff1 == diff2) {
    	cout << "Equal";
    }
    if (diff1 < diff2) {
    	cout << "First";
    }
}