#include <stdio.h>  
#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
 
using namespace std;

struct pt {
	long double x, y;
};

long double dist(pt a, pt b) {
	return pow(pow((a.x - b.x), 2) + pow((a.y - b.y), 2), 0.5);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pt> arr;
    for (int i = 0; i < n; i++) {
    	int x, y;
    	cin >> x >> y;
    	pt p;
    	p.x = x;
    	p.y = y;
    	arr.push_back(p);
    }
    long double ans = 0;
    long double max_d = 0;
    for (int i = 0; i < arr.size(); i++) {
    	long double d = dist(arr[i], arr[(i + 1) % arr.size()]);
    	ans += d;
    	max_d = max(max_d, d);
    }
    ans -= max_d;
    cout << ans;
}