#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <cmath>
#include <complex>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <vector>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) begin(a), end(a)
#define int long long
#define sqr(x) ((x) * (x))

using namespace std;
using ll = long long;

#ifdef _debug
#include "lib/debug.h"
#else
#define debug(...) 42
#endif

const int K = 15;
int sum[K];

int fac = 1 * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10;

void solve() {
  int n, k;
  cin >> n >> k;
  vector<int> s(n);
  forn(i, n) {
    cin >> s[i];
  }
  forn(i, n) {
    int a;
    cin >> a;
    sum[s[i]] += abs(a - s[i]);
  }

  k *= fac;
  int rest = 0;

  for (int d = 1; d <= 10; ++d) {
    rest += sum[d] * (fac / d);
  }

  int res = 0;
  for (int d = 1; d <= 10; ++d) {
    rest -= sum[d] * (fac / d);
    if (rest > k) {
      res += sum[d];
      continue;
    }
    int lim = (k - rest) / (fac / d);
    res += max(0ll, sum[d] - lim);
    break;
  }
  cout << res << "\n";
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  solve();
  return 0;
}