﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
#include <deque>
using namespace std;

#define X real()
#define Y imag()
#define int long long
#define all(X) begin(X), end(X)
#define rall(X) (X).rbegin(), (X).rend()
#define union sedaeda
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

struct node {
	int old_num;
	node *l = nullptr, *r = nullptr;
};

void renumerate(node *v, int k, map<int, node*> &flat) {
	flat[k] = v;
	if (v->l != nullptr)
		renumerate(v->l, 2 * k, flat);
	if (v->r != nullptr)
		renumerate(v->r, 2 * k + 1, flat);
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	int n; cin >> n;
	vector<node*> flata, flatb;
	flata.resize(n); flatb.resize(n);

	for (auto &i : flata)
		i = new node();
	for (auto &i : flatb)
		i = new node();

	for (int i = 1; i < n; i++) {
		int p; cin >> p;
		flata[i]->old_num = i;
		if (flata[p]->l == nullptr)
			flata[p]->l = flata[i];
		else flata[p]->r = flata[i];
	}
	for (int i = 1; i < n; i++) {
		int p; cin >> p;
		flatb[i]->old_num = i;
		if (flatb[p]->l == nullptr)
			flatb[p]->l = flatb[i];
		else flatb[p]->r = flatb[i];
	}
	
	

	map<int, node*> numa, numb;

	renumerate(flata[0], 1, numa);
	renumerate(flatb[0], 1, numb);

	std::set<int> nums;
	for (auto &i : numa)
		nums.insert(i.first);
	vector<pair<int, int>> ans;
	for (auto &i : numb) {
		if (numa.find(i.first) == numa.end()) {
			while(numb.find(*nums.rbegin()) != numb.end())
				nums.erase(*nums.rbegin());

			int num = *nums.rbegin();

			if (i.first % 2 == 0)
				numa[i.first / 2]->l = numa[num];
			else numa[i.first / 2]->r = numa[num];
			
			numa[i.first] = numa[num];
			nums.erase(num);

			ans.push_back({ numa[num]->old_num, numa[i.first / 2]->old_num });
		}
	}
	cout << ans.size() << "\n";
	for (auto &i : ans)
		cout << i.first << " " << i.second << "\n";
	return 0;
}