#include <bits/stdc++.h>

typedef long long ll;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
template <typename T1, typename T2> inline bool chkmin(T1 &x,T2 y){if(y<x){x=y;return 1;}return 0;};
template <typename T1, typename T2> inline bool chkmax(T1 &x,T2 y){if(y>x){x=y;return 1;}return 0;};

using namespace std;

void Input() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

const int INF = 1e9;

int main() {
    Input();

    int n;
    cin >> n;
    vector<int> p(n);

    for (int i = 1; i < n - 1; ++i) {
        cin >> p[i];
    }

    for (int i = 0; i < n; ++i) {
        if (p[i] == 0) p[i] = i;
        else p[i] = p[i - p[i]];
    }

    /* for (int i : p) */
    /*     cerr << i << ' '; */
    /* cerr << endl; */

    deque<int> q;
    vector<int> dist(n, INF);
    dist[0] = 0;
    q.push_back(0);

    while(!q.empty()) {
        int cur = q.front();
        q.pop_front();

        auto turns = [&p, n] (int cur) {
            vector<pair<int, int>> res;
            for (int i = cur + 1; i < min(cur + 6, n); ++i) {
                res.emplace_back(p[i], 1);
            }
            if (cur + 6 < n) {
                res.emplace_back(p[cur + 6], 0);
            }
            return res;
        };

        for (auto [i, cost] : turns(cur)) {
            /* cerr << dist[i] << ' ' << dist[cur] << ' ' <<  cost << endl; */
            if (chkmin(dist[i], dist[cur] + cost)) {
                if (cost == 0)
                    q.emplace_front(i);
                else
                    q.emplace_back(i);
            }
        }
    }

    cout << (dist[n - 1] == INF ? -1 : dist[n - 1]) << endl;
    return 0;
}