#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#if LOCAL
#define dbg(o) ({ cout << #o << " = " << (o) << "\n"; o; })
#else
#define dbg(o) (o)
#endif

#define ff first
#define ss second
#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
ll rng(ll l, ll r) { return uniform_int_distribution<ll> (l, r) (rnd); }

void vendory() {}

void sol() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 1; i < n - 1; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) a[i] = i;
        else a[i] = a[i - a[i]];
    }
    vector<vector<int>> graf(n);
    vector<int> d(n, 1e9);
    for (int i = 0; i < n; i++) {
        for (int k = 5; k >= 1; k--) {
            graf[i].emplace_back(a[min(i + k, n - 1)]);
        }
    }
    queue<int> q;
    q.emplace(0);
    d[0] = 0;

    vector<bool> six(n);
    function<void(int, int)> try_six = [&](int v, int upd) {
        if (six[v])
            return;
        six[v] = true;
        int nxt = a[min(v + 6, n - 1)];
        if (d[nxt] == 1e9) {
            d[nxt] = upd;
            q.emplace(nxt);
        }
        for (auto &i: graf[nxt]) {
            if (d[i] == 1e9) {
                d[i] = upd;
                q.emplace(i);
            }
        }
        try_six(nxt, upd);
    };

    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        try_six(v, d[v] + 1);
        for (auto &i : graf[v]) {
            if (d[i] == 1e9) {
                d[i] = d[v] + 1;
                q.emplace(i);
            }
        }
    }
    if (d[n - 1] == 1e9) cout << -1 << '\n';
    else cout << d[n - 1] << '\n';
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#if LOCAL
    freopen("../D/input.txt", "r", stdin);
    vendory();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cout << "\n================================ " << i << " ================================" << endl;
        sol();
    }
#else
    vendory();
    sol();
#endif
    return (0-0);  // <3
}