#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#if LOCAL
#define dbg(o) ({ cout << #o << " = " << (o) << "\n"; o; })
#else
#define dbg(o) (o)
#endif

#define ff first
#define ss second
#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
ll rng(ll l, ll r) { return uniform_int_distribution<ll> (l, r) (rnd); }

void vendory() {}

vector<pii> answer;

void query(int v, int u) {
    answer.emplace_back(v, u);
}

struct a {
    int root;
    vector<int> p;
    vector<int> cnt;
    vector<int> v;
    queue<int> leafs;

    void update_leafs() {
        leafs = queue<int>();
        for (auto &i: v) {
            if (cnt[i] == 0) {
                leafs.push(i);
            }
        }
    }

    int get_leaf() {
        int u = leafs.front();
        leafs.pop();
        cnt[p[u]]--;
        if (cnt[p[u]] == 0) {
            leafs.push(p[u]);
        }
        return u;
    }

    int rebuild() {
        if (cnt[root] == 0)
            return -1;
        vector<int> son;
        for (auto &i: v) {
            if (p[i] == root) {
                son.emplace_back(i);
            }
        }

        if (son.size() == 1) {
            int tmp_root = root;
            root = son[0];
            return tmp_root;
        }
        vector<vector<int>> graf(p.size());
        for (auto &i: v) {
            if (i != root) {
                graf[p[i]].emplace_back(i);
            }
        }
        v.clear();
        function<int(int)> find_leaf = [&](int u) -> int {
            v.emplace_back(u);
            if (graf[u].empty())
                return u;
            int leaf;
            for (auto &i: graf[u]) {
                leaf = find_leaf(i);
            }
            return leaf;
        };
        function<void(int)> add_missing = [&](int u) {
            v.emplace_back(u);
            for (auto &i: graf[u])
                add_missing(i);
        };
        add_missing(son[0]);
        int tmp_root = root;
        root = son[1];
        int leaf = find_leaf(root);
        p[son[0]] = leaf;
        cnt[leaf]++;
        query(son[0], leaf);
        update_leafs();
        return tmp_root;
    }

    explicit a(vector<int> &p) : root(0), p(p) {
        v.resize(p.size());
        iota(all(v), 0);
        cnt.resize(p.size());
        for (int i = 1; i < (int) p.size(); i++) {
            cnt[p[i]]++;
        }
        update_leafs();
    }
};

vector<vector<int>> b;

void subiso(int v, int p, a &tree) {
    int now = tree.get_leaf();
    query(now, p);
    for (auto &i: b[v]) {
        subiso(i, now, tree);
    }
}

void iso(int v, a &tree) {
    int last_root = tree.rebuild();
    if (b[v].empty())
        return;
    if (b[v].size() == 1) {
        iso(b[v][0], tree);
        return;
    }
    subiso(b[v][0], last_root, tree);
    iso(b[v][1], tree);
}

void sol() {
    answer.clear();
    b.clear();
    int n;
    cin >> n;
    vector<int> pa(n, -1), pb(n, -1);
    for (int i = 1; i < n; i++) cin >> pa[i];
    for (int i = 1; i < n; i++) cin >> pb[i];
    b.resize(n);
    for (int i = 1; i < n; i++)
        b[pb[i]].emplace_back(i);
    a tree(pa);
    iso(0, tree);
    assert(answer.size() <= n);
    cout << answer.size() << '\n';
    for (auto &[v, u]: answer) {
        cout << v << ' ' << u << '\n';
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#if LOCAL
    freopen("../D/input.txt", "r", stdin);
    vendory();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cout << "\n================================ " << i << " ================================" << endl;
        sol();
    }
#else
    vendory();
    sol();
#endif
    return (0-0);  // <3
}