

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.security.KeyPair;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.PriorityQueue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.stream.Collectors;
import javax.lang.model.type.ArrayType;
import javax.swing.JInternalFrame;


public class Main {


  public static void main(String[] args) {
    MyScanner sc = new MyScanner();
    PrintWriter out = new PrintWriter(System.out);
    long n = sc.nextInt();
    long k = sc.nextInt();
    long s1 = sc.nextInt();
    long s2 = sc.nextInt();

    if(s1 < n || s1 > n*k) {
      if(s2 < n || s2 > n*k) {
        System.out.println("Equal");
      } else {
        System.out.println("Second");
      }
    } else if(s2 < n || s2 > n*k) {
      System.out.println("First");
    } else {
      if(s1 == s2) System.out.println("Equal");
      else if(s1 < s2) {
        if((s1 - n) > (n*k - s2)) {
          System.out.println("First");
        } else if((s1 - n) < (n*k - s2)) {
          System.out.println("Second");
        } else {
          System.out.println("Equal");
        }
      } else {
        if((s1 - n) > (n*k - s2)) {
          System.out.println("Second");
        } else if((s1 - n) < (n*k - s2)) {
          System.out.println("First");
        } else {
          System.out.println("Equal");
        }
      }
    }

  }




  static Random rand = new Random();

  //-----------PrintWriter for faster output---------------------------------
  public static PrintWriter out;

  //-----------MyScanner class for faster input----------
  public static class MyScanner {

    BufferedReader br;
    StringTokenizer st;

    public MyScanner() {
      br = new BufferedReader(new InputStreamReader(System.in));
    }

    String next() {
      while (st == null || !st.hasMoreElements()) {
        try {
          st = new StringTokenizer(br.readLine());
        } catch (IOException e) {
          e.printStackTrace();
        }
      }
      return st.nextToken();
    }

    int nextInt() {
      return Integer.parseInt(next());
    }

    long nextLong() {
      return Long.parseLong(next());
    }

    double nextDouble() {
      return Double.parseDouble(next());
    }

    String nextLine() {
      String str = "";
      try {
        str = br.readLine();
      } catch (IOException e) {
        e.printStackTrace();
      }
      return str;
    }

  }


}