

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.security.KeyPair;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.PriorityQueue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.stream.Collectors;
import javax.lang.model.type.ArrayType;
import javax.swing.JInternalFrame;


public class Main {


  public static void main(String[] args) {
    MyScanner sc = new MyScanner();
    PrintWriter out = new PrintWriter(System.out);
    int n = sc.nextInt();
    int k = sc.nextInt();
    int[] a = new int[n];
    int[] s = new int[n];
    double r = 0;
    long[] parts = new long[11];
    for(int i = 0;i<n;i++) {
      s[i] = sc.nextInt();
    }
    for(int i = 0;i<n;i++) {
      a[i] = sc.nextInt();
      parts[s[i]] += Math.abs(a[i] - s[i]);
      r += (Math.abs(a[i] - s[i])*1.0d)/(s[i]*1.0d);
    }
    r-=k;
    int answer = 0;
    for(int i = 1;i<=10;i++) {
      if(r <= 0) break;
      if((parts[i]*1.0d)/(1.0d*i) >= r) {
        long t = (long) (r*i);
        if((t*1.0d)/(i*1.0d) < r) t++;
        if((t*1.0d)/(i*1.0d) < r) t++;
        answer += t;
        break;
      } else {
        answer += parts[i];
        r -= (parts[i]*1.0d)/(1.0d*i);
      }
    }
    System.out.println(answer);



  }




  static Random rand = new Random();

  //-----------PrintWriter for faster output---------------------------------
  public static PrintWriter out;

  //-----------MyScanner class for faster input----------
  public static class MyScanner {

    BufferedReader br;
    StringTokenizer st;

    public MyScanner() {
      br = new BufferedReader(new InputStreamReader(System.in));
    }

    String next() {
      while (st == null || !st.hasMoreElements()) {
        try {
          st = new StringTokenizer(br.readLine());
        } catch (IOException e) {
          e.printStackTrace();
        }
      }
      return st.nextToken();
    }

    int nextInt() {
      return Integer.parseInt(next());
    }

    long nextLong() {
      return Long.parseLong(next());
    }

    double nextDouble() {
      return Double.parseDouble(next());
    }

    String nextLine() {
      String str = "";
      try {
        str = br.readLine();
      } catch (IOException e) {
        e.printStackTrace();
      }
      return str;
    }

  }


}