#include <iostream>
#include <vector>
int n;
std::vector <int> p;

int main() {
    std::cin >> n;
    p.resize(n + 1, 0);
    for (int i = 2; i <= n - 1; i++) {
        std::cin >> p[i];
    }
    std::vector <int> last(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        if (p[i] != 0) {
            last[i] = last[i - p[i]];
        } else {
            last[i] = i;
        }
    }
    std::vector <int> dist(n + 1, 10000000);
    dist[1] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 1; j <= 5; j++) {
            int next1 = last[std::min(n, i + j)];
            dist[next1] = std::min(dist[next1], dist[i] +  1);
        }
        std::vector <int> visited(n + 1, 0);
        int next = i + 6;
        int d = dist[i] + 1;
        while (next <= n && !visited[next]) {
            visited[next] = 1;
            next = last[std::min(n, next)];
            for (int j = 1; j <= 5; j++) {
                int next1 = last[std::min(n, next + j)];
                dist[next1] = std::min(dist[next1], d);
            }
            next += 6;
            d++;
        }
    }
    if (dist[n] == 10000000) {
        std::cout << "-1";
    } else {
        std::cout << dist[n];
    }
}