#include <iostream>
#include <utility>
#include <cstdint>

using namespace std;

bool validate(int64_t L, int64_t R, int64_t d, pair<int64_t, int64_t> &answer) {
    int64_t a = (L / d) * d; // первое число после L, делящееся на d
    if (a < L) {
        a += d;
    }
    int64_t b = a + d;
    if (L <= a && b <= R) {
        answer = {a, b};
        return true;
    }
    return false;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int64_t L, R;
    cin >> L >> R;

    int64_t to = R - L;
    pair<int64_t, int64_t> answer;
    for (int64_t d = to; d >= 1; --d) {
        if (validate(L, R, d, answer)) {
            cout << answer.first << ' ' << answer.second << endl;
            return 0;
        }
    }
    return 0;
}
