def calculate_prob(N, K, S):
    dp = [[0] * (S + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for n in range(1, N + 1):
        for s in range(1, S + 1):
            for i in range(1, K + 1):
                if s - i >= 0:
                    dp[n][s] += dp[n - 1][s - i]

    return dp[N][S]

N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

probability_S1 = calculate_prob(N, K, S1)
probability_S2 = calculate_prob(N, K, S2)

if probability_S1 > probability_S2:
    print("First")
elif probability_S2 > probability_S1:
    print("Second")
else:
    print("Equal")