#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    long double eps = 1e-7;

    int n, k;
    cin >> n >> k;

    vector<int> s(n);
    vector<pair<int, int>> v;

    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    int t;
    long double deviation = 0;
    for (int i = 0; i < n; ++i) {
        cin >> t;
        if (t != s[i]) {
            v.push_back(make_pair(s[i], t));
            deviation += abs(s[i] - t) * 1.0 / s[i];
        }
    }

    sort(v.begin(), v.end());

    double x;
    long long ans = 0;
    for (int i = 0; i < v.size(); ++i) {
        x = abs(v[i].first - v[i].second) * 1.0 / v[i].first;
        if (k + eps < deviation - x) {
            deviation -= x;
            ans += abs(v[i].first - v[i].second);
        }
        else {
            if (abs(deviation - x - k) < eps) {
                ans += abs(v[i].first - v[i].second);
            }
            else {
                ans += max((abs(v[i].first - v[i].second) - v[i].first * (x - deviation + k)), (long double)1.0);
            }
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
