#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    long double eps = 1e-7;

    long long n, k;
    cin >> n >> k;

    vector<int> s(n);
    vector<pair<int, int>> v;

    int lcm = 2520;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    int t;
    long long deviation = 0;
    for (int i = 0; i < n; ++i) {
        cin >> t;
        if (t != s[i]) {
            v.push_back(make_pair(s[i], t));
            deviation += abs(s[i] - t) * 1LL * lcm / s[i];
        }
    }

    sort(v.begin(), v.end());

    long long x;
    long long ans = 0;
    for (int i = 0; i < v.size(); ++i) {
        x = abs(v[i].first - v[i].second) * 1ll * lcm / v[i].first;
        if (k * lcm < deviation - x) {
            deviation -= x;
            ans += abs(v[i].first - v[i].second);
        }
        else {
            if (deviation - x - k == 0) {
                ans += abs(v[i].first - v[i].second);
            }
            else {
                ans += (abs(v[i].first - v[i].second) - v[i].first * 1LL * (x - deviation + lcm * k) / lcm);
            }
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
