#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;



int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	long double x0, y0;
	cin >> x0 >> y0;
	long double px(x0), py(x0);

	long double x, y;
	long double res = 0;
	long double max_edge = 0;
	long double cur_edge;

	for (int i = 1; i < n; ++i) {
		cin >> x >> y;
	
		cur_edge = sqrt((x - px) * (x - px) + (y - py) * (y - py));
		max_edge = max(cur_edge, max_edge);
		res += cur_edge;
		px = x;
		py = y;
	}

	cur_edge = sqrt((x - x0) * (x - x0) + (y - y0) * (y - y0));
	max_edge = max(cur_edge, max_edge);
	res += cur_edge;
	res -= max_edge;


	printf("%.12f\n", res);

	return 0;
}

