#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,abm,mmx,avx,tune=native")
// #pragma GCC target("avx,avx2")
// #pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define m_p make_pair
#define pii pair <int, int>
#define YES cout << "YES\n"
#define NO cout << "NO\n"
#define vi vector<int>
#define vii vector<pii>
#define vvi vector<vector<int> >
#define mii map<int, int>
const int INF = 1000000007;
const ll INF2 = 100000000000000007;
const int MOD1 = 998244353;
const int MOD = 1000000007;
const int SIZE = 1000010;
const int base = 53;
const long double eps = 1e-6;
const long double pi = acosl(-1.0);
ll add(ll a, ll b) {
    return ((a + b) % MOD + MOD) % MOD;
}
ll mult(ll a, ll b) {
    return (((a % MOD) * (b % MOD)) % MOD + MOD) % MOD;
}
ll binpowmod(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) res = mult(res, a);
        a = mult(a, a);
        n >>= 1;
    }
    return res;
}
ll binpow(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
        }
        a *= a;
        n >>= 1;
    }
    return res;
}
ll inv(ll a) {
    return binpowmod(a, MOD - 2);
}
ll del(ll a, ll b) {
    return mult(a, inv(b));
}
ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}
ll lcm(ll a, ll b) {
    return a * b / gcd(a, b);
}

vector<string> table;
vector<vector<int> > g, colors;
queue<pii> q;
vector<vector<bool> > used;
int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
int megaX[4] = {2, 0, -2, 0};
int megaY[4] = {0, 2, 0, -2};

bool exist(int x, int y) {
    if (x < 0 || x >= table.size() || y < 0 || y >= table[0].size()) return false;
    return true;
}

void bfs(int startX, int startY, int color) {
    q.push({startX, startY});
    used[startX][startY] = true;
    g.push_back(vector<int>());
    while (!q.empty()) {
        pii p = q.front();
        colors[p.first][p.second] = color;
        q.pop();
        for (int i = 0; i < 4; ++i) {
            int toX = p.first + dx[i];
            int toY = p.second + dy[i];
            if (exist(toX, toY) && table[toX][toY] != '#' && !used[toX][toY]) {
                q.push({toX, toY});
                used[toX][toY] = true;
            }
            toX = p.first + megaX[i];
            toY = p.second + megaY[i];
            if (exist(toX, toY) && table[toX][toY] != '#' && colors[toX][toY] && colors[toX][toY] < color) {
                g[color - 1].push_back(colors[toX][toY] - 1);
                g[colors[toX][toY] - 1].push_back(color - 1);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG   
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    double cl = clock();
#endif

    long long n, m;
    cin >> n >> m;

    long long a = m - 1, b = m;
    long long ans = 1;
    for (long long i = 2; i <= 1000000; ++i)
    {
        long long b1 = m - (m % i);
        long long a1 = b1 / (i) * (i - 1);
        long long gc = b1 / i;
        if (n <= b1 && m >= b1 && n <= a1 && m >= a1)
        {
            if (gc > ans)
            {
                ans = gc;
                a = a1;
                b = b1;
            }
        }
    }
    cout << a << " " << b;

#ifdef DEBUG
    cout << "\n\n" << fixed << (clock() - cl) / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}