﻿#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <cmath>
#include <iomanip>

typedef long long ll;

FILE* stream;

int main()
{
	//freopen_s(&stream, "input.txt", "r", stdin);

	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	
	int n;
	std::cin >> n;

	std::vector <std::pair<int, int>> mas;

	for (int i = 0; i< n; i++)
	{
		int x, y;
		std::cin >> x >> y;
		mas.push_back({ x,y });
	}

	double sum =0 ;
	double max = 0;

	for (int i = 1; i < n; i++)
	{
		double t = std::sqrt( (mas[i].first-mas[i-1].first) * (mas[i].first - mas[i - 1].first) + (mas[i].second - mas[i - 1].second) * (mas[i].second - mas[i - 1].second));
		sum += t;
		if (t - max > 2.2204460492503131e-016) {
			max = t;
		}
	}

	double t = std::sqrt((mas[0].first - mas[n-1].first) * (mas[0].first - mas[n - 1].first) + (mas[0].second - mas[n - 1].second) * (mas[0].second - mas[n - 1].second));
	sum += t;
	if (t - max > 2.2204460492503131e-016) {
		max = t;
	}
	sum -= max;

	std::cout<< std::fixed << std::setprecision(6) << sum ;

}
