#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <time.h>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

struct point {
    int x, y;
    point() {}
    point(int x, int y): x(x), y(y) {}

    void init() {
        cin >> x >> y;
    }
    long double length() {
        return sqrtl(x * x + y * y);
    }
    point operator - (point other) {
        return point(x - other.x, y - other.y);
    }
};

signed main() {
#ifdef LOCAL
    //freopen("in_vanya.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(10);
    int n;
    cin >> n;
    vector <point> p(n);
    for (int i = 0; i < n; i++) p[i].init();
    long double sm = 0, maxi = 0;
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        long double cur = (p[j] - p[i]).length();
        maxi = max(maxi, cur);
        sm += cur;
    }
    cout << fixed << sm - maxi << endl;
    return 0;
}