#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> s(n), a(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = {s[i], a[i]};
    }
    sort(v.begin(), v.end(),
         [](pair<int, int> a, pair<int, int> b){
            return a.first < b.first;
    });
    double ex = 0;
    for (int i = 0; i < n; ++i) {
        ex += abs(s[i] - a[i]) / (double)s[i];
    }
    double cur = ex;
    int j = 0;
    long long ans = 0;
    while (cur > k) {
        cur -= abs(v[j].first - v[j].second) / (double)v[j].first;
        ans += abs(v[j].first - v[j].second);
        j++;
    }
    j--;
    if (j < 0){
        cout << 0;
        return 0;
    }
    ans -= abs(v[j].first - v[j].second);
    cur += abs(v[j].first - v[j].second) / (double)v[j].first;
    long long l = 0, r = abs(v[j].first - v[j].second);
    while (r - l != 1) {
        long long m = (r + l) / 2;
        if (cur - m / (double)v[j].first > k)
            l = m;
        else
            r = m;
    }
    cout << ans + r;
}