﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>

using namespace std;
typedef long long ll;


double per(double x, double y, double x1, double y1)
{
	return sqrt(abs(x - x1) * abs(x - x1) + abs(y - y1) * abs(y - y1));
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	double sum = 0;
	double x1, y1;
	bool start = false;
	double xst, yst;
	double maxi = -1;
	for (ll i = 0; i < n; i++)
	{
		double x, y;
		cin >> x >> y;
		if (!start)
		{
			xst = x; yst = y;
			x1 = x; y1 = y;
			start = true;
		}
		else
		{
			if (i == n - 1)
			{
				double one= per(x1, y1, x, y),two= per(x, y, xst, yst);
				sum += one;
				sum += two;
				x1 = x;y1 = y;
				maxi = max(maxi, two);
				maxi = max(maxi, one);
			}
			else
			{
				double one = per(x1, y1, x, y);
				sum += one;
				x1 = x;y1 = y;
				maxi = max(maxi, one);
			}
			
		}
	}
	sum -= maxi;
	//sum = round(sum * 1000000) / 1000000;
	std::cout << std::fixed;
	std::cout << std::setprecision(6);
	std::cout << sum;

	return 0;
}
