#include <iostream>
#include <fstream>
#include <algorithm> 
#include <string>
#include <cmath>
#include <vector>
using namespace std;

int main(){
    ifstream in("input.txt");
    int n;
    int inf = 1000000000;
    in >> n;
    vector<int> a(n, 0);
    for(int i = 1;i <= n - 2;i++){
        in >> a[i];
    }
    vector<int> depth(n, inf);
    vector<int> portal;
    vector<int> diff(n, 1);
    depth[0] = 0;
    for(int i = 0;i < n;i++){
        if(a[i] == 0){
            portal.push_back(i);
        } else{
             portal.push_back(portal[i - a[i]]);
        }
    }
    for(int i = 0; i < n;i++){
        if (a[i] != 0 || (depth[i] == inf)){
            continue;
        }

        for(int j = 1;j <= min(6, n - 1 - i);j++){
            // cout << i << " " << j << endl;
            if (j == 6){
                diff[portal[i + j]] = 0;
            }
            // if (i == 0 && j == 6){
            //     cout << i << " " << j << " " << portal[i + j] << " " << depth[i] << " " << diff[i] << endl;
            // }
            depth[portal[i + j]] = min(depth[i] + diff[i], depth[portal[i + j]]);
        }
        if (depth[0] == 1){
            cout << i << endl;
        }
    }

    // cout << endl;
    // for(int i =0;i < n;i++){
    //     cout << diff[i] << " ";
    //     // cout << a[i] << " " << depth[i] << endl;
    // }
    // cout << endl;
    // for(int i =0;i < n;i++){
    //     cout << depth[i] << " ";
    //     // cout << a[i] << " " << depth[i] << endl;
    // }
    // cout << endl;
    // for(int i =0;i < n;i++){
    //     cout << portal[i] << " ";
    //     // cout << a[i] << " " << depth[i] << endl;
    // }
    // cout << endl;
    // cout << depth[n - 1] << endl;
    if (depth[n - 1] == inf){
        cout << -1;
    } else {
        cout << depth[n - 1];
    }
    in.close();
    return 0;
}