#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <iomanip>

using namespace std;

#define ll long long

int solve();

int main() {
    solve();
    return 0;
}

ll FACTORIAL = 2520;

int solve() {
    int n; ll k;
    cin >> n >> k;
    k *= FACTORIAL;
    std::vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> v[i].second;
    }
    sort(v.begin(), v.end());
    ll cur_k = 0;
    for (int i = 0; i < n; i++) {
        cur_k += (FACTORIAL * abs(v[i].first - v[i].second)) / v[i].first;
    }
    if (cur_k <= k) {
        cout << 0 << endl;
        return 0;
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll d = (FACTORIAL * abs(v[i].first - v[i].second)) / v[i].first;
        if (cur_k - d > k) {
            cur_k -= d;
            ans += abs(v[i].first - v[i].second);
            continue;
        }
        ans += (cur_k - k) * v[i].first / FACTORIAL;
        if (((cur_k - k) * v[i].first) % FACTORIAL != 0) {
            ans += 1;
        }
        break;
    }
    cout << ans << endl;
    return 0;
}
