#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <queue>

using namespace std;

#define ll long long

int solve();

int main() {
    solve();
    return 0;
}

int solve() {
    int n;
    cin >> n;
    int p1[1000];
    int p2[1000];
    int d1[1000];
    for (int i = 0; i < n; i++) {
        d1[i] = 0;
    }
    for (int i = 1; i < n; i++) {
        cin >> p1[i];
        d1[p1[i]]++;
    }
    for (int i = 1; i < n; i++) {
        cin >> p2[i];
    }

    vector<pair<int, int>> ans;

    while (true) {
        bool f = true;
        for (int v = 1; v < n && f; v++) {
            if (p1[v] == p2[v])
                continue;
            int fromU = p1[v];
            int toU = p2[v];
            if (d1[toU] < 2) {
                int t = toU;
                bool flagIsChild = false;
                while (t > 0) {
                    t = p1[t];
                    if (t == v) {
                        flagIsChild = true;
                    }
                }
                if (flagIsChild == false) {
                    ans.push_back({v, toU});
                    //cout << v << " " << toU << "\n";
                    p1[v] = toU;
                    d1[fromU]--;
                    d1[toU]++;
                    f = false;
                    break;
                }
            }
        }
        if (!f)
            continue;

        //cout << 1;
        int a = -1;
        int b = -1;
        int dt[1000];
        queue<int> q;
        for (int i = 0; i < n; i++) {
            dt[i] = d1[i];
            if (dt[i] == 0) {
                q.push(i);
            }
        }
        //cout << 2;
        while (!q.empty()) {
            int cur = q.front();
            //cout << cur << "\n";
            q.pop();
            if (p1[cur] != p2[cur]) {
                a = cur;
                break;
            }
            if (cur != 0) {
                dt[p1[cur]]--;
                if (cur != 0 && dt[p1[cur]] == 0)
                    q.push(p1[cur]);
            }
        }
        //cout << 3;
        for (int i = 1; i < n; i++) {
            if (dt[i] == 0) {
                int t = i;
                int flagIsChild = false;
                while (t != 0) {
                    if (t == a){
                        flagIsChild = true;
                        break;
                    }
                    t = p1[t];
                }
                if (flagIsChild)
                    continue;
                b = i;
                break;
            }
        }
        //cout << a << " " << b << "\n";
        if (b == -1 || a == -1) {
            break;
        }
        p1[a] = b;
        ans.push_back({a, b});
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first << " " << ans[i].second << "\n";
    }

    return 0;
}
