#include <iostream>
#include <vector>

double length(double x1, double y1, double x2, double y2) {
	double x = x2 - x1;
	double y = y2 - y1;
	double result = sqrt(x*x + y*y);

	return result;
}


int main() {

	int n;
	std::cin >> n;
	std::vector<std::vector<double>> A;

	double x;
	double y;
	for (int i = 0; i < n; ++i) {
		std::cin >> x >> y;
		std::vector<double> tmp;
		tmp.push_back(x);
		tmp.push_back(y);
		tmp.push_back(0);

		A.push_back(tmp);
	}

	int counter = n-1;
	A[0][2] = 1;
	int index1 = 0;
	double sum = 0;

	while (counter) {
		int index2 = -1;
		double min = 1e10;

		for (int i = 0; i < n; ++i) {
			double len = length(A[index1][0], A[index1][1], A[i][0], A[i][1]);
			if (A[i][2] == 0 && len < min) {
				index2 = i;
				min = len;
			}
		}
		A[index2][2] = 1;
		index1 = index2;
		sum += min;
		--counter;
	}

	std::cout << sum;

	return 0;
}