#include <iostream>
#include <iomanip>


double length(double x1, double y1, double x2, double y2) {
	double x = x2 - x1;
	double y = y2 - y1;
	double result = sqrt(x*x + y*y);

	return result;
}


int main() {

	int n;
	std::cin >> n;
	double sum = 0;
	double max = 0;
	double x1;
	double y1;
	double x2;
	double y2;
	std::cin >> x1 >> y1;
	double startx = x1;
	double starty = y1;

	for (int i = 1; i < n; ++i) {
		std::cin >> x2 >> y2;
		double len = length(x1, y1, x2, y2);
		
		if (len > max) {
			max = len;
		}
		sum += len;

		x1 = x2;
		y1 = y2;
	}
	sum += length(startx, starty, x2, y2);
	sum -= max;

	std::cout << std::fixed << std::setprecision(6) << sum;

	return 0;
}