#include <iostream>
#include <cmath>
#include <cstddef>

int main() {
    int64_t N, K, s1, s2;
    std::cin >> N >> K >> s1 >> s2;

    int64_t exp1 = (K + 1) * N / 2, exp2 = ((K + 1) * N + 1) / 2;
    int64_t r1 = std::min(std::abs(s1 - exp1), std::abs(s1 - exp2));
    int64_t r2 = std::min(std::abs(s2 - exp1), std::abs(s2 - exp2));

    int64_t expect = (K + 1) * N;
    if ((s1 < N || s1 > K * N) && (s2 < N || s2 > K * N)) {
        std::cout << "Equal" << std::endl;
    } else if (r1 == r2) {
        std::cout << "Equal" << std::endl;
    } else if (r1 < r2) {
        std::cout << "First" << std::endl;
    } else {
        std::cout << "Second" << std::endl;
    }

    return 0;
}