#include <bits/stdc++.h>

#define ull unsigned long long
#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T>istream &operator>>(istream &in, vector<T> &v){for(int i = 0; i < v.size(); ++i){in >> v[i];}return in;}
template<typename T>ostream &operator<<(ostream &out, const vector<T> &v){for(int i = 0; i < v.size(); ++i){out << v[i] << ' ';}return out;}

void solve(){
    int n, m, k; std::cin >> n >> m >> k;
    vector<vector<bool>> v(n,vector<bool>(m));

    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            char cur; std::cin >> cur;

            v[i][j] = cur == '.';
        }
    }

    vector<vector<int>> dfs(n,vector<int>(m, -1));

    queue<pair<int, int>> q;
    int startX, startY, endX, endY;
    std::cin >> startX >> startY >> endX >> endY;
    q.push({--startX, --startY});
    dfs[startX][startY] = k;

    int x[4] = {-1, 1, 0, 0},
        y[4] = {0, 0, -1, 1},
        xs[4] = {-2, 2, 0, 0},
        ys[4] = {0, 0, -2, 2};
        
    while (!q.empty()){
        auto cur = q.front(); q.pop();

        for(int i = 0; i < 4; ++i){
            auto next = cur;
            next.first+=x[i];
            next.second+=y[i];
            if(next.first < 0 or next.first >= n or
                next.second < 0 or next.second >= m){
                continue;
                }

            if(v[next.first][next.second] and dfs[next.first][next.second] < dfs[cur.first][cur.second]){
                dfs[next.first][next.second] = dfs[cur.first][cur.second];
                q.push(next);
            }
        }

        if(dfs[cur.first][cur.second] > 0){
            for(int i = 0; i < 4; ++i){
                auto next = cur;
                next.first+=xs[i];
                next.second+=ys[i];
                if(next.first < 0 or next.first >= n or
                   next.second < 0 or next.second >= m){
                    continue;
                   }

                if(v[next.first][next.second] and dfs[next.first][next.second] < dfs[cur.first][cur.second]-1){
                    dfs[next.first][next.second] = dfs[cur.first][cur.second]-1;
                    q.push(next);
                }
            }
        }
    }
    
    cout << (dfs[--endX][--endY] == -1 ? "NO" : "YES");
}

int main(){
    ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    cout.tie(0);

    int t = 1;
    while (t--){
        solve();
    }

    return 0;
}