#include <bits/stdc++.h>

#define ull unsigned long long
#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T>istream &operator>>(istream &in, vector<T> &v){for(int i = 0; i < v.size(); ++i){in >> v[i];}return in;}
template<typename T>ostream &operator<<(ostream &out, const vector<T> &v){for(size_t i = 0; i < v.size(); ++i){out << v[i] << ' ';}return out;}

void solve(){
    int n; cin >> n;
    vector<int> v(n,0);
    for(int i = 1; i < n-1; ++i){
        cin >> v[i];
    }
    
    vector<int> dfs(n, INT_MAX);
    dfs[0] = 0;
    dfs[n-1] = -1;
    queue<int> q;
    q.push(0);

    while(!q.empty()){
        int cur = q.front(); q.pop();
        for(int i = 1; i <= 6; ++i){
            int next = cur + i;
            int move = dfs[cur] + (i < 6);
            if(next >= n-1){
                if(dfs[n-1] == -1 or dfs[n-1] > dfs[cur]+1  ){
                    dfs[n-1] = dfs[cur]+1;
                }
                continue;
            }

            if(dfs[next] > move){
                dfs[next] = move;

                
                while(v[next] > 0){
                    next -= v[next];
                    if(dfs[next] > move){
                        dfs[next] = move;
                    }
                    else if(v[next] > 0){
                        next = 0;
                        break;
                    }
                }

                if(next != 0){
                    q.push(next);
                }
            }
        }
    }

    cout << dfs[n-1];
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    while (t--){
        solve();
    }

    return 0;
}