// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define add push_back
#define f first
#define s second
#define pw(x) (1ll << (x))
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ll INF = (ll)1e9 + 2023;

const int MAX_N = 1e5 + 10;

struct Node {
	std::map<char, Node*> mp;
};

pair<bool, Node*> check(Node *node, const std::string &s) {
	for (int i = 0; i < s.size(); ++i) {
		if (node->mp.find(s[i]) == node->mp.end()) {
			return make_pair(false, nullptr);
		}
		node = node->mp[s[i]];
	}
	return make_pair(true, node);
}

void add(Node *node, const std::string &s) {
	for (int i = 0; i < s.size(); ++i) {
		if (node->mp.find(s[i]) == node->mp.end()) {
			node->mp[s[i]] = new Node();
		}
		node = node->mp[s[i]];
	}
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int q;
	cin >> q;
	Node *root = new Node();
	map<string, int> last_suf;
	for (int i = 0; i < q; ++i) {
		string str;
		cin >> str;
		pair<bool, Node *> res = check(root, str);
		std::string added;
		if (!res.first) {
			added = str;
		} else {
			int beg;
			if (last_suf.find(str) == last_suf.end()) {
				beg = 0;
			} else {
				beg = last_suf[str];
			}
			for (int j = beg + 1; j <= INF; ++j) {
				string suf = to_string(j);
				pair<bool, Node *> suf_res = check(res.second, suf);
				if (!suf_res.first) {
					added = str + suf;
					last_suf[str] = j;
					break;
				}
			}
		}
		cout << added << '\n';
		add(root, added);
	}
}