#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

long long N, K, S1, S2;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> N >> K >> S1 >> S2;

    if ((S1 < N || S1 > N * K) && (S2 < N || S2 > N * K)) {
        std::cout << "Equal" << std::endl;
        return 0;
    }

    if ((S1 < N || S1 > N * K)) {
        std::cout << "Second" << std::endl;
        return 0;
    }

    if ((S2 < N || S2 > N * K)) {
        std::cout << "First" << std::endl;
        return 0;
    }

    if (N == 1 || S1 == S2) {
        std::cout << "Equal" << std::endl;
        return 0;
    }

    long long distance_a = abs(2 * S1 - (N * K + N));
    long long distance_b = abs(2 * S2 - (N * K + N));

    if (distance_a < distance_b) {
        std::cout << "First" << std::endl;
    } else if (distance_a > distance_b) {
        std::cout << "Second" << std::endl;
    } else {
        std::cout << "Equal" << std::endl;
    }

    return 0;
}