#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

double N, K, S1, S2;

double middle;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> N >> K >> S1 >> S2;

    if ((S1 < N || S1 > N * K) && (S2 < N || S2 > N * K)) {
        std::cout << "Equal" << std::endl;
        return 0;
    }

    if ((S1 < N || S1 > N * K)) {
        std::cout << "Second" << std::endl;
        return 0;
    }

    if ((S2 < N || S2 > N * K)) {
        std::cout << "First" << std::endl;
        return 0;
    }

    if (N == 1) {
        std::cout << "Equal" << std::endl;
        return 0;
    }

    middle = (N * K + N) / 2;

    double distance_a = abs(middle - S1);
    double distance_b = abs(middle - S2);

    if (distance_a < distance_b) {
        std::cout << "First" << std::endl;
    } else if (distance_a > distance_b) {
        std::cout << "Second" << std::endl;
    } else {
        std::cout << "Equal" << std::endl;
    }

    return 0;
}