#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

void solve() {
    int n;
    cin >> n;
    unordered_map<string, int> db;
    unordered_set<string> strings;
    while (n-- > 0) {
        string str;
        cin >> str;
        if (strings.find(str) == strings.end()) {
            db[str] = 0;
            strings.insert(str);
            cout << str << '\n';
        } else {
            string newStr;
            do {
                db[str]++;
                newStr = str + to_string(db[str]);
            } while (strings.find(newStr) != strings.end());
            strings.insert(newStr);
            cout << newStr << '\n';
        }
    }
}

int main() {
    solve();
}