#include <bits/stdc++.h>

// #define short short
#define all(v) v.begin(), v.end()

using namespace std;

vector<pair<short, short>> d = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}}, md = {{2, 0}, {-2, 0}, {0, 2}, {0, -2}};
bool used[1000][1000];

short solve() {
  short n, m; cin >> n >> m;
  int32_t k; cin >> k;
  vector<string> v(n);
  for (auto& i : v) cin >> i;
  short s1, s2, f1, f2; cin >> s1 >> s2 >> f1 >> f2;
  s1--, s2--, f1--, f2--;
  struct el {
    short x, y;
    int32_t kk;
  };

  auto check = [&](short x, short y) {
    if (x < n && y < m && x >= 0 && y >= 0 && v[x][y] != '#') return 1;
    return 0;
  };

  queue<el> q;
  el st = {.x = s1, .y = s2, .kk = 0};
  q.push(st);
  while (!q.empty()) {
    el elem = q.front(); q.pop();
    used[elem.x][elem.y] = 1;
    // cout << elem.x << ' ' << elem.y << endl;
    if (elem.x == f1 && elem.y == f2) {
      cout << "YES\n"; return 0;
    }
    for (auto [a, b] : d) if (check(elem.x + a, elem.y + b) && !used[elem.x + a][elem.y + b]) {
      q.push({elem.x + a, elem.y + b, elem.kk});
    }
    if (elem.kk < k)
      for (auto [a, b] : md) if (check(elem.x + a, elem.y + b) && !used[elem.x + a][elem.y + b]) {
        q.push({elem.x + a, elem.y + b, elem.kk+1});
      }
  }
  cout << "NO\n";
  return 0;
}

signed main() {
  ios::sync_with_stdio(0); cin.tie(0);
  solve();

  return 0;
}