#include <bits/stdc++.h>

// #define int int
#define all(v) v.begin(), v.end()

using namespace std;

vector<pair<int, int>> d = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}}, md = {{2, 0}, {-2, 0}, {0, 2}, {0, -2}};
bool used[1000][1000];

int solve() {
  int n, m; cin >> n >> m;
  int32_t k; cin >> k;
  vector<string> v(n);
  for (auto& i : v) cin >> i;
  int s1, s2, f1, f2; cin >> s1 >> s2 >> f1 >> f2;
  s1--, s2--, f1--, f2--;
  struct el {
    int x, y;
    int wasM;
  };

  auto check = [&](int x, int y) {
    if (x < n && y < m && x >= 0 && y >= 0 && v[x][y] != '#') { return true;}
    return false;
  };

  queue<el> q;
  queue<el> qq;
  q.push({s1, s2, 0});
  auto bfs1 = [&]() {
    while (!q.empty()) {
      el elem = q.front(); q.pop();
      qq.push({elem.x, elem.y, 0});
      // cout << elem.x << ' ' << elem.y << ' ' << elem.wasM << endl;
      if (elem.x == f1 && elem.y == f2) {
        return 1;
      }
      for (auto [a, b] : d) if (check(elem.x + a, elem.y + b) && !used[elem.x + a][elem.y + b]) {
        used[elem.x + a][elem.y + b] = 1;
        q.push({elem.x + a, elem.y + b, 0});
      }
    }
    return 0;
  };

  auto bfs2 = [&]() {
    while (!qq.empty()) {
      el elem = qq.front(); qq.pop();
      // cout << elem.x << ' ' << elem.y << ' ' << elem.wasM << endl;
      if (elem.x == f1 && elem.y == f2) {
        return 1;
      }
      for (auto [a, b] : md) if (check(elem.x + a, elem.y + b) && !used[elem.x + a][elem.y + b]) {
        used[elem.x + a][elem.y + b] = 1;
        q.push({elem.x + a, elem.y + b, 0});
      }
    }
    return 0;
  };

  // cout << "!!!" << endl;
  for (int i = 0; i < k; ++i) {
    if (bfs1() || bfs2()) {cout << "YES\n"; return 0;} 
  }
  if (bfs1()) {
    cout << "YES\n"; return 0;
  }
  cout << "NO\n";
  return 0;
}

signed main() {
  ios::sync_with_stdio(0); cin.tie(0);
  solve();

  return 0;
}