#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
vector<vector<pair<ll, ll>>> g;

vector<ll> dijkstra(ll s, ll n) {
    vector<ll> d(n, 1e18);
    d[0] = 0;
    set<pair<ll, ll>>q;
    q.insert({0, s});
    while (!q.empty()) {
        ll v = q.begin()->second;
        q.erase(q.begin());
        for (auto [w, u] : g[v]) {
            if (d[u] > d[v] + w) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }
    return d;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie();
	cin.tie(0);
	ll n; cin >> n;
	g.resize(n);
	vector<ll> a;
	a.push_back(0);
	for (ll i = 1; i < n - 1; i++) {
		ll x; cin >> x;
		a.push_back(x);
	}
	a.push_back(0);
	//cout << "sus\n" << endl;
	
	for (ll i = 0; i < n; ++i) {
		if (a[i] != 0) {
			g[i] = {{0, i - a[i]}};
			continue;
		}
	//	cout << "sussy\n" << endl;
		if (i + 6 >= n) {
			g[i] = {{1, n - 1}};
			continue;
		}
	//	cout << "amogus\n" << endl;
		for (ll j = 1; j <= 6; ++j) {
			ll w = 1;
			if (j == 6) w = 0;
	//		cout << j << endl;
			if (a[i + j] != 0) {
				g[i].push_back({w, i + j - a[i + j]});
			} else {
				g[i].push_back({w, i + j});
			}
		}
	}
	//cout << "sus\n" << endl;
	auto d = dijkstra(0, n);
	if (d[n - 1] == 1e18) {
		cout << -1;
		return 0;
	}
	cout << d[n - 1];
	return 0;
}