def dice_probability(int_dice_number: int, int_number_to_find: int, k: int) -> float:
    list_values, list_interm_probability = list_values_and_interm_probabilities(int_dice_number, k)
    if int_number_to_find < list_values[0] or int_number_to_find > list_values[-1]:
        result_out: float = 0.0
    else:
        for i in range(len(list_values)):
            if list_values[i] == int_number_to_find:
                result_out: float = list_interm_probability[i] / (k ** int_dice_number)
                break
    return result_out



def list_values_and_interm_probabilities(int_dice_number: int, k: int) -> tuple[list[int], list[int]]:
    list_values = [i for i in range(int_dice_number, k * int_dice_number + 1)]
    list_interm_probability = [1] * k  # [1, 1, 1, 1, 1, 1]
    for i in range(int_dice_number - 1):
        list_interm_probability = multiply_by_ones(list_interm_probability, k)
    return list_values, list_interm_probability



def multiply_by_ones(list_in: list[int], k: int) -> list[int]:
    list_dummy: list[list[int]] = []
    for i in range(k):
        list_dummy.append([0] * i)
    list_for_sum: list[list[int]] = []
    for i in range(k):
        list_for_sum.append(list_dummy[i] + list_in + list_dummy[k - i - 1])
    list_out: list[int] = []
    for i in range(len(list_for_sum[0])):
        sum_out: int = 0
        for j in range(k):
            sum_out += list_for_sum[j][i]
        list_out.append(sum_out)
    return list_out


n = int(input())
k = int(input())
s1 = int(input())
s2=int(input())
v1 = dice_probability(n, s1, k)
v2 = dice_probability(n, s2, k)
if v1>v2:
    print('First')
elif v2>v1:
    print('Second')
else:
    print('Equal')