﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
    int n, k;
    cin >> n >> k;

    vector<int> s(n), a(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<pair<int, int>> b;
    b.reserve(n);  // Улучшим производительность, задав начальный размер

    for (int i = 0; i < n; i++) {
        b.emplace_back(s[i], a[i]);  // Заменим push_back на emplace_back
    }

    sort(b.begin(), b.end());

    double total_difference = 0.0;
    for (const auto& pair : b) {
        total_difference += abs(pair.first - pair.second) / static_cast<double>(pair.first);
    }

    int count = 0;
    while (total_difference > k) {
        if (b[0].first - b[0].second == 0) {
            b.erase(b.begin());
        }
        if (b[0].first > b[0].second) {
            b[0].second += 1;
        }
        else {
            b[0].second -= 1;
        }
        count++;

        total_difference = 0.0;
        for (const auto& pair : b) {
            total_difference += abs(pair.first - pair.second) / static_cast<double>(pair.first);
        }
    }

    cout << count << endl;

    return 0;
}
