#include <iostream>
#include <vector>

using namespace std;

int main() {
    int h, w;
    cin >> h >> w;

    vector<string> bubbleState(h);
    for (int i = 0; i < h; i++) {
        cin >> bubbleState[i];
    }

    int flipped = 1;
    int notFlipped = 2;

    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if ((i + j) % 2 == 0) {
                if (bubbleState[i][j] == '1') {
                    flipped++;
                } else {
                    notFlipped++;
                }
            } else {
                if (bubbleState[i][j] == '0') {
                    flipped++;
                } else {
                    notFlipped++;
                }
            }
        }
    }

    cout << min(flipped, notFlipped) << endl;

    return 0;
}
