#include <iostream>
#include <algorithm>

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main() {
    int L, R;
    std::cin >> L >> R;

    int max_gcd = 0;
    std::pair<int, int> max_pair;

    for (int x = L; x <= R; x++) {
        for (int y = x + 1; y <= R; y++) {
            int current_gcd = gcd(x, y);
            if (current_gcd > max_gcd) {
                max_gcd = current_gcd;
                max_pair = {x, y};
            }
        }
    }

    std::cout << max_pair.first << " " << max_pair.second;

    return 0;
}