#include <iostream>
#include <algorithm>

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main() {
    int L, R;
    std::cin >> L >> R;

    int max_gcd = 0;
    std::pair<int, int> max_pair;

    for (int d = R; d >= L; d--) {
        for (int x = L; x <= R; x++) {
            if (x % d != 0) continue;
            for (int y = x + d; y <= R; y += d) {
                int current_gcd = gcd(x, y);
                if (current_gcd == d && current_gcd > max_gcd) {
                    max_gcd = current_gcd;
                    max_pair = {x, y};
                }
            }
        }
        if (max_gcd > 0) break;
    }


    std::cout << max_pair.first << " " << max_pair.second;

    return 0;
}