#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>


const long long DEN = 2520;
const long long INF = 2e9;

long long abs(long long a) {
    if (a >= 0) return a;
    return -a;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    long long n, k, q = 0;
    std::cin >> n >> k;
    k *= DEN;
    std::vector<std::pair<long long, long long>> arr(n);
    for (int i = 0; i < n; i++) {
        std::cin >> arr[i].first;
    }
    for (int i = 0; i < n; i++) {
        std::cin >> arr[i].second;
    }
    for (int i = 0; i < n; i++) {
        q += abs(arr[i].second - arr[i].first) * DEN / arr[i].first;
    }
    std::sort(arr.begin(), arr.end());
    if (q <= k) {
        std::cout << 0;
        return 0;
    }
    int i = 0;
    long long t = 0;
    while (true) {
        if (abs(arr[i].second - arr[i].first) * DEN / arr[i].first >= q - k) {
            t += (q - k + (DEN / arr[i].first) - 1) / (DEN / arr[i].first);
            break;
        }
        else {
            t += abs(arr[i].second - arr[i].first);
            q -= abs(arr[i].second - arr[i].first) * DEN / arr[i].first;
        }
        i++;
    }
    std::cout << t;
}