#include <iostream>
#include <vector>
#include <map>
#include <cmath>
using namespace std;
int NOD = 180;

int main() {
    long long n;
    long long target_k, k;
    vector<long long> s;
    vector<long long> a;

    map<long long, long long> count;
    map<long long, long long> w;
    for (long long i = 1; i < 11; i++) {
        count[i] = 0;
        w[i] = NOD / i;
    }
    cin >> n >> target_k;
    target_k *= NOD;
    for (long long i = 0; i < n; i++) {
        long long number;
        cin >> number;
        s.push_back(number);
    }
    for (long long i = 0; i < n; i++) {
        long long number;
        cin >> number;
        a.push_back(number);
    }
    k = 0;
    for (long long i = 0; i < n; i++) {
        count[s[i]] += abs(a[i] - s[i]);
        k += abs((a[i] - s[i]) * w[s[i]]);
    }

    if (k < target_k) {
        swap(k, target_k);
    }

    long long denominator = 1;
    long long ans = 0;

    while (k - target_k > 0) {
        while (denominator <= 10 && (count[denominator] == 0 || (k - count[denominator] * w[denominator]) - target_k > 0)) {
            k -= count[denominator] * w[denominator];
            ans += count[denominator];
            count[denominator] = 0;
            denominator += 1;
        }
        k -= w[denominator];
        ans += 1;
    }

    cout << ans << endl;
    return 0;
}
