#include <iostream>
#include <string>
#include <unordered_map>

std::unordered_map<std::string, int> mp;

int find(std::string &s, int i) {
    std::string ns = s + (i == 0 ? "" : std::to_string(i));
    if (mp.find(ns) != mp.end()) {
        return find(s, i + 1);
    }
    return i;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    int q; std::cin >> q;
    while (q--) {
        std::string s; std::cin >> s;
	int i = find(s, 0);
	std::string ns = s + (i == 0 ? "" : std::to_string(i));
	std::cout << ns << '\n';
	mp[ns] = 0;
	mp[s]++;
    }
    return 0;
}

