﻿#include <bits/stdc++.h>
#define int long long

using namespace std;

struct User{
    std::set<int> banned{};
    int last = 0;

    int FindNext(){
        while (banned.find(last) != banned.end()){
            last++;
        }
        banned.insert(last);
        return last++;
    }

};

std::map<std::string, User> users;
std::vector<int> pow_10;

void AddBanned(std::string name, int num){
    auto user_it = users.find(name);
    if (user_it == users.end()){
        users.insert({name, User{}});
        user_it = users.find(name);
    }
    user_it->second.banned.insert(num);
}

std::string AddUser(std::string name){
    auto user_it = users.find(name);
    if (user_it == users.end()){
        users.insert({name, User{}});
        user_it = users.find(name);
    }
    int last = user_it->second.FindNext();
    std::string s = name + (last == 0 ? "" : std::to_string(last));
    int num = 0, len = 0;
    string ans = s;
    AddBanned(s, 0);
    while (s.size() > 1 && std::isdigit(s.back())) {
        num += (s.back() - '0') * pow_10[len];
        len++;
        s.pop_back();
        if (num != 0) AddBanned(s, num);
    }
    return ans;
}


signed main() {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int q;
    std::cin >> q;
    pow_10.resize(12);
    pow_10[0] = 1;
    for (int i = 1; i < 12; ++i) pow_10[i] = pow_10[i - 1] * 10;
    for (int i = 0; i < q; ++i){
        std::string s;
        std::cin >> s;
        std::cout << AddUser(s) << '\n';
    }
    return 0;
}
