#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

int main() {
    int L, R;
    std::cin >> L >> R;

    int max_gcd = 1;
    std::pair<int, int> max_pair;

    for (int x = L; x <= R; ++x) {
        for (int y = x + 1; y <= R; ++y) {
            int current_gcd = std::__gcd(x, y);
            if (current_gcd > max_gcd) {
                max_gcd = current_gcd;
                max_pair = std::make_pair(x, y);
            }
        }
    }

    std::cout << max_pair.first << " " << max_pair.second << std::endl;

    return 0;
}