#include <iostream>
#include <sstream>

long long GCD(long long a, long long b)
{
    while (b != 0)
    {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main()
{
    std::string input;
    std::getline(std::cin, input);
    std::istringstream iss(input);
    long long L, R;
    iss >> L >> R;

    long long maxGCD = 0;
    long long x = 0;
    long long y = 0;

    for (long long i = L; i <= R; i++)
    {
        for (long long j = i + 1; j <= R; j++)
        {
            long long gcd = GCD(i, j);
            if (gcd > maxGCD)
            {
                maxGCD = gcd;
                x = i;
                y = j;
            }
        }
    }

    std::cout << x << " " << y << std::endl;

    return 0;
}