def convert_tree(node):
    if node is None or not node.left and not node.right:
        return None
    left = convert_tree(node.left)
    right = convert_tree(node.right)
    result = []
    for i in range(len(left)):
        new_edge = [i, j]
        while len(new_edge) > 0:
            next_node = new_edge[-1][0]
            if next_node == node:
                continue
            new_edge.append((next_node, j + 1))
        result.append(new_edge)
    for i in range(len(right)):
        new_edge = [i, j]
        while len(new_edge) > 0:
            next_node = new_edge[-1][0]
            if next_node == node:
                continue
            new_edge.append((next_node, j - 1))
        result.append(new_edge)
    return result