#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> c;
    vector<double> distance;

    for (int i = 0; i < N; i++) {
        vector<int> kate;
        int a, b;
        cin >> a >> b;
        kate.push_back(a);
        kate.push_back(b);
        c.push_back(kate);
    }

    for (int i = 1; i < N; i++) {
        int a1 = c[i-1][0];
        int b1 = c[i-1][1];
        int a2 = c[i][0];
        int b2 = c[i][1];
        double dist = sqrt(pow(a1-a2, 2) + pow(b1-b2, 2));
        distance.push_back(dist);
    }

    int a1 = c[0][0];
    int b1 = c[0][1];
    int a2 = c[N-1][0];
    int b2 = c[N-1][1];
    double dist = sqrt(pow(a1-a2, 2) + pow(b1-b2, 2));
    distance.push_back(dist);

    double max_dis = distance[0];
    for (int i = 1; i < distance.size(); i++) {
        if (distance[i] > max_dis) {
            max_dis = distance[i];
        }
    }

    double res = 0;
    for (int i = 0; i < distance.size(); i++) {
        res += distance[i];
    }
    res -= max_dis;

    cout << fixed;
    cout.precision(6);
    cout << res << endl;

    return 0;
}
