def find_winner(N, K, S1, S2):
  el1 = [[0] * (K * N + 1) for _ in range(N + 1)]
  el2 = [[0] * (K * N + 1) for _ in range(N + 1)]
  el1[0][0] = el2[0][0] = 1

  for i in range(1, N + 1):
    for j in range(1, K * N + 1):
      for k in range(1, K + 1):  
        if j - k >= 0:
          el1[i][j] += el1[i - 1][j - k]
          el2[i][j] += el2[i - 1][j - k]

  var1 = el1[N][S1] / (K ** N)
  var2 = el2[N][S2] / (K ** N)

  if var1 > var2:
    return "First"
  elif var2 > var1:
    return "Second"
  else:
    return "Equal"

N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = find_winner(N, K, S1, S2)
print(result)