def find_winner(N, K, S1, S2):
  dp = [[0] * (S1 + S2 + 1) for _ in range(N + 1)]
  dp[0][0] = 1
  
  for i in range(1, N + 1):
    for j in range(S1 + 1):
      for k in range(1, K + 1):
        if j - k >= 0:
          dp[i][j] += dp[i - 1][j - k] / K
  
  var2 = 0
  for i in range(N * K + 1):
    if 0 <= i - S2 <= S1:
      var2 += dp[N][i]
  
  var1 = 1 - var2
  
  if var1 > var2:
    return "First"
  elif var2 > var1:
    return "Second"
  else:
    return "Equal"

N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

result = find_winner(N, K, S1, S2)
print(result)