#include <iostream>
#include <unordered_map>
#include <vector>
using namespace std;

unordered_map<string, int> userCounts;

string getUniqueName(const string& name) {
    string uniqueName = name;
    while (userCounts.count(uniqueName) > 0) {
        uniqueName = name + to_string(userCounts[name]++);
    }
    userCounts[uniqueName]++;
    return uniqueName;
}

int main() {
    int q;
    cin >> q;

    vector<string> results;

    for (int i = 0; i < q; i++) {
        string name;
        cin >> name;
        string uniqueName = getUniqueName(name);
        results.push_back(uniqueName);
    }

    // Вывод результатов
    for (const string& name : results) {
        cout << name << endl;
    }

    return 0;
}