/*
   Moon and sun, fear and love
   Everything a part of love
   Head, heart, light against dark
   Uh, everything a part of love
   Uh, everything a part of love
   Earth, star, everything falls
   Everything a part of love
   Rain and snow
   Everything a part of what you are
   Love, love, love, love
   Everything a part of love
   Love, two as one, fall in love
   Everything a part of love
   One, one, two, one, two
   Everything a part of you
   Everything a part of you
   Love is one, everything there always was, us

   I want it, I-I-I want it
   I want it, I want it
   I-I-Iconic, iconic
   I want it, I-I-I want it
   I want it, I want it
   I-I-Iconic
   I love it, I want it
   I-I-I love it
   I love it, I want it
   I-I-Iconic
*/

// #pragma GCC optimize("Ofast,unroll-loops")
#ifdef LOCAL
#include "debug.h"
#else
#include <bits/stdc++.h>
#define debug(x...)
#endif

using namespace std;

#define int ll

typedef long long ll;
typedef long double ld;
#define sz(x) int((x).size())

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif

const int N = 2e5 + 10;
const int MOD = 1e9 + 7;
// const int MOD = 998244353;
const ld eps = 5e-8;
const pair<int, int> dir[] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

const int LCM = 2520;

struct Part {
    int delta, s;
};

int ceil2(int x, int y) {
    return (x + y - 1) / y;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout << fixed << setprecision(9);
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    int n;
    ll k;
    cin >> n >> k;
    k *= LCM;

    vector<int> a(n), s(n);
    for (int& x : s) {
        cin >> x;
    }
    for (int& x : a) {
        cin >> x;
    }

    vector<Part> v(n);
    ll l = 0;

    for (int i = 0; i < n; ++i) {
        int delta = abs(a[i] - s[i]);
        l += delta * LCM / s[i];

        v[i] = {delta, s[i]};
    }
    sort(v.begin(), v.end(), [](Part x, Part y) {
        return x.s < y.s;
    });

    int ans = 0;
    for (auto [delta, s] : v) {
        if (l - delta * LCM / s >= k) {
            l -= delta * LCM / s;
            ans += delta;
        } else {
            int p = ceil2(l - k, LCM / s);
            ans += p;
            break;
        }
    }

    cout << ans << endl;

    return 0;
}