import kotlin.math.pow

fun main() {
    val n = readLine()!!.toInt()
    val k = readLine()!!.toInt()
    val s1 = readLine()!!.toInt()
    val s2 = readLine()!!.toInt()

    val expectedValue1 = expectedValue(s1, n, k)
    val expectedValue2 = expectedValue(s2, n, k)

    when {
        expectedValue1 > expectedValue2 -> println("First")
        expectedValue1 < expectedValue2 -> println("Second")
        else -> println("Equal")
    }
}

fun expectedValue(target: Int, n: Int, k: Int): Double {
    if (n == 0) {
        return if (target == 0) 1.0 else 0.0
    }

    var expectedValue = 0.0

    for (d in 1..k) {
        if (target - d >= 0) {
            expectedValue += d * expectedValue(target - d, n - 1, k)
        }
    }

    return expectedValue / k.toDouble().pow(n)
}
