fun findMaxGCDPair(L: Long, R: Long): Pair<Long, Long> {
    var maxGCD = 1L
    var resultPair = Pair(1L, 2L)

    for (i in L..R) {
        var j = i * 2
        while (j <= R) {
            val currentGCD = findGCD(i, j)
            if (currentGCD > maxGCD) {
                maxGCD = currentGCD
                resultPair = Pair(i, j)
            }
            j += i
        }
    }

    return resultPair
}

fun findGCD(a: Long, b: Long): Long {
    return if (b == 0L) a else findGCD(b, a % b)
}

fun main() {
    val (L, R) = readLine()!!.split(" ").map { it.toLong() }

    val resultPair = findMaxGCDPair(L, R)
    println("${resultPair.first} ${resultPair.second}")
}
