fun findMaxGCDPair(L: Long, R: Long): Pair<Long, Long> {
    var maxGCD = 0L
    var resultPair = Pair(L, R)

    for (i in L..R) {
        for (j in 2 * i..R step i) {
            val currentGCD = findGCD(i, j)
            if (currentGCD > maxGCD) {
                maxGCD = currentGCD
                resultPair = Pair(i, j)
            }
        }
    }

    return resultPair
}

fun findGCD(a: Long, b: Long): Long {
    return if (b == 0L) a else findGCD(b, a % b)
}

fun main() {
    val (L, R) = readLine()!!.split(" ").map { it.toLong() }

    val resultPair = findMaxGCDPair(L, R)
    println("${resultPair.first} ${resultPair.second}")
}
