import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;

public class H {
    public static void main(String[] args) throws Exception {
        try (var reader = new BufferedReader(new InputStreamReader(System.in))) {
            var n = Long.parseLong(reader.readLine());
            var m = new HashMap<String, MutableLong>();

            for (int i = 0; i < n; i++) {
                var line = reader.readLine();
                var k = m.computeIfAbsent(line, a -> new MutableLong());
                var o = k.getAndIncrement();
                while (o != 0) {
                    var rl = line + o;
                    var mk = m.computeIfAbsent(rl, a -> new MutableLong());
                    if (mk.getValue() == 0) {
                        line = rl;
                        mk.getAndIncrement();
                        break;
                    }
                    o = k.getAndIncrement();
                }
                System.out.println(line);
            }
        }
    }

    static class MutableLong {
        private long value;

        public MutableLong(long v) {
            value = v;
        }

        public MutableLong() {
            this(0);
        }

        public long getValue() {
            return value;
        }

        public long getAndIncrement() {
            return value++;
        }
    }
}
