import java.util.Scanner;

public class Task_A {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int alicePoints = scanner.nextInt();
        int bobPoints = scanner.nextInt();
        scanner.close();

        // || (alicePoints == 0 && bobPoints == 0)
        // Проверка на Error
        if (Math.abs(alicePoints - bobPoints) % 2 != 0) {
            System.out.println("Error");
            return;
        }

        // Проверка на Undefined
        if (alicePoints == bobPoints && alicePoints != 1 && alicePoints != 0) {
            System.out.println("Undefined");
            return;
        }

        int aliceWins = 0, bobWins = 0, draws = 0;

        // Учитываем хотя бы одну ничью, если требуется
        if (alicePoints % 2 == 1 || bobPoints % 2 == 1) {
            draws++;
            alicePoints--;
            bobPoints--;
        }

        // Распределяем победы и ничьи
        while (alicePoints >= 2 && bobPoints >= 2) {
            alicePoints -= 2;
            bobPoints -= 2;
            draws++;
        }

        aliceWins = alicePoints / 2;
        bobWins = bobPoints / 2;

        System.out.println(aliceWins + " " + bobWins + " " + draws);
    }
}