import java.util.Scanner;

public class Task_D {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        int K = scanner.nextInt();
        int S1 = scanner.nextInt();
        int S2 = scanner.nextInt();

        long[][] dp = new long[N + 1][K * N + 1];
        dp[0][0] = 1;

        for (int i = 1; i <= N; i++) {
            for (int j = 1; j <= K * N; j++) {
                for (int k = 1; k <= K; k++) {
                    if (j - k >= 0) {
                        dp[i][j] += dp[i - 1][j - k];
                    }
                }
            }
        }

        if (dp[N][S1] > dp[N][S2]) {
            System.out.println("First");
        } else if (dp[N][S1] < dp[N][S2]) {
            System.out.println("Second");
        } else {
            System.out.println("Equal");
        }
    }
}
