
#include <iostream>
 
long long gcd(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}
 
int main() {
    long long L, R;
    std::cin >> L >> R;
 
    long long maxGCD = 1;
    long long maxX = L;
    long long maxY = L + 1;
 
    for (long long x = L; x < R; x++) {
        for (long long y = x + 1; y <= R; y++) {
            long long currentGCD = gcd(x, y);
            if (currentGCD > maxGCD) {
                maxGCD = currentGCD;
                maxX = x;
                maxY = y;
            }
        }
    }
 
    std::cout << maxX << " " << maxY << std::endl;
 
    return 0;
}
 
