N = int(input())
K = int(input())
player_1 = int(input())
player_2 = int(input())
sr = N * (K + 1) // 2
low = max(sr - N//2, 1)
up = min(sr + N//2, K*N)
if player_1 == player_2 == sr:
    print("Equal")
    exit()

dp = [[0] * (K*N+1) for _ in range(N+1)]
dp[0][0] = 1
for i in range(1, N+1):
    for j in range(i, K*i+1):
        for k in range(1, K+1):
            if j-k >= 0:
                dp[i][j] += dp[i-1][j-k]

cnt1 = dp[N][player_1]
cnt2 = dp[N][player_2]

chance1 = cnt1 / sum(dp[N][low:up+1])
chance2 = cnt2 / sum(dp[N][low:up+1])

if chance1 > chance2:
    print("First")
elif chance2 > chance1:
    print("Second")
else:
    print("Equal")