#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;
using ull = unsigned long long;
using ll = unsigned long long;

bool pred(ll m, ll L, ll R) {
    ll K_1 = R/m;
    ll K_0 = K_1 - 1;
    return m * K_1 <= R && m * K_0 >=L;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ull L, R;
    cin >> L >> R;
    ull l(0), r(R);
    while (l < r - 1) {
        ull m = (r + l) / 2;
        if (pred(m, L, R))
            l = m;
        else
            r = m;
    }
    cout << (R/l - 1) * l << " " << R/l * l;
}