#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <string>
#include <algorithm>

using namespace std;
using ull = unsigned long long;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    map<string, int> names;
    while (q--) {
        string name;
        cin >> name;
        if (names[name] == 0) {
            cout << name << "\n";
            names[name] = 1;
        } else {
            int i = names[name];
            while (names[name + to_string(i)])
                i++;
            cout << name << i << "\n";
            names[name] = i;
            names[name + to_string(i)] = 1;
        }
    }

}