#include <cassert>

#include <iostream>
#include <algorithm>

constexpr size_t max_len = 100;

int main()
{
	int height = 0;
	int width = 0;
	std::string input_buffer;

	std::cin >> height >> width;
	std::cin.ignore();

	int outside_count = 0;
	int inside_count = 0;

	for (int h = 0; h < height; h++)
	{
		std::getline(std::cin, input_buffer);
		assert(input_buffer.length() == width);
		
		for (int w = 0; w < width; w++)
		{
			if (input_buffer[w] == '1')
			{
				inside_count++;
				continue;
			}
			outside_count++;
		}
	}

	std::cout << std::min(outside_count, inside_count);
}
