#include <vector>
#include <string>
#include <unordered_map>

#include <iostream>

int main()
{
	int requests = 0;
	std::cin >> requests;
	std::cin.ignore();

	std::vector<std::string> names;
	names.reserve(requests);
	std::unordered_map<std::string, int> db;

	for (int i = 0; i < requests; i++)
	{
		std::string input;
		std::getline(std::cin, input);
	
		auto it = db.find(input);
		if (db.end() != it)
		{
			std::string try_name = input + std::to_string(it->second++);
		
			auto it2 = db.find(try_name);
			while (db.end() != it2)
			{
				try_name = input + std::to_string(it->second++);
				it2 = db.find(try_name);
			}

			input = try_name;
		}

		db[input] = 1;
		names.push_back(input);
	}

	std::cout << std::endl;
	for (const std::string& name : names)
	{
		std::cout << name << std::endl;
	}
}
