#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

const string ERROR = "Error";
const string UNDEFINED = "Undefined";

void Solve() {
    int a, b;
    cin >> a >> b;
    if (a == 0 && b == 0) {
        cout << "0\n0\n0\n";
        return;
    }
    if (a == 0 && b == 1 ||
        a == 1 && b == 0) {
        cout << ERROR << "\n";
        return;
    }
    if (a == 1 && b == 1) {
        cout << "0\n0\n1\n";
        return;
    }

    if (a == 0 && b % 2 == 0) {
        cout << "0\n" << b / 2 << "\n0\n";
        return;
    }
    if (a == 0 && b % 2 != 0) {
        cout << ERROR << "\n";
        return;
    }
    if (a % 2 == 0 && b == 0) {
        cout << a / 2 << "\n0\n0\n";
        return;
    }
    if (a % 2 != 0 && b == 0) {
        cout << ERROR << "\n";
        return;
    }

    if (a == 1 && b % 2 == 1) {
        cout << "0\n" << b / 2 << "\n1\n";
        return;
    }
    if (a % 2 == 1 && b == 1) {
        cout << a / 2 << "\n0\n" << "1\n";
        return;
    }
    if (a == 1 && b % 2 == 0 ||
        a % 2 == 0 && b == 1) {
        cout << ERROR << "\n";
        return;
    }
    if ((a + b) % 2 == 1) {
        cout << ERROR << "\n";
        return;
    }
    cout << UNDEFINED << "\n";
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}
