#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

void Solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    int num_zero = 0;
    for (auto& x : a) {
        cin >> x;
        num_zero += count(x.begin(), x.end(), '0');
    }
    int num_one = n * m - num_zero;
    cout << min(num_zero, num_one) << "\n";
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}
