#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

const int MULTIPLY = 2 * 2 * 2 * 3 * 3 * 5 * 7;

void Solve() {
    int n, k;
    cin >> n >> k;
    k *= MULTIPLY;
    vector<pair<int, int>> d(n);
    vector<int> s(n), a(n);
    for (auto& x : s) {
        cin >> x;
    }
    for (auto& x : a) {
        cin >> x;
    }
    int current_k = 0;
    for (int i = 0; i < n; ++i) {
        d[i] = {(int)MULTIPLY / s[i], abs(a[i] - s[i])};
//        current_k += abs(a[i] - s[i]) / s[i];
        current_k += d[i].first * d[i].second;
    }
    if (current_k <= k) {
        cout << "0\n";
        return;
    }
    sort(d.rbegin(), d.rend());
    int time = 0;
    for (const auto& [x, y] : d) {
//        cout << "current_k = " << current_k << "\n";
        if (x * y < current_k - k) {
//            cout << "y = " << y << "\n";
            time += y;
//            if (x == 0) {
//                current_k -= 2;
//            }
//            cout << "x = " << x << "\n";
            current_k -= x * y;
        } else {
//            cout << "x = " << x << "\n";
            int value = (current_k - k + x - 1) / x;
//            cout << "value = " << value << "\n";
            time += value;
            break;
        }
    }
    cout << time << "\n";
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}
