#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define int long long

using namespace std;

void Solve() {
    int q;
    cin >> q;
    unordered_map<string, int> db;
    for (int i = 0; i < q; ++i) {
        string s;
        cin >> s;
        if (db.count(s)) {
            string t = s;
            while (db.count(t)) {
                t = s + to_string(db[s]);
                ++db[s];
            }
            cout << t << "\n";
            db[t] = 1;
        } else {
            cout << s << "\n";
            db[s] = 1;
        }
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
//    double start = clock();
    int num_tests = 1;
#ifdef LOCAL
    std::cin >> num_tests;
#endif
    for (int i = 0; i < num_tests; ++i) {
#ifdef LOCAL
        std::cout << "Case #" << i + 1 << ":\n";
#endif
        Solve();
    }
#ifdef LOCAL
//    cout << "Time: " << (clock() - start) / CLOCKS_PER_SEC << "\n";
#endif
}
