#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

void solve() {
	int n, k;
	cin >> n >> k;
    vector<int> s(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<pair<long double, pair<int, int>>> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = make_pair(abs(a[i] - s[i]), make_pair(a[i], s[i]));
    }
    sort(p.begin(), p.end());
    for (int i = 0; i < n; ++i) {
        a[i] = p[i].second.first;
        s[i] = p[i].second.second;
    }
    long long l = -1;
    long long r = 1ll << 62;
    while (l + 1 < r) {
        long long mid = (l + r + 1) / 2;
        long long x = mid;
        // x = 3;
        vector<int> a2(a);
        for (int i = 0; i < n && x > 0; ++i) {
            if (abs(a[i] - s[i]) <= x) {
                x -= abs(a[i] - s[i]);
                a2[i] = s[i];
            }
            else {
                if (a[i] > s[i]) {
                    a2[i] -= x;
                }
                else {
                    a2[i] += x;
                }
                x = 0;
            }
        }
        long double val = 0;
        for (int i = 0; i < n; ++i) {
            val += abs(a2[i] - s[i]) / (long double)s[i];
            // cout << a2[i] << " " << s[i] << endl;
        }
        // cout << val << endl;
        if (val <= k) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    cout << r << '\n';
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
