#include <iostream>
#include <map>
#include <set>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

void solve() {
	map<string, set<pair<int, int>>> blocked;
	set<string> names;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        string s;
        cin >> s;
        if (!names.count(s)) {
            names.insert(s);
        }
        else if (blocked[s].empty()){
            blocked[s].insert({0,0});
            s += "1";
            names.insert(s);
        }
        else {
            if (blocked[s].begin()->first != 0) {
                blocked[s].insert({0,0});
            }
            int x = blocked[s].begin()->second;
            s += to_string(x + 1);
            names.insert(s);
        }
        cout << s << "\n";
        int suff = 0;
        int pw = 1;
        while (s.length() > 0) {
            if (!('0' <= s.back() && s.back() <= '9')) {
                break;
            }
            suff = (s.back() - '0') * pw + suff;
            pw *= 10;
            s.pop_back();
            if (s.length() > 0) {
                if (blocked[s].empty() || blocked[s].begin()->first != 0) {
                    blocked[s].insert({0,0});
                }
                auto it = blocked[s].lower_bound({suff, 0});
                if (it == blocked[s].begin()) {
                    blocked[s].insert({suff, suff});
                }
                else if (next(it, -1)->second < suff - 1) {
                    blocked[s].insert({suff, suff});
                }
                else {
                    auto p = *next(it, -1);
                    auto p2 = *it;
                    bool b = false;
                    if (it != blocked[s].end()) {
                        if (it->first == suff + 1) {
                            b = true;
                            int r = it->second;
                            blocked[s].erase(p);
                            blocked[s].erase(p2);
                            blocked[s].insert({p.first, p2.second});
                        }
                    }
                    if (!b) {
                        blocked[s].erase(p);
                        p.second = suff;
                        blocked[s].insert(p);
                    }
                }
            }
        }
    }
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
