#include <iostream>
#include <vector>
using namespace std;

#define ENABLE_FAST_IO ios_base::sync_with_stdio(false); cin.tie(nullptr);

void solve() {
	int n;
	cin >> n;
    vector<int> p(n + 1);
    p[1] = 0;
    p[n] = 0;
    for (int i = 2; i < n; ++i) {
        cin >> p[i];
    }
    vector<int> dp(n + 1, 1000000);
    vector<vector<int>> I(n + 1);
    dp[n] = 0;
    for (int i = n - 1; i >= 1; --i) {
        if (p[i] != 0) {
            if (i - p[i] >= 0) {
                I[i - p[i]].push_back(i);
            }
            continue;
        }
        for (int step = 1; step <= 6; ++step) {
            if (i + step > n) {
                break;
            }
            // if (p[i + step] == 0) {
                if (step < 6) {
                    dp[i] = min(dp[i], dp[i + step] + 1);
                }
                else {
                    dp[i] = min(dp[i], dp[i + step]);
                }
            // }

        }
        for (int j : I[i]) {
            dp[j] = min(dp[j], dp[i]);
        }
    }
    // cout<< dp[6];
    cout << ((dp[1] >= 1000000) ? -1 : dp[1]) << '\n';
}

int main() {
	ENABLE_FAST_IO
	int t = 1;
	// cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
