#include <iostream>
#include <unordered_map>
#include <vector>
#include <string>
#include <set>
#include <stack>
typedef long long ll;


int main() {
    ll n;
    std::cin >> n;
    ll k;
    std::cin >> k;
    ll s1;
    std::cin >> s1;
    ll s2;
    std::cin >> s2;
    //x_1 + ... x_n = s1, x_i in [1; k]
    //x_i = t_i - 1
    //t_1 + ... + t_n = s1 - n [0; k - 1]
    ll s1mk = s1 - n;
    ll s2mk = s2 - n;
    if (s1mk < 0 && s2mk < 0) {
        std::cout << "Equal";
        return 0;
    }
    else if (s1mk < 0) {
        std::cout << "Second";
        return 0;
    } else if (s2mk < 0) {
        std::cout << "First";
        return 0;
    }
    ll max_possible_answer = (n * (k - 1));
    if (s1mk > max_possible_answer && s2mk > max_possible_answer) {
        std::cout << "Equal";
        return 0;
    } else if (s1mk > max_possible_answer) {
        std::cout << "Second";
        return 0;
    } else if (s2mk > max_possible_answer){
        std::cout << "First";
        return 0;
    }
    ll center = max_possible_answer / 2 + max_possible_answer % 2;
    ll how_close_to_center1 = std::max(center, s1mk) - std::min(center, s1mk);
    ll how_close_to_center2 = std::max(center, s2mk) - std::min(center, s2mk);
    if (how_close_to_center1 == how_close_to_center2) {
        std::cout << "Equal\n";
        return 0;
    } else if (how_close_to_center1 < how_close_to_center2) {
        std::cout << "First\n";
        return 0;
    } else {
        std::cout << "Second\n";
        return 0;
    }
    std::cout << "Equal\n";
    return 0;
}