#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

int get_sum(const std::vector<int>& sa, const std::vector<int>& aa) {
    int sum = 0;
    for (int i = 0; i < sa.size(); ++i) {
        sum += aa[i] / sa[i] - 1;
    }
    return sum;
}

int main() {
    int N, K;
    std::cin >> N >>K;

    std::vector<int> s(N);
    std::vector<int> a(N);

    for (int i = 0; i < N; ++i) {
        std::cin >> s[i];
    }

    for (int i = 0; i < N; ++i) {
        std::cin >> a[i];
    }

    int count = 0;
    std::vector<int> lens(N);
    for (int i = 0; i < N; ++i) {
        lens[i] = abs(a[i] / s[i] - 1) - abs((a[i] - 1) / s[i] - 1);
    }
    
    if (get_sum(s, a)<0){
        while (get_sum(s, a) < -K) {
            int maxlen=0;
            int j = 0;
            for(int i =0; i< lens.size(); i++){
                if (lens[i]>maxlen){
                    j = i;
                }
            }
            a[j] -= 1;
            count += 1;
            lens[j] = abs(a[j] / s[j] - 1) - abs((a[j] - 1) / s[j] - 1);
        }
    } else {
        while (get_sum(s, a) > K) {
            int maxlen=0;
            int j = 0;
            for(int i =0; i< lens.size(); i++){
                if (lens[i]>maxlen){
                    j = i;
                }
            }
            a[j] -= 1;
            count += 1;
            lens[j] = abs(a[j] / s[j] - 1) - abs((a[j] - 1) / s[j] - 1);
        }
    }
    

    std::cout << count << std::endl;

    return 0;
}