#include <bits/stdc++.h>
using namespace std;

const int dx[] = {1, -1, 0, 0, 2, -2, 0, 0};
const int dy[] = {0, 0, 1, -1, 0, 0, 2, -2};

struct State {
    int x, y, k;
    State(int x, int y, int k): x(x), y(y), k(k) {}
};

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> cityy(n);
    for (int i = 0; i < n; i++) {
        cin >> cityy[i];
    }

    int sx, sy, ex, ey;
    cin >> sx >> sy >> ex >> ey;
    sx--; sy--; ex--; ey--; // Чтобы индексы начинались с 0

    vector<vector<vector<bool>>> vis(n, vector<vector<bool>>(m, vector<bool>(k + 1, false)));
    queue<State> q;
    q.emplace(sx, sy, k);
    vis[sx][sy][k] = true;

    int step = 0;
    while (!q.empty()) {
        int q_size = q.size();
        while (q_size--) {
            State cur = q.front(); q.pop();

            if (cur.x == ex && cur.y == ey) {
                cout << "YES\n";
                return 0;
            }

            for (int dir = 0; dir < 8; dir++) {
                int nx = cur.x + dx[dir];
                int ny = cur.y + dy[dir];
                int nk = cur.k - (dir >= 4);

                if (nx >= 0 && nx < n && ny >= 0 && ny < m && cityy[nx][ny] == '.' && nk >= 0 && !vis[nx][ny][nk]) {
                    vis[nx][ny][nk] = true;
                    q.emplace(nx, ny, nk);
                }
            }
        }
        step++;
    }

    cout << "NO\n";
    return 0;
}
