from math import ceil

N, K = map(int, input().split())

standart_w = list(map(int, input().split()))
our_w = list(map(int, input().split()))

K_diff = [
    1.0,
    1.0,
    0.5,
    0.3333333333333286,
    0.25,
    0.20000000000000284,
    0.1666666666666643,
    0.14285714285714235,
    0.125,
    0.11111111111111072,
    0.10000000000000142
]
sum_weight = sum(map(lambda x, y: abs(x - y) / x, standart_w, our_w))
our_standart_diff = list(map(lambda x, y: x - y, our_w, standart_w))

num_operations = 0

# Сортируем
our_w = [x for _, x in sorted(zip(standart_w, our_w))]
our_standart_diff = [x for _, x in sorted(zip(standart_w, our_standart_diff))]
standart_w.sort()

for i in range(N):
    if sum_weight - (K_diff[standart_w[i]] * our_standart_diff[i]) >= K:
        sum_weight -= (K_diff[standart_w[i]] * our_standart_diff[i])
        num_operations += our_standart_diff[i]
    else:
        num_operations += ceil((sum_weight - K) / K_diff[standart_w[i]])
        break

print(num_operations)

