#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <math.h>
#include <iomanip>

int main(int argc, char **argv) {

    long long n;
    std::vector<long long> x;
    std::vector<long long> y;

    std::cin >> n;

    for(long long i = 0; i < n; i++)
    {
        long long cur;
        std::cin >> cur;
        x.push_back(cur);
        std::cin >> cur;
        y.push_back(cur);
    }

    long double p = 0;
    long double cur = 0;
    long double largest = 0;

    for (long long i = 0; i < n-1; ++i) {
        cur = sqrt((x[i] - x[i+1])*(x[i] - x[i+1]) + (y[i] - y[i+1])*(y[i] - y[i+1]));
        p += cur;
        largest = fmax (largest, cur);
    }
    cur = sqrt((x[0] - x[n-1])*(x[0] - x[n-1]) + (y[0] - y[n-1])*(y[0] - y[n-1]));
    p += cur;
    largest = fmax (largest, cur);


    printf("%.6Lf", p - largest);
    return 0;
}
