def min_flips_to_restore(pop_it):
    # Преобразуем строку в одномерный массив пупырок
    pop_it_array = [int(cell) for row in pop_it for cell in row]

    # Посчитаем количество пупырок в состоянии 0 и 1
    count_0 = sum(1 for cell in pop_it_array if cell == 0)
    count_1 = len(pop_it_array) - count_0

    # Возвращаем минимальное количество переключений,
    # которое нужно сделать, чтобы все пупырки были в одном состоянии
    return min(count_0, count_1)


# Считываем высоту и ширину поп-ита
h, w = map(int, input().split())

# Считываем состояние поп-ита
pop_it = [input().strip() for _ in range(h)]

# Вызываем функцию для расчета минимального количества переключений
min_flips = min_flips_to_restore(pop_it)

# Выводим результат
print(min_flips)
