def can_seat_introverts(N, K, introverts):
    left_space = introverts
    right_space = N - introverts - 1
    return left_space >= K and right_space >= K
 
def find_largest_number_of_introverts(N, K):
    left, right = 2, N
    result = 2
 
    while left <= right:
        mid = (left + right) // 2
 
        if can_seat_introverts(N, K, mid):
            result = mid
            left = mid + 1
        else:
            right = mid - 1
 
    return result
 
N = int(input())
K = int(input())
 
largest_introverts = find_largest_number_of_introverts(N, K)
 
print(largest_introverts)
