def gcd(a, b):
    while b:
        a, b = b, a % b
    return a

def find_max_gcd_pair(L, R):
    # Ищем максимальный GCD среди всех пар различных чисел в диапазоне L и R
    max_gcd = 1  # Минимальный GCD
    x = L
    y = L + 1

    while y <= R:
        current_gcd = gcd(x, y)
        if current_gcd > max_gcd:
            max_gcd = current_gcd
            result_x, result_y = x, y

        # Увеличиваем y и при необходимости сдвигаем x
        if y < R:
            y += 1
        else:
            x += 1
            y = x + 1

    return result_x, result_y

# Чтение входных данных
L, R = map(int, input().split())

# Находим пару с максимальным GCD
result_x, result_y = find_max_gcd_pair(L, R)

# Выводим результат
print(result_x, result_y)
