#include <iostream>

int gcd(int a, int b) {
    while (b) {
        a = a % b;
        std::swap(a, b);
    }
    return a;
}

std::pair<int, int> findMaxGcdPair(int L, int R) {
    int maxGcd = 1;
    int resultX = L;
    int resultY = L + 1;

    for (int x = L; x <= R; x++) {
        for (int y = x + 1; y <= R; y++) {
            int currentGcd = gcd(x, y);
            if (currentGcd > maxGcd) {
                maxGcd = currentGcd;
                resultX = x;
                resultY = y;
            }
        }
    }

    return std::make_pair(resultX, resultY);
}

int main() {
    int L, R;
    std::cin >> L >> R;

    std::pair<int, int> result = findMaxGcdPair(L, R);

    std::cout << result.first << " " << result.second << std::endl;

    return 0;
}
