def process_usernames(Q, queries):
    usernames = set()
    result = []
    
    for i in range(Q):
        username = queries[i]
        if username not in usernames:
            usernames.add(username)
            result.append(username)
        else:
            j = 1
            while True:
                new_username = f"{username}{j}"
                if new_username not in usernames:
                    usernames.add(new_username)
                    result.append(new_username)
                    break
                j += 1

    return result

# Read the number of queries
Q = int(input())

# Read queries
queries = []
for _ in range(Q):
    query = input().strip()
    queries.append(query)

# Process queries
result = process_usernames(Q, queries)

# Output the result
for username in result:
    print(username)
