def process_usernames(Q, queries):
    usernames = {}
    result = []

    for i in range(Q):
        username = queries[i]

        if username not in usernames:
            usernames[username] = 1
            result.append(username)
        else:
            while True:
                new_username = f"{username}{usernames[username]}"
                if new_username not in usernames:
                    usernames[username] += 1
                    usernames[new_username] = 1
                    result.append(new_username)
                    break
                else:
                    usernames[username] += 1

    return result

# Read the number of queries
Q = int(input())

# Read queries
queries = []
for _ in range(Q):
    query = input().strip()
    queries.append(query)

# Process queries
result = process_usernames(Q, queries)

# Output the result
for username in result:
    print(username)
