def prob(N, K, S1, S2):
    P1 = [[0 for _ in range(S1 + 1)] for _ in range(N + 1)]
    P2 = [[0 for _ in range(S2 + 1)] for _ in range(N + 1)]

    P1[0][0] = 1
    P2[0][0] = 1

    for i in range(1, N + 1):
        for s in range(1, S1 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    P1[i][s] += (1 / K) * P1[i - 1][s - k]

        for s in range(1, S2 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    P2[i][s] += (1 / K) * P2[i - 1][s - k]

    return P1[N][S1], P2[N][S2]


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

P1, P2 = prob(N, K, S1, S2)

if P1 > P2:
    print("First")
elif P2 > P1:
    print("Second")
else:
    print("Equal")
