def prob(N, K, S1, S2):
    P1 = [0] * (S1 + 1)
    P2 = [0] * (S2 + 1)

    P1[0] = 1
    P2[0] = 1

    for i in range(1, N + 1):
        new_P1 = [0] * (S1 + 1)
        new_P2 = [0] * (S2 + 1)

        for s in range(1, S1 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    new_P1[s] += (1 / K) * P1[s - k]

        for s in range(1, S2 + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    new_P2[s] += (1 / K) * P2[s - k]

        P1 = new_P1
        P2 = new_P2

    return P1[S1], P2[S2]


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

P1, P2 = prob(N, K, S1, S2)

if P1 > P2:
    print("First")
elif P2 > P1:
    print("Second")
else:
    print("Equal")
