def prob(N, K, S, memo):
    if S < 0:
        return 0.0
    if N == 0:
        return 1.0 if S == 0 else 0.0
    if (N, S) in memo:
        return memo[(N, S)]

    P = 0.0
    for k in range(1, K + 1):
        P += (1 / K) * prob(N - 1, K, S - k, memo)

    memo[(N, S)] = P
    return P

N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

if N == 1:
    pos1 = 0 < S1 < K
    pos2 = 0 < S2 < K
    if pos1 and pos2:
        print("Equal")
    elif pos1:
        print("First")
    elif pos2:
        print("Second")
    else:
        print("Equal")
else:
    memo = {}
    P1 = prob(N, K, S1, memo)
    P2 = prob(N, K, S2, memo)

    if P1 > P2:
        print("First")
    elif P2 > P1:
        print("Second")
    else:
        print("Equal")
