#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
struct part{
    int s;
    int a;
    int a_s;
    double s_1;
};

bool compareInterval(part i1, part i2)
{
    return (i1.s_1 > i2.s_1);
}


int main() {

   int n;
   int k;
   double dev = 0;
   std::cin >> n >> k;
   std::vector<part> vec(n);
   for(int i=0;i<n;i++){
       std::cin >> vec[i].s;
   }
   for(int i=0;i<n;i++){
       std::cin >> vec[i].a;
       vec[i].a_s=abs(vec[i].a-vec[i].s);
       vec[i].s_1=fabs(1.0/vec[i].s);
       dev += vec[i].a_s*vec[i].s_1;
   }
   std::sort(vec.begin(),vec.end(),compareInterval);
   int i=0;
   int sum = 0;
   while (dev > k){
       part p = vec[i++];
       int diff = (int)std::max(0.0,std::ceil((dev - k) / p.s_1));
       int mins = std::min(diff,p.a_s);
       dev -= mins * p.s_1;
       sum += mins;
   }
   std::cout<< sum <<"\n";
}