from math import sqrt, ceil


def go(elem_list, x, y):
    for elem in elem_list:
        higher = y - y % elem
        if x <= higher - elem:
            return higher - elem, higher


def max_gcd(l, r):
    gr = ceil(sqrt(r))
    delta = r - l
    if gr < delta:
        elems = (r // factor for factor in range(r // delta, gr))
    else:
        elems = range(delta, 0, -1)
    return go(elems, l, r)


L, R = map(int, input().split())
print(*max_gcd(L, R))
