def calculate_probability(N, K, S):
    dp = [0] * (S + 1)
    dp[0] = 1

    for _ in range(N):
        new_dp = [0] * (S + 1)
        for s in range(S + 1):
            for k in range(1, K + 1):
                if s - k >= 0:
                    new_dp[s] += dp[s - k]
        dp = new_dp

    return dp[S]

def find_winner(N, K, S1, S2):
    prob_first = calculate_probability(N, K, S1)
    prob_second = calculate_probability(N, K, S2)

    if prob_first > prob_second:
        return "First"
    elif prob_second > prob_first:
        return "Second"
    else:
        return "Equal"


N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

winner = find_winner(N, K, S1, S2)

print(winner)
