import math


def distance(x1, y1, x2, y2):
    return math.sqrt((x1 - x2) ** 2 + (y1 - y2) ** 2)


def find_sides(monster, N):
    sides = []
    for i in range(N):
        next = i+1
        if i == N-1:
            next = 0
        sides.append(distance(monster[i][0], monster[i][1], monster[next][0], monster[next][1]))

    sides.remove(max(sides))
    print(sum(sides))
    return


def main():
    N = int(input())
    monster = []
    min_distance = float('inf')

    for _ in range(N):
        x, y = map(int, input().split())
        monster.append((x, y))
    find_sides(monster, N)


main()
