#include <iostream>

long long gcd(long long a, long long b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

int main() {
    long long L, R;
    std::cin >> L >> R;

    long long maxGCD = gcd(L, L + 1);
    long long num1 = L;
    long long num2 = L + 1;

    for (long long i = L; i <= R; i++) {
        for (long long j = i + 1; j <= R; j++) {
            long long currentGCD = gcd(i, j);
            if (currentGCD > maxGCD) {
                maxGCD = currentGCD;
                num1 = i;
                num2 = j;
            }
        }
    }

    std::cout << num1 << " " << num2 << std::endl;
    return 0;
}