import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.math.BigInteger
import java.util.*
import kotlin.math.abs
fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

fun truesolve() {
    val n = readLong().toBigInteger()
    val k = readLong().toBigInteger()
    val two = 2.toBigInteger()
    val ss1 = readLong().toBigInteger()
    val ss2 = readLong().toBigInteger()
    var s1 = ss1 * two
    var s2 = ss2 * two
    if (ss1.toLong() !in (n.toLong())..(n.toLong() * k.toLong())) {
        s1 = Long.MAX_VALUE.toBigInteger()
    }
    if (ss2.toLong() !in (n.toLong())..(n.toLong() * k.toLong())) {
        s2 = Long.MAX_VALUE.toBigInteger()
    }
    val one = 1
    val left = n * two
    val right = n * k * two
    val navg = ((k + one.toBigInteger()) * n)
    var fdist = (s1 - navg).abs()
    var sdist = (s2 - navg).abs()
    if (fdist == sdist) {
        fdist = min((s1 - left).abs(), (s1 - right).abs())
        sdist = min((s2 - left).abs(), (s2 - right).abs())
        if (fdist == sdist) {
            out.println("Equal")
        } else if (fdist < sdist) {
            out.println("Second")
        } else {
            out.println("First")
        }
    } else if (fdist < sdist) {
        out.println("First")
    } else {
        out.println("Second")
    }
}

fun solve() {
    truesolve()
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}