import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.math.BigInteger
import java.util.*
import kotlin.collections.ArrayList
import kotlin.collections.HashMap
import kotlin.collections.HashSet
import kotlin.math.abs
fun <T : Comparable<T>> min(a: T, b: T) = if (a < b) a else b
fun <T : Comparable<T>> max(a: T, b: T) = if (a > b) a else b

fun solve() {
    val n = readInt()
    val parents = IntArray(n)
    val hasMap = HashMap<Int, HashSet<Int>>()
    val target = IntArray(n)
    val targetMap = HashMap<Int, HashSet<Int>>()
    for (i in 1 until n) {
        parents[i] = readInt()
        hasMap[parents[i]] = (hasMap[parents[i]]?:HashSet())
        hasMap[parents[i]]!!.add(parents[i])
    }
    for (i in 1 until n) {
        target[i] = readInt()
        targetMap[target[i]] = (targetMap[target[i]]?:HashSet())
        targetMap[target[i]]!!.add(i)
    }
    var ans = ArrayList<String>()
    for (i in 0 until n) {
        for (x in targetMap[i]?:HashSet()) {
            if (hasMap[i] != null && hasMap[i]!!.contains(x)) {
                continue
            }
            ans.add("$x $i")
        }
    }
    out.println(ans.size)
    for (a in ans) {
        out.println(a)
    }
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

var tok = StringTokenizer("", " ")
var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()!!
}

fun readInt() = read().toInt()
fun readLong() = read().toLong()
fun readIntArray(n: Int) = IntArray(n) {
    readInt()
}
fun readLongArray(n: Int) = LongArray(n) {
    readLong()
}