﻿#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <random>
#include <cstring>
#include <numeric>
#include <queue>
#include <cassert>
#include <fstream>
#include <sstream>
#include <bitset>

using namespace std;

#define M_PI 3.14159265358979323846264338327950288419716939937510
#define inf 1e15
#define eps 1e-10
#define fori(n)for (long long i = 0; i < (n); i++)
#define forj(n)for (long long j = 0; j < (n); j++)
#define rep(i, n)for (long long i = 0; i < (n); i++)
#define re return
#define ll long long
#define ull unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define bit(i, n) ((n >> i) & 1)
#define ld long double
#define vec vector
#define unq(x) x.resize(unique(all(x)) - x.begin())

int __not_lg(ll n) { int cnt = 0; while (n /= 2) cnt++; re cnt; }
struct dsu {
	vector<int> v, cnt;
	void build(int n) { v.resize(n); cnt.resize(n); iota(all(v), 0); fill(all(cnt), 1); }
	dsu() {}
	dsu(int n) { build(n); }
	int get_par(int i) { if (v[i] != i)v[i] = get_par(v[i]); re v[i]; }
	bool check(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); re i1 == i2; }
	void merge(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); if (i1 == i2)re; if (cnt[i1] > cnt[i2])swap(i1, i2); cnt[i1] += cnt[i2]; v[i2] = i1; }
};

#ifdef LOCAL_BOBER
#define __lg(n) __not_lg(n)
#define __int128 ll
#define asdasdasfasd ifstream fl("sample.io")
#define ffast_io ios::sync_with_stdio(false);\
				 cout.tie(nullptr)
#define cin fl
#else
#define asdasdasfasd //freopen("input.txt", "r", stdin);\
					 freopen("output.txt", "w", stdout);
#define ffast_io ios::sync_with_stdio(false);\
				 cout.tie(nullptr); cin.tie(nullptr)
#define tvq 100000
#endif

template<class T> T fast_pow(T n, ll p) { if (p == 1) re n; if (p % 2) re n* fast_pow(n, p - 1); re fast_pow(n * n, p / 2); }
template<class T> T mod_fast_pow(T n, T p, T m) { if (p == 0) re(T)1; if (p % 2 == 1) re n* mod_fast_pow(n, p - 1, m) % m; re mod_fast_pow(n * n % m, p / 2, m); }
template<class T> T gcd(T a, T b) { if (!a)re b; re gcd(b % a, a); }
template<class T> void umax(T& a, T b) { a = max(a, b); }
template<class T> void umin(T& a, T b) { a = min(a, b); }
template<class T> istream& operator >> (istream& o, vector<T>& x) { for (auto& el : x) o >> el; re o; }
template<class T, class U> istream& operator >> (istream& o, pair<T, U>& x) { o >> x.first >> x.second; re o; }
template<class T> istream& operator >> (istream& o, pair<T, T>& x) { o >> x.first >> x.second; re o; }
template<class T, class U> pair<T, U> operator-(pair<T, U> a, pair<T, U> b) { return { a.first - b.first, a.second - b.second }; }
template<class T, class U> pair<T, U> operator+(pair<T, U> a, pair<T, U> b) { return { a.first + b.first, a.second + b.second }; }
template<class T> vector<T> operator+(vector<T> a, vector<T> b) { fori(a.size())a[i] += b[i]; re a; }
template<class T> vector<T> operator-(vector<T> a, vector<T> b) { fori(a.size())a[i] -= b[i]; re a; }
template<class T> string to_bin(T n) { string s = ""; while (n) { s = to_string(n % 2) + s; n >>= 1; } re s; }
template<class T> string fixed_to_bin(T n, ll q) { string s = "";  fori(q) { s = to_string(n % 2) + s; n >>= 1; } re s; }
ll from_bin(string s) { ll m = 0; fori(s.size()) { m = (m * 2) + s[i] - '0'; } re m; }
template<class T> int cnt_bit(T n) { int cnt = 0; while (n) { cnt += n % 2; n >>= 1; }re cnt; }

/*
888888888$$8W8888W888WWWWWWW888WWWWWWWWWWWWWWWWWWWWWWWW8W88$88WW8WWW8888888WW888888888888888WWW888WWW8888WWWWWWW88888WWWWW88888888
888888888$$8W8888WW8888888888888WWWWWWWWWWWWW888888888888W8$$8WW88WWWWWW888888W8888WWW8888888WW8888WWWWW8WWWWWWW8WW88WWWWWWWW88888
88888888888WW8888888888888888888WW88WW88888888888888888888$$88888888888888888888888888888888WW8888WWWWWWW888WWW88888888WWW88888888
888888888$88W8888W888WWW88888888WWWWWW8888WWWWWWWWWW888WWW8$8W8W8888888W88888888888888888888WW8888WWWWWWWW8WWWWW8888WWWWWWWW888888
888888888$88WW8WWWW8888888888888WWWWWWW88888W88WWWWW8WWWWW8$$8W88WWWWW88888888888888888888888888888WWWWW8W888WWW888WWWWW8888888888
888888888$88W8WWWW8888888888888WW888W888888W888W8888WWW8WW$@8WW8W888888888888888888888888888888888W88888888WWW88888888888888888888
88888888$$88W88W8W8888WWWWW88WWWWWWWWWWWW88W888WWWW8WWW88W8$8WWW88888888888888888WW888888WWWWWW88WWWWWWW8WWWWWW88888WWWWWWW8888888
888888888888WWWWWWW888WWW888888WWWWWWWWWWW8WW88WWW9999HH999999999999999WWW888888W888888888888WW888WWWWWWWWWWWWWWWWW8WWWWWWW8888888
88888888888WWWWWWW88888W8888888WWWWWWW88W88888WW9HHHHHHHHHHHHHH444H99HHH9WW888888888888888888W8888W88888WW88WWWW888888WW8888888888
888888888888W8888W88888WWWWWWWWWWWWWW8WWW888WW99999HHHHHHHH999999999999999W88W88W8888888888WWW888WWWWWWW88WWWWWW888WWW88WWWWWWWW88
8WW888888888WWWWWWW888888W8888WWWW88888888W99HH4444ZZZZZZZZZZZ44HHHHHH999999WW8W888888888888WWW888WWWW8W8888888WW88888888888888888
8W888888888WWWWW8888888888888888W88WW88899HHHH44ZZZZZ111ZZZZZZZ4HHHH9999999WWW8888888888888WWW888888888888888888888888888888888888
888888888888W8888888888888WWWWWWWWWWW888W999HHH4444ZZZZZZ4444444HHH99WW99WWW8W8W8888888888WWWW8888WWWWWW88WWWWWWWW88WWWW8888888888
W8888888888WWW88WWWW888WWWW88WWWWWWWWWW999H4Z111lllllllllllll111111ZZ44HHHHH99W99WW88888888WWWW8888WWWWW8888888WWWWWWWWW8888888888
W8888888888WWWWWWWW888888W8888WWWWWWWW99H4ZZZ11111111111111111ZZZZZZZ444H999H9WWWW888888888WWW88888WW88888888888888WWW888888888888
88888888888WWW8WW88888888888WWWW8WWWWWW9444444ZZZZZZZZZZZZZZZZ444444HH44H9WW9HW8WW888888W88WWWW88WWWWWWW88WWWWWWWWWWWWW8WWWWWWWW88
W8WW8888888WWWWW8WWWWWWWWWWWWWWW8WWW99HZ1l11lllll((((((((((((llll111111ZZZ4H99H9WWWWW8888W88WWW888WWWWW88888888WWW8888888888888888
88888888888WWW888WWW888WWWWWW88W99999Z11111111lllll(((llllllll11111ZZZZZZ14W9H98WWWW888888888W88888WW88888WWW888888888888888888888
8W8888888888W88W88888WW888W888W999WWHZZZZZZZ11111111111111111ZZZZZZ4444HH449W9W8888WW8888888WWW888WWWWWWWWWWWWWW888888888888888888
WWW88888888WWWWWWWWWWWWWWW8WWW89HHHH4lllll((((((rrrrrrrrrrr((((((lllll111ZZ14H99WWWW9WW888888WW8888WWWWWWWW888WWWWWWWWWWWW88888888
8W888888888WWWWWWWW88WWWW88WWWW9999Zll1llll((((((((((((((((lllllll11111ZZ4ZZ4H999WW99W8888888888888WWW88888888WW888888888888888888
88888888888WW8888WW888WWW8W88W9HW9411ZZ111111llllllllllll1111111ZZZZZZ4444444H999WWW9W88888WWW8888WWWW8888WWWWWW88888888W8888WWW88
88888888888WWW8W8WWWWWWWW8W88W99WHZl(ll((((rrrrrrr/////rrrrrr((((((((lll111Z11Z4HHH9999WW888WWW888WWWWW88888WWWW888888888WW8WWWW88
88888888888WWW8W8WWWWWWWW88WW99991ll1lllll((((((((rrrr((((((((llllll11111Z4ZZ1Z44H99999W888WWW8888WWW88888888888888888888888888888
88888888888WW8888888WWW88W8W99999H1ZZ1111111lllllllllllllll1111111ZZZZZZZ4444Z14H99W99WWW88WWWW888WWWWWWWWWWWWWW88888888WW88888888
W8888888888WWW8W8WWWWWWW8W8W9WW9W41ll(((rrrrrrrrr///////rrrrrrrrr(((((llll11ZZ1ll1Z4H9999W8WWW88888WWWW8888WWWWWWWWW88WWW888888888
88888888888WWWWWW8WWWWW88WW9HHHH1(l1llll((((((((rrrr((((((((((((((llll1111ZZ4ZZ1l144H9W9W88W888888WWWW8888888888W888888W8888888888
88888888888WW88W88WWWW88889H9HH4l(l1Z111111lllllllllllllllll111111111ZZZZ4444H4ZZZ44498W9W8WWWW888WWWWWW888WWWW8WWWWWWWWW888888888
888WW888888WWW8WWWWWWWW8889999H4ll1ZZ(rrrrrrrr////////rrrrrrrrrrrrr(((((lll111ZZ1111ZZ49W9WWWWW888WWWWWWWWWWWW888WWWWWWW8888888888
88888888888WW88WWWWWWWW8W99H44Zl((ll(l(((((((rrrrrrrrrrr(((((((((((llll11111Z44ZZZ1Z4Z49W9W8W88888WW888888888888888888888888888888
88888888888WW8888888WW888WH4ZZZll11lll1l1lllllllll(((((llllllllll11111ZZZ44444H44444HHHHWW88WWW888WWWWWW88888888888WWW888888888888
88888888888WWW8WWWWWWW888WHHH4111ZZZ111rrrr////////////////rrrrrrrrrr((((lllll1ZZ1Z1Z44449WWWWW888WWWW8W8888WWWWW8WWWWW88888888888
88888888888WWWWWW8WWW888WH4HZl(lll((rrr((rrrrrrrrrrrrrrrrrr((((((((((llll11111Z4ZZZZZHH4HWWW8WW888WWW8WW88888888888888888888888888
88888888888WW88W888WW88WW4HH1(llllll((((llll((((ll((((rr((((lllllll1111ZZZZZZZ4HH4444H9HH9WWW88W8WWWWWWWWW88888W888888888WWW888888
88888888888WWW8888WW8W88W99H1111ZZ111111lr///////////////////rrrrrrrrr((((((lll1ZZZZZZ4444H9WW8888WWWWWWWW888888W88888888888888888
88888888888WWW888WWW8W8WHH41l((((((rrrrrrrrrrrrrrr///////rrrrrr(r((((((lllllll1Z4Z44ZZ4H4H9WWW8888WWW88888888888888888888888888888
888888888888WW8888888889H441lllllll(((((((l(((((rrrrrrrrrr(((llllllll111ZZZZZZZ4H44HHHH999WWWWW8WWWWWWW8888WWWWWWWWWWW88W88WW88888
88888888888WWWWWWW88WW89H94Z1111Z1111llllll/////!!!!!!!!!!/////////rrrrr((((((ll1111ZZZ44HH9WW88888WWWW88888888WW88WW8888W8WWW88W8
88888888888WWWWWWW8WWWWH441l((((((rrrrrrr//rrr//////////////rrrrrr((((((llllll11ZZZ4444499HW888888WWW8888888888W888888888888888888
888888888888WW888W8WW8WHHHZlllllll(((rrrrrrr((rr//////////rr((((lllll1111111ZZZ444HHHHH9WW9W8W8W8WWWWWWWWWWWWWW888WW88888888888888
88888888888WWWWWWWWWW8WH99411111111lllllll(((//!!!!!!!!!!!!!//////rrrrrr((((((lll11ZZZZ4HH99WWW888WWWW8WW8WWWW888888888888W888WW88
88888888888WWW88W88WWW94H41l((((((rr/////////r//!!!!!!!/!////rrrrr((((((llllll11ZZZ4444HH99W8W88888WW888888WWW88W88888888888888888
88888888888WW888888W889HH41lll((l(((rrrrrrrrrrrr///////////rrr((lll1ll11111ZZ1ZZ444HHHH99WWWWWW888WWWW8WWWWWWWWWWWWWWW888888888888
88888888888WWW88WW8WW8W99H41111ll1llllll(l(((((!!!!!!!!!!!!!!!////rrrrrr(((((((ll11ZZZ44H999WWW88WWWWW88WWW88888W88WWW8888888W8888
88888888888WWW88WW8WW8W94Z1l((((rrrr//////////////////////!///rrrrr((r((((lllll1ZZZZ44HH999WWWW88WWWW88W88888888888888888888888888
888888888888W888WW8WW8W9H4Z1ll(((((rrrrrrrrrrrr/r(rrrrrrrr/rr((((((llllll111ZZZZ444HH9999WWWWWWW8WWWWWWW88888888WWW888WW8888888888
88888888888WWWWWW8WWW8W99H4Z1111lllllll(((((((((r////////!!!////////rrrrrrr(((ll111ZZ444H999WW8888WWWWWW888888888WW8888888888W8888
88888888888WWW8W88WW8W9HH4Z1l(((rrrrr//////////////rrrrrr///////rrr((rr((((lll1ZZZZZ44HH99WW888888WWWW8888888888888888888888888888
88888888888WWW8888WW889HHH4Z1l((((((rrrrrrrr//////r(((((((rrr/rr(((l(((llll111Z4H44HHH999WW8899W8WWWWWW88888888WWWWWWW88888WWW8888
88888888888WWWWWWWWW88W999H4Z11llllllll((((((rrrr//////////!!!!/////////rrrrr((l11Z1ZZ4449WWWH1Z98WW8888888WWWWWW8WWWW888888888888
88888888888WWWWW88WW8W9HH4Z1l((((rrr/////////!!!!!!///////!!!//////rrrrrrr((((llZZZZZ44H9WWWH4HH88W8W8W888888888888888888888888888
88888888888WWW8888W88WH9HH4Z1ll((((((rrrrrrr//////////rr////rr((rr((((((llllll1144HH44H9W8$8H9WHW8WWWWWW88888888888888888888W88888
88888888888WWWWWW8WW8WWW9994Z11llllll((((rrrrrrr/////!!!/!!!////////rrrrrrrrr((ll1ZZZZZ4H9WWH4HHZW8WWWW88888888888888888W888888888
88888888888WWWWWWWWW8WHHHH41((((((rr////!////!!!:!!!!/////rrrrrrr((llllll(((ll11Z44Z444H9W9HH99ZW8W8888888888888888888888888888888
88888888888WWW88WW8W8WZ4H9HZll((l(((rrrrrrrr////!/////rr(((((llll1Z44444ZZ11ZZZZ4HHHHHH99WW9WW9498WW8WWW88888888888888888888W88888
88888888888WWWWWW8WW8WZHWW9411ll11ll((((((((((ll((((rrr/////rrr((l1Z4Z111llll(ll1ZZZZZZ4HHHHH4Z11W8WWWWWW8888888888WWWWWW888888888
88888888888WWWWWWWW884l4HHZ1l((((((rrrr//rr((llll(rr///rrrr(((llZZ4H41llll11lll11ZZZZZ4H9HH9H44l98WWWW8888888888888888888888888888
88888888888WWW88WW888Hl4H941ll((llll((((r(l11ZZZZ11l(rrr((l1111449H41ll1ZZZ44Z1ZZZZZ44H9W999HHH148WW88888888888W888888888888888888
88888888888WWWW8WWWW$H149H4Z11ll1111lll(ll1ZZ44HHZZ11l(((/r(((l1Z4Zl(lZ4HHZ1ZZ1llllll1Z4HHHH4Z11(488WW88W888888W8888888W8888888888
88888888888WWWW8WWW8WlrlZZ1ll(((lll((rr(l1llllll111l(rrr/r(lllZ4Z11lrl1H84l14HZlllll1ZHHH9W94Z411888W88W88888888888888888888888888
88888888888WWWW8WWWW8Zrl1ZZ1ll(((ll((r(lZ1ll(lll11Z11l(rrrl114HHZZ4l!(4WWZl14HHZZZ11Z4H99W8WH44Z1W88888WW888888888888WW88888888888
88888888888WWWW8W8WW84l1lZ4Z11lll(llllZ4Z1ZHHHHZZZ4ZZZ1((((r(lZ1((lr/!(Z4Zllll1lll(((l144HW9HZlll1W88W88W88888888888WWWW88WWWW8888
88888888888WWWWWWWW8Wl/r((l1l(((rrr((lZ1(lZ99HZ(l1111l(r/!/(1ZZr1lrl(r((l(ll111((((l1Z4HHWW9H1lZ1W8WW8888888888888888888888W888888
$8888888888WW8W8WW888Zrlll1Z1l((((((l1ZZ1/l9WW4r/111l(l(r//rZ4Zl111ll(((ll1Z441l1111Z4H99W88WZ14Z9WWWW8W8WWWW8888888WWW88888888888
88888888888WWWW8WWWW$9lll1Z4Z1lllll1ZZZZ1r(Z4HZ((111l(lll((l1lll(rrrrr//rr(lll(rrr(((l14HH9994((14WWWWWWW888W888888WWWWW8W88888888
88888888888WW8WWWWW88Z/rrr(lll(rr/r((((((rr(((((((((rrrr///r(11ll((llll(ll1l(rr((((l1Z4HHH9W9Z(Z4W8WWW8888888888888888888888888888
$8888888888WWW8WW88W89((l((111l(rrrrr(lll((rrrr(l1l(r((((rrrll4Z1lllll11Z111l(ll111ZZ4H999W8W4Z4HW8WWW888WWW888WW88888888888888888
88888888888WWWWWWWWW88Z(l1lZ4Z1ll((((ll111l(r(l1ZZ1lll1ll((l11Zl((rrrrrrrrr///rr((((ll14HHHHHZ1Z49WWW88WW8WWW888WW8888888888888888
88888888888WW8888WWW8W1//rrl1l(r/rr///rrr((((((l(rrrrrrr///r((l1l(((((rrrrrrrr((((l11Z4H999HZ4H49W8W888888W88888888888888888888888
88888888888WW88888WW88HrrrrlZ1l((((rrrrrrr(llll(((rr((((rr/r(l11Z1l(llllll(lllll1111Z4H99WWH4HHHWWWWW88888W8888888888WWWWW88888888
88888888888WWWWWW8WWW8W1(ll1ZZZ11llll((((((((((((l(llllll(((11Z4Z((r///rr///rrrrr((((lZ4H994Z44498WWW88W888888888WWW88888888888888
8888888888WWWWWWW8WWW89l/r(l1l((rr/////////////////rrrrr///rr(llll(rrrrrrrrr((((llll1ZHH99H44H988WWW88W8W8888888W88888888888888888
88888888888WWW88W8WWW889(rr1Z1l((((rrr//rrrr((rrrrr((((((rrr(l11111l(((((((ll111111ZZ49WWW9H4H88WWWW88WWWW888WWW888888888888888888
88888888888WWWWWWWWWWW88Z(r14Z111llll(((((((l((rr(ll1lllll(l11ZZZZ1r/!///////rrrr((ll1ZHH9H4Z4W8W8WWWWWWW8888888W8WWW8888888888888
88888888888WWW8WWWWWWW8WZ//lZl((rrr///////////!!!!/rrrrrr//rr(llll(r//r/rrr(((lllll11ZH99HH4HW8W8WWWW88W8888888888888888W888888888
88888888888WWW88W88W8W889l/(Z1ll((((((rrrrrrr//////((((((((((l11111l(r((((llll11ZZZZZ49WW99HW8WWWWWWWWWWW88WWW8W8WWW888WWWW8888888
88888888888WWWW8WW8WWWW884((ZZ11111llll((rrrrrrrrr(l111lllll11Z44ZZZl/////rrrrr(((ll11ZHHH44HW8WWWWWWW8WW888WW8888888888W888888888
8888888888WWWW88W88W88W884((11l((rrr////!!!!!!!///r(((rrr//rr(llllllrrrrrr((lllll11ZZZHHHHH9W888WWWW8888888WW888888888888888888888
88888888888WW8888W8W888888Zr1Z1l(ll(((rrr/////rr(r((ll((((rr((l111l11(((lll11111ZZ44449W9HHWWWWWWWWWWWWWW8WWW888888888WWWWW8888888
88888888888WWW8888888WWWW89(14Z1111llll((rrrr((ll(l1111ll(rr(l1ZZZ1Z4Zl//rrrrr((ll1111ZHHHH9W888WWWWWW888W88W88888888888WWW8888888
88888888888WWW8888W8WWWWWW4(l1l(((rrrrr//////rrr/r((rrrrr/!/r(ll((l1Z(rr(((((ll11ZZZZZH99W88WW8W8WWWW88888888888888888888888888888
$8888888888WWW88888888WW888llZ1llll(l(((((rrr((((r((((((((r((l1ZlllZH1((ll11111ZZ4444HH9988WWWW8WWWWW8WWWW888WW8W888888W8888888888
8888888888WWW8888WWWWWWWW88W11ZZZ1111llllllll111l((111Z4Z1ll1ZHW944WWZlllrrr(((lll111ZZ4HW88WWW88WWWWW8WWWW88888888888888W88888888
$8888888888W888WWWWWWWWWWW8841lll(((rrrrrrrrr((r///(14H4Z111ZH9WHHHH1(rrr((((lll111ZZZ4HW88WWW888WWW888888888888888888888888888888
$888888888888888W88WWWWW8WW$8Z11llllll((((((ll((r(((lZZZ1Z4H9W9HZ1Z1l((l((ll11111ZZ4HHH9W8WWWWWWWWWW88WWWWW88888888888888888888888
$8888888888WWWWWWWWWWWWWW8W884ZZ11Z11111111111lll(lllllll1Z444ZZZZ111111111(((((((l1ZZZ498WWWWWWWWWWW888WWW88888888888888888888888
$888888888WWWW8WWWWWWWWWW8W8WZlll(((((rrrrr(((rr(rr(((((rr((rrr(ll((ll((ll(lllllllZZZZ498WWWW8WWWWW8888888888888888888888888888888
$8888888888WWWW8888WWWWW8888$Hlllllll((((((lll((lllllll(rll((((ll1lllll11lll1l111Z444HHW8WWWWWWWWWWWWWWW88888888888888888888888888
$8888888888WWWWWWWWWWWWWWWWW8WZZ11111lllll11ZZ1llllll((((11ll((ll11111ZZZ1111(r(((1ZZZZHW8WWWWWWWWWW88WWWW888888888888888888888888
$888888888WWWWW88WWWWWWWWWWW8H1ll(((rrrrr(llll(rrrr//////rrr///rrrrr((((((lll(((l1Z444H888WW8888WW88WWWWW8888888888888888888888888
$$888888888WWWWWW888888WW88888Z1llll(((((llllll(rrrr(((((r/rrr(11Z11lll1Z11llrll14HHH4988WWWW88WWWWWWWWW88888888888888888888888888
$888888888WWWWWWW8WWWWWWWWWW88HZZ111lllll111ZZZ1l1144HHHH4Z114H999WW9H98WZ11l((r(lZZZZ49WWWWWWWWWWWWWWWWWW888888888888888888888888
$888888888WWW88W8WWWWWWWWWWW8W4lll(((rrrr((lll14HHH44ZZ11ZZ4HH44ZZZ19884(rrr//r(1444ZHW88WWW888WWWWWWW8888888888888888888888888888
$8888888888WW8888888WWWW8888W8W1l1lll(rrr(ll(r(48894(rr!r(rlZlrlrrrrW8Hl/rrrrrrrZHHHH988WWWWWWWWWWWWWWWW88888888888888888888888888
$8888888888WWW8WW888WWWW8W88W8841Z111llllllll((lZH4Z(r/:/r!/(/!(//l4WHZlllll(((l1ZZZZ498WWWWWWWWWWWWWWWWWW888888888888888888888888
$8888888888WWW8WW88WWW8888WWW8WZlll(((rrrrrrrr//r(ll(r!:!/!//!/rrlZ1l((rrrrrrrr(1444HW888WWWWW8W8888888888888888888888888888888888
$8888888888WWW88888888888WW88W$9111lll(((((((rrrrl11ZZl((rrrrr(Z4Z1ZZ1l(r(((rr(l14HH9W8W8WWWWWWW8WWWW88888888888888888888888888888
$8888888888WWWWW8WWWWWWWW8W88W884ZZ111llllllll((((1ZZZ1ZZ4ZZ4ZZZZZ44441ll1lllllZ4HH4H9W88WWWWWWW8WWWWWWWW8888888888888888888888888
$888888888WWWW8888888WWWWWW8WW8WHlll(((((rrrrrr//r(((((r//r(rrrr(l111l(rr((rr((1ZZZ99W88WWWWWW8888WW888888888888888888888888888888
$8888888888WWW888888888888W88888WZ111lll(((((((rrrr(l11l(/rll(l1ZZZZZ1l((ll(((l144Z49W8WWWWWWWW8WWWWW88888888888888888888888888888
8888888888WWWWWWWWWWWWWWWWWW88888WZZZ11111llllll(((ll1Z1111ZZ1ZZ4444Z1l1111111Z4HH49WH9W8WWWWWW88WWWWW8WW8888888888888888888888888
$888888888WWWWWWWWWWWWWWWWWWWWWW89Zlllll(((rrrrrrrrr(((((((((lll1111l(r(ll(((l1ZZZ4H99W8WWWWWW88WWWW888888888888888888888888888888
$$888888888WW888W8888888WW8WW8WW889Z11lll((((((((rr((ll111111ZZZZZZ1l((ll1l(l1ZZZ4H99HW8WWWWWWWWWWWW888888888888888888888888888888
$$888888888WWW8WWWWWWWWWWWWWW888888HZZ11111lllllll((lll11Z4444ZZZZ111ll1ZZ11Z4444HWWW999W8WWWWWWWWWWW888W8888888888888888888888888
$$88888888WWWWWWW8888888WWWWW88888WZ11l(((((((((r//rrrrrr(((ll((l((rrr(l1lll1ZZZ499HHHH888WWWWWWWWW8888888888888888888888888888888
$$$88888888WWW888888888888W888WW88811411llll((((((rrrr(((((((l(l(((((r(l11l1Z4ZZH99H99H988WWWWWWWWWWWWW888888888888888888888888888
$$888888888WWWWWW8888WWWW888WW88W8W11441Z11111l1l(((((rr(r(((((llll((lZZZZ44H44HW8999W99W88WWWW8WWWWW8W888888888888888888888888888
$$88888888WWWW8WW8888WWWWWWW8888884llZZZ1lll1l((rr///////////rrrrrr/r(ll11Z4ZZ4999HHHHHHH$W88W8W8WW8888888888888888888888888888888
$$$88888888WWW88W888WWW8888888888$Hll1Z4Z1ll11lll((rrrrrrrrr((((((rr(l11ZZ44449WW999HHHHH98888WWWWWWWWW888888888888888888888888888
$8888888888WWWWWW8WWWWWW8W888WWW88ZlZ1ZHH4ZZZZZZ1lll(((((((((lll(((l1ZZ4HHHHH98WWWWW9999HH894WWW8WWWWWW888888888888888888888888888
$8888888888WWWWWW88WWWW88888WWW88H((ll1Z44ZZZZ11l((rr///////////r/rl111Z49H4H9999HHH444Z14WlH88WWWWW8W8888888888888888888888888888
$8888888888WWWW8888888888888WWWW84(lll11Z444ZZZZZll(((rrrr(((rrrr((l1ZZH99HHWW9999HH44ZZ11W898WWWWWWWWW888888888888888888888888888
$8888888888WWWWW8WWWW88888WWWWWW8Zl1l111Z4H4444HH44Z11ll((llll((l11ZZ49W899W8WWWW99HH444Z1W848WW8WWWWWW888888888888888888888888888
$8888888888WWWW8888888888WWWWWH99((((llll1Z4ZZ1Z44Z1l(((((((((((ll1Z4HW99999H99H4ZZ11l1l(ZWW98WW8WWWWWW888888888888888888888888888
$$888$88888888888888WWW88WWW8W18Hrll((lll11Z44ZZ1Z4HHZ1ll11ll111Z44HWWW99999999H4111ll11l18$88W8WWWWWWW888888888888888888888888888
$$888888888WWWWWWWWWWWWWWWWW89Z8Zlllll11111Z4HHH4ZZ4HWW9HHHHHH99WWWWWWWWWWWWWW9HZZ111111lZW8WWWWWWWWWW888WWW8888888888888888888888
$8888888888WWWWWWWWWWWWWWWWWWH9H(r((r((((lll1Z4H44Z1Z4H999W999999999999999HHH41l((l(((l(l988WWWWW8WWW88888888888888888888888888888
$888$888888WWW88WWWWWWWWWWWW898Wr((((((llll1l1144HHH4Z1ZZ44444HH4H9999W9999H4Zl((l((ll((488WWWWWWWWWW88888888888888888888888888888
$8888888888WWWWWWWWWWWWWWWWWW8$H(((l(((llll11111Z4H9W99H44444HH99WWW8WWW999H41lll1111llH888WWWWWWWWWW88888888888W88888888888888888
$88888888WWWWWWWWWWWWWWWWWWWW89lrrrrrrrr((((llllll1Z4H9999999999WW9999H44Z1l(rrrr((rrZW88W8WWWWWWWW8888888888888888888888888888888
$8$$8888WWWWW888WWWW88WWWW88WW8Z/r(rr((((((((ll11lllll1Z4H99WWW9W999H44ZZ1l(((((((rrZW$8W888WWWW8WW8888888888888WWW888888888888888
$888888WWWWWWWWWWWWWWWWWWWWWWW$Wl((((((((lll(ll11Z1llllllll1Z444HH44ZZZZZ1lllllll(lH88WWW88WWWWWWWW8888888888888888WW8888888888888
$8$88WWWWWWWWWWWWWWWWWWWWWWWW88W4//rr/rrrrrrrr((llll(((((((((((llllllll((rrr/r//(HW8WWWWW8WWWWWWWWW8888888888888888888888888888888
$$88WWWWWWWWWWWWWWWWWWWWWWWWWW888H(/r(rr(rrrr(r((l11lllllll11l11llllll(((((r//r19888WW8W888WWWWWW8888888WW8888888888888W8888888888
$8WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW$W1r/(((((((((((ll11111111ZZZZZ111lllll((r/r1988WWWWWWWW8WWWWWWW8888888888888888888888WW888888888
8WWW88WWWWWWWWWWWWWWWWWWWWWWW8WWWW8WZr!!///rrrrrrrr(lll11111llll(rr/rrr/!/(Z988WWWWWWWWWW8WWWWWW8888888888888888888888888888888888
WWW888WW88888888888888WWWWWWWWWW88W88W4lr///rrrrrrr((ll11111lll(rr////r((4W$8888WW8WWWWWW88WW8888888888W88888888888888888888888888
WWWWWWWW8WWWWWWWWWWWWWWWWWWWWWWWW9WWW8$89Zl(r//rr(((((ll111l((rr//r(lZ4W$88WWWWWWWWWWWWWW88WWWWW8888888W88888888888888888888WW8888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW889HZl(r/////////////r(l14HW8888WWW8WWWWWWWWWWW888WW888W8W8888W888888888888888888888WW88$$
WW88WWWWWWWWWWWWWWWWWWWW888WW88WWWWWWWWWW888$8W994444ZZZZ44H99WW88888WWWWWWWWWWWWWWWWWW888WW8888888888888888888888888888888888WW8$
WWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWWWW8888888888888888WWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWW888W88WW88888888888888888888888888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWW888888WWW888888888888888888888888WW
WWWWWWWWWWWWWW888888888WWW8WW88WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWWW8WWW88W88888888888888WW888WWWWWWWW88888WW88888888
WWWWWWWW8WWWWWW88WWWWWWWWWWWW88WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWWW88WWWWWWWWW8888WWWW888888
8WWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW88WWWWWWW8W88WWWWW8888WWWWWW888888888888888
888WWWWWWWWWWWWWWWWWWWWWWW8WW88WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW888WW88W888WW888888WWWW888WWWWWWWWWWWW8888888888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWW8W88WWWWW888WWWWWWWWWWWWWWWWW88888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW88WWWWWWW8888WWWWW888W8WWWWWWWWWWWWWW888888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWW88WWWWWWWWWW888W8888WWWWWWWWWWWWWWWWWWW8888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWWW888WWWWWWWWWWWWWWWWWWWWW88
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWWWWWWWWWWWWW888WWW88WWWWWWWWWWWWWW88888
WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW8WWWW8W88WWWWWW8WWW88888888888WWWWWWWWWWWWWWWWWW
*/

/*
	___        __              __   ______          __        _____ __             __          __  __
   /   | _____/ /___  ______ _/ /  / ____/___  ____/ /__     / ___// /_____ ______/ /______   / / / /__  ________
  / /| |/ ___/ __/ / / / __ `/ /  / /   / __ \/ __  / _ \    \__ \/ __/ __ `/ ___/ __/ ___/  / /_/ / _ \/ ___/ _ \
 / ___ / /__/ /_/ /_/ / /_/ / /  / /___/ /_/ / /_/ /  __/   ___/ / /_/ /_/ / /  / /_(__  )  / __  /  __/ /  /  __/
/_/  |_\___/\__/\__,_/\__,_/_/   \____/\____/\__,_/\___/   /____/\__/\__,_/_/   \__/____/  /_/ /_/\___/_/   \___/

*///coating_len

random_device dev;
//mt19937 rd(dev());
mt19937 rd(42);

struct str {
    long long x, y;

    bool operator==(const str& other) {
        return (x == other.x && y == other.y);
    }
};

istream& operator>>(istream& s, str& p) {
    return s >> p.x >> p.y;
}

vector<str> convex_hull(vector<str> v, bool up) {
    if (v.size() <= 2)return v;
    vector<str> ans = { v[0], v[1] };

    for (int i = 2; i < v.size(); i++) {
        while (ans.size() >= 2) {
            str v1 = { ans.back().x - ans[ans.size() - 2].x, ans.back().y - ans[ans.size() - 2].y };
            str v2 = { v[i].x - ans[ans.size() - 2].x, v[i].y - ans[ans.size() - 2].y };

            if (v1.x * v2.y - v1.y * v2.x >= 0 && up) ans.pop_back();
            else if (v1.x * v2.y - v1.y * v2.x <= 0 && !up) ans.pop_back();
            else break;
        }
        ans.push_back(v[i]);
    }

    re ans;
}

int main() {
	asdasdasfasd; ffast_io;

    int n; cin >> n;
    vector<str> v, ans;

    fori(n) {
        str t; cin >> t;
        if (find(v.begin(), v.end(), t) == v.end())v.push_back(t);
    }

    sort(v.begin(), v.end(), [](str a, str b) {
        if (a.x == b.x)return a.y > b.y;
        return a.x < b.x;
        });

    vector<str> a = { v[0] }, b = { v[0] };
    str vc = { v.back().x - v[0].x, v.back().y - v[0].y };
    for (int i = 1; i + 1 < v.size(); i++) {
        str tv = { v[i].x - v[0].x, v[i].y - v[0].y };
        if (tv.y * vc.x - vc.y * tv.x > 0)a.push_back(v[i]);
        else b.push_back(v[i]);
    }
    if (v.size() > 1) { a.push_back(v.back()); b.push_back(v.back()); }

    a = convex_hull(a, true);
    b = convex_hull(b, false);

    if (n % 2 == 0) {
        ans = b;
        for (int i = a.size() - 2; i > 0; i--)ans.push_back(a[i]);
    }
    else {
        ans = a;
        for (int i = b.size() - 2; i > 0; i--)ans.push_back(b[i]);
    }

    ld anss = 0;
    ld mx = 0;

    fori(n) {
        ld ln = sqrt((ans[i].x - ans[(i + 1) % n].x) * (ans[i].x - ans[(i + 1) % n].x) + (ans[i].y - ans[(i + 1) % n].y) * (ans[i].y - ans[(i + 1) % n].y));
        anss += ln;
        umax(mx, ln);
    }

    cout << fixed;
    cout.precision(10);

    cout << anss - mx;
}