#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int q; cin >> q;

    unordered_map<string, int> m;

    string name;
    while (cin >> name) {
        auto it = m.find(name);
        bool has_name = it != m.end();
        if (!has_name) {
            m.insert(pair<string, int>(name, 1));
            cout << name << '\n';
        } else {
            string new_name = "";
            do {
                new_name = name + std::to_string((*it).second);
                ++(*it).second;
            } while(m.find(new_name) != m.end());
            m.insert(pair<string, int>(new_name, 1));
            cout << new_name << '\n';
        }
    }


}