#include <bits/stdc++.h>

using namespace std;

//#define int long long

mt19937_64 rnd(441225); // ddly^^

//#define double long double
#define all(a) a.begin(), a.end()
#define sz(x) long(x.size())

//const int inf = 1e17, MOD = 1e9 + 7;

vector<int> dx = {0, 1, 0 ,-1};
vector<int> dy = {1, 0, -1, 0};
vector<int> meg_x = {0, 2, 0, -2};
vector<int> mag_y = {2, 0, -2, 0};


int mx = 1000;


struct Node {
    int sum;
    Node* left;
    Node* right;


    Node(int x = 0) {
        sum = x;
        left = right = nullptr;
    }


    Node(Node* l, Node* r) {
        sum = 0;
        left = right = nullptr;
        if (l) {
            sum += l->sum;
            left = l;
        }
        if (r) {
            sum += r->sum;
            right = r;
        }
    }

};


Node* updd(Node* v, int tl, int tr, int i, int x) {
    if (tl == tr) {
        return new Node(x);
    }
    if (!v) v = new Node(0);
    int tm = (tl + tr) >> 1;
    if (i <= tm) {
        return new Node(updd(v->left, tl, tm, i, x), v->right);
    }
    else {
        return new Node(v->left, updd(v->right, tm + 1, tr, i, x));
    }
}


int gett(Node* v, int tl, int tr, int l, int r) {
    if (!v) return 0;
    if (l > tr || tl > r) return 0;
    if (l <= tl && tr <= r) return v->sum;
    int tm = (tl + tr) >> 1;
    return gett(v->left, tl, tm, l, r) + gett(v->right, tm + 1, tr, l, r);
}


Node* upd(Node* v, int i, int x) {
    if (i >= mx) return v;
    return updd(v, 0, mx - 1, i, x);
}


int get(Node* v, int l, int r) {
    return gett(v, 0, mx - 1, l, r);
}


string str(int x) {
    string res;
    while (x) {
        int d = x % 10;
        int id = long('0');
        id += d;
        res += char(id);
        x /= 10;
    }
    reverse(all(res));
    return res;
}


int integer(string &s) {
    int res = 0;
    for (char c : s) {
        res *= 10;
        res += long(c) - long('0');
    }
    return res;
}


int get2(string s) {
    reverse(all(s));
    return integer(s);
}


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int q;
    cin >> q;
    vector<string> a;
    map<string, int> mxx;
    map<string, Node*> cnt;
    for (int i = 0; i < q; i++) {
        string s;
        cin >> s;
        a.push_back(s);
        while (sz(s) && '0' <= s.back() && s.back() <= '9') s.pop_back();
        mxx[s]++;
    }
    int ind = 0;
//    for (auto p : mxx) mx = max(mx, p.second);
    while (q--) {
        string s = a[ind++];
        if (cnt[s] == nullptr) {
            cnt[s] = new Node(0);
        }
//        if (s == "fst2") {
//            cout << get(cnt[s], 0, mx - 1) << "?\n";
//        }
        if (!get(cnt[s], 0, 0)) {
            cout << s << "\n";
            cnt[s] = upd(cnt[s], 0, 1);
            string cur = "";
            while (sz(s) && '0' <= s.back() && s.back() <= '9') {
                cur += s.back();
                s.pop_back();
                if (!cnt[s]) cnt[s] = new Node(0);
                cnt[s] = upd(cnt[s], get2(cur), 1);
            }
        }
        else {
            int l = 0;
            int r = mx;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                int c = get(cnt[s], 0, m);
                if (c == m + 1) l = m;
                else r = m;
            }
            cout << s << r << "\n";
            string s2 = s + str(r);
//            cout << r << " " << str(r) << "???\n";
//            if (s == "fst" && r == 2) {
//                cout << s2 << "!!!\n";
//            }
            cnt[s] = upd(cnt[s], r, 1);
            if (!cnt[s2]) cnt[s2] = new Node(0);
            cnt[s2] = upd(cnt[s2], 0, 1);
            string cur = "";
            while (sz(s2) && '0' <= s2.back() && s2.back() <= '9') {
                cur += s2.back();
                s2.pop_back();
                if (!cnt[s2]) cnt[s2] = new Node(0);
                cnt[s2] = upd(cnt[s2], get2(cur), 1);
            }
        }
    }
}