#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937_64 rnd(441225); // ddly^^

#define double long double
#define sz(x) long(x.size())
#define pb push_back

const int inf = 1e17, MOD = 1e9 + 7;

vector<int> dp(200005, inf);
vector<int> empt(200005, 0);

int get(int n, vector<int> &to, int i) {
    if (dp[i] < inf) return dp[i];
    for (int j = 1; j <= 6; j++) {
        if (j - i < 0) break;
        dp[i] = min(dp[i], get(n, to, i - j) + 1);
    }
    return dp[i];
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 1; i < n - 1; i++) {
        cin >> p[i];
    }
    vector<int> to(n);
    for (int i = 0; i < n; i++) {
        to[i] = i;
    }
    for (int i = 0; i < n; i++) {
        if (!p[i]) continue;
        to[i] = to[i - p[i]];
    }
    dp[0] = 0;
    deque<int> q;
    q.pb(0);
    while (sz(q)) {
        int v = q.front();
        q.pop_front();
        int edge = 1;
        if (empt[v]) edge--;
        for (int j = 1; j <= 6; j++) {
            if (v + j >= n) break;
            int u = to[v + j];
//            if (v == 0 && j == 6) cout << u << "?\n";
//            if (v == 5 && j == 4) cout << edge << "!\n";
            if (edge) {
                if (dp[u] > dp[v] + edge || (dp[u] == dp[v] + edge && j == 6 && !empt[u])) {
                    dp[u] = dp[v] + edge;
                    if (j == 6) empt[u] = 1;
                    q.pb(u);
                }
            }
            else {
                if (dp[u] > dp[v] || (dp[u] == dp[v] && !empt[u]) && j == 6) {
                    dp[u] = dp[v];
                    if (j == 6) empt[u] = 1;
                    q.pb(u);
                }
            }
        }
    }
    int ans = dp[n - 1];
    if (ans >= inf) ans = -1;
    cout << ans;
}