#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <queue>
#define all(x) x.begin(), x.end()
#define vec vector
using namespace std;
typedef long long ll;
typedef long long nt;

const nt MAXN = 1e6 + 13;
const long long INF = 1e18 + 13;
const double EPS = 0.0000001;


vec<pair<nt, nt>> gr[MAXN];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	nt n;
	cin >> n;
	vec<nt> p(n, 0);
	for (nt i = 1; i < n - 1; ++i) cin >> p[i];
	for (nt i = 0; i < n; ++i) {
		if (p[i] == 0) continue;
		if (p[i - p[i]] == 0) {
			p[i] = i + 1 - p[i];
			continue;
		}
		p[i] = p[i - p[i]];
	}
	for (nt i = 1; i <= n; ++i) {
		if (p[i - 1] == 0) {
			vector<pair<nt, nt>> e;
			for (nt k = 1; k <= 5; ++k) {
				if (n >= i + k) {
					e.push_back({ i + k, 1 });
				}
			}
			if (n >= i + 6) {
				if (p[i + 6 - 1] == 0) {
					e.push_back({ i + 6, 0 });
				}
				else {
					e.push_back({ p[i + 6 - 1], 0 });
				}
			}
			sort(all(e));
			for (nt s = 0; s < e.size(); ++s) {
				gr[i].push_back(e[s]);
				if (s != e.size() - 1) {
					if (e[s + 1].first == e[s].first) {
						++s;
						continue;
					}
				}
			}
		}
	}

	deque<nt> q;
	q.push_back(1);
	vec<nt> d(n + 1, INF);
	vec<bool> vis(n + 1, 0);
	d[1] = 0;
	while (!q.empty()) {
		nt v = q.front();
		vis[v] = 1;
		q.pop_front();
		for (auto t : gr[v]) {
			if (vis[t.first]) continue;
			d[t.first] = d[v] + t.second;
			vis[t.first] = 1;
			if (t.second == 0) {
				q.push_front(t.first);
			}
			else {
				q.push_back(t.first);
			}
		}
	}
	if (d[n] == INF) {
		cout << "-1\n";
	}
	else {
		cout << d[n] << "\n";
	}
}