#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <cassert>
#include <numeric>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define lll __int128
#define ull unsigned long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vi vector<int>
int INF = 2e18 + 100;
int MOD = 998244353;
string YES = "YES\n";
string NO = "NO\n";
int N = 1e6 + 500;

void cinvec(vector<int> &vec) {
    for (int &el : vec) {
        cin >> el;
    }
}

vector<int> fact;

void fact_precnt() {
    fact.resize(N + 1);
    fact[0] = 1;
    for (int i = 1; i <= N; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
}

int fast_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        return fast_pow(a * a % MOD, b / 2);
    }
    return a * fast_pow(a, b - 1) % MOD;
}

int inv(int x) {
    return fast_pow(x, MOD - 2);
}

int c(int n, int k) {
    if (k > n) {
        return 0;
    }
    return fact[n] * inv(fact[k] * fact[n - k] % MOD) % MOD;
}

void solve() {
    __int128 n, k;
    int t1, t2;
    cin >> t1 >> t2;
    n = t1;
    k = t2;
    vector<pair<__int128,__int128>> a(n);
    __int128 mul = 1;
    for (int i = 1; i <= 10; ++i) {
        mul *= i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> t1;
        a[i].fi = t1;
    }
    for (int i = 0; i < n; ++i) {
        cin >> t1;
        a[i].se = t1;
    }
    sort(all(a));
    bool flag = false;
    __int128 ans = 0;
    k *= mul;
    for (__int128 i = n - 1; i >= 0; --i) {
        __int128 tmp = abs(a[i].se - a[i].fi) * mul / a[i].fi;
        if (flag) {
            ans += abs(a[i].se - a[i].fi);
        } else {
            if (k == tmp) {
                flag = true;
            }
            else if (k < tmp) {
                __int128 l = 0, r = abs(a[i].fi - a[i].se);
                while (r - l > 1) {
                    __int128 m = (l + r) / 2;
                    if (m * mul / a[i].fi <= k) {
                        l = m;
                    }
                    else {
                        r = m;
                    }
                }
                ans += abs(a[i].fi - a[i].se) - l;
                flag = true;
            } else {
                k -= tmp;
            }
        }
    }
    t1 = ans;
    cout << t1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    //fact_precnt();
    //int q; cin >> q;
    //while (q--)
    solve();
    return 0;
}