#include <bits/stdc++.h>

using namespace std;

const int N = 1e3 + 500;

int cnt[N][N], n, m, k;
char c[N][N];
set<pair<int, pair<int, int> > > se;

int Sx, Sy, Ex, Ey;

int steps1[4][2] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
int steps2[4][2] = {{2, 0}, {-2, 0}, {0, 2}, {0, -2}};

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  cin >> n >> m >> k;

  for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++) {
      cin >> c[i][j];
      cnt[i][j] = 1e9;
    }

  cin >> Sx >> Sy;
  cin >> Ex >> Ey;

  Sx--;
  Sy--;
  Ex--;
  Ey--;

  se.insert({0, {Sx, Sy}});

  while (!se.empty()) {
    auto asd = *se.begin();
    se.erase(se.begin());
    int cur_k = asd.first;
    int cur_x = asd.second.first;
    int cur_y = asd.second.second;

    if (cnt[cur_x][cur_y] <= cur_k || cur_k > k) continue;
    cnt[cur_x][cur_y] = cur_k;

    if (cur_x == Ex && cur_y == Ey) {
      cout << "YES";
      return 0;
    }

    for (int i = 0; i < 4; i++) {
      int cx = cur_x + steps1[i][0];
      int cy = cur_y + steps1[i][1];

      if (cx >= 0 && cx < n && cy >= 0 && cy < m && c[cx][cy] != '#') {
        se.insert({cur_k, {cx, cy}});
      }
    }

    for (int i = 0; i < 4; i++) {
      int cx = cur_x + steps2[i][0];
      int cy = cur_y + steps2[i][1];

      if (cx >= 0 && cx < n && cy >= 0 && cy < m && c[cx][cy] != '#') {
        se.insert({cur_k + 1, {cx, cy}});
      }
    }
  }

  cout << "NO";
}
