import java.io.BufferedInputStream
import kotlin.math.abs

class D {
    companion object {
        @JvmStatic
        fun main(args: Array<String>) {
            val fs = FastScanner()
            val n = fs.nextInt()
            val k = fs.nextInt()
            val s1 = fs.nextInt()
            val s2 = fs.nextInt()
            if (n == 1) {
                println("Equal")
            } else {
                val mid = (n + n * k).toFloat() / 2
                var abs1 = abs(s1 - mid)
                var abs2 = abs(s2 - mid)
                if (s1 < n || s1 > n * k) {
                    abs1 = Float.MAX_VALUE
                }
                if (s2 < n || s2 > n * k) {
                    abs2 = Float.MAX_VALUE
                }
                if (abs1 < abs2) {
                    println("First")
                } else if (abs1 == abs2) {
                    println("Equal")
                } else {
                    println("Second")
                }
            }
        }
    }

    class FastScanner {
        private val BS = 1 shl 16
        private val NC = 0.toChar()
        private val buf = ByteArray(BS)
        private var bId = 0
        private var size = 0
        private var c = NC
        private var `in`: BufferedInputStream? = null

        private val char: Char
            get() {
                while (bId == size) {
                    size = try {
                        `in`!!.read(buf)
                    } catch (e: Exception) {
                        return NC
                    }
                    if (size == -1) return NC
                    bId = 0
                }
                return buf[bId++].toInt().toChar()
            }

        fun nextInt(): Int {
            var neg = false
            if (c == NC) c = char
            while (c < '0' || c > '9') {
                if (c == '-') neg = true
                c = char
            }
            var res = 0
            while (c in '0'..'9') {
                res = (res shl 3) + (res shl 1) + (c - '0')
                c = char
            }
            return if (neg) -res else res
        }

        init {
            `in` = BufferedInputStream(System.`in`, BS)
        }
    }
}