import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    private void solve(Scanner sc) {
        int n = sc.nextInt();
        int[] l = new int[n];
        int[] r = new int[n];
        for (int i = 0; i < n; i++) {
            l[i] = sc.nextInt();
            r[i] = sc.nextInt();
        }
        double res = 0;
        for (int i = 1; i < n; i++) {
            res += dist(i, i - 1, l, r);
        }
        System.out.println(res);
    }

    private double dist(int a, int b, int[] l, int[] r) {
        return Math.sqrt((l[a] - l[b]) * (l[a] - l[b]) + ((r[a] - r[b]) * ((r[a] - r[b]))));
    }
}
