import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = 1;
        while (n-- > 0) {
            new Main().solve(sc);
        }
    }

    private void solve(Scanner sc) {
        int n = sc.nextInt();
        int[] x = new int[n];
        int[] y = new int[n];
        double[] dist = new double[n];
        for (int i = 0; i < n; i++) {
            x[i] = sc.nextInt();
            y[i] = sc.nextInt();
        }
        double res = 0;
        double ans = Double.MAX_VALUE;
        for (int i = 0; i < n; i++) {
            dist[i] = dist(i, (i + 1) % n, x, y);
            res += dist[i];
        }
        for (int i = 0; i < n; i++) {
            ans = Math.min(ans, res - dist[i]);
        }
        System.out.println(ans);

    }

    private double dist(int a, int b, int[] x, int[] y) {
        return Math.sqrt((long) (x[a] - x[b]) * (long) (x[a] - x[b]) + (long) (y[a] - y[b]) * (long) (y[a] - y[b]));
    }
}
