#include <iostream>
#include <unordered_set>
#include <string>

using namespace std;

int main() {
	int q;
	cin >> q;

	unordered_set<string> names;
	string name;
	getline(cin, name);

	for (int i = 0; i < q; ++i) {
		getline(cin, name);

		if (names.find(name) == names.end()) {
			cout << name << endl;
			names.insert(name);
			continue;
		}

		long long left = 0;
		long long right = 10000000000LL;

		while (left < right - 1) {
			long long middle = left + (right - left) / 2;
			string temp = name + to_string(middle);

			if (names.find(temp) != names.end()) {
				left = middle;
			}
			else {
				right = middle;
			}
		}

		names.insert(name + to_string(right));

		cout << name + to_string(right) << endl;
	}

	return 0;
}
