#include <iostream>
#include <algorithm>
#include <vector>

#pragma GCC optimize("Ofast")

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    long long N, K;
    std::cin >> N >> K;
    std::vector<std::pair<long long, long long>> S_delta(N);
    std::vector<long long> A(N);
    double deltaSum = 0;
    for (int i = 0; i < N; ++i) {
        std::cin >> S_delta[i].first;
    }
    for (int i = 0; i < N; ++i) {
        std::cin >> A[i];
        S_delta[i].second = std::abs(A[i] - S_delta[i].first);
        deltaSum += S_delta[i].second / S_delta[i].first;
    }
    std::sort(S_delta.begin(), S_delta.end());
    int ans = 0;
    deltaSum -= K;
    for (int i = 0; i < S_delta.size(); ++i) {
        if (deltaSum > S_delta[i].first * S_delta[i].second) {
            deltaSum -= S_delta[i].second / S_delta[i].first;
            ans += S_delta[i].second;
        } else {
            while (deltaSum > 0) {
                deltaSum -= 1 / S_delta[i].first;
                ans++;
            }
        }
    }
    std::cout << ans << std::endl;
    return 0;
}