#include <bits/stdc++.h>
using namespace std;

const vector<int> dx = {1, -1, 0, 0};
const vector<int> dy = {0, 0, 1, -1};

int main() {
    auto is_valid = [](int cx, int n) -> bool {
        return (cx >= 0) && (cx < n);
    };

    int N, M, k;
    cin >> N >> M >> k;
    vector<string> g(N);
    for(int i = 0; i < N; i++)cin >> g[i];

    int startX, startY, endX, endY;
    cin >> startX >> startY >> endX >> endY;
    startY--; startX--; endY--; endX--;

    if (g[startX][startY] == '#') {
        cout << "NO\n";
        return 0;
    }

    deque<tuple<int, int, int>> q; // x, y, k
    q.emplace_front(startX, startY, k);
    while(!q.empty()) {
        auto [x, y, kk] = q.front();
        q.pop_front();

        g[x][y] = '0';
        if(x == endX && y == endY){
            cout << "YES\n";
            return 0;
        }

        for (int i = 0; i < 4; i++){
            int cx = x + dx[i];
            int cy = y + dy[i];
            if (is_valid(cx, N) && is_valid(cy, M) && g[cx][cy] == '.'){
                q.emplace_front(cx, cy, kk);
            }

            if (kk <= 0) {
                continue;
            }

            cx = x + 2 * dx[i];
            cy = y + 2 * dy[i];

            if (is_valid(cx, N) && is_valid(cy, M) && g[cx][cy] == '.') {
                q.emplace_back(cx, cy, kk - 1);
            }
        }
    }

    cout << "NO\n";
}