#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ld hypot(pll& a, pll& b) {
    return sqrtl((a.ft - b.ft) * (a.ft - b.ft) + (a.sc - b.sc) * (a.sc - b.sc));
}

void solve() {
    int n;
    cin >> n;
    vector<pll> a(n);
    for (auto& i : a) cin >> i.ft >> i.sc;
    ld res = 0;
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        res += hypot(a[i], a[j]);
    }
    ld ans = res;
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        ans = min(ans, res - hypot(a[i], a[j]));
    }
    cout << fixed << setprecision(20) << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin); 
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
