#include <iostream>
#include <cmath>
using namespace std;
#define ll long long

#pragma GCC optimize("Ofast")

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n, k, s1, s2;
    std::cin >> n >> k >> s1 >> s2;
    double mat = double((1 + k)) / 2;
    mat *= n;

    if ((s1 < n || s1 > k * n) && (s2 < n || s2 > k * n)) {
        std::cout << "Equal";
        return 0;
    }

    if ((s1 < n || s1 > k * n) && (s2 >= n && s2 <= k * n)) {
        std::cout << "Second";
        return 0;
    }

    if ((s2 < n || s2 > k * n) && (s1 >= n && s1 <= k * n)) {
        std::cout << "First";
        return 0;
    }

    double sx1 = std::abs(mat - s1);
    double sx2 = std::abs(mat - s2);
    if (sx1 == sx2) {
        std::cout << "Equal";
        return 0;
    }
    if (sx1 > sx2) {
        std::cout << "Second";
        return 0;
    }
    std::cout << "First";
}
