#include <iostream>
#include <set>
#include <cmath>
#include <queue>
#include <algorithm>

#define ll long long

using namespace std;

int main() {
    long double eps = 0.000001;
    int n, k; cin >> n >> k;
    vector<int> s(n), a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    priority_queue<pair<int, int>> ost, neost;
    long double sum = 0;
    for (int i = 0; i < n; i++) {
        sum += (long double)abs(a[i] - s[i]) / (long double)s[i];
        ost.push({abs((a[i] - s[i]) % s[i]), i});
    }

    long double delta = sum - k;

    if (delta <= 0) {
        cout << 0;
        return 0;
    }

    long long ans = 0;

    while (delta > 0) {
        pair<int, int> ost_ = {INT_MAX, -1}, neost_ = {INT_MAX, -1};
        if (ost.empty() && neost.empty()) {
            break;
        }
        if (!ost.empty())
            ost_ = ost.top();
        if (!neost.empty())
            neost_ = neost.top();

        if (ost_ < neost_) {
            ost.pop();
            long double x = min((long double)s[ost_.second] * abs(a[ost_.second] - ost_.first), ceil(s[ost_.second] * delta));
            delta -= x / s[ost_.second];
            a[ost_.second] -= x;
            ans += x;
            if (a[ost_.second] != 0) {
                neost.push({s[ost_.second], ost_.second});
            }
        }
        else {
            neost.pop();
            long double x = min((long double)s[neost_.second] * abs(a[neost_.second] - neost_.first), ceil(s[neost_.second] * delta));
            a[neost_.second] -= x;
            ans += x;
        }
    }

    cout << ans;
}