#include <iostream>
#include <cmath>
#include <vector>
#include <iomanip>
#include <algorithm>

using namespace std;


#pragma GCC optimize("Ofast")

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n;
    std::cin >> n;
    std::vector<int> x(n);
    std::vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> x[i] >> y[i];
    }
    std::vector<double> s(n);
    for (int i = 1; i < n; ++i) {
        s[i] = std::sqrt((x[i] - x[i - 1]) * (x[i] - x[i - 1])  + (y[i] - y[i - 1]) * (y[i] - y[i-1]));
    }
    s[0] = std::sqrt((x[0] - x[n - 1]) * (x[0] - x[n - 1])  + (y[0] - y[n - 1]) * (y[0] - y[n - 1]));
    sort(s.begin(), s.end());
    double ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        ans += s[i];
    }
    std::cout << std::fixed;
    std::cout << setprecision(8);
    std::cout << ans << std::endl;
}