#include <iostream>
#include <cmath>
#include <vector>
#include <iomanip>
#include <algorithm>

using namespace std;


#pragma GCC optimize("Ofast")

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n;
    std::cin >> n;
    std::vector<double> x(n);
    std::vector<double> y(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> x[i] >> y[i];
    }
    double ans = 0;
    double max_s = 0;
    for (int i = 1; i < n; ++i) {
        double ds = std::sqrt((x[i] - x[i - 1]) * (x[i] - x[i - 1])  + (y[i] - y[i - 1]) * (y[i] - y[i-1]));
        ans += ds;
        max_s = std::max(max_s, ds);
    }
    double ds = std::sqrt((x[0] - x[n - 1]) * (x[0] - x[n - 1])  + (y[0] - y[n - 1]) * (y[0] - y[n - 1]));
    ans += ds;
    max_s = std::max(max_s, ds);

    ans -= max_s;
    std::cout << std::fixed;
    std::cout << setprecision(6);
    std::cout << ans << std::endl;
}