#include <iostream>
#include <set>
#include <cmath>
#include <queue>
#include <algorithm>

#define ll long long

using namespace std;

int main() {
    vector<char> prime_bool(10e6 + 1, true);
    prime_bool[0] = prime_bool[1] = false;
    for (int i = 2; i <= 10e6; ++i)
        if (prime_bool[i])
            if (i * 1ll * i <= 10e6)
                for (int j = i * i; j <= 10e6; j += i)
                    prime_bool[j] = false;
    vector<int> prime;
    for (int i = 2; i < prime_bool.size(); i++) {
        if (prime_bool[i]) {
            prime.push_back(i);
        }
    }
    ll l, r;
    ll ans = 0, b = -1;
    cin >> l >> r;

    for (ll i = r; i >= l; i--) {
        for (int j = 0; j < prime.size(); j++) {
            if (i / prime[j] < l) {
                break;
            }
            if (i % prime[j] == 0) {
                if (i / prime[j] > ans) {
                    ans = i / prime[j];
                    b = i;
                }
                break;
            }
        }
    }
    if (b == -1) {
        cout << l << " " << r;
        return 0;
    }
    cout << ans << " " << b;

}