#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>

struct pnt {
    int x, y;
};

double distance(const pnt &p1, const pnt &p2) {
    int dx = p1.x - p2.x;
    int dy = p1.y - p2.y;
    return sqrt(dx * dx + dy * dy);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<pnt> pnts(n);
    double max_len{}, perimiter{};
    for (int i = 0; i < n; ++i) {
        std::cin >> pnts[i].x >> pnts[i].y;

        if (i > 0) {
            double dist = distance(pnts[i], pnts[i - 1]);
            perimiter += dist;
            max_len = std::max(max_len, dist);
        }
    }


    double dist = distance(pnts[0], pnts[pnts.size() - 1]);
    perimiter += dist;
    max_len = std::max(max_len, dist);

    std::cout << perimiter - max_len;
}
