#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;
using psi = pair<string, int>;
int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int q;
    cin >> q;

    unordered_map<string, int> m;

    string name, new_name;
    while (cin >> name) {
        auto it = m.find(name);
        if (it == m.end()) {
            m.insert(psi(name, 1));
            cout << name << endl;
        } else {
            new_name = "";
            do {
                new_name = name + std::to_string(it->second++);
            } while(m.find(new_name) != m.end());
            m.insert(psi(new_name, 1));
            cout << new_name << endl;
        }
    }
    return 0;


}