#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef pair<ll, ll> pll;
typedef pair<int, int> pi;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> less_set;

#define all(a)  a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
//#define mp      make_pair
#define pb      push_back
#define eb      emplace_back
#define _1      first
#define _2      second
#define be		begin()
#define en		end()

#define sum(a)     ( accumulate (all(a), 0ll))
#define mine(a)    (*min_element(all(a)))
#define maxe(a)    (*max_element(all(a)))
#define mini(a)    ( min_element(all(a)) - (a).begin())
#define maxi(a)    ( max_element(all(a)) - (a).begin())
#define lowb(a, x) ( lower_bound(all(a), (x)) - (a).begin())
#define uppb(a, x) ( upper_bound(all(a), (x)) - (a).begin())
#define rad(a)     ( a / PI * 180)

#define _default ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr); cout << fixed; cout.precision(20);

template<typename T, typename M>
std::istream& operator>>(std::istream& in, std::pair<T, M>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T, typename M>
std::ostream& operator<<(std::ostream& out, std::pair<T, M>& p) {
    out << p.first << ' ' << p.second << std::endl;
    return out;
}

template<typename T>
std::istream& operator>>(std::istream& in, std::vector<T>& a) {
    for (T& x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
std::ostream& operator<<(std::ostream& out, std::vector<T>& a) {
    for (T& x : a) {
        out << x << ' ';
    }
    return out;
}

ostream& operator<<(ostream &out, __int128 a) {
    string s;
    while (a) {
        s += a % 10 + '0';
        a /= 10;
    }
    reverse(all(s));
    out << s;
    return out;
}

istream& operator>>(istream &in, __int128 a) {
    string s;
    in >> s;
    a = 0;
    reverse(all(s));
    for (auto c : s) {
        a *= 10;
        a += c + '0';
    }
    return in;
}

ll C(ll n, ll k) {
    if (k == 0 || n == k) {
        return 1;
    }
    if (k > n) {
        return 0;
    }
    return C(n - 1, k - 1) + C(n - 1, k);
}

inline ull cpl2(ull x) {
    x = x - 1;
    x = x | (x >> 1);
    x = x | (x >> 2);
    x = x | (x >> 4);
    x = x | (x >> 8);
    x = x | (x >> 16);
    return x + 1;
}

const ll INF = 1e9, SIZE = 2e5, MOD = 998244353;
const ld EPS = 1e-8, PI = acos(-1);
const std::string yes = "YES\n", no = "NO\n", alphabet = "abcdefghijklmnopqrstuvwxyz";

inline void precalc() {

}

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto &x : a) {
        cin >> x;
    }
    map<char, int> mp;
    for (auto &x : a) {
        for (auto c : x) {
            mp[c]++;
        }
    }
    cout << min(mp['0'], mp['1']);
}

int main() {
    _default
    freopen("input.txt", "r", stdin);
    // ifstream cin("input.txt");
    int test = 1;
    // cin >> test;
    precalc();
    while (test--) {
        solve();
    }
    return 0;
}