#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_set>

using namespace std;

#define double long double

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#define int long long
    int n, m;
    double res = 0, k;
    cin >> n >> m;
    k = m;
    vector<pair<int, int>> vec(n, pair<int, int>(0, 0));
    for (int i = 0; i < n; ++i) {
        cin >> m;
        vec[i].first = m;
    }
    for (int i = 0; i < n; ++i) {
        cin >> m;
        vec[i].second = m;
    }
    std::sort(vec.begin(), vec.end());
    for (int i = 0; i < n; ++i) {
        res += (double) abs(vec[i].second - vec[i].first) / (double) vec[i].first;
    }
    int point = 0;
    int minutes = 0;
    int diff;
    while (res > k) {
        diff = abs(vec[point].first - vec[point].second);
        if (diff == 0) {
            ++point;
            continue;
        }
        if (res - (double) diff / vec[point].first > k) {
            res -= diff / vec[point].first;
            minutes += diff;
            vec[point].second = vec[point].first;
            ++point;
        } else{
            diff = ceil((res - k) * vec[point].first);
            minutes += diff;
            break;
        }
    }
    cout << minutes;
    return 0;
}
