#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = long long;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    int A; cin >> A;
    int B; cin >> B;

    if (A % 2 != B % 2) {
        cout << "Error";
        return;
    }

    if (A >= 2 && B >= 2) {
        cout << "Undefined";
        return;
    }
    if (A == 1) {
        cout << 0 << '\n';
        cout << (B - 1) / 2 << '\n';
        cout << 1 << '\n';
        return;
    }
    if (B == 1) {
        cout << (A - 1) / 2 << '\n';
        cout << 0 << '\n';
        cout << 1 << '\n';
        return;
    }

    if (A == 0) {
        cout << 0 << '\n';
        cout << B / 2 << '\n';
        cout << 0 << '\n';
        return;
    }

    if (B == 0) {
        cout << A / 2 << '\n';
        cout << 0 << '\n';
        cout << 0 << '\n';
        return;
    }
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
