#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = long long;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    ll n, m;
    cin >> n >> m;

    ll t = n * m;
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        cnt += std::count(s.begin(), s.end(), '0');
    }
    cout << min(cnt, t - cnt);
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
