#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = long long;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    ll n, k;
    ll s1, s2;
    cin >> n >> k;
    cin >> s1 >> s2;

    bool can1 = (s1 >= n) && (s1 <= n * k);
    bool can2 = (s2 >= n) && (s2 <= n * k);

    s1 *= 2;
    s2 *= 2;
    ll w = n * (k + 1);
    if (!can1 && !can2) {
        cout << "Equal";
        return;
    }

    if (can1 && !can2) {
        cout << "First";
        return;
    }

    if (!can1 && can2) {
        cout << "Second";
        return;
    }

    ll a1 = abs(w - s1);
    ll a2 = abs(w - s2);
    if (a1 == a2) {
        cout << "Equal";
        return;
    }

    if (a1 > a2) {
        cout << "Second";
        return;
    }
    cout << "First";
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
