#include <iostream>
#include <bits/stdc++.h>

namespace alg {
    using namespace std;
    using ll = long long;
    using vll = vector<ll>;
    using pll = pair<ll, ll>;

    istream& operator>>(istream& is, vll& a) {
        for (auto& elem: a) {
            is >> elem;
        }
        return is;
    }

    template<typename T, typename B>
    bool contains(const set<T>& s, const B& val) {
        return s.find(val) != s.end();
    }
}

using namespace alg;

void Solve() {
    ll n, k;
    cin >> n >> k;

    ll LCM = 1;
    for (int i = 1; i <= 10; i++) {
        LCM = lcm(LCM, i);
    }

    vll s(n);
    vll a(n);
    cin >> s;
    cin >> a;

    k *= LCM;
    multiset<pll, greater<>> d;

    ll curk = -k;
    ll cnt = 0;

    for (int i = 0; i < n; i++) {
        curk += (LCM / s[i]) * abs(s[i] - a[i]);
        d.insert({LCM / s[i], abs(s[i] - a[i])});
    }

    while (curk > 0) {
        pll cur = *d.begin();
        d.erase(d.begin());

        ll need = (curk - 1) / cur.first + 1;
        if (need > cur.second) {
            curk -= cur.second * cur.first;
            cnt += cur.second;
        } else {
            cnt += need;
            break;
        }
    }

    cout << cnt;
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        Solve();
        cout << "\n";
    }

    return 0;
}
