#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
using namespace std;

#define int long long

int n, m;
vector<string> a;

bool ok(int i, int j) {
    if (i < 0 || i >= n || j < 0 || j >= m || a[i][j] == '#') {
        return false;
    }
    return true;
}

void solve() {
    int k;
    cin >> n >> m >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int si, sj;
    cin >> si >> sj;
    int fi, fj;
    cin >> fi >> fj;
    --si; --sj; --fi; --fj;
    deque<pair<int, int> > q;
    vector<vector<int> > dist(n, vector<int>(m, 1e18));
    dist[si][sj] = 0;
    q.push_back({ si, sj });
    while (!q.empty()) {
        int i = q.front().first;
        int j = q.front().second;
        q.pop_front();
        vector<pair<int, int> > ds = { { i - 1, j }, { i, j - 1 }, { i + 1, j }, { i, j + 1 } };
        for (auto x : ds) {
            int ni = x.first;
            int nj = x.second;
            if (ok(ni, nj) && (dist[ni][nj] > 1e9)) {
                dist[ni][nj] = dist[i][j];
                q.push_front({ ni, nj });
            }
        }
        ds = { { i - 2, j }, { i, j - 2 }, { i + 2, j }, { i, j + 2 } };
        for (auto x : ds) {
            int ni = x.first;
            int nj = x.second;
            if (ok(ni, nj) && (dist[ni][nj] > 1e9)) {
                dist[ni][nj] = dist[i][j] + 1;
                q.push_back({ ni, nj });
            }
        }
    }
    if (dist[fi][fj] <= k) {
        cout << "YES" << "\n";
    } else {
        cout << "NO" << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long t = 1;
    /* cin >> t; */
    while (t--) {
        solve();
    }
}