#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

#define pb push_back
#define ff first
#define ss second
#define pp pair
#define int long long
#define ll long long
#define dl long double

ostream &operator<<(ostream &out, const pair<int, int> &a) {
    out << a.ff << ' ' << a.ss;
    return out;
}

istream &operator>>(istream &in, pair<int, int> &a) {
    in >> a.ff >> a.ss;
    return in;
}


const int maxn = 1e5 + 100, inf = 1e18;


void solve() {
    int n, k, z = 2520;
    cin >> n >> k;
    vector<pair<int, int>> a(n);
    for (int i = 0 ; i < n ; i++) cin >> a[i].ff;
    for (int i = 0 ; i < n ; i++) cin >> a[i].ss;
    sort(a.begin(), a.end());
    int d = 0;
    for (auto i : a) {
        d += abs(i.ff - i.ss) * z / i.ff;
    }
    if (d <= k * z) {
        cout << 0;
        return;
    }
    d -= k * z;
    int ans = 0;
    for (auto i : a) {
        if (d - abs(i.ff - i.ss) * z / i.ff > 0) {
            d -= abs(i.ff - i.ss) * z / i.ff;
            ans += abs(i.ff - i.ss);
        } else {
            int l = 0, r = 1e15, m;
            while (r - l > 1) {
                m = (l + r) / 2;
                if (d <= (m * z) / i.ff) r = m;
                else l = m;
            }
            ans += r;
            break;
        }
    }
    cout << ans;
}

signed main() {
#ifdef Local
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
#ifndef Local
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
//    cout << fixed << setprecision(15);
//    cin >> tests;
    while (tests--) solve();
#ifdef Local
//    cout << "\nruntime = " << clock() / 1000.0 << '\n';
#endif
//    cerr << "amogus";
}