#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vll = vector<long long>;
using mii = map<int, int>;
using pii = pair<int, int>;
using pll = pair<long long, long long>;
using pld = pair<long double, long double>;

#define mod(A, B) (((A) % (B) + B) % (B))
#define chrono chrono::steady_clock::now().time_since_epoch().count()
#define debug(p) cerr << "debug: " << p << "\n";

#define dbg(...) cout << "[" << #__VA_ARGS__ << "]: "; cout << to_string(__VA_ARGS__) << endl
template <typename T, size_t N> int SIZE(const T (&t)[N]){ return N; } template<typename T> int SIZE(const T &t){ return t.size(); } string to_string(const string s, int p1=0, int p2=1e9){ return '"' + ((p1 < s.size()) ? s.substr(p1, p2-p1+1) : "") + '"'; } string to_string(const char* s) { return to_string((string) s); } string to_string(const bool b) { return (b ? "true" : "false"); } string to_string(const char c){ return string({c}); } template<size_t N> string to_string(const bitset<N> &b, int p1=0, int p2=1e9){ string t = ""; for(int __iii__ = min(p1,SIZE(b)),  __bbb__ = min(p2, SIZE(b)-1); __iii__ <= __bbb__; ++__iii__){ t += b[__iii__] + '0'; } return '"' + t + '"'; } template <typename A, typename... C> string to_string(const A (&v), int p1=0, int p2=1e9, C... coords); int l_v_l_v_l = 0, t_a_b_s = 0; template <typename A, typename B> string to_string(const pair<A, B> &p) { l_v_l_v_l++; string res = "(" + to_string(p.first) + ", " + to_string(p.second) + ")"; l_v_l_v_l--; return res; } template <typename A, typename... C> string to_string(const A (&v), int p1, int p2, C... coords) { int rnk = rank<A>::value; string tab(t_a_b_s, ' '); string res = ""; bool first = true; if(l_v_l_v_l == 0) res += "\n"; res += tab + "["; p1 = min(p1, SIZE(v)), p2 = min(p2, SIZE(v)); auto p = begin(v); advance(p, p1); auto r = p; advance(r, (p2-p1) + (p2 < SIZE(v))); for (auto e = p; e != r; e = nept(e)) { if (!first) { res += ", "; } first = false; l_v_l_v_l++; if(e != p){ if(rnk > 1) { res += "\n"; t_a_b_s = l_v_l_v_l; }; } else{ t_a_b_s = 0; } res += to_string(*e, coords...); l_v_l_v_l--; } res += "]"; if(l_v_l_v_l == 0) res += "\n"; return res; } void dbgm(){;} template<typename Heads, typename... Tails> void dbgm(Heads H, Tails... T){ cout << to_string(H) << " | "; dbgm(T...); }
#define dbgm(...) cout << "[" << #__VA_ARGS__ << "]: "; dbgm(__VA_ARGS__); cout << endl

const int MOD1 = 998244353;
const int MOD2 = 1000013011;
const int BASE1 = 100003;
const int BASE2 = 31;
const ll LINF = 2e18;
const int INF = 2e9;
const ld EPS = 5e-10;

mt19937_64 mt(chrono);

map<string, set<pll>> mp;

set<pll>::iterator f(string s, ll& suff){
    if(mp.find(s) == mp.end()){
        mp[s].insert({-LINF, -LINF});
        mp[s].insert({LINF, LINF});
        mp[s].insert({suff, suff});
        return mp[s].find({suff, suff});
    }
    auto& st = mp[s];
    auto a = st.lower_bound({suff, suff});
    if(a->first > suff)
        a = prev(a);
    if(a->second < suff){
        st.insert({suff, suff});
        return st.find({suff, suff});
    }
    suff = suff * 10 + 1;
    a = st.lower_bound({suff, suff});
    if(a->first > suff)
        a = prev(a);
    if(a->second < suff){
        st.insert({suff, suff});
        return st.find({suff, suff});
    }
    ll l = a->first, r = a->second;
    st.erase(a);
    st.insert({l, r + 1});
    suff = r + 1;
    return st.find({l, r + 1});
}

void solve() {
    int q; cin >> q;
    while(q--){
        string s; cin >> s;
        string t = s;
        ll suff = 0, p = 0;
        while(t.size() && isdigit(t.back())){
            suff += (t.back() - '0') * pow(10LL, p++);
            t.pop_back();
        }
        if(suff){
            int l = to_string(suff).size();
            for(int i=0; i<l; ++i)
                s.pop_back();
        }
        // cerr << s << " " << suff << "\n";
        // if(mp.find(s) != mp.end()){
        //     for(auto i : mp[s]){
        //         cerr << i.first << "-" << i.second << " ";
        //     }
        //     cerr << "\n";
        // }

        auto i = f(s, suff);
        //cerr << i->first << "-" << i->second << "\n";
        if((*prev(i)).second == (*i).first - 1LL){
            ll l = (*prev(i)).first, r = (*i).second;
            mp[s].erase(prev(i));
            mp[s].erase(i);
            mp[s].insert({l, r});
            i = mp[s].find({l, r});
        }
        if((*i).second == (*next(i)).first){
            ll l = (*i).first, r = (*next(i)).second;
            mp[s].erase(next(i));
            mp[s].erase(i);
            mp[s].insert({l, r});
        }
        cout << s;
        if(suff)
            cout << to_string(suff);
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    //cin >> tt;
    for (int i = 0; i < tt; ++i)
        solve();
}