#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ff first
#define ss second
#define pp pair
#define int long long
#define ll long long
#define dl long double

ostream &operator<<(ostream &out, const pair<int, int> &a) {
    out << a.ff << ' ' << a.ss;
    return out;
}

istream &operator>>(istream &in, pair<int, int> &a) {
    in >> a.ff >> a.ss;
    return in;
}


const int maxn = 1e5 + 100, inf = 1e18;


void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 1 ; i < n - 1 ; i++) cin >> p[i];
    int to[2 * n];
    for (int i = 0 ; i < n ; i++) {
        if (!p[i]) to[i] = i;
        else to[i] = to[i - p[i]];
        to[i + n] = to[i] + n;
    }
    int dist[n * 2];
    for (int i = 0 ; i < 2 * n ; i++) dist[i] = inf;
    dist[0] = 0;
    set<pair<int, int>> q;
    q.insert({0, 0});
    while (!q.empty()) {
        auto[d, v] = *q.begin();
        q.erase(q.begin());
        if (v < n) {
            for (int i = 1 ; i <= 6 ; i++) {
                int u = to[min(v + i, n - 1)];
                if (dist[u] > d + 1) {
                    q.erase({dist[u], u});
                    dist[u] = d + 1;
                    q.insert({dist[u], u});
                }
            }
            int u = to[min(v + 6, n - 1)] + n;
            if (dist[u] > d + 1) {
                q.erase({dist[u], u});
                dist[u] = d + 1;
                q.insert({dist[u], u});
            }
        } else {
            for (int i = 1 ; i <= 6 ; i++) {
                int u = to[min(v + i, 2 * n - 1)] - n;
                if (dist[u] > d + 1) {
                    q.erase({dist[u], u});
                    dist[u] = d + 1;
                    q.insert({dist[u], u});
                }
            }
            int u = to[min(v + 6, 2 * n - 1)];
            if (dist[u] > d) {
                q.erase({dist[u], u});
                dist[u] = d;
                q.insert({dist[u], u});
            }
        }
    }
    if (dist[2 * n - 1] == inf) cout << "-1";
    else cout << dist[2 * n - 1];
}

signed main() {
#ifdef Local
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
#ifndef Local
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
//    cout << fixed << setprecision(15);
//    cin >> tests;
    while (tests--) solve();
#ifdef Local
//    cout << "\nruntime = " << clock() / 1000.0 << '\n';
#endif
//    cerr << "amogus";
}