#include <bits/stdc++.h>

using namespace std;

#define fr first
#define sc second
#define pb push_back
#define ll long long

const long double EPS = 1e-10;

void f(vector<int> &dp, vector<int> &a, int i, int n, int from) {
    if(dp[i] == INT_MAX - 1) {
        return;
    }
    for(int j = 1; j < 7; j++) {
        int to = min(n-1, i + j);
        while(to > 0 && a[to] != 0 && dp[to] >= dp[from] + 1) {
            to = to - a[to];
        }
        if(to < 0 || a[i] != 0 || dp[to] < dp[from] + 1) {
            continue;
        }
        dp[to] = min(dp[to], 1 + dp[from]);
        if(j == 6) {
            f(dp, a, to, n, i);
        }
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin>>n;
    vector<int> a(n, 0);
    for(int i = 1; i < n - 1; i++) {
        cin>>a[i];
    }
    vector<int> dp(n, INT_MAX - 1);
    dp[0] = 0;
    for(int i = 0; i < n-1; i++) {
        f(dp, a, i, n, i);
    }
    if(dp[n-1] == INT_MAX - 1) {
        cout<<-1;
        return 0;
    }
    cout<<dp[n-1];
}