#include <bits/stdc++.h>
using namespace std;
#define len(s) (int)s.size()

char matrix[1005][1005];
int dd[4][2] = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
int dd2[4][2] = {{-2, 0}, {2, 0}, {0, 2}, {0, -2}};



int main() {
  int n, m, k;
  cin >> n >> m >> k;

  const int inf = 1e9 + 7;
  int d[n + 1][m + 1];
  int p[n + 1][m + 1];
  bool used[n + 1][m + 1];

  for(int i = 0; i < n; i++){
    for(int j = 0; j < m; j++){
      cin >> matrix[i][j];
      d[i][j] = inf;
    }
  }

  int sx, sy;
  cin >> sx >> sy;
  int fx, fy;
  cin >> fx >> fy;

  sx--; sy--;
  fx--; fy--;



  d[sx][sy] = 0;
  used[sx][sy] = true;


  /*for(int i = 0; i < n; i++){
      for(int j = 0; j < m; j++){
          cout << (d[i][j] != inf ? to_string(d[i][j]) : "@");
      }
      cout << "\n";
  }*/

  deque<pair<int, int>> pending;
  pending.emplace_back(sx, sy);

  while (!pending.empty()) {
    int x = pending.front().first;
    int y = pending.front().second;
    pending.pop_front();

    for(auto &i : dd){
      int dx = i[0] + x;
      int dy = i[1] + y;
      //cout << " bef !!! " << x << ' ' << y << ' ' << dx << ' ' << dy << ' ' << d[sx][sy] << "\n";

      if(dx >= 0 && dy >= 0 && dx < n && dy < m && !used[dx][dy]){
        //cout << x << ' ' << y << ' ' << dx << ' ' << dy << "\n";
        if(matrix[x][y] == '.'){
          if(matrix[dx][dy] == '.') {
            d[dx][dy] = d[x][y] + 0;
            used[dx][dy] = true;
            pending.emplace_front(dx, dy);
          }
          else {
            d[dx][dy] = d[x][y] + 1;
            used[dx][dy] = true;
            pending.emplace_back(dx, dy);
          }
        }
        else{
          if(matrix[dx][dy] == '.') {
            bool ok = false;
            for(auto &j : dd){
              int tx = x + j[0];
              int ty = y + j[1];
              if(tx >= 0 && ty >= 0 && tx < n && ty < m && used[tx][ty] && matrix[tx][ty] == '.'){
                for(auto &l : dd2){
                  int px = tx + l[0];
                  int py = ty + l[1];
                  if(px == dx && py == dy) ok = true;
                }
              }
            }
            if(ok){
              d[dx][dy] = d[x][y] + 0;
              used[dx][dy] = true;
              pending.emplace_front(dx, dy);
            }
          }
        }
      }
    }
  }
  /*for(int i = 0; i < n; i++){
       for(int j = 0; j < m; j++){
           cout << (d[i][j] != inf ? to_string(d[i][j]) : "@");
       }
       cout << "\n";
   }*/

  cout << (d[fx][fy] <= k ? "YES" : "NO");
  return 0;
}