#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  ll n;
  cin >> n;
  vector<ll> p(n);
  vector<ll> win(n, 2 * 10e6);
  p[0] = 0;
  p[n - 1] = n - 1;
  set<ll, greater<>> nodes = {0, n - 1};
  win[n - 1] = 0;
  for (ll i = 1; i < n - 1; ++i) {
    ll portal;
    cin >> portal;
    if (portal == 0) {
      p[i] = i;
      nodes.emplace(i);
    } else {
      p[i] = p[i - portal];
    }
  }

  for (auto node: nodes) {
    for (ll i = 1; i <= 6; ++i) {
      if (node + i < n) {
        if (p[node + i] > node) {
          if (p[node + i] == n - 1) {
            win[node] = 1;
          } else {
            win[node] = min(win[node], win[p[node + i]] + (i == 6 ? 0 : 1));
          }
        }
      }
    }
  }


  ll w = (win[0] == 2 * 10e6) ? -1 : win[0];

  cout << w;
  return 0;
}