#include <algorithm>
#include <iostream>
#include <cmath>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    long long fx, fy, x, y, px, py;
    double sum = 0, max_side = INT32_MIN;

    auto dist = [&] (long long px, long long py, long long x, long long y) {
        double side = sqrt(abs(px - x) * abs(px - x) + abs(py - y) * abs(py - y));
        max_side = max(max_side, side);
        sum += side;
    };

    for (int i = 0; i < n; i++) {
        if (!i) {
            cin >> fx >> fy;
            x = fx, y = fy;
            continue;
        }
        px = x, py = y;
        cin >> x >> y;
        dist(px, py, x, y);
    }
    dist(x, y, fx, fy);
    sum -= max_side;
    cout << sum << '\n';
}
