#include <bits/stdc++.h>

using namespace std;


//#define int long long

long long ll_inf = 6e18;

//void solve() {
//    int q; cin >> q;
//    map<string, int> kek;
//    for (int i = 0; i < q; ++i) {
//        string s; cin >> s;
//        if (kek.find(s) == kek.end()) {
//            kek[s] = 1;
//            cout << s << '\n';
//            continue;
//        } else {
//            int current_add = kek[s];
//            kek[s]++;
//            s += to_string(current_add);
//            kek[s]++;
//            cout << s << '\n';
//        }
////        kek[s] = 1;
////        cout << s << '\n';
////        if(kek.find(s) == kek.end()) {
////            kek[s] = 0;
////            cout << s << '\n';
////        } else {
////            kek[s]++;
////            string new_s = s + to_string(kek[s]);
////            kek[new_s]++;
////            cout << s << kek[s] << '\n';
////        }
//    }
//}

vector<int> dx{-1, 0, 0, 1}, dy{0, -1, 1, 0};
vector<int> super_dx{-2, 0, 0, 2}, super_dy{0, -2, 2, 0};

void solve() {
    int n, m, k; cin >> n >> m >> k;
    vector<vector<int>> d(n, vector<int>(m, 1e8));
    vector<vector<int>> matrix(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        for (int j = 0; j < m; ++j) {
            if (s[j] == '.') {
                matrix[i][j] = 1;
            } else {
                matrix[i][j] = 0;
            }
        }
    }

    auto check = [&](int x, int y) {
        return 0 <= x && x < n && 0 <= y && y < m && matrix[x][y];
    };


    int s_x, s_y, t_x, t_y; cin >> s_x >> s_y >> t_x >> t_y; --s_x; --s_y; --t_x; --t_y;
    deque<array<int, 2>> kek;
    d[s_x][s_y] = 0;
    kek.push_front({s_x, s_y});
    while(!kek.empty()) {
        auto [v_x, v_y] = kek.front(); kek.pop_front();
        if (d[v_x][v_y] > k) {
            break;
        }
        for (int i = 0; i < 4; ++i) {
            int new_x = v_x + dx[i], new_y = v_y + dy[i];
            if (check(new_x, new_y)) {
                if (d[new_x][new_y] > d[v_x][v_y]) {
                    d[new_x][new_y] = d[v_x][v_y];
                    kek.push_front({new_x, new_y});
                }
            }
        }


        for (int i = 0; i < 4; ++i) {
            int new_x = v_x + super_dx[i], new_y = v_y + super_dy[i];
            if (check(new_x, new_y)) {
                if (d[new_x][new_y] > d[v_x][v_y] + 1) {
                    d[new_x][new_y] = d[v_x][v_y] + 1;
                    kek.push_back({new_x, new_y});
                }
            }
        }
    }

    if (d[t_x][t_y] <= k) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);

    solve();
}