#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

// #define int long long

using namespace std;

int n;
vector<vector<int>> A, B;
vector<bool> used;
vector<pair<int, int>> ans;

int get_trash() {
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = true;
            return i;
        }
    }
    assert(false);
}

void dfs(int v, int u) {
    // cerr << "dfs: " << v << " " << u << "\n";
    used[v] = true;
    vector<int> new_nei;
    new_nei.reserve(A[v].size());
    for (int x : A[v]) {
        if (!used[x]) {
            new_nei.push_back(x);
        }
    }
    A[v].swap(new_nei);
    for (int i = 0; i < min(A[v].size(), B[u].size()); i++) {
        int x = A[v][i];
        used[x] = true;
    }
    while (A[v].size() < B[u].size()) {
        int x = get_trash();
        // cerr << "deb: " << x << " " << v << "\n";
        ans.push_back({x, v});
        A[v].push_back(x);
    }
    A[v].resize(B[u].size());
    for (int i = 0; i < A[v].size(); i++) {
        int x = A[v][i];
        int y = B[u][i];
        dfs(x, y);
    }
}

void solve() {
    cin >> n;
    A.resize(n);
    vector<pair<int, int>> edges_a(n - 1);
    vector<int> par_a(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        par_a[i] = p;
        A[p].push_back(i);
        edges_a[i - 1] = {p, i};
    }
    B.resize(n);
    vector<pair<int, int>> edges_b(n - 1);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        B[p].push_back(i);
        edges_b[i - 1] = {p, i};
    }
    used.resize(n);
    dfs(0, 0);
    cout << ans.size() << "\n";
    for (auto [v, u] : ans)
        cout << v << " " << u << "\n";
    cout.flush();


    for (auto [v, u] : ans) {
        assert(v != 0);
        int p = par_a[v];
        edges_a.erase(find(all(edges_a), make_pair(min(v, p), max(v, p))));
        edges_a.push_back({min(v, u), max(v, u)});
        par_a[v] = u;
    }

    for (auto &[v, u] : edges_a) {
        if (v > u)
            swap(v, u);
    }
        // cerr << "edges_a:\n";
        // for (auto [x, y] : edges_a)
        //     cerr << x << " " << y << "\n";
    // for (auto &[v, u] : edges_b) {
    //     if (v > u)
    //         swap(v, u);
    // }
    // vector<int> p(n);
    // iota(all(p), 0);
    // do {
    //     bool ok = true;
    //     for (auto [v, u] : edges_b) {
    //         int x = p[v], y = p[u];
    //         if (find(all(edges_a), make_pair(x, y)) == edges_a.end() && find(all(edges_a), make_pair(y, x)) == edges_a.end()) {
    //             ok = false;
    //             break;
    //         }
    //     }
    //     if (ok)
    //         return;
    // } while (next_permutation(all(p)));
    // assert(false);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef dimss
        freopen("test.txt", "r", stdin);
    #endif

    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
        #ifdef dimss
            cerr << "--------\n";
        #endif
    }
    return 0;
}
