#include <bits/stdc++.h>
using namespace std;
 
#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i,a,b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()
 
using ll = long long;
using pll = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;
 
const double EPS = 1e-5;
 
mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());


int dfs(int v, vvi&adj, vector<vi>&result, int par) {
    if (adj[v].size() == 0) return v;
    if (adj[v].size() == 1) return dfs(adj[v][0], adj, result, v);
    else {
        dfs(adj[v][1], adj, result, v);

        int x = dfs(adj[v][0], adj, result, v);
        result.push_back({adj[v][1], x, v});
        return x;
    }
}

void solve() {
    ll n; cin >> n;

    vector<int> goodind(1, 0);
    vector<int> badind(1, 0);

    vvi adj_bad(n), adj_good(n);
    rep(i, n - 1) {
        int x; cin >> x;
        adj_bad[x].push_back(i + 1);
    }
    rep(i, n - 1) {
        int x; cin >> x;
        adj_good[x].push_back(i + 1);
    }

    vector<vi> operations;
    dfs(0, adj_bad, operations, -1);

    each(i, operations) {
        adj_bad[i[2]].pop_back();
        adj_bad[i[1]].push_back(i[0]);
    }

    vector<vi> newgood;
    dfs(0, adj_good, newgood, -1); 

    each(i, newgood) {
        adj_good[i[2]].pop_back();
        adj_good[i[1]].push_back(i[0]);
    }

    while(adj_bad[badind.back()].size()) badind.push_back(adj_bad[badind.back()][0]);
    
    while(adj_good[goodind.back()].size()) goodind.push_back(adj_good[goodind.back()][0]);

    vi normindex(n);
    rep(i, n) normindex[goodind[i]] = badind[i];

    if (operations.size() + newgood.size() > n) {
        exit(228);
    }
    cout << operations.size() + newgood.size() << '\n';
    each(i, operations) cout << i[0] << " " << i[1] << '\n';
    reverse(all(newgood));
    each(i, newgood) cout << normindex[i[0]] << " "  << normindex[i[2]] << '\n';
}
 
int main() {
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(0);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}