#include <bits/stdc++.h>
#include <ctime>
#pragma GCC optimize("O3,fast-math")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,bmi2,tune=native")
#ifdef KOK
#include "debug_output.h"
#define dbg(x)                                                                 \
    cerr << "\n" << #x << ":\n ";                                              \
    debug::print(x);                                                           \
    cerr << "\n"
#else
#define dbg(x) ;
#endif

#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define rep(i, k, n) for (int i = k; i < n; i++)
#define rrep(i, k, n) for (int i = n - 1; i >= k; i--)
#define frl(i, x) for (auto &i : x)
#define forall(i, x) frl(i, x)
#define pb push_back
#define eb emplace_back
#define F first
#define S second

using ll = long long;
using ld = long double;
using dd = double;

using namespace std;

ld dist(pair<ll, ll> a, pair<ll, ll> b) {
    return sqrtl((a.F - b.F) * (a.F - b.F) + (a.S - b.S) * (a.S - b.S));
}

void solve() {
    int n;
    cin >> n;
    vector<pair<ll, ll>> v(n);
    frl(i, v) cin >> i.F >> i.S;
    ld max_len = 0;
    ld sum = 0;
    rep(i, 0, n) {
        auto a = v[i];
        auto b = v[(i + 1) % n];
        max_len = max(max_len, dist(a, b));
        sum += dist(a, b);
    }
    cout << sum - max_len;
}

signed main() {
    cin.tie(0)->ios::sync_with_stdio(0);
    int tt = 1;
    // cin >> tt;
    cout << setprecision(15) << fixed;
    while (tt--)
        solve();

#ifdef KOK
    cerr << setprecision(6) << fixed;
    cerr << "\nTime: " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
    return 0;
}