#include <bits/stdc++.h>

#define int long long
#define F first
#define S second
#define pii pair<int, int>
#define pb push_back
#define ld long double
#ifdef OlegSanders
#else
#define cerr if(0)cerr
#endif

using namespace std;

const int INF = 1e18 + 1234567;
const int MOD = 1e9 + 7;
const int N = 1e3 + 7;

mt19937_64 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

vector<pii> g1;
vector<pii> g2;
vector<int> deep1;
vector<int> deep2;
vector<int> par1;
vector<int> par2;

void calc(vector<pii> &g, vector<int> &deep, vector<int> &par, int v = 0, int k = 0) {
    if (v == -1) return;
    calc(g, deep, par, g[v].F, k + 1);
    calc(g, deep, par, g[v].S, k + 1);
    deep[v] = k;

    if (g[v].F != -1) {
        par[g[v].F] = v;
        deep[v] = max(deep[v], deep[g[v].F]);
    }

    if (g[v].S != -1) {
        par[g[v].S] = v;
        deep[v] = max(deep[v], deep[g[v].S]);
    }
}

vector< vector<int> > lines1(1, vector<int>{});
vector< vector<int> > lines2(1, vector<int>{});

void bamb_dfs(vector<pii> &g, vector<int> &deep, vector< vector<int> > &lines, int v = 0, int arr = 0) {
    if (v == -1) return;
//    cerr << "step_1 " << v << ' ' << g[v].F << ' ' << g[v].S << ' ' << arr << endl;
    lines[arr].pb(v);
    if (g[v].F == -1 && g[v].S == -1) {
        return;
    }
    //cerr << "step_2 " << v << ' ' << g[v].F << ' ' << g[v].S << ' ' << arr << endl;
    if (g[v].F == -1 || g[v].S == -1) {
        bamb_dfs(g, deep, lines, max(g[v].F, g[v].S), arr);
        return;
    }
    //cerr << "step_3 " << v << ' ' << g[v].F << ' ' << g[v].S << ' ' << arr << endl;
    if (deep[g[v].F] > deep[g[v].S]) {
        bamb_dfs(g, deep, lines, g[v].F, arr);
        lines.pb({});
        bamb_dfs(g, deep, lines, g[v].S, lines.size() - 1);
    } else {
        bamb_dfs(g, deep, lines, g[v].S, arr);
        lines.pb({});
        bamb_dfs(g, deep, lines, g[v].F, lines.size() - 1);
    }
}

void obx(vector<pii> &g, vector<int> &a, int v = 0) {
    if (v == -1)return;
    cerr << v << ' ' << g[v].F << ' ' << g[v].S << endl;
    a.pb(v);
    obx(g, a, max(g[v].F, g[v].S));
}

void zapr(vector<pair<int, pii>> &kek, vector<pii> &g, vector<int> &par, vector<vector<int>> &lines) {
    for (int i = 1; i < lines.size(); i++) {
        // par[u] - u -> v
        int u = lines[i][0];
        int v = lines[0].back();
        cerr << "par " << par[u] << ' ' << u << " -> " << v << endl;
        kek.pb({u, {par[u], v}});
        if (g[par[u]].F == u) {
            g[par[u]].F = -1;
        }
        if (g[par[u]].S == u) {
            g[par[u]].S = -1;
        }
        if (g[v].F == -1) {
            g[v].F = u;
        } else {
            g[v].S = u;
        }
        cerr << g[par[u]].F << ' ' << g[par[u]].S << endl;
        par[u] = v;
        cerr << "LOL " << g[v].F << ' ' << g[v].S << endl;
        lines[0].back() = lines[i].back();
    }
}

int32_t main() {
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    g1.resize(n + 5, {-1, -1});
    g2.resize(n + 5, {-1, -1});
    deep1.resize(n + 5, 0);
    deep2.resize(n + 5, 0);
    par1.resize(n + 5, 0);
    par2.resize(n + 5, 0);
    for (int i = 1; i < n; i++) {
        int pr;
        cin >> pr;
        if (g1[pr].F == -1) {
            g1[pr].F = i;
        } else {
            g1[pr].S = i;
        }
    }
    for (int i = 1; i < n; i++) {
        int pr;
        cin >> pr;
        if (g2[pr].F == -1) {
            g2[pr].F = i;
        } else {
            g2[pr].S = i;
        }
    }

    calc(g1, deep1, par1);
    bamb_dfs(g1, deep1, lines1);

    calc(g2, deep2, par2);
    bamb_dfs(g2, deep2, lines2);

    vector<pair<int, pii>> kek1;
    vector<pair<int, pii>> kek2;

    zapr(kek1, g1, par1, lines1);

    cerr << endl << endl;

    zapr(kek2, g2, par2, lines2);

    cerr << endl << endl;

    vector<int> a1;
    vector<int> a2;
    obx(g1, a1);
    obx(g2, a2);

//    for (int i = 0; i < n; i++) {
//        cout << g2[i].F << ' ' << g2[i].S << endl;
//    }
//    for (auto to: a2) {
//        cout << to << endl;
//    }
//    return 0;

    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        mp[a2[i]] = a1[i];
    }
    vector<pii> ans;
    for (auto to:kek1) {
        ans.pb({to.F, to.S.S});
    }
    for (int i = (int)(kek2.size()) - 1; i >= 0; i--) {
        auto to = kek2[i];
        ans.pb({mp[to.F], mp[to.S.F]});
    }
    cout << ans.size() << endl;
    for (auto to: ans) {
        cout << to.F << ' ' << to.S << endl;
    }
}
