#include <bits/stdc++.h>
using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

int f = 0;

void dfs(int curx, int cury, int fx, int fy, int n, int m, int k, vector<vector<int>> &used) {
	f = (curx == fx) && (cury == fy);
	if (f)
		return;

	used[curx][cury] = 1;

	for (int i = -1; i <= 1; i++) {
		for (int j = -1; j <= 1; j++) {
			if (i != j && !(i * j) && (curx + i > -1 && curx + i < n) && (cury + j > -1 && cury + j < m)) {
				if (!used[curx + i][cury + j]) {
					dfs(curx + i, cury + j, fx, fy, n, m, k, used);
					if (f)
						return;
				}
			}
		}
	}
	if (k) {
		for (int i = -2; i <= 2; i += 2) {
			for (int j = -2; j <= 2; j += 2) {
				if (i != j && !(i * j) && (curx + i > -1 && curx + i < n) && (cury + j > -1 && cury + j < m)) {
					if (!used[curx + i][cury + j]) {
						dfs(curx + i, cury + j, fx, fy, n, m, k - 1, used);
						if (f)
							return;
					}
				}
			}
		}
	}
	used[curx][cury] = 0;
}
signed main() {
	int n, m, k, s1, s2, f1, f2;
	fin>>n>>m>>k;

	vector <vector <int>> used(n, vector<int>(m, 0));
	for (int i = 0; i < n; ++ i) {
		string s;
		fin>>s;
		for (int j = 0; j < m; ++ j)
			if (s[j] == '#')
				used[i][j] = -1;
	}
	fin>>s1>>s2>>f1>>f2;
	--s1;
	--s2;
	--f1;
	--f2;
	dfs(s1, s2, f1, f2, n, m, k, used);
	fout<<(f ? "YES" : "NO");
}
