#include <bits/stdc++.h>
using namespace std;
/*
ifstream fin("input.txt");
ofstream fout("output.txt");
*/
void bfs(int sx, int sy, int fx, int fy, int n, int m, int k, vector<vector<pair<int, int>>> &used) {
	vector<vector<pair<int, int>>> p(n, vector<pair<int, int>>(m, {-1, -1}));
	set<pair<int, int>> a;
	a.insert({sx, sy});
	used[sx][sy] = {1, 0};

	while (!a.empty()) {
		int curx = (*a.begin()).first, cury = (*a.begin()).second;
		a.erase(a.begin());
		int f = 1;

		for (int i = -1; i <= 1; i++) {
			for (int j = -1; j <= 1; j++) {
				if (i != j && !(i * j) && (curx + i > -1 && curx + i < n) && (cury + j > -1 && cury + j < m)) {
					if (!used[curx + i][cury + j].first)
						f = 0;

		for (int i = -1; i <= 1; i++) {
			for (int j = -1; j <= 1; j++) {
				if (i != j && !(i * j) && (curx + i > -1 && curx + i < n) && (cury + j > -1 && cury + j < m)) {
					if (!used[curx + i][cury + j].first) {
						a.insert({curx + i, cury + j});
						used[curx + i][cury + j] = {1, min(used[curx + i][cury + j].second, 1)};
						p[curx + i][cury + j] = {curx, cury};
					}
				}
			}
		}
		if (!f) {
			for (int i = -2; i <= 2; i += 2) {
				for (int j = -2; j <= 2; j += 2) {
					if (i != j && !(i * j) && (curx + i > -1 && curx + i < n) && (cury + j > -1 && cury + j < m)) {
						if (!used[curx + i][cury + j].first) {
							a.insert({curx + i, cury + j});
							used[curx + i][cury + j] = {1, min(used[curx + i][cury + j].second, 2)};
							if (min(used[curx + i][cury + j].second, 2) == used[curx + i][cury + j].second) {
								p[curx + i][cury + j] = {curx, cury};
							}
						}
					}
				}
			}
		}
	}
	int cnt = 0;
	f = 0;
	for (pair<int, int> i = {fx, fy}; i.first != -1; i = p[i.first][i.second]) {
		if (i.first == sx && i.second == sy)
			f = 1;
		if (used[i.first][i.second].second == 2)
			++cnt;
	}
	cout<<((f && cnt <= k) ? "YES" : "NO");

}
signed main() {
	int n, m, k, s1, s2, f1, f2;
	cin>>n>>m>>k;

	vector <vector <pair<int, int>>> used(n, vector<pair<int, int>>(m, {0, 2}));
	for (int i = 0; i < n; ++ i) {
		string s;
		cin>>s;
		for (int j = 0; j < m; ++ j)
			if (s[j] == '#')
				used[i][j] = {-1, 0};
	}
	cin>>s1>>s2>>f1>>f2;
	--s1;
	--s2;
	--f1;
	--f2;
	bfs(s1, s2, f1, f2, n, m, k, used);
}
