#include <iostream>
#include <string>
#include <vector>
 
using namespace std;

int n, m, k;
string ans = "NO";
pair<int, int> start, dest;
vector<vector<int>> g;


void dfs(pair<int, int> curr, int jumps) {
    if (curr == dest) {
        ans = "YES";
        return;
    }
    int x = curr.first;
    int y = curr.second;
    if (x > 0) {
        if (g[x-1][y] == -1 || g[x-1][y] < jumps) {
            g[x-1][y] = jumps;
            dfs({x-1, y}, jumps);
        }
    }
    if (x+1 < n) {
        if (g[x+1][y] == -1 || g[x+1][y] < jumps) {
            g[x+1][y] = jumps;
            dfs({x+1, y}, jumps);
        }
    }
    if (y > 0) {
        if (g[x][y-1] == -1 || g[x][y-1] < jumps) {
            g[x][y-1] = jumps;
            dfs({x, y-1}, jumps);
        }
    }
    if (y+1 < m) {
        if (g[x][y+1] == -1 || g[x][y+1] < jumps) {
            g[x][y+1] = jumps;
            dfs({x, y+1}, jumps);
        }
    }
    if (jumps > 0) {
        jumps -= 1;
        if (x > 1) {
            if (g[x-2][y] == -1 || g[x-2][y] < jumps) {
                g[x-2][y] = jumps;
                dfs({x-2, y}, jumps);
            }
        }
        if (x+2 < n) {
            if (g[x+2][y] == -1 || g[x+2][y] < jumps) {
                g[x+2][y] = jumps;
                dfs({x+2, y}, jumps);
            }
        }
        if (y > 1) {
            if (g[x][y-2] == -1 || g[x][y-2] < jumps) {
                g[x][y-2] = jumps;
                dfs({x, y-2}, jumps);
            }
        }
        if (y+2 < m) {
            if (g[x][y+2] == -1 || g[x][y+2] < jumps) {
                g[x][y+2] = jumps;
                dfs({x, y+2}, jumps);
            }
        }
    }
}
 
int main() {
    cin >> n >> m >> k;
    g.resize(n);
    string s;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        for (char ch: s) {
            if (ch == '.') {
                g[i].push_back(-1);
            } else {
                g[i].push_back(k+1);
            }
        }
    }
    int x, y;
    cin >> x >> y;
    start = {x-1, y-1};
    cin >> x >> y;
    dest = {x-1, y-1};
    dfs(start, k);
    cout << ans;
}