import sys
sys.setrecursionlimit(1000000000)
input = sys.stdin.readline
n, m, k = map(int, input().split())
field = [input() for _ in range(n)]
total = n * m
start, end = [tuple(map(lambda x: int(x) - 1, input().split()))[::-1] for _ in range(2)]
next_iteration = [False] * total
was = [False] * total


def get_pos(current):
    return current[0] + current[1] * m


def dfs(current, has_jump: bool):
    if was[get_pos(current)]:
        return
    was[get_pos(current)] = True
    for dx in range(-1, 2):
        for dy in range(-1, 2):
            if abs(dx) + abs(dy) != 1:
                continue
            if not (0 <= current[0] + dx < m and 0 <= current[1] + dy < n):
                continue
            if field[current[1] + dy][current[0] + dx] != '#':
                dfs((current[0] + dx, current[1] + dy), has_jump)
    if has_jump:
        for dx in range(-1, 2):
            for dy in range(-1, 2):
                if abs(dx) + abs(dy) != 1:
                    continue
                dx *= 2
                dy *= 2
                if not (0 <= current[0] + dx < m and 0 <= current[1] + dy < n):
                    continue
                if field[current[1] + dy][current[0] + dx] != '#':
                    next_iteration[get_pos((current[0] + dx, current[1] + dy))] = True


next_iteration[get_pos(start)] = True
while True:
    real_next = next_iteration.copy()
    next_iteration = [False] * total
    happened = False
    for i, need in enumerate(real_next):
        if need and not was[i]:
            happened = True
            dfs((i % m, i // m), k > 0)
    if not happened:
        break
    k -= 1
if was[get_pos(end)]:
    print('YES')
else:
    print('NO')
'''
3 3 1
.#.
#.#
.#.
1 1
3 3

2 2 0
#.
..
1 2
2 1

2 5 2
.#.#.
###..
1 1
2 4

'''
