#include <iostream>

#define int_t long long

int_t count(int_t m, int_t n, int_t k) {
    if (m == 0 && n == 0) {
        return 1;
    }
    if (m <= 0) {
        return 0;
    }
    int_t ans = 0;
    for (int_t i = 1; i <= k; i++) {
        ans += count(m - i, n - 1, k);
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("/home/mavlyut/CLionProjects/untitled1/in", "r", stdin);
    freopen("/home/mavlyut/CLionProjects/untitled1/out", "w", stdout);
#endif
    std::ios_base::sync_with_stdio(false);

    int_t n, k, s1, s2;
    std::cin >> n >> k >> s1 >> s2;
    int_t diff = count(s1, n, k) - count(s2, n, k);
    std::cout << (diff > 0 ? "First" : (diff == 0 ? "Equal" : "Second"));
}
