#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const long long GCD = 2520;

long long calc_diff(vector<pair<long long, long long>>& s) {
    long long ans = 0;
    for (const auto& p: s) {
        ans += abs(p.first - p.second) * GCD / p.first;
    }
    return ans;
} 

int main()
{
    long long n, k;
    cin >> n >> k;
    vector<pair<long long, long long>> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i].first;
    for (int i = 0; i < n; i++)
        cin >> s[i].second;
    sort(s.begin(), s.end());
    long long diff = calc_diff(s) - k * GCD;
    int point = 0;
    int counter = 0;
    while (diff > 0) {
        if (s[point].first == s[point].second) {
            point++;
            continue;
        }
        int take = min(abs(s[point].first - s[point].second), (diff + GCD / s[point].first - 1) / (GCD / s[point].first));
        diff -= take * GCD / s[point].first;
        counter += take;
        s[point].second = s[point].first;
    }
    cout << counter << '\n';
}
