#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const long long GCD = 8 * 9 * 5 * 7;

int main()
{
    long long n, k;
    cin >> n >> k;
    vector<pair<long long, long long>> vec(n, {0, 0});
    for (size_t i = 0; i < n; i++)
    {
        cin >> vec[i].first;
    }
    for (size_t i = 0; i < n; i++)
    {
        cin >> vec[i].second;
    }
    sort(vec.begin(), vec.end());

    long long error = 0;
    for (const auto& p: vec) {
        error += abs(p.first - p.second) * (GCD / p.first);
    }

    size_t pos = 0;
    long long ans = 0;
    while (error > k * GCD) {
        long long adv = GCD / vec[pos].first;
        long long take = min(abs(vec[pos].first - vec[pos].second), (error - k * GCD + adv - 1) / adv);
        error -= take * adv;
        ans += take;
        pos++;
    }
    cout << ans << '\n';
}
