#pragma GCC optimize("Ofast")
#include <iostream>
#include <random>
#include <vector>
#include <random>
#include <string>
#include <stack>
#include <cmath>
#include <complex>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <cstdio>
#include <memory>
#include <cassert>

#define ld double
#define pll pair<ll,ll>
#define X first
#define Y second
#define int long long

using ll = long long;

using namespace std;

int const mod = 998244353;

vector<vector<int>> field;
vector<vector<int>> dp;
int n;
int m;

void upd_dp(bool where, int new_k, deque<pll > &q, int x, int y) {
  if (x >= 0 && x < n && y >= 0 && y < m && field[x][y]) {
    if (dp[x][y] < new_k) {
      dp[x][y] = new_k;
      if (where) {
        q.push_back({x, y});
      } else {
        q.push_front({x, y});
      }
    }
  }
}

void bfs(pll start, int k) {
  deque<pll > q;
  dp[start.X][start.Y] = k;
  q.push_back(start);
  while (!q.empty()) {
    auto [x, y] = q.front();
    q.pop_front();
    upd_dp(0, dp[x][y], q, x + 1, y);
    upd_dp(0, dp[x][y], q, x - 1, y);
    upd_dp(0, dp[x][y], q, x, y + 1);
    upd_dp(0, dp[x][y], q, x, y - 1);
    if (dp[x][y] > 0) {
      upd_dp(1, dp[x][y] - 1, q, x + 2, y);
      upd_dp(1, dp[x][y] - 1, q, x - 2, y);
      upd_dp(1, dp[x][y] - 1, q, x, y + 2);
      upd_dp(1, dp[x][y] - 1, q, x, y - 2);
    }
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  int k;
  cin >> n >> m >> k;
  field.resize(n, vector<int>(m));
  dp.resize(n, vector<int>(m, -1));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      char x;
      cin >> x;
      if (x == '.') {
        field[i][j] = 1;
      } else {
        field[i][j] = 0;
      }
    }
  }
  pll start;
  cin >> start.X >> start.Y;
  int x, y;
  cin >> x >> y;
  x--, y--;
  start.X--, start.Y--;
  bfs(start, k);
  if (dp[x][y] >= 0) cout << "YES\n";
  else cout << "NO\n";
}