#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}
#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <iomanip>
#include <deque>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;
typedef vector<int> vi;
typedef vector <vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef vector <vii> vvii;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 2e9;
FILE* stream;

void solve()
{
    ll n, k;
    cin >> n >> k;
    ll c = 2*2*2*3*3*5*7;
    vector<pair<ll, ll>> s(n);
    for (ll i = 0; i < n; i++) {
        cin >> s[i].first;
    }
    ll d = 0;
    for (ll i = 0; i < n; i++) {
        cin >> s[i].second;
        s[i].second = abs(s[i].second - s[i].first);
        d += s[i].second * c / s[i].first;
    }
    sort(s.begin(), s.end(), [](const pair<ll, ll>& a, const pair<ll, ll>& b) { return a.first < b.first; });
    ll res = 0, i = 0;
    k *= c;
    while (k < d) {
        if (d - k > s[i].second * c / s[i].first) {
            res += s[i].second;
            d -= s[i].second * c / s[i].first;
        } else {
            ll l = 0, r = s[i].second;
            while (l < r - 1) {
                ll m = (l + r) / 2;
                if (d - k > m * c / s[i].first) {
                    l = m;
                } else {
                    r = m;
                }
            }
            res += r;
            break;
        }
        i++;
    }
    cout << res << "\n";
}

signed main()
{
#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}