#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <iomanip>
#include <deque>
#include <random>
#include <ctime>

using namespace std;
typedef long long ll;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef vector<vii> vvii;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 2e9;

void solve() {
    ll n;
    cin >> n;
    vi a(n + 10);
    forn(i, n - 2)cin >> a[i + 1];

    vi p(n + 10);
    vi steps(n + 10, INF);
    steps[0] = 0;
    forn(i, n + 9) {
        p[i] = i;
    }
    for (int i = 1; i < n; i++) {
        p[i] = p[i - a[i]];
    }
    for (int i = 0; i < n; i++) {
        for (int k = 1; k < 6; k++) {
            ll next = p[i + k];
            steps[next] = min(steps[next], steps[i] + 1);
        }
        ll next = p[i + 6];
        if (next == n - 1) {
            steps[next] = min(steps[next], steps[i] + 1);
        } else {
            steps[next] = min(steps[next], steps[i]);
        }
    }
//    wv(a);
//    wv(p);
//    wv(steps)
    ll ans = steps[n - 1];
    if (ans == INF) cout << -1 << endl;
    else cout << ans;
}

signed main() {
#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}