#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    int n;
    cin >> n;

    ll k;
    cin >> k;

    ll F = 1;
    for (ll i = 1; i <= 10; i++) {
        F *= i;
    }

    vector<ll> s(n);
    for (auto &x: s) cin >> x;

    vector<ll> a(n);
    for (auto &x: a) cin >> x;

    vector <int> indexes(n);
    iota(indexes.begin(), indexes.end(), 0);

    sort(indexes.begin(), indexes.end(), [&s] (int lhs, int rhs) {
        return s[lhs] < s[rhs];
    });

    ll total = 0;
    for (int i = 0; i < n; i++) {
        total += abs(a[i] - s[i]) * (F / s[i]);
    }

    auto f = [&] (int i, ll x) {
        return total - abs(a[i] - s[i]) * (F / s[i]) + abs(abs(a[i] - s[i]) - x) * (F / s[i]);
    };

    ll answer = 0;
    for (int i: indexes) {
        if (total <= k * F) {
            break;
        }

        ll mid, l = 0, r = abs(a[i] - s[i]);
        while (r - l > 1) {
            mid = (l + r) / 2;

            if (f(i, mid) <= k * F) {
                r = mid;
            } else {
                l = mid;
            }
        }

        answer += r;
        total = total - abs(a[i] - s[i]) * (F / s[i]) + abs(abs(a[i] - s[i]) - r) * (F / s[i]);
    }

    cout << answer << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}