#include <iostream>
#include <unordered_map>
#include <unordered_set>

using namespace std;

inline pair<string, string> get_str_prefix(string arg) {
    int last_non_digit = 0;
    for (int i = 0; i < arg.length(); ++i) {
        if (!isdigit(arg[i])) {
            last_non_digit = i;
        }
    }
    return make_pair(arg.substr(0, last_non_digit + 1), arg.substr(last_non_digit + 1));
}

inline void solve() {
    int q;
    cin >> q;
    unordered_map<string, unordered_set<int>> m;
    for (int i = 0; i < q; i++) {
        string a;
        cin >> a;

        pair<string, string> p = get_str_prefix(a);
        string pref = p.first;
        string suf = p.second;

        if (m[pref].empty()) {
            m[pref].insert(suf.empty() ? -1 : stoi(suf));
            cout << a << "\n";
        } else {
            if (!suf.empty() && m[pref].find(stoi(suf)) == m[pref].end()) {
                cout << a << "\n";
                m[pref].insert(stoi(suf));
            } else {
                int k = 1;

                int i = 1000000;

                while (i > 0) {
                    string t = suf + to_string(k);
                    if (m[pref].find(stoi(t)) == m[pref].end()) {
                        cout << pref + t << "\n";
                        m[pref].insert(stoi(t));
                        break;
                    }
                    k++;
                    i--;
                }
            }
        }
    }

}

int main() {
    solve();
}