from sys import setrecursionlimit


def dfs(y, x, k_count):
    visited[x][y] = True
    can_leave = False
    if y == ay - 1 and x == ax - 1:
        print("YES")
        quit()
    if x > 0 and Burg[x - 1][y] != '#' and not visited[x - 1][y]:
        can_leave = True
        dfs(y, x - 1, k_count)
    if x < N - 1 and Burg[x + 1][y] != '#' and not visited[x + 1][y]:
        can_leave = True
        dfs(y, x + 1, k_count)
    if y > 0 and Burg[x][y - 1] != '#' and not visited[x][y - 1]:
        can_leave = True
        dfs(y - 1, x, k_count)
    if y < M - 1 and Burg[x][y + 1] != '#' and not visited[x][y + 1]:
        can_leave = True
        dfs(y + 1, x, k_count)

    if not can_leave and k_count < K:
        if x > 1 and Burg[x - 2][y] != '#' and not visited[x - 2][y]:
            dfs(y, x - 2, k_count + 1)
        if x < N - 2 and Burg[x + 2][y] != '#' and not visited[x + 2][y]:
            dfs(y, x + 2, k_count + 1)
        if y > 1 and Burg[x][y - 2] != '#' and not visited[x][y - 2]:
            dfs(y - 2, x, k_count + 1)
        if y < M - 2 and Burg[x][y + 2] != '#' and not visited[x][y + 2]:
            dfs(y + 2, x, k_count + 1)


setrecursionlimit(100000000)
N, M, K = map(int, input().split(" "))
Burg = [[] for _ in range(N)]
visited = [[False for _ in range(M)] for _ in range(N)]

dx = 0
dy = 0
ax = 0
ay = 0
# N == x, M == y

for i in range(N):
    Burg[i] = list(input())

dx, dy = map(int, input().split(" "))
ax, ay = map(int, input().split(" "))

dfs(dy - 1, dx - 1, 0)

if not visited[ax - 1][ay - 1]:
    print("NO")
    quit()

