def binom(n, k):
    if k == 0 or n == k:
        return 1
    if k > n:
        return 0
    if k == 1:
        return n

    b = 1
    for i in range(1, k + 1):
        b *= n - (k - i)
        b /= i
    return b


def comb(n, k, m):
    m1 = -1
    s = 0
    i = 0
    while i <= n / (m + 1):
        m1 *= -1
        s += m1 * binom(k, i) * binom(n - i * (m + 1) + k - 1, k - 1)
        i += 1
    return s


n = int(input())
k = int(input())
s1 = int(input())
s2 = int(input())

f = comb(s1 - n, n, k - 1)
s = comb(s2 - n, n, k - 1)

if f == s:
    print("Equal")
elif f > s:
    print("First")
else:
    print("Second")