#include <bits/stdc++.h>
#define forn(i, n) for (ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define f first
#define s second
typedef long long ll;
typedef long double ld;
using namespace std;

vector<string> ginp(0);
ll n, m, k;

ll cntcomp = 0;
vector<vector<ll>> compnum(0);

bool isok(pair<ll, ll> p) {
    return 0 <= p.f && p.f < n && 0 <= p.s && p.s <= m;
}

bool isc(pair<ll, ll> p) {
    return isok(p) && ginp[p.f][p.s] == '.';
}

bool isc(ll i, ll j) {
    return isc({i, j});
}

void dfs1(int x, int y) {
    compnum[x][y] = cntcomp;
    vector<pair<ll, ll>> v = { {x, y-1},{x, y+1}, {x-1, y}, {x+1, y} };
    for (auto u : v) {
        if (isc(u) && compnum[u.f][u.s] == -1) {
            dfs1(u.f, u.s);
        }
    }
}


vector<vector<int>> g(0);


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n  >> m >> k;
    ginp.resize(n);
    compnum.resize(n, vector<ll>(m, -1));
    forn(i, n) {
        cin >> ginp[i];
    }
    //done: ументшить на 1 старт и финиш коорднаты 
    pair<ll, ll> st, end;
    cin >> st.first >> st.second >> end.first >> end.second;
    st.f--;
    st.s--;
    end.f--;
    end.s--;


    //dfs1
    forn(i, n) {
        forn(j, m) {
            if (compnum[i][j] == -1 && isc(i, j)) {
                dfs1(i, j);
                cntcomp ++;
            }
        }
    }

    g.resize(cntcomp);

    forn(x, n) {
        forn(y, m) {
            if (isc(x, y)) {
                vector<pair<ll, ll>> v = { {x, y-2},{x, y+2}, {x-2, y}, {x+2, y} };
                for (auto u : v) {
                    if (isc(u)) {
                        if (g[compnum[x][y]].empty() || (!g[compnum[x][y]].empty() && g[compnum[x][y]].back() != compnum[u.f][u.s])) {
                            g[compnum[x][y]].push_back(compnum[u.f][u.s]);
                        }
                    }
                }
            }
        }
    }

    int cs = compnum[st.f][st.s];
    int compend = compnum[end.f][end.s];

    // bfs
    queue<int> q;
    q.push(cs);
    vector<bool> used(cntcomp, false);
    vector<int> d(cntcomp, -1);
    used[cs] = true;
    d[cs] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (!used[u]) {
                used[u] = true;
                q.push(u);
                d[u] = d[v]+1;
            }
        }
    }



    if (used[compend] && d[compend] <= k) {
        cout  << "YES\n";
    } else {
        cout << "NO\n";
    }

    return 0;
}