#include <bits/stdc++.h>
using namespace std;
 
#define int long long
#define double long double
#define ld double
 
#define all(x) x.begin(), x.end()
 
const int INF = 2e9 + 5;
// const int SZ = 1 << 18;
const double eps = 1e-10;
 
const int maxN = 1e6 + 10;
map <char, int> go[maxN];
bool isEnd[maxN];
int mex[maxN];
set <int> nums[maxN];
int sz = 0;

void insert (string & s) {
    int len = s.size();
    int curr = 0;
    for (auto elem : s) {
        if (!go[curr].count(elem)) go[curr][elem] = ++sz;
        curr = go[curr][elem];
    }
    isEnd[curr] = true;

    int suff = len - 1;
    while (suff >= 0 && isdigit(s[suff])) --suff;
    if (!isdigit(s[suff])) ++suff;
    
    curr = 0;
    for (int i = 0; i < suff; ++i)
        curr = go[curr][s[i]];

    for (int i = suff; i < len; ++i) {
        nums[curr].insert(stoll(s.substr(i, len - i)));
        while (nums[curr].count(mex[curr])) ++mex[curr];
        curr = go[curr][s[i]];
    }
}

bool find (string & s) {
    int curr = 0;
    for (auto elem : s) {
        if (!go[curr].count(elem)) return false;
        curr = go[curr][elem];
    }
    return isEnd[curr];
}

void add_user (string & s) {
    if (!find(s)) {
        insert(s);
        cout << s << endl;
    }
    else {
        int curr = 0;
        for (auto elem : s) {
            curr = go[curr][elem];
        }
        string t = s + to_string(mex[curr]);
        cout << t << endl;
        insert(t);
    }
}

void solve() {
    fill(mex, mex + maxN, 1);
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        string s; cin >> s;
        add_user(s);
    }
}
 
signed main(){
 
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    cout << fixed << setprecision(10);
 
    int t = 1;
    // cin >> t;
 
    while (t--){
        solve();
        cout << '\n';
    }
 
}