#include <bits/stdc++.h>
using namespace std;
 
// #define int long long
#define double long double
#define ld double
 
#define all(x) x.begin(), x.end()
 
const int INF = 2e9 + 5;
const int SZ = 1 << 18;
const double eps = 1e-10;
 
int p[SZ];
int d[SZ][2];
 
int n;
 
void solve(){
 
    cin >> n;
    p[1] = 1;
    p[n] = n;
    for (int i = 2; i < n; i++){
        cin >> p[i];
        if (p[i]){
            p[i] = p[i - p[i]];
        }else{
            p[i] = i;
        }
    }
 
    for (int i = 0; i < SZ; i++){
        d[i][0] = d[i][1] = INF;
    }
    d[1][0] = 0;
    deque<pair<int, int>> q;
    q.push_back({1, 0});
 
    while (q.size()){
        pair<int, int> cur = q.front();
        q.pop_front();
 
        for (int i = 1; i <= 6; i++){
            int w = cur.second ^ 1;
            pair<int, int> next = {min(n, cur.first + i), i == 6 ? 1 : 0};
            next.first = p[next.first];
 
            if (d[next.first][next.second] > d[cur.first][cur.second] + w){
                d[next.first][next.second] = d[cur.first][cur.second] + w;
                if (w){
                    q.push_back(next);
                }else{
                    q.push_front(next);
                }
            }
        }
    }
 
    int ans = min(d[n][0], d[n][1]);
    if (ans == INF){
        cout << -1;
        return;
    }
    cout << ans;
 
}
 
signed main(){
 
    // freopen("input.txt", "r", stdin);
 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    cout << fixed << setprecision(10);
 
    int t = 1;
    // cin >> t;
 
    while (t--){
        solve();
        cout << '\n';
    }
 
}