def distance(x1, y1, x2, y2):
    return math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)

def polygon_circumference(vertices):
    length = 0
    n = len(vertices)
    maxLen = -10

    for i in range(n):
        x1, y1 = vertices[i]
        x2, y2 = vertices[(i + 1) % n]
        curdist = distance(x1, y1, x2, y2)
        maxLen = max(maxLen, curdist)
        length += curdist

    return length - maxLen

def solve():
    n = int(input())
    vertices = []
    for i in range(n):
        x, y = map(int, input().split())
        vertices.append([x, y])

    return round(polygon_circumference(vertices), 5)

print(solve())