#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back

#ifndef LOCAL
#define cerr                                                                                                           \
	if (0)                                                                                                             \
	cerr
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vi> vvi;

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> &p) {
	out << "(" << p.ff << ", " << p.ss << ")";

	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> &v) {
	out << "[";
	for (T &e : v)
		out << e << ", ";
	out << "]";

	return out;
}

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}

	return 0;
}

vector<ll> primes;
vector<ll> lp;

ll maxp = 5e6;

void erat()
{
	primes.reserve(maxp);
	lp.resize(maxp);

	for(ll i = 2; i < maxp; i++)
	{
		if(lp[i] == 0)
		{
			lp[i] = i;
			primes.pb(i);
		}

		for(int j = 0; j < primes.size() && primes[j] <= lp[i] && primes[j] * i < maxp; j++)
			lp[i * primes[j]] = primes[j];
	}
}

void solve() {
	ll l, r;
	cin >> l >> r;

	erat();

	ll ansa = l, ansb = l+1;
	ll ans = 1;
	for(ll prime : primes)
	{
		ll a = (r / prime) * (prime - 1);
		ll b = (r / prime) * prime;

		if(a >= l)
		{
			if(ans < r/prime)
			{
				ans = max(ans, r/prime);
				ansa = a, ansb = b;
			}
		}
	}

	cout << ansa << " " << ansb;
}

