#include <bits/stdc++.h>
using namespace std;
 
template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
      os << vec[i] << " \n"[i + 1 == vec.size()];
   return os;
}
 
template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}
 
typedef long long ll;
typedef long double ld;
#define endl "\n"

const int INF = 1e9 + 1000;

const int M = 50000;
const int N = 21;
const ld eps = 1e-9;
const ld PI = atan2l(0, -1);


ll my_pow(ll a, ll p){
    if (p == 0)
        return 1;
    if(p % 2 == 0)
        return my_pow(a * a, p / 2);
    return my_pow(a, p - 1) * a;
}

void solve()
{
    ll a, b;
    cin >> a >> b;
    if (abs(a - b) == 1)
        cout << "Error\n";
    else if (a >= 2 && b >= 2)
        cout << "Undefined\n";
    else {
        if (a == 1){
            cout << 0 << "\n";
            cout << b / 2 << "\n";
            cout << 1 << "\n";
        }
        if (b == 1){
            cout << a / 2 << "\n";
            cout << 0 << "\n";
            cout << 1 << "\n";
        }
        if (a == 0) {
            cout << 0 << "\n";
            cout << b / 2 << "\n";
            cout << 0 << "\n";
        }
        if (b == 0) {
            cout << a / 2 << "\n";
            cout << 0 << "\n";
            cout << 0 << "\n";
        }
    }
}
 
signed main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
   #ifndef LOCAL
   // freopen("disttosegment.in", "r", stdin);
   // freopen("disttosegment.out", "w", stdout);
   // #else
   // freopen("mincut.in", "r", stdin);
   // freopen("mincut.out", "w", stdout);
   #endif
 
   int t = 1;
   // cin >> t;
   while(t--)
   {
      // cout << t << endl;
      solve();
   }
   return 0;
}