#include <bits/stdc++.h>
using namespace std;
 
template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
      os << vec[i] << " \n"[i + 1 == vec.size()];
   return os;
}
 
template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}
 
typedef long long ll;
typedef long double ld;
#define endl "\n"

const int INF = 1e9 + 1000;

const int M = 50000;
const int N = 21;
const ld eps = 1e-9;
const ld PI = atan2l(0, -1);


ll my_pow(ll a, ll p){
    if (p == 0)
        return 1;
    if(p % 2 == 0)
        return my_pow(a * a, p / 2);
    return my_pow(a, p - 1) * a;
}

void solve()
{
    int h, w; cin  >> h >> w;
    ll cnt1 = 0, cnt0 = 0;

    for(int i = 0; i < h; i++)
    {
        string s; cin >> s;
        for(int j = 0; j < w; j++)
        {
            if (s[j] == '0')
                cnt0++;
            else
                cnt1++;
        }
    }
    cout << min(cnt1, cnt0) << "\n";
}
 
signed main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
   #ifndef LOCAL
   // freopen("disttosegment.in", "r", stdin);
   // freopen("disttosegment.out", "w", stdout);
   // #else
   // freopen("mincut.in", "r", stdin);
   // freopen("mincut.out", "w", stdout);
   #endif
 
   int t = 1;
   // cin >> t;
   while(t--)
   {
      // cout << t << endl;
      solve();
   }
   return 0;
}