#include <bits/stdc++.h>
using namespace std;
  
template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
      os << vec[i] << " \n"[i + 1 == vec.size()];
   return os;
}
  
template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}
  
typedef long long ll;
typedef long double ld;
#define endl "\n"
 
const int INF = 1e9 + 1000;
 
const int M = 50000;
const int N = 21;
const ld eps = 1e-9;
const ld PI = atan2l(0, -1);
 
 
ll my_pow(ll a, ll p){
    if (p == 0)
        return 1;
    if(p % 2 == 0)
        return my_pow(a * a, p / 2);
    return my_pow(a, p - 1) * a;
}
 
void solve()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<string> fl(n);
    vector<vector<int>> was(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
        cin >> fl[i];
    int x1, y1;
    cin >> x1 >> y1;
    x1 --;
    y1 --;
    int x2, y2;
    cin >> x2 >> y2;
    x2 --;
    y2 --;
    priority_queue<pair<int, pair<int, int>>> q;
    q.push({0, {x1, y1}});
    int s = 0;
    while(!q.empty()){
        auto cur = q.top();
        q.pop();
        auto v = cur.second;
        was[v.first][v.second] = 1;
        //cout << v.first << " " << v.second << "\n";
        if (fl[v.first][v.second] == '#')
            continue;
        //cout << v.first << " " << v.second << "\n";
        if (v.first == x2 && v.second == y2){
            s = 1;
            break;
        }
        if (v.first + 1 < n && !was[v.first + 1][v.second] && fl[v.first + 1][v.second] != '#'){
            q.push({cur.first, {v.first + 1, v.second}});
        }
        if (v.first - 1 >= 0 && !was[v.first - 1][v.second] && fl[v.first - 1][v.second] != '#'){
            q.push({cur.first, {v.first - 1, v.second}});
        }
        if (v.second + 1 < m && !was[v.first][v.second + 1] && fl[v.first][v.second + 1] != '#'){
            q.push({cur.first, {v.first, v.second + 1}});
        }
        if (v.second - 1 >= 0 && !was[v.first][v.second - 1] && fl[v.first][v.second - 1] != '#'){
            q.push({cur.first, {v.first, v.second - 1}});
        }
        if (cur.first < k ){
            if (v.first + 2 < n && !was[v.first + 2][v.second] && fl[v.first + 2][v.second] != '#'){
                q.push({cur.first + 1, {v.first + 2, v.second}});
            }
            if (v.first - 2 >= 0 && !was[v.first - 2][v.second] && fl[v.first - 2][v.second] != '#'){
                q.push({cur.first + 1, {v.first - 2, v.second}});
            }
            if (v.second + 2 < m && !was[v.first][v.second + 2] && fl[v.first][v.second + 2] != '#'){
                q.push({cur.first + 1, {v.first, v.second + 2}});
            }
            if (v.second - 2 >= 0 && !was[v.first][v.second - 2] && fl[v.first][v.second - 2] != '#'){
                q.push({cur.first + 1, {v.first, v.second - 2}});
            }
        }
    }
    if(s)
        cout << "YES\n";
    else
        cout << "NO\n";
}
  
signed main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
  
   #ifndef LOCAL
   // freopen("disttosegment.in", "r", stdin);
   // freopen("disttosegment.out", "w", stdout);
   // #else
   // freopen("mincut.in", "r", stdin);
   // freopen("mincut.out", "w", stdout);
   #endif
  
   int t = 1;
   // cin >> t;
   while(t--)
   {
      // cout << t << endl;
      solve();
   }
   return 0;
}