#include <bits/stdc++.h>
using namespace std;
 
template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
      os << vec[i] << " \n"[i + 1 == vec.size()];
   return os;
}
 
template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}
 
typedef long long ll;
typedef long double ld;
#define endl "\n"
 
const int INF = 1e9 + 1000;

const int M = 50000;
const int N = 21;
const ld eps = 1e-9;
const ld PI = atan2l(0, -1);


ll my_pow(ll a, ll p){
    if (p == 0)
        return 1;
    if(p % 2 == 0)
        return my_pow(a * a, p / 2);
    return my_pow(a, p - 1) * a;
}
 
vector<ll> g[200005];

ll was[200005];
ll a[200005];
ll pos[200005];
ll ans[200005];

void dfs(ll v, ll pred, ll br){
 //   cout << "v : " << v << " " << pred << " " << br << endl;
    was[v] = 1;
    ans[v] = min(ans[v],ans[pred] + (br == 6 ? 0 : 1));
    for(auto to : g[v]){
//        cout << "to: " << to << endl;
        if(pos[to] == to && ans[v] + (to - v == 6 ? 0 : 1) < ans[to]){
            dfs(to, v, to - v);
        }
        else if(ans[v] + (to - v == 6 ? 0 : 1) < ans[pos[to]]){
            dfs(pos[to], v, to - v);
        }
    }
}

void solve()
{
    ll n;
    cin >> n;
    a[0] = 0;
    a[n-1] = 0;
    pos[0] = 0;
    g[0].push_back(1);
    g[0].push_back(2);
    g[0].push_back(3);
    g[0].push_back(4);
    g[0].push_back(5);
    g[0].push_back(6);
    for(int i = 1; i < n; i++){
        ans[i] = 999999999;
    }
    ans[0] = 0;
    for(int i = 1; i < n - 1; i++){
        cin >> a[i];
        if(a[i] == 0)
            pos[i] = i;
        pos[i] = pos[i - a[i]];
        g[i].push_back(i + 1);
        g[i].push_back(i + 2);
        g[i].push_back(i + 3);
        g[i].push_back(i + 4);
        g[i].push_back(i + 5);
        g[i].push_back(i + 6);
    }
    pos[n-1] = n - 1;
    dfs(0, 0, 0);
    if(ans[n-1] == 999999999){
        cout << -1 << endl;
    }
    else
        if(ans[n-1] == 0)
            cout << 1 << endl;
        else
            cout << ans[n - 1] << endl;
}
 
signed main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
   #ifndef LOCAL
   // freopen("disttosegment.in", "r", stdin);
   // freopen("disttosegment.out", "w", stdout);
   // #else
   // freopen("mincut.in", "r", stdin);
   // freopen("mincut.out", "w", stdout);
   #endif
 
   int t = 1;
   // cin >> t;
   while(t--)
   {
      // cout << t << endl;
      solve();
   }
   return 0;
}