#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long double ld;

const ld EPS = 1e-8;

signed main() {
    int n, k;
    cin >> n >> k;
    int init_k = k;
    vector<pair<int, int>> S(n);
    for (int i = 0; i < n; ++i) {
        cin >> S[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> S[i].second;
    }
    if (k == 0) {
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += abs(S[i].first - S[i].second);
        }
        cout << ans << endl;
        return 0;
    }
    sort(S.begin(), S.end());
    reverse(S.begin(), S.end());
    ld sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += ld(abs(S[i].first - S[i].second)) / S[i].first;
    }
    int ans = 0;
    while (sum > k) {
        if (sum - k - ld(abs(S.back().first - S.back().second)) / S.back().first > EPS) {
            sum -= ld(abs(S.back().first - S.back().second)) / S.back().first;
            ans += abs(S.back().first - S.back().second);
            S.pop_back();
        } else {
            int l = 1;
            int r = S.back().first - S.back().second;
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (sum - k - ld(abs(S.back().first - S.back().second + m)) / S.back().first > EPS) {
                    r = m;
                } else {
                    l = m;
                }
            }
            ans += S.back().second - l;
            break;
        }
    }
    cout << ans << endl;
    return 0;
}