#include <iostream>
#include <vector>
#include <deque>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> snake;
    snake.push_back(0);
    for (int i = 0; i < n - 2; i++) {
        int a;
        cin >> a;
        snake.push_back(a);
    }
    snake.push_back(0);
    for (int i = 0; i < n; ++i) {
        if (snake[i] == 0) {
            continue;
        }
        if (snake[i - snake[i]] != 0) {
            snake[i] = snake[i - snake[i]];
        } else {
            snake[i] = i - snake[i] + 1;
        }
    }
    for (int i = 0; i < 10; ++i) {
        snake.push_back(0);
    }
    deque<int> bfs01;
    bfs01.push_back(0);
    vector<int> dist(n + 10, 1'000'000'000);
    dist[0] = 0;
    while(!bfs01.empty()) {
        int cur = bfs01[0];
        if (cur >= n) {
            break;
        }
        bfs01.pop_front();
        int n6 = cur;
        while (true) {
            if (snake[cur + 6] == 0) {
                n6 = cur + 6;
            } else {
                n6 = snake[cur + 6] - 1;
            }
            if (dist[n6] == 1'000'000'000 && n6 < n) {
                dist[n6] = dist[cur];
                for (int i = 1; i < 6; ++i) {
                    int ne;
                    if (snake[n6 + i] == 0) {
                        ne = n6 + i;
                    } else {
                        ne = snake[n6 + i] - 1;
                    }
                    if (dist[ne] == 1'000'000'000) {
                        dist[ne] = dist[n6] + 1;
                        bfs01.push_back(ne);
                    }
                }
                dist[n6] = dist[cur] + 1;
                bfs01.push_back(n6);
            } else {
                break;
            }
        }
        for (int i = 1; i < 6; ++i) {
            int ne;
            if (snake[cur + i] == 0) {
                ne = cur + i;
            } else {
                ne = snake[cur + i] - 1;
            }
            if (dist[ne] == 1'000'000'000) {
                dist[ne] = dist[cur] + 1;
                bfs01.push_back(ne);
            }
        }
    }
    int minim = 1'000'000'000;
    for (int i = n - 1; i < dist.size(); i++) {
        minim = min(minim, dist[i]);
    }
    if (minim == 1'000'000'000) {
        cout << -1;
    } else {
        cout << minim;
    }
}