#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <map>
#include <string>
#include <stack>
#include <numeric>
#include <random>
#include <algorithm>
#include <unordered_map>
#include <queue>
#include <cctype>
using namespace std;
#define int long long
#define M7 1'000'000'007LL
#define mod 998244353
#define INF M7 * M7
#define ALL(a) a.begin(), a.end()
#define eps 1e-9
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
//int get_rnd(int l, int r){
//    return rnd() % (r - l + 1) + l;
//}

void solve() {

  int n, k, s1, s2;
  cin >> n >> k >> s1 >> s2;

  int l, r;
  if (n * (k + 1) % 2 == 0) {
      l = r = (n * (k + 1)) / 2;
  } else {
    l = (n * (k + 1)) / 2;
    r = (n * (k + 1) + 1) / 2;
  }

  if(abs(l - s1) == abs(r - s2)) cout << "Equal";
  else if(abs(l - s1) > abs(r - s2)) cout << "Second";
  else cout << "First";
}

signed main() {
#ifdef LOCAL_ARTEM
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int t = 1; //cin >> t;
  while (t--) solve();

#ifdef LOCAL_ARTEM
  cout << '\n' << fixed << setprecision(3) << 1. * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
  return 0;
}