#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <map>
#include <string>
#include <stack>
#include <numeric>
#include <random>
#include <algorithm>
#include <unordered_map>
#include <queue>
#include <cctype>
using namespace std;
#define int long long
#define M7 1'000'000'007LL
#define mod 998244353
#define INF M7 * M7
#define ALL(a) a.begin(), a.end()
#define eps 1e-9
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
//int get_rnd(int l, int r){
//    return rnd() % (r - l + 1) + l;
//}

void solve() {

  int n;
  cin >> n;

  vector<int> a(n, 0);
  for (int i = 0; i < n - 2; i++) cin >> a[i + 1];

  vector<int> to(n, 0);
  for (int i = 0; i < n; i++) to[i] = i;

  for (int i = 1; i < n; i++) {
    to[i] = to[max(0LL, i - a[i])];
  }

//  for (auto &i : to) cout << i << " ";

  vector<int> dp(n, INF);
  dp[0] = 0;
  for (int i = 0; i < n - 1; i++) {
    if (dp[i] == INF) continue;
    for (int j = 1; j <= 6; j++) {
      int poz = min(i + j, n - 1);
      int will = to[poz];
      dp[will] = min(dp[will], dp[i] + 1 - (j == 6));
    }
  }
  if(dp[n - 1] == INF) cout << -1;
  else cout << dp[n - 1] + 1;
}

signed main() {
#ifdef LOCAL_ARTEM
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int t = 1; //cin >> t;
  while (t--) solve();

#ifdef LOCAL_ARTEM
  cout << '\n' << fixed << setprecision(3) << 1. * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
  return 0;
}