#include <iostream>
#include <vector>

struct klukalo{
    int s;
    int a;
};

struct counting {
    std::vector<klukalo> k;
    int c;
};

void CountingSort(std::vector<klukalo>* klukalos, int n) {
    counting c[11]{};
    for (int i = 0; i < n; i++) {
        c[(*klukalos)[i].s].c++;
        c[(*klukalos)[i].s].k.push_back((*klukalos)[i]);
    }

    int k = 0;
    for (int i = 0; i <= 10; i++) {
        for (int j = 0; j < c[i].k.size(); ++j) {
            (*klukalos)[k] = c[i].k[j];
            k++;
            c[i].c--;
        }
    }
}

int main() {
    int n;
    int k;
    std::cin >> n >> k;
    std::vector<klukalo> klukalos(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> klukalos[i].s;
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> klukalos[i].a;
    }

    CountingSort(&klukalos, n);
//    for (int i = 0; i < n; ++i) {
//        std::cout << klukalos[i].s << ' ' << klukalos[i].a << '\n';
//    }
    int cnt = 0;
    double myK = 0;
    for (int i = 0; i < n; ++i) {
        myK += std::abs(klukalos[i].a - klukalos[i].s) / (double)klukalos[i].s;
    }

    int ind = 0;
    while (myK > k) {
        cnt++;
        myK -= (1.0 / klukalos[ind].s);
        if ((--klukalos[ind].a) == klukalos[ind].s) {
            ++ind;
        }
    }

    std::cout << cnt;

    return 0;
}