#include <iostream>
#include <string>
#include <unordered_set>

int main() {
    int q;
    std::cin >> q;

    std::unordered_set<std::string> users;
    for (int i = 0; i < q; ++i) {
        std::string name;
        std::cin >> name;

        if (users.count(name) == 0) {
            // пользователь с таким именем ещё не зарегистрирован
            users.insert(name);
            std::cout << name << '\n';
        } else {
            // имя уже занято, нужно добавить число в конец
            int suffix = 1;
            while (users.count(name + std::to_string(suffix)) > 0) {
                ++suffix;
            }
            users.insert(name + std::to_string(suffix));
            std::cout << name + std::to_string(suffix) << '\n';
        }
    }

    return 0;
}
