#include <iostream>
#include <string>
#include <unordered_set>
#include <sstream>

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(false);

    int q;
    std::cin >> q;

    std::unordered_set<std::string> users;
    users.reserve(100000);
    std::ostringstream output;
    for (int i = 0; i < q; ++i) {
        std::string name;
        std::cin >> name;

        if (users.count(name) == 0) {
            // пользователь с таким именем ещё не зарегистрирован
            users.insert(name);
            output << name << '\n';
        } else {
            // имя уже занято, нужно добавить число в конец
            int suffix = 1;
            while (users.count(name + std::to_string(suffix)) > 0) {
                ++suffix;
            }
            users.insert(name + std::to_string(suffix));
            output << name + std::to_string(suffix) << '\n';
        }
    }

    std::cout << output.str();

    return 0;
}
