#include <bits/stdc++.h>
using namespace std;

#define int long long

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif  // LOCAL
    int n, k;
    cin >> n >> k;
    vector<int> s(n);
    for (auto &i : s) {
        cin >> i;
    }

    vector<int> sum(11);
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        sum[s[i]] += abs(a - s[i]);
    }

    long double diff = 0;
    for (int i = 1; i < 11; ++i) {
        diff += static_cast<long double>(sum[i]) / i;
    }

    int result = 0;
    for (int i = 1; i < 11 and diff > k; ++i) {
        if (diff - static_cast<long double>(sum[i]) / i >= k) {
            diff -= static_cast<long double>(sum[i]) / i;
            result += sum[i];
        } else {
            int left = 0;
            int right = sum[i];
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (diff - static_cast<long double>(mid) / i > k) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            diff -= static_cast<long double>(right) / i;
            result += right;
            break;
        }
    }
    cout << result << '\n';
}
