#include <bits/stdc++.h>
using namespace std;

#define int long long

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif  // LOCAL
    int n, k;
    cin >> n >> k;
    vector<int> s(n);
    for (auto &i : s) {
        cin >> i;
    }

    vector<int> sum(11, 0);
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        sum[s[i]] += abs(a - s[i]);
    }

    vector<long double> diff(12, 0);
    diff[11] = 0;
    for (int i = 10; i > 0; --i) {
        diff[i] = diff[i + 1] + static_cast<long double>(sum[i]) / i;
    }

    int result = 0;
    for (int i = 1; i < 11; ++i) {
        if (diff[i] * i - sum[i] > k * i) {
            result += sum[i];
        } else {
            if (diff[i] <= static_cast<long double>(k)) {
                break;
            }

            int left = 0;
            int right = sum[i];
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (diff[i] * i - mid > k * i) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            result += right;
            break;
        }
    }
    cout << result << '\n';
}
