#include <bits/stdc++.h>

using namespace std;

struct cmp{
    bool operator() (const pair<double, double> &a, const pair<double, double> &b) const {
        return (a.first == b.first) ? a.second > b.second : a.first < b.first;
    }
};

int main() {
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(0);
    //    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<double> s(n, 0);
    vector<double> a(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    double Delta = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        Delta += fabs(a[i]-s[i])/s[i];
    }
    if (Delta <= k) {
        cout << 0 << '\n';
        return 0;
    }
    vector<pair<double, double>> array(n);
    for (int i = 0; i < n; i++) {
        array[i] = make_pair(s[i], fabs(a[i]-s[i]));
    }
    sort(array.begin(), array.end(), cmp());
    double time = 0;
    for (const pair<double, double> _pair : array) {
        double s_i = _pair.first;
        double diff = _pair.second;
        if (Delta - diff / s_i > k) {
            time += diff;
            Delta -= diff / s_i;
        } else {
            // Delta - diff / s_i <= k then don't need to remove all diff, just a part of it. Which part?
            // d = Delta - k -- how much to remove.
            // ceil(d * s_i) -- how many diff should be
            time += ceil((Delta - k) * s_i);
            break;
        }
    }
    cout << (long long) time << '\n';
    return 0;
}
