import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        int K = scanner.nextInt();

        int totalSeats = N;
        int introversions = 0;
        int currentSeat = 2;
        int previousSeat = N - 2;

        while (currentSeat <= previousSeat) {
            int availableSeats = (previousSeat - currentSeat) + 3;
            if (availableSeats >= K) {
                introversions += 2;
                currentSeat += K;
                previousSeat -= K;
            } else {
                currentSeat += 1;
                previousSeat -= 1;
            }
        }

        System.out.println(introversions);
    }
}