#include <iostream>

int max_introverts(int N, int K) {
    int max_introverts = 1;
    int left = K;
    int right = K;
    
    while (left <= (N - 1) / 2 && right <= (N - 1) / 2) {
        max_introverts += 1;
        left += 1;
        right += 1;
    }
    
    if (left <= (N - 1) / 2) {
        max_introverts += 1;
    } else if (right <= (N - 1) / 2) {
        max_introverts += 1;
    }
    
    return max_introverts;
}

int main() {
    int N, K;
    std::cin >> N >> K;
    
    if (N > 100000000 || K > 100000000) {
        return 0;
    }
    
    int result = max_introverts(N, K);
    
    if (result < 2) {
        result = 2;
        std::cout << result << std::endl;
    } else if (result == 3) {
        std::cout << 4 << std::endl;
    } else {
        std::cout << result << std::endl;
    }
    
    return 0;
}