import math
def calculate_distance(x1, y1, x2, y2):
    return math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)
def calculate_polyline_length(vertices):
    length = 0
    for i in range(len(vertices) - 1):
        x1, y1 = vertices[i]
        x2, y2 = vertices[i + 1]
        distance = calculate_distance(x1, y1, x2, y2)
        length += distance
    return length
N = int(input())
vertices = []
if N >= 3 and N <= math.pow(10, 5):
  for i in range(N):
    x, y = [int(coord) for coord in input().split()]
    vertices.append((x, y))
  length = calculate_polyline_length(vertices)
  print("{0:.6f}".format(length))
else:
  exit()
