def calculate_prob(N, K, S):
    dp = [[0] * (S + 1) for _ in range(N + 1)]
    dp[0][0] = 1

    for i in range(1, N + 1):
        for j in range(1, S + 1):
            for k in range(1, min(K + 1, j + 1)):
                dp[i][j] += dp[i - 1][j - k]

    return dp[N][S]

# Чтение входных данных
N = int(input())
K = int(input())
S1 = int(input())
S2 = int(input())

# Вычисление вероятностей
prob1 = calculate_prob(N, K, S1)
prob2 = calculate_prob(N, K, S2)

# Сравнение вероятностей и вывод результата
if prob1 > prob2:
    print("First")
elif prob1 < prob2:
    print("Second")
else:
    print("Equal")
