def calculate_winning_chances(N, K, S1, S2):
    # Создаем массивы для подсчета вероятностей победы первого и второго игроков
    chances_first = [0] * (N * K + 1)  # +1, так как сумма от 0 до N*K возможна
    chances_second = [0] * (N * K + 1)
    total_combinations = 0  # Общее количество возможных комбинаций

    def count_sum(summ, depth):
        nonlocal total_combinations

        if depth == N:
            if summ == S1:
                chances_first[summ] += 1
            if summ == S2:
                chances_second[summ] += 1
            total_combinations += 1
            return

        for i in range(1, K + 1):
            count_sum(summ + i, depth + 1)

    count_sum(0, 0)

    if chances_first[S1] > chances_second[S2]:
        return "First"
    elif chances_second[S2] > chances_first[S1]:
        return "Second"
    else:
        return "Equal"

# Пример использования:
N = int(input())  # Число запусков рулетки
K = int(input())  # Количество чисел на рулетке
S1 = int(input())  # Сумма, на которую поставил первый игрок
S2 = int(input())  # Сумма, на которую поставил второй игрок

result = calculate_winning_chances(N, K, S1, S2)
print(result)
