import math

def gcd(a, b):
    if b == 0:
        return a
    return gcd(b, a % b)


def find_max_gcd(L, R):
    max_gcd = 0
    ans = (0, 0)

    for i in range(L, R):
        for j in range(i + 1, R + 1):
            current_gcd = gcd(i, j)
            if current_gcd > max_gcd:
                max_gcd = current_gcd
                ans = (i, j)

    return ans


# Считываем входные данные
L, R = map(int, input().split())

# Вычисляем и выводим пару с наибольшим НОД
result = find_max_gcd(L, R)
print(result[0], result[1])