#include <iostream>
#include <cmath>

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

std::pair<int, int> find_max_gcd(int L, int R) {
    int max_gcd = 0;
    std::pair<int, int> ans = std::make_pair(0, 0);

    for (int i = L; i < R; i++) {
        for (int j = i + 1; j <= R; j++) {
            int current_gcd = gcd(i, j);
            if (current_gcd > max_gcd) {
                max_gcd = current_gcd;
                ans = std::make_pair(i, j);
            }
        }
    }

    return ans;
}

int main() {
    int L, R;
    std::cin >> L >> R;

    std::pair<int, int> result = find_max_gcd(L, R);

    std::cout << result.first << " " << result.second << std::endl;

    return 0;
}